/* axios v0.5.4 | (c) 2015 by Matt Zabriskie */

/*!
	 * @overview es6-promise - a tiny implementation of Promises/A+.
	 * @copyright Copyright (c) 2014 Yehuda Katz, Tom Dale, Stefan Penner and contributors (Conversion to ES6 API by Jake Archibald)
	 * @license   Licensed under MIT license
	 *            See https://raw.githubusercontent.com/jakearchibald/es6-promise/master/LICENSE
	 * @version   2.0.1
	 */

/* @preserve
 * The MIT License (MIT)
 * 
 * Copyright (c) 2014 Petka Antonov
 * 
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 * 
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 * 
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 * THE SOFTWARE.
 * 
 */

/*
MIT LICENSE
Copyright (c) 2007 Monsur Hossain (http://monsur.hossai.in)

Permission is hereby granted, free of charge, to any person
obtaining a copy of this software and associated documentation
files (the "Software"), to deal in the Software without
restriction, including without limitation the rights to use,
copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the
Software is furnished to do so, subject to the following
conditions:

The above copyright notice and this permission notice shall be
included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
OTHER DEALINGS IN THE SOFTWARE.
*/

/**
 * @license
 * lodash 3.10.0 (Custom Build) <https://lodash.com/>
 * Build: `lodash modern -o ./lodash.js`
 * Copyright 2012-2015 The Dojo Foundation <http://dojofoundation.org/>
 * Based on Underscore.js 1.8.3 <http://underscorejs.org/LICENSE>
 * Copyright 2009-2015 Jeremy Ashkenas, DocumentCloud and Investigative Reporters & Editors
 * Available under MIT license <https://lodash.com/license>
 */

/*! loglevel - v1.3.1 - https://github.com/pimterry/loglevel - (c) 2015 Tim Perry - licensed MIT */

// +----------------------------------------------------------------------+
// | murmurHash3.js v2.1.2 (http://github.com/karanlyons/murmurHash.js)   |
// | A javascript implementation of MurmurHash3's x86 hashing algorithms. |
// |----------------------------------------------------------------------|
// | Copyright (c) 2012 Karan Lyons                                       |
// | Freely distributable under the MIT license.                          |
// +----------------------------------------------------------------------+

define("axios",[],function(){return function(e){function t(r){if(n[r])return n[r].exports;var i=n[r]={exports:{},id:r,loaded:!1};return e[r].call(i.exports,i,i.exports,t),i.loaded=!0,i.exports}var n={};return t.m=e,t.c=n,t.p="",t(0)}([function(e,t,n){e.exports=n(1)},function(e,t,n){"use strict";var r=n(2),i=n(3),s=n(4),o=n(5),u=n(6);!function(){var e=n(9);e&&"function"==typeof e.polyfill&&e.polyfill()}();var a=e.exports=function f(e){e=i.merge({method:"get",headers:{},transformRequest:r.transformRequest,transformResponse:r.transformResponse},e),e.withCredentials=e.withCredentials||r.withCredentials;var t=[o,void 0],n=Promise.resolve(e);for(f.interceptors.request.forEach(function(e){t.unshift(e.fulfilled,e.rejected)}),f.interceptors.response.forEach(function(e){t.push(e.fulfilled,e.rejected)});t.length;)n=n.then(t.shift(),t.shift());return n.success=function(e){return s("success","then","https://github.com/mzabriskie/axios/blob/master/README.md#response-api"),n.then(function(t){e(t.data,t.status,t.headers,t.config)}),n},n.error=function(e){return s("error","catch","https://github.com/mzabriskie/axios/blob/master/README.md#response-api"),n.then(null,function(t){e(t.data,t.status,t.headers,t.config)}),n},n};a.defaults=r,a.all=function(e){return Promise.all(e)},a.spread=n(7),a.interceptors={request:new u,response:new u},function(){function e(){i.forEach(arguments,function(e){a[e]=function(t,n){return a(i.merge(n||{},{method:e,url:t}))}})}function t(){i.forEach(arguments,function(e){a[e]=function(t,n,r){return a(i.merge(r||{},{method:e,url:t,data:n}))}})}e("delete","get","head"),t("post","put","patch")}()},function(e,t,n){"use strict";var r=n(3),i=/^\)\]\}',?\n/,s={"Content-Type":"application/x-www-form-urlencoded"};e.exports={transformRequest:[function(e,t){return r.isFormData(e)?e:r.isArrayBuffer(e)?e:r.isArrayBufferView(e)?e.buffer:!r.isObject(e)||r.isFile(e)||r.isBlob(e)?e:(!r.isUndefined(t)&&r.isUndefined(t["Content-Type"])&&(t["Content-Type"]="application/json;charset=utf-8"),JSON.stringify(e))}],transformResponse:[function(e){if("string"==typeof e){e=e.replace(i,"");try{e=JSON.parse(e)}catch(t){}}return e}],headers:{common:{Accept:"application/json, text/plain, */*"},patch:r.merge(s),post:r.merge(s),put:r.merge(s)},xsrfCookieName:"XSRF-TOKEN",xsrfHeaderName:"X-XSRF-TOKEN"}},function(e){"use strict";function t(e){return"[object Array]"===v.call(e)}function n(e){return"[object ArrayBuffer]"===v.call(e)}function r(e){return"[object FormData]"===v.call(e)}function i(e){return"undefined"!=typeof ArrayBuffer&&ArrayBuffer.isView?ArrayBuffer.isView(e):e&&e.buffer&&e.buffer instanceof ArrayBuffer}function s(e){return"string"==typeof e}function o(e){return"number"==typeof e}function u(e){return"undefined"==typeof e}function a(e){return null!==e&&"object"==typeof e}function f(e){return"[object Date]"===v.call(e)}function l(e){return"[object File]"===v.call(e)}function c(e){return"[object Blob]"===v.call(e)}function h(e){return e.replace(/^\s*/,"").replace(/\s*$/,"")}function p(e,n){if(null!==e&&"undefined"!=typeof e){var r=t(e)||"object"==typeof e&&!isNaN(e.length);if("object"==typeof e||r||(e=[e]),r)for(var i=0,s=e.length;s>i;i++)n.call(null,e[i],i,e);else for(var o in e)e.hasOwnProperty(o)&&n.call(null,e[o],o,e)}}function d(){var e={};return p(arguments,function(t){p(t,function(t,n){e[n]=t})}),e}var v=Object.prototype.toString;e.exports={isArray:t,isArrayBuffer:n,isFormData:r,isArrayBufferView:i,isString:s,isNumber:o,isObject:a,isUndefined:u,isDate:f,isFile:l,isBlob:c,forEach:p,merge:d,trim:h}},function(e){"use strict";e.exports=function(e,t,n){try{console.warn("DEPRECATED method `"+e+"`."+(t?" Use `"+t+"` instead.":"")+" This method will be removed in a future release."),n&&console.warn("For more information about usage see "+n)}catch(r){}}},function(e,t,n){(function(t){"use strict";e.exports=function(e){return new Promise(function(r,i){try{"undefined"!=typeof window?n(8)(r,i,e):"undefined"!=typeof t&&n(8)(r,i,e)}catch(s){i(s)}})}}).call(t,n(10))},function(e,t,n){"use strict";function r(){this.handlers=[]}var i=n(3);r.prototype.use=function(e,t){return this.handlers.push({fulfilled:e,rejected:t}),this.handlers.length-1},r.prototype.eject=function(e){this.handlers[e]&&(this.handlers[e]=null)},r.prototype.forEach=function(e){i.forEach(this.handlers,function(t){null!==t&&e(t)})},e.exports=r},function(e){"use strict";e.exports=function(e){return function(n){e.apply(null,n)}}},function(e,t,n){"use strict";var r=n(2),i=n(3),s=n(11),o=n(12),u=n(13),a=n(14),f=n(15);e.exports=function(e,t,n){var l=a(n.data,n.headers,n.transformRequest),h=i.merge(r.headers.common,r.headers[n.method]||{},n.headers||{});i.isFormData(l)&&delete h["Content-Type"];var p=new(XMLHttpRequest||ActiveXObject)("Microsoft.XMLHTTP");p.open(n.method.toUpperCase(),s(n.url,n.params),!0),p.onreadystatechange=function(){if(p&&4===p.readyState){var r=u(p.getAllResponseHeaders()),i=-1!==["text",""].indexOf(n.responseType||"")?p.responseText:p.response,s={data:a(i,r,n.transformResponse),status:p.status,statusText:p.statusText,headers:r,config:n};(p.status>=200&&p.status<300?e:t)(s),p=null}};var d=f(n.url)?o.read(n.xsrfCookieName||r.xsrfCookieName):void 0;if(d&&(h[n.xsrfHeaderName||r.xsrfHeaderName]=d),i.forEach(h,function(e,t){l||"content-type"!==t.toLowerCase()?p.setRequestHeader(t,e):delete h[t]}),n.withCredentials&&(p.withCredentials=!0),n.responseType)try{p.responseType=n.responseType}catch(v){if("json"!==p.responseType)throw v}i.isArrayBuffer(l)&&(l=new DataView(l)),p.send(l)}},function(e,t,n){var r;(function(e,i,s){(function(){"use strict";function u(e){return"function"==typeof e||"object"==typeof e&&null!==e}function a(e){return"function"==typeof e}function f(e){return"object"==typeof e&&null!==e}function l(){}function c(){return function(){e.nextTick(v)}}function h(){var e=0,t=new W(v),n=document.createTextNode("");return t.observe(n,{characterData:!0}),function(){n.data=e=++e%2}}function p(){var e=new MessageChannel;return e.port1.onmessage=v,function(){e.port2.postMessage(0)}}function d(){return function(){setTimeout(v,1)}}function v(){for(var e=0;R>e;e+=2){var t=V[e],n=V[e+1];t(n),V[e]=void 0,V[e+1]=void 0}R=0}function m(){}function g(){return new TypeError("You cannot resolve a promise with itself")}function y(){return new TypeError("A promises callback cannot return that same promise.")}function b(e){try{return e.then}catch(t){return Q.error=t,Q}}function w(e,t,n,r){try{e.call(t,n,r)}catch(i){return i}}function E(e,t,n){U(function(e){var r=!1,i=w(n,t,function(n){r||(r=!0,t!==n?T(e,n):C(e,n))},function(t){r||(r=!0,k(e,t))},"Settle: "+(e._label||" unknown promise"));!r&&i&&(r=!0,k(e,i))},e)}function S(e,t){t._state===J?C(e,t._result):e._state===K?k(e,t._result):L(t,void 0,function(t){T(e,t)},function(t){k(e,t)})}function x(e,t){if(t.constructor===e.constructor)S(e,t);else{var n=b(t);n===Q?k(e,Q.error):void 0===n?C(e,t):a(n)?E(e,t,n):C(e,t)}}function T(e,t){e===t?k(e,g()):u(t)?x(e,t):C(e,t)}function N(e){e._onerror&&e._onerror(e._result),A(e)}function C(e,t){e._state===$&&(e._result=t,e._state=J,0===e._subscribers.length||U(A,e))}function k(e,t){e._state===$&&(e._state=K,e._result=t,U(N,e))}function L(e,t,n,r){var i=e._subscribers,s=i.length;e._onerror=null,i[s]=t,i[s+J]=n,i[s+K]=r,0===s&&e._state&&U(A,e)}function A(e){var t=e._subscribers,n=e._state;if(0!==t.length){for(var r,i,s=e._result,o=0;o<t.length;o+=3)r=t[o],i=t[o+n],r?_(n,r,i,s):i(s);e._subscribers.length=0}}function O(){this.error=null}function M(e,t){try{return e(t)}catch(n){return G.error=n,G}}function _(e,t,n,r){var i,s,o,u,f=a(n);if(f){if(i=M(n,r),i===G?(u=!0,s=i.error,i=null):o=!0,t===i)return void k(t,y())}else i=r,o=!0;t._state!==$||(f&&o?T(t,i):u?k(t,s):e===J?C(t,i):e===K&&k(t,i))}function D(e,t){try{t(function(t){T(e,t)},function(t){k(e,t)})}catch(n){k(e,n)}}function P(e,t,n,r){this._instanceConstructor=e,this.promise=new e(m,r),this._abortOnReject=n,this._validateInput(t)?(this._input=t,this.length=t.length,this._remaining=t.length,this._init(),0===this.length?C(this.promise,this._result):(this.length=this.length||0,this._enumerate(),0===this._remaining&&C(this.promise,this._result))):k(this.promise,this._validationError())}function H(){throw new TypeError("You must pass a resolver function as the first argument to the promise constructor")}function B(){throw new TypeError("Failed to construct 'Promise': Please use the 'new' operator, this object constructor cannot be called as a function.")}function j(e){this._id=rt++,this._state=void 0,this._result=void 0,this._subscribers=[],m!==e&&(a(e)||H(),this instanceof j||B(),D(this,e))}var F;F=Array.isArray?Array.isArray:function(e){return"[object Array]"===Object.prototype.toString.call(e)};var I,q=F,R=(Date.now||function(){return(new Date).getTime()},Object.create||function(e){if(arguments.length>1)throw new Error("Second argument not supported");if("object"!=typeof e)throw new TypeError("Argument must be an object");return l.prototype=e,new l},0),U=function(e,t){V[R]=e,V[R+1]=t,R+=2,2===R&&I()},z="undefined"!=typeof window?window:{},W=z.MutationObserver||z.WebKitMutationObserver,X="undefined"!=typeof Uint8ClampedArray&&"undefined"!=typeof importScripts&&"undefined"!=typeof MessageChannel,V=new Array(1e3);I="undefined"!=typeof e&&"[object process]"==={}.toString.call(e)?c():W?h():X?p():d();var $=void 0,J=1,K=2,Q=new O,G=new O;P.prototype._validateInput=function(e){return q(e)},P.prototype._validationError=function(){return new Error("Array Methods must be provided an Array")},P.prototype._init=function(){this._result=new Array(this.length)};var Y=P;P.prototype._enumerate=function(){for(var e=this.length,t=this.promise,n=this._input,r=0;t._state===$&&e>r;r++)this._eachEntry(n[r],r)},P.prototype._eachEntry=function(e,t){var n=this._instanceConstructor;f(e)?e.constructor===n&&e._state!==$?(e._onerror=null,this._settledAt(e._state,t,e._result)):this._willSettleAt(n.resolve(e),t):(this._remaining--,this._result[t]=this._makeResult(J,t,e))},P.prototype._settledAt=function(e,t,n){var r=this.promise;r._state===$&&(this._remaining--,this._abortOnReject&&e===K?k(r,n):this._result[t]=this._makeResult(e,t,n)),0===this._remaining&&C(r,this._result)},P.prototype._makeResult=function(e,t,n){return n},P.prototype._willSettleAt=function(e,t){var n=this;L(e,void 0,function(e){n._settledAt(J,t,e)},function(e){n._settledAt(K,t,e)})};var Z=function(e,t){return(new Y(this,e,!0,t)).promise},et=function(e,t){function n(e){T(s,e)}function r(e){k(s,e)}var i=this,s=new i(m,t);if(!q(e))return k(s,new TypeError("You must pass an array to race.")),s;for(var o=e.length,u=0;s._state===$&&o>u;u++)L(i.resolve(e[u]),void 0,n,r);return s},tt=function(e,t){var n=this;if(e&&"object"==typeof e&&e.constructor===n)return e;var r=new n(m,t);return T(r,e),r},nt=function(e,t){var n=this,r=new n(m,t);return k(r,e),r},rt=0,it=j;j.all=Z,j.race=et,j.resolve=tt,j.reject=nt,j.prototype={constructor:j,then:function(e,t){var n=this,r=n._state;if(r===J&&!e||r===K&&!t)return this;var i=new this.constructor(m),s=n._result;if(r){var o=arguments[r-1];U(function(){_(r,i,o,s)})}else L(n,i,e,t);return i},"catch":function(e){return this.then(null,e)}};var st=function(){var e;e="undefined"!=typeof i?i:"undefined"!=typeof window&&window.document?window:self;var t="Promise"in e&&"resolve"in e.Promise&&"reject"in e.Promise&&"all"in e.Promise&&"race"in e.Promise&&function(){var t;return new e.Promise(function(e){t=e}),a(t)}();t||(e.Promise=it)},ot={Promise:it,polyfill:st};n(16).amd?(r=function(){return ot}.call(t,n,t,s),void 0===r||!(s.exports=r)):"undefined"!=typeof s&&s.exports?s.exports=ot:"undefined"!=typeof this&&(this.ES6Promise=ot)}).call(this)}).call(t,n(10),function(){return this}(),n(17)(e))},function(e){function t(){if(!s){s=!0;for(var e,t=i.length;t;){e=i,i=[];for(var n=-1;++n<t;)e[n]();t=i.length}s=!1}}function n(){}var r=e.exports={},i=[],s=!1;r.nextTick=function(e){i.push(e),s||setTimeout(t,0)},r.title="browser",r.browser=!0,r.env={},r.argv=[],r.version="",r.versions={},r.on=n,r.addListener=n,r.once=n,r.off=n,r.removeListener=n,r.removeAllListeners=n,r.emit=n,r.binding=function(){throw new Error("process.binding is not supported")},r.cwd=function(){return"/"},r.chdir=function(){throw new Error("process.chdir is not supported")},r.umask=function(){return 0}},function(e,t,n){"use strict";function r(e){return encodeURIComponent(e).replace(/%40/gi,"@").replace(/%3A/gi,":").replace(/%24/g,"$").replace(/%2C/gi,",").replace(/%20/g,"+")}var i=n(3);e.exports=function(e,t){if(!t)return e;var n=[];return i.forEach(t,function(e,t){null!==e&&"undefined"!=typeof e&&(i.isArray(e)||(e=[e]),i.forEach(e,function(e){i.isDate(e)?e=e.toISOString():i.isObject(e)&&(e=JSON.stringify(e)),n.push(r(t)+"="+r(e))}))}),n.length>0&&(e+=(-1===e.indexOf("?")?"?":"&")+n.join("&")),e}},function(e,t,n){"use strict";var r=n(3);e.exports={write:function(e,t,n,i,s,o){var u=[];u.push(e+"="+encodeURIComponent(t)),r.isNumber(n)&&u.push("expires="+(new Date(n)).toGMTString()),r.isString(i)&&u.push("path="+i),r.isString(s)&&u.push("domain="+s),o===!0&&u.push("secure"),document.cookie=u.join("; ")},read:function(e){var t=document.cookie.match(new RegExp("(^|;\\s*)("+e+")=([^;]*)"));return t?decodeURIComponent(t[3]):null},remove:function(e){this.write(e,"",Date.now()-864e5)}}},function(e,t,n){"use strict";var r=n(3);e.exports=function(e){var t,n,i,s={};return e?(r.forEach(e.split("\n"),function(e){i=e.indexOf(":"),t=r.trim(e.substr(0,i)).toLowerCase(),n=r.trim(e.substr(i+1)),t&&(s[t]=s[t]?s[t]+", "+n:n)}),s):s}},function(e,t,n){"use strict";var r=n(3);e.exports=function(e,t,n){return r.forEach(n,function(n){e=n(e,t)}),e}},function(e,t,n){"use strict";function r(e){var t=e;return o&&(u.setAttribute("href",t),t=u.href),u.setAttribute("href",t),{href:u.href,protocol:u.protocol?u.protocol.replace(/:$/,""):"",host:u.host,search:u.search?u.search.replace(/^\?/,""):"",hash:u.hash?u.hash.replace(/^#/,""):"",hostname:u.hostname,port:u.port,pathname:"/"===u.pathname.charAt(0)?u.pathname:"/"+u.pathname}}var i,s=n(3),o=/(msie|trident)/i.test(navigator.userAgent),u=document.createElement("a");i=r(window.location.href),e.exports=function(e){var t=s.isString(e)?r(e):e;return t.protocol===i.protocol&&t.host===i.host}},function(e){e.exports=function(){throw new Error("define cannot be used indirect")}},function(e){e.exports=function(e){return e.webpackPolyfill||(e.deprecate=function(){},e.paths=[],e.children=[],e.webpackPolyfill=1),e}}])}),!function(e){if("object"==typeof exports&&"undefined"!=typeof module)module.exports=e();else if("function"==typeof define&&define.amd)define("bluebird",[],e);else{var t;"undefined"!=typeof window?t=window:"undefined"!=typeof global?t=global:"undefined"!=typeof self&&(t=self),t.Promise=e()}}(function(){var define,module,exports;return function e(t,n,r){function i(o,u){if(!n[o]){if(!t[o]){var a=typeof _dereq_=="function"&&_dereq_;if(!u&&a)return a(o,!0);if(s)return s(o,!0);var f=new Error("Cannot find module '"+o+"'");throw f.code="MODULE_NOT_FOUND",f}var l=n[o]={exports:{}};t[o][0].call(l.exports,function(e){var n=t[o][1][e];return i(n?n:e)},l,l.exports,e,t,n,r)}return n[o].exports}var s=typeof _dereq_=="function"&&_dereq_;for(var o=0;o<r.length;o++)i(r[o]);return i}({1:[function(e,t,n){"use strict";t.exports=function(e){function n(e){var n=new t(e),r=n.promise();return n.setHowMany(1),n.setUnwrap(),n.init(),r}var t=e._SomePromiseArray;e.any=function(e){return n(e)},e.prototype.any=function(){return n(this)}}},{}],2:[function(e,t,n){"use strict";function a(){this._isTickUsed=!1,this._lateQueue=new o(16),this._normalQueue=new o(16),this._trampolineEnabled=!0;var e=this;this.drainQueues=function(){e._drainQueues()},this._schedule=s.isStatic?s(this.drainQueues):s}function f(e,t,n){this._lateQueue.push(e,t,n),this._queueTick()}function l(e,t,n){this._normalQueue.push(e,t,n),this._queueTick()}function c(e){this._normalQueue._pushOne(e),this._queueTick()}var r;try{throw new Error}catch(i){r=i}var s=e("./schedule.js"),o=e("./queue.js"),u=e("./util.js");a.prototype.disableTrampolineIfNecessary=function(){u.hasDevTools&&(this._trampolineEnabled=!1)},a.prototype.enableTrampoline=function(){this._trampolineEnabled||(this._trampolineEnabled=!0,this._schedule=function(e){setTimeout(e,0)})},a.prototype.haveItemsQueued=function(){return this._normalQueue.length()>0},a.prototype.throwLater=function(e,t){arguments.length===1&&(t=e,e=function(){throw t});if(typeof setTimeout!="undefined")setTimeout(function(){e(t)},0);else try{this._schedule(function(){e(t)})}catch(n){throw new Error("No async scheduler available\n\n    See http://goo.gl/m3OTXk\n")}},u.hasDevTools?(s.isStatic&&(s=function(e){setTimeout(e,0)}),a.prototype.invokeLater=function(e,t,n){this._trampolineEnabled?f.call(this,e,t,n):this._schedule(function(){setTimeout(function(){e.call(t,n)},100)})},a.prototype.invoke=function(e,t,n){this._trampolineEnabled?l.call(this,e,t,n):this._schedule(function(){e.call(t,n)})},a.prototype.settlePromises=function(e){this._trampolineEnabled?c.call(this,e):this._schedule(function(){e._settlePromises()})}):(a.prototype.invokeLater=f,a.prototype.invoke=l,a.prototype.settlePromises=c),a.prototype.invokeFirst=function(e,t,n){this._normalQueue.unshift(e,t,n),this._queueTick()},a.prototype._drainQueue=function(e){while(e.length()>0){var t=e.shift();if(typeof t!="function"){t._settlePromises();continue}var n=e.shift(),r=e.shift();t.call(n,r)}},a.prototype._drainQueues=function(){this._drainQueue(this._normalQueue),this._reset(),this._drainQueue(this._lateQueue)},a.prototype._queueTick=function(){this._isTickUsed||(this._isTickUsed=!0,this._schedule(this.drainQueues))},a.prototype._reset=function(){this._isTickUsed=!1},t.exports=new a,t.exports.firstLineError=r},{"./queue.js":28,"./schedule.js":31,"./util.js":38}],3:[function(e,t,n){"use strict";t.exports=function(e,t,n){var r=function(e,t){this._reject(t)},i=function(e,t){t.promiseRejectionQueued=!0,t.bindingPromise._then(r,r,null,this,e)},s=function(e,t){this._isPending()&&this._resolveCallback(t.target)},o=function(e,t){t.promiseRejectionQueued||this._reject(e)};e.prototype.bind=function(r){var u=n(r),a=new e(t);a._propagateFrom(this,1);var f=this._target();a._setBoundTo(u);if(u instanceof e){var l={promiseRejectionQueued:!1,promise:a,target:f,bindingPromise:u};f._then(t,i,a._progress,a,l),u._then(s,o,a._progress,a,l)}else a._resolveCallback(f);return a},e.prototype._setBoundTo=function(e){e!==undefined?(this._bitField=this._bitField|131072,this._boundTo=e):this._bitField=this._bitField&-131073},e.prototype._isBound=function(){return(this._bitField&131072)===131072},e.bind=function(r,i){var s=n(r),o=new e(t);return o._setBoundTo(s),s instanceof e?s._then(function(){o._resolveCallback(i)},o._reject,o._progress,o,null):o._resolveCallback(i),o}}},{}],4:[function(e,t,n){"use strict";function i(){try{Promise===s&&(Promise=r)}catch(e){}return s}var r;typeof Promise!="undefined"&&(r=Promise);var s=e("./promise.js")();s.noConflict=i,t.exports=s},{"./promise.js":23}],5:[function(e,t,n){"use strict";var r=Object.create;if(r){var i=r(null),s=r(null);i[" size"]=s[" size"]=0}t.exports=function(t){function h(e,r){var i;e!=null&&(i=e[r]);if(typeof i!="function"){var s="Object "+n.classString(e)+" has no method '"+n.toString(r)+"'";throw new t.TypeError(s)}return i}function p(e){var t=this.pop(),n=h(e,t);return n.apply(e,this)}function d(e){return e[this]}function v(e){var t=+this;return t<0&&(t=Math.max(0,t+e.length)),e[t]}var n=e("./util.js"),r=n.canEvaluate,o=n.isIdentifier,u,a;t.prototype.call=function(e){var t=arguments.length,n=new Array(t-1);for(var i=1;i<t;++i)n[i-1]=arguments[i];return n.push(e),this._then(p,undefined,undefined,n,undefined)},t.prototype.get=function(e){var t=typeof e=="number",n;if(!t)if(r){var i=a(e);n=i!==null?i:d}else n=d;else n=v;return this._then(n,undefined,undefined,e,undefined)}}},{"./util.js":38}],6:[function(e,t,n){"use strict";t.exports=function(t){var n=e("./errors.js"),r=e("./async.js"),i=n.CancellationError;t.prototype._cancel=function(e){if(!this.isCancellable())return this;var t,n=this;while((t=n._cancellationParent)!==undefined&&t.isCancellable())n=t;this._unsetCancellable(),n._target()._rejectCallback(e,!1,!0)},t.prototype.cancel=function(e){return this.isCancellable()?(e===undefined&&(e=new i),r.invokeLater(this._cancel,this,e),this):this},t.prototype.cancellable=function(){return this._cancellable()?this:(r.enableTrampoline(),this._setCancellable(),this._cancellationParent=undefined,this)},t.prototype.uncancellable=function(){var e=this.then();return e._unsetCancellable(),e},t.prototype.fork=function(e,t,n){var r=this._then(e,t,n,undefined,undefined);return r._setCancellable(),r._cancellationParent=undefined,r}}},{"./async.js":2,"./errors.js":13}],7:[function(e,t,n){"use strict";t.exports=function(){function a(e){this._parent=e;var t=this._length=1+(e===undefined?0:e._length);b(this,a),t>32&&this.uncycle()}function f(e,t){for(var n=0;n<t.length-1;++n)t[n].push("From previous event:"),t[n]=t[n].join("\n");return n<t.length&&(t[n]=t[n].join("\n")),e+"\n"+t.join("\n")}function l(e){for(var t=0;t<e.length;++t)if(e[t].length===0||t+1<e.length&&e[t][0]===e[t+1][0])e.splice(t,1),t--}function c(e){var t=e[0];for(var n=1;n<e.length;++n){var r=e[n],i=t.length-1,s=t[i],o=-1;for(var u=r.length-1;u>=0;--u)if(r[u]===s){o=u;break}for(var u=o;u>=0;--u){var a=r[u];if(t[i]!==a)break;t.pop(),i--}t=r}}function h(e){var t=[];for(var n=0;n<e.length;++n){var r=e[n],s=i.test(r)||"    (No stack trace)"===r,u=s&&m(r);s&&!u&&(o&&r.charAt(0)!==" "&&(r="    "+r),t.push(r))}return t}function p(e){var t=e.stack.replace(/\s+$/g,"").split("\n");for(var n=0;n<t.length;++n){var r=t[n];if("    (No stack trace)"===r||i.test(r))break}return n>0&&(t=t.slice(n)),t}function d(e){var t;if(typeof e=="function")t="[function "+(e.name||"anonymous")+"]";else{t=e.toString();var n=/\[object [a-zA-Z0-9$_]+\]/;if(n.test(t))try{var r=JSON.stringify(e);t=r}catch(i){}t.length===0&&(t="(empty array)")}return"(<"+v(t)+">, no stack trace)"}function v(e){var t=41;return e.length<t?e:e.substr(0,t-3)+"..."}function y(e){var t=e.match(g);if(t)return{fileName:t[1],line:parseInt(t[2],10)}}var t=e("./async.js"),n=e("./util.js"),r=/[\\\/]bluebird[\\\/]js[\\\/](main|debug|zalgo|instrumented)/,i=null,s=null,o=!1,u;n.inherits(a,Error),a.prototype.uncycle=function(){var e=this._length;if(e<2)return;var t=[],n={};for(var r=0,i=this;i!==undefined;++r)t.push(i),i=i._parent;e=this._length=r;for(var r=e-1;r>=0;--r){var s=t[r].stack;n[s]===undefined&&(n[s]=r)}for(var r=0;r<e;++r){var o=t[r].stack,u=n[o];if(u!==undefined&&u!==r){u>0&&(t[u-1]._parent=undefined,t[u-1]._length=1),t[r]._parent=undefined,t[r]._length=1;var a=r>0?t[r-1]:this;u<e-1?(a._parent=t[u+1],a._parent.uncycle(),a._length=a._parent._length+1):(a._parent=undefined,a._length=1);var f=a._length+1;for(var l=r-2;l>=0;--l)t[l]._length=f,f++;return}}},a.prototype.parent=function(){return this._parent},a.prototype.hasParent=function(){return this._parent!==undefined},a.prototype.attachExtraTrace=function(e){if(e.__stackCleaned__)return;this.uncycle();var t=a.parseStackAndMessage(e),r=t.message,i=[t.stack],s=this;while(s!==undefined)i.push(h(s.stack.split("\n"))),s=s._parent;c(i),l(i),n.notEnumerableProp(e,"stack",f(r,i)),n.notEnumerableProp(e,"__stackCleaned__",!0)},a.parseStackAndMessage=function(e){var t=e.stack,n=e.toString();return t=typeof t=="string"&&t.length>0?p(e):["    (No stack trace)"],{message:n,stack:h(t)}},a.formatAndLogError=function(e,t){if(typeof console!="undefined"){var n;if(typeof e=="object"||typeof e=="function"){var r=e.stack;n=t+s(r,e)}else n=t+String(e);typeof u=="function"?u(n):(typeof console.log=="function"||typeof console.log=="object")&&console.log(n)}},a.unhandledRejection=function(e){a.formatAndLogError(e,"^--- With additional stack trace: ")},a.isSupported=function(){return typeof b=="function"},a.fireRejectionEvent=function(e,n,r,i){var s=!1;try{typeof n=="function"&&(s=!0,e==="rejectionHandled"?n(i):n(r,i))}catch(o){t.throwLater(o)}var u=!1;try{u=E(e,r,i)}catch(o){u=!0,t.throwLater(o)}var f=!1;if(w)try{f=w(e.toLowerCase(),{reason:r,promise:i})}catch(o){f=!0,t.throwLater(o)}!u&&!s&&!f&&e==="unhandledRejection"&&a.formatAndLogError(r,"Unhandled rejection ")};var m=function(){return!1},g=/[\/<\(]([^:\/]+):(\d+):(?:\d+)\)?\s*$/;a.setBounds=function(e,t){if(!a.isSupported())return;var n=e.stack.split("\n"),i=t.stack.split("\n"),s=-1,o=-1,u,f;for(var l=0;l<n.length;++l){var c=y(n[l]);if(c){u=c.fileName,s=c.line;break}}for(var l=0;l<i.length;++l){var c=y(i[l]);if(c){f=c.fileName,o=c.line;break}}if(s<0||o<0||!u||!f||u!==f||s>=o)return;m=function(e){if(r.test(e))return!0;var t=y(e);return t&&t.fileName===u&&s<=t.line&&t.line<=o?!0:!1}};var b=function(){var t=/^\s*at\s*/,n=function(e,t){return typeof e=="string"?e:t.name!==undefined&&t.message!==undefined?t.toString():d(t)};if(typeof Error.stackTraceLimit=="number"&&typeof Error.captureStackTrace=="function"){Error.stackTraceLimit=Error.stackTraceLimit+6,i=t,s=n;var u=Error.captureStackTrace;return m=function(e){return r.test(e)},function(e,t){Error.stackTraceLimit=Error.stackTraceLimit+6,u(e,t),Error.stackTraceLimit=Error.stackTraceLimit-6}}var a=new Error;if(typeof a.stack=="string"&&a.stack.split("\n")[0].indexOf("stackDetection@")>=0)return i=/@/,s=n,o=!0,function(t){t.stack=(new Error).stack};var f;try{throw new Error}catch(l){f="stack"in l}return"stack"in a||!f||typeof Error.stackTraceLimit!="number"?(s=function(e,t){return typeof e=="string"?e:typeof t!="object"&&typeof t!="function"||t.name===undefined||t.message===undefined?d(t):t.toString()},null):(i=t,s=n,function(t){Error.stackTraceLimit=Error.stackTraceLimit+6;try{throw new Error}catch(n){t.stack=n.stack}Error.stackTraceLimit=Error.stackTraceLimit-6})}([]),w,E=function(){if(n.isNode)return function(e,t,n){return e==="rejectionHandled"?process.emit(e,n):process.emit(e,t,n)};var e=!1,t=!0;try{var r=new self.CustomEvent("test");e=r instanceof CustomEvent}catch(i){}if(!e)try{var s=document.createEvent("CustomEvent");s.initCustomEvent("testingtheevent",!1,!0,{}),self.dispatchEvent(s)}catch(i){t=!1}t&&(w=function(t,n){var r;return e?r=new self.CustomEvent(t,{detail:n,bubbles:!1,cancelable:!0}):self.dispatchEvent&&(r=document.createEvent("CustomEvent"),r.initCustomEvent(t,!1,!0,n)),r?!self.dispatchEvent(r):!1});var o={};return o.unhandledRejection="onunhandledRejection".toLowerCase(),o.rejectionHandled="onrejectionHandled".toLowerCase(),function(e,t,n){var r=o[e],i=self[r];return i?(e==="rejectionHandled"?i.call(self,n):i.call(self,t,n),!0):!1}}();return typeof console!="undefined"&&typeof console.warn!="undefined"&&(u=function(e){console.warn(e)},n.isNode&&process.stderr.isTTY?u=function(e){process.stderr.write("[31m"+e+"[39m\n")}:!n.isNode&&typeof (new Error).stack=="string"&&(u=function(e){console.warn("%c"+e,"color: red")})),a}},{"./async.js":2,"./util.js":38}],8:[function(e,t,n){"use strict";t.exports=function(t){function a(e,t,n){this._instances=e,this._callback=t,this._promise=n}function f(e,t){var n={},r=i(e).call(n,t);if(r===s)return r;var a=o(n);return a.length?(s.e=new u("Catch filter must inherit from Error or be a simple predicate function\n\n    See http://goo.gl/o84o68\n"),s):r}var n=e("./util.js"),r=e("./errors.js"),i=n.tryCatch,s=n.errorObj,o=e("./es5.js").keys,u=r.TypeError;return a.prototype.doFilter=function(e){var n=this._callback,r=this._promise,o=r._boundValue();for(var u=0,a=this._instances.length;u<a;++u){var l=this._instances[u],c=l===Error||l!=null&&l.prototype instanceof Error;if(c&&e instanceof l){var h=i(n).call(o,e);return h===s?(t.e=h.e,t):h}if(typeof l=="function"&&!c){var p=f(l,e);if(p===s){e=s.e;break}if(p){var h=i(n).call(o,e);return h===s?(t.e=h.e,t):h}}}return t.e=e,t},a}},{"./errors.js":13,"./es5.js":14,"./util.js":38}],9:[function(e,t,n){"use strict";t.exports=function(e,t,n){function i(){this._trace=new t(o())}function s(){if(n())return new i}function o(){var e=r.length-1;return e>=0?r[e]:undefined}var r=[];return i.prototype._pushContext=function(){if(!n())return;this._trace!==undefined&&r.push(this._trace)},i.prototype._popContext=function(){if(!n())return;this._trace!==undefined&&r.pop()},e.prototype._peekContext=o,e.prototype._pushContext=i.prototype._pushContext,e.prototype._popContext=i.prototype._popContext,s}},{}],10:[function(e,t,n){"use strict";t.exports=function(t,n){var r=t._getDomain,i=e("./async.js"),s=e("./errors.js").Warning,o=e("./util.js"),u=o.canAttachTrace,a,f,l=o.isNode&&(!!process.env.BLUEBIRD_DEBUG||process.env.NODE_ENV==="development");return l&&i.disableTrampolineIfNecessary(),t.prototype._ignoreRejections=function(){this._unsetRejectionIsUnhandled(),this._bitField=this._bitField|16777216},t.prototype._ensurePossibleRejectionHandled=function(){if((this._bitField&16777216)!==0)return;this._setRejectionIsUnhandled(),i.invokeLater(this._notifyUnhandledRejection,this,undefined)},t.prototype._notifyUnhandledRejectionIsHandled=function(){n.fireRejectionEvent("rejectionHandled",a,undefined,this)},t.prototype._notifyUnhandledRejection=function(){if(this._isRejectionUnhandled()){var e=this._getCarriedStackTrace()||this._settledValue;this._setUnhandledRejectionIsNotified(),n.fireRejectionEvent("unhandledRejection",f,e,this)}},t.prototype._setUnhandledRejectionIsNotified=function(){this._bitField=this._bitField|524288},t.prototype._unsetUnhandledRejectionIsNotified=function(){this._bitField=this._bitField&-524289},t.prototype._isUnhandledRejectionNotified=function(){return(this._bitField&524288)>0},t.prototype._setRejectionIsUnhandled=function(){this._bitField=this._bitField|2097152},t.prototype._unsetRejectionIsUnhandled=function(){this._bitField=this._bitField&-2097153,this._isUnhandledRejectionNotified()&&(this._unsetUnhandledRejectionIsNotified(),this._notifyUnhandledRejectionIsHandled())},t.prototype._isRejectionUnhandled=function(){return(this._bitField&2097152)>0},t.prototype._setCarriedStackTrace=function(e){this._bitField=this._bitField|1048576,this._fulfillmentHandler0=e},t.prototype._isCarryingStackTrace=function(){return(this._bitField&1048576)>0},t.prototype._getCarriedStackTrace=function(){return this._isCarryingStackTrace()?this._fulfillmentHandler0:undefined},t.prototype._captureStackTrace=function(){return l&&(this._trace=new n(this._peekContext())),this},t.prototype._attachExtraTrace=function(e,t){if(l&&u(e)){var r=this._trace;r!==undefined&&t&&(r=r._parent);if(r!==undefined)r.attachExtraTrace(e);else if(!e.__stackCleaned__){var i=n.parseStackAndMessage(e);o.notEnumerableProp(e,"stack",i.message+"\n"+i.stack.join("\n")),o.notEnumerableProp(e,"__stackCleaned__",!0)}}},t.prototype._warn=function(e){var t=new s(e),r=this._peekContext();if(r)r.attachExtraTrace(t);else{var i=n.parseStackAndMessage(t);t.stack=i.message+"\n"+i.stack.join("\n")}n.formatAndLogError(t,"")},t.onPossiblyUnhandledRejection=function(e){var t=r();f=typeof e=="function"?t===null?e:t.bind(e):undefined},t.onUnhandledRejectionHandled=function(e){var t=r();a=typeof e=="function"?t===null?e:t.bind(e):undefined},t.longStackTraces=function(){if(i.haveItemsQueued()&&l===!1)throw new Error("cannot enable long stack traces after promises have been created\n\n    See http://goo.gl/DT1qyG\n");l=n.isSupported(),l&&i.disableTrampolineIfNecessary()},t.hasLongStackTraces=function(){return l&&n.isSupported()},n.isSupported()||(t.longStackTraces=function(){},l=!1),function(){return l}}},{"./async.js":2,"./errors.js":13,"./util.js":38}],11:[function(e,t,n){"use strict";var r=e("./util.js"),i=r.isPrimitive;t.exports=function(e){var t=function(){return this},n=function(){throw this},r=function(){},s=function(){throw undefined},o=function(e,t){if(t===1)return function(){throw e};if(t===2)return function(){return e}};e.prototype["return"]=e.prototype.thenReturn=function(e){return e===undefined?this.then(r):i(e)?this._then(o(e,2),undefined,undefined,undefined,undefined):this._then(t,undefined,undefined,e,undefined)},e.prototype["throw"]=e.prototype.thenThrow=function(e){return e===undefined?this.then(s):i(e)?this._then(o(e,1),undefined,undefined,undefined,undefined):this._then(n,undefined,undefined,e,undefined)}}},{"./util.js":38}],12:[function(e,t,n){"use strict";t.exports=function(e,t){var n=e.reduce;e.prototype.each=function(e){return n(this,e,null,t)},e.each=function(e,r){return n(e,r,null,t)}}},{}],13:[function(e,t,n){"use strict";function a(e,t){function n(r){if(!(this instanceof n))return new n(r);u(this,"message",typeof r=="string"?r:t),u(this,"name",e),Error.captureStackTrace?Error.captureStackTrace(this,this.constructor):Error.call(this)}return o(n,Error),n}function b(e){if(!(this instanceof b))return new b(e);u(this,"name","OperationalError"),u(this,"message",e),this.cause=e,this.isOperational=!0,e instanceof Error?(u(this,"message",e.message),u(this,"stack",e.stack)):Error.captureStackTrace&&Error.captureStackTrace(this,this.constructor)}var r=e("./es5.js"),i=r.freeze,s=e("./util.js"),o=s.inherits,u=s.notEnumerableProp,f,l,c=a("Warning","warning"),h=a("CancellationError","cancellation error"),p=a("TimeoutError","timeout error"),d=a("AggregateError","aggregate error");try{f=TypeError,l=RangeError}catch(v){f=a("TypeError","type error"),l=a("RangeError","range error")}var m="join pop push shift unshift slice filter forEach some every map indexOf lastIndexOf reduce reduceRight sort reverse".split(" ");for(var g=0;g<m.length;++g)typeof Array.prototype[m[g]]=="function"&&(d.prototype[m[g]]=Array.prototype[m[g]]);r.defineProperty(d.prototype,"length",{value:0,configurable:!1,writable:!0,enumerable:!0}),d.prototype.isOperational=!0;var y=0;d.prototype.toString=function(){var e=Array(y*4+1).join(" "),t="\n"+e+"AggregateError of:"+"\n";y++,e=Array(y*4+1).join(" ");for(var n=0;n<this.length;++n){var r=this[n]===this?"[Circular AggregateError]":this[n]+"",i=r.split("\n");for(var s=0;s<i.length;++s)i[s]=e+i[s];r=i.join("\n"),t+=r+"\n"}return y--,t},o(b,Error);var w=Error.__BluebirdErrorTypes__;w||(w=i({CancellationError:h,TimeoutError:p,OperationalError:b,RejectionError:b,AggregateError:d}),u(Error,"__BluebirdErrorTypes__",w)),t.exports={Error:Error,TypeError:f,RangeError:l,CancellationError:w.CancellationError,OperationalError:w.OperationalError,TimeoutError:w.TimeoutError,AggregateError:w.AggregateError,Warning:c}},{"./es5.js":14,"./util.js":38}],14:[function(e,t,n){var r=function(){"use strict";return this===undefined}();if(r)t.exports={freeze:Object.freeze,defineProperty:Object.defineProperty,getDescriptor:Object.getOwnPropertyDescriptor,keys:Object.keys,names:Object.getOwnPropertyNames,getPrototypeOf:Object.getPrototypeOf,isArray:Array.isArray,isES5:r,propertyIsWritable:function(e,t){var n=Object.getOwnPropertyDescriptor(e,t);return!!(!n||n.writable||n.set)}};else{var i={}.hasOwnProperty,s={}.toString,o={}.constructor.prototype,u=function(e){var t=[];for(var n in e)i.call(e,n)&&t.push(n);return t},a=function(e,t){return{value:e[t]}},f=function(e,t,n){return e[t]=n.value,e},l=function(e){return e},c=function(e){try{return Object(e).constructor.prototype}catch(t){return o}},h=function(e){try{return s.call(e)==="[object Array]"}catch(t){return!1}};t.exports={isArray:h,keys:u,names:u,defineProperty:f,getDescriptor:a,freeze:l,getPrototypeOf:c,isES5:r,propertyIsWritable:function(){return!0}}}},{}],15:[function(e,t,n){"use strict";t.exports=function(e,t){var n=e.map;e.prototype.filter=function(e,r){return n(this,e,r,t)},e.filter=function(e,r,i){return n(e,r,i,t)}}},{}],16:[function(e,t,n){"use strict";t.exports=function(t,n,r){function u(){return this}function a(){throw this}function f(e){return function(){return e}}function l(e){return function(){throw e}}function c(e,t,n){var r;return s(t)?r=n?f(t):l(t):r=n?u:a,e._then(r,o,undefined,t,undefined)}function h(e){var i=this.promise,s=this.handler,o=i._isBound()?s.call(i._boundValue()):s();if(o!==undefined){var u=r(o,i);if(u instanceof t)return u=u._target(),c(u,e,i.isFulfilled())}return i.isRejected()?(n.e=e,n):e}function p(e){var n=this.promise,i=this.handler,s=n._isBound()?i.call(n._boundValue(),e):i(e);if(s!==undefined){var o=r(s,n);if(o instanceof t)return o=o._target(),c(o,e,!0)}return e}var i=e("./util.js"),s=i.isPrimitive,o=i.thrower;t.prototype._passThroughHandler=function(e,t){if(typeof e!="function")return this.then();var n={promise:this,handler:e};return this._then(t?h:p,t?h:undefined,undefined,n,undefined)},t.prototype.lastly=t.prototype["finally"]=function(e){return this._passThroughHandler(e,!0)},t.prototype.tap=function(e){return this._passThroughHandler(e,!1)}}},{"./util.js":38}],17:[function(e,t,n){"use strict";t.exports=function(t,n,r,i){function c(e,n,r){for(var s=0;s<n.length;++s){r._pushContext();var o=f(n[s])(e);r._popContext();if(o===a){r._pushContext();var u=t.reject(a.e);return r._popContext(),u}var l=i(o,r);if(l instanceof t)return l}return null}function h(e,n,i,s){var o=this._promise=new t(r);o._captureStackTrace(),this._stack=s,this._generatorFunction=e,this._receiver=n,this._generator=undefined,this._yieldHandlers=typeof i=="function"?[i].concat(l):l}var s=e("./errors.js"),o=s.TypeError,u=e("./util.js"),a=u.errorObj,f=u.tryCatch,l=[];h.prototype.promise=function(){return this._promise},h.prototype._run=function(){this._generator=this._generatorFunction.call(this._receiver),this._receiver=this._generatorFunction=undefined,this._next(undefined)},h.prototype._continue=function(e){if(e===a)return this._promise._rejectCallback(e.e,!1,!0);var n=e.value;if(e.done===!0)this._promise._resolveCallback(n);else{var r=i(n,this._promise);if(!(r instanceof t)){r=c(r,this._yieldHandlers,this._promise);if(r===null){this._throw(new o("A value %s was yielded that could not be treated as a promise\n\n    See http://goo.gl/4Y4pDk\n\n".replace("%s",n)+"From coroutine:\n"+this._stack.split("\n").slice(1,-7).join("\n")));return}}r._then(this._next,this._throw,undefined,this,null)}},h.prototype._throw=function(e){this._promise._attachExtraTrace(e),this._promise._pushContext();var t=f(this._generator["throw"]).call(this._generator,e);this._promise._popContext(),this._continue(t)},h.prototype._next=function(e){this._promise._pushContext();var t=f(this._generator.next).call(this._generator,e);this._promise._popContext(),this._continue(t)},t.coroutine=function(e,t){if(typeof e!="function")throw new o("generatorFunction must be a function\n\n    See http://goo.gl/6Vqhm0\n");var n=Object(t).yieldHandler,r=h,i=(new Error).stack;return function(){var t=e.apply(this,arguments),s=new r(undefined,undefined,n,i);return s._generator=t,s._next(undefined),s.promise()}},t.coroutine.addYieldHandler=function(e){if(typeof e!="function")throw new o("fn must be a function\n\n    See http://goo.gl/916lJJ\n");l.push(e)},t.spawn=function(e){if(typeof e!="function")return n("generatorFunction must be a function\n\n    See http://goo.gl/6Vqhm0\n");var r=new h(e,this),i=r.promise();return r._run(t.spawn),i}}},{"./errors.js":13,"./util.js":38}],18:[function(e,t,n){"use strict";t.exports=function(t,n,r,i){var s=e("./util.js"),o=s.canEvaluate,u=s.tryCatch,a=s.errorObj,f;t.join=function(){var e=arguments.length-1,s;e>0&&typeof arguments[e]=="function"&&(s=arguments[e]);var d=arguments.length,m=new Array(d);for(var g=0;g<d;++g)m[g]=arguments[g];s&&m.pop();var u=(new n(m)).promise();return s!==undefined?u.spread(s):u}}},{"./util.js":38}],19:[function(e,t,n){"use strict";t.exports=function(t,n,r,i,s){function p(e,t,n,r){this.constructor$(e),this._promise._captureStackTrace();var i=o();this._callback=i===null?t:i.bind(t),this._preservedValues=r===s?new Array(this.length()):null,this._limit=n,this._inFlight=0,this._queue=n>=1?[]:h,u.invoke(d,this,undefined)}function d(){this._init$(undefined,-2)}function v(e,t,n,r){var i=typeof n=="object"&&n!==null?n.concurrency:0;return i=typeof i=="number"&&isFinite(i)&&i>=1?i:0,new p(e,t,i,r)}var o=t._getDomain,u=e("./async.js"),a=e("./util.js"),f=a.tryCatch,l=a.errorObj,c={},h=[];a.inherits(p,n),p.prototype._init=function(){},p.prototype._promiseFulfilled=function(e,n){var r=this._values,s=this.length(),o=this._preservedValues,u=this._limit;if(r[n]===c){r[n]=e;if(u>=1){this._inFlight--,this._drainQueue();if(this._isResolved())return}}else{if(u>=1&&this._inFlight>=u){r[n]=e,this._queue.push(n);return}o!==null&&(o[n]=e);var a=this._callback,h=this._promise._boundValue();this._promise._pushContext();var p=f(a).call(h,e,n,s);this._promise._popContext();if(p===l)return this._reject(p.e);var d=i(p,this._promise);if(d instanceof t){d=d._target();if(d._isPending())return u>=1&&this._inFlight++,r[n]=c,d._proxyPromiseArray(this,n);if(!d._isFulfilled())return this._reject(d._reason());p=d._value()}r[n]=p}var v=++this._totalResolved;v>=s&&(o!==null?this._filter(r,o):this._resolve(r))},p.prototype._drainQueue=function(){var e=this._queue,t=this._limit,n=this._values;while(e.length>0&&this._inFlight<t){if(this._isResolved())return;var r=e.pop();this._promiseFulfilled(n[r],r)}},p.prototype._filter=function(e,t){var n=t.length,r=new Array(n),i=0;for(var s=0;s<n;++s)e[s]&&(r[i++]=t[s]);r.length=i,this._resolve(r)},p.prototype.preservedValues=function(){return this._preservedValues},t.prototype.map=function(e,t){return typeof e!="function"?r("fn must be a function\n\n    See http://goo.gl/916lJJ\n"):v(this,e,t,null).promise()},t.map=function(e,t,n,i){return typeof t!="function"?r("fn must be a function\n\n    See http://goo.gl/916lJJ\n"):v(e,t,n,i).promise()}}},{"./async.js":2,"./util.js":38}],20:[function(e,t,n){"use strict";t.exports=function(t,n,r,i){var s=e("./util.js"),o=s.tryCatch;t.method=function(e){if(typeof e!="function")throw new t.TypeError("fn must be a function\n\n    See http://goo.gl/916lJJ\n");return function(){var r=new t(n);r._captureStackTrace(),r._pushContext();var i=o(e).apply(this,arguments);return r._popContext(),r._resolveFromSyncValue(i),r}},t.attempt=t["try"]=function(e,r,u){if(typeof e!="function")return i("fn must be a function\n\n    See http://goo.gl/916lJJ\n");var a=new t(n);a._captureStackTrace(),a._pushContext();var f=s.isArray(r)?o(e).apply(u,r):o(e).call(u,r);return a._popContext(),a._resolveFromSyncValue(f),a},t.prototype._resolveFromSyncValue=function(e){e===s.errorObj?this._rejectCallback(e.e,!1,!0):this._resolveCallback(e,!0)}}},{"./util.js":38}],21:[function(e,t,n){"use strict";t.exports=function(t){function o(e,t){var o=this;if(!n.isArray(e))return u.call(o,e,t);var a=i(t).apply(o._boundValue(),[null].concat(e));a===s&&r.throwLater(a.e)}function u(e,t){var n=this,o=n._boundValue(),u=e===undefined?i(t).call(o,null):i(t).call(o,null,e);u===s&&r.throwLater(u.e)}function a(e,t){var n=this;if(!e){var o=n._target(),u=o._getCarriedStackTrace();u.cause=e,e=u}var a=i(t).call(n._boundValue(),e);a===s&&r.throwLater(a.e)}var n=e("./util.js"),r=e("./async.js"),i=n.tryCatch,s=n.errorObj;t.prototype.asCallback=t.prototype.nodeify=function(e,t){if(typeof e=="function"){var n=u;t!==undefined&&Object(t).spread&&(n=o),this._then(n,a,undefined,this,e)}return this}}},{"./async.js":2,"./util.js":38}],22:[function(e,t,n){"use strict";t.exports=function(t,n){var r=e("./util.js"),i=e("./async.js"),s=r.tryCatch,o=r.errorObj;t.prototype.progressed=function(e){return this._then(undefined,undefined,e,undefined,undefined)},t.prototype._progress=function(e){if(this._isFollowingOrFulfilledOrRejected())return;this._target()._progressUnchecked(e)},t.prototype._progressHandlerAt=function(e){return e===0?this._progressHandler0:this[(e<<2)+e-5+2]},t.prototype._doProgressWith=function(e){var n=e.value,i=e.handler,u=e.promise,a=e.receiver,f=s(i).call(a,n);if(f===o){if(f.e!=null&&f.e.name!=="StopProgressPropagation"){var l=r.canAttachTrace(f.e)?f.e:new Error(r.toString(f.e));u._attachExtraTrace(l),u._progress(f.e)}}else f instanceof t?f._then(u._progress,null,null,u,undefined):u._progress(f)},t.prototype._progressUnchecked=function(e){var r=this._length(),s=this._progress;for(var o=0;o<r;o++){var u=this._progressHandlerAt(o),a=this._promiseAt(o);if(!(a instanceof t)){var f=this._receiverAt(o);typeof u=="function"?u.call(f,e,a):f instanceof n&&!f._isResolved()&&f._promiseProgressed(e,a);continue}typeof u=="function"?i.invoke(this._doProgressWith,this,{handler:u,promise:a,receiver:this._receiverAt(o),value:e}):i.invoke(s,a,e)}}}},{"./async.js":2,"./util.js":38}],23:[function(e,t,n){"use strict";t.exports=function(){function S(e){if(typeof e!="function")throw new a("the promise constructor requires a resolver function\n\n    See http://goo.gl/EC22Yn\n");if(this.constructor!==S)throw new a("the promise constructor cannot be invoked directly\n\n    See http://goo.gl/KsIlge\n");this._bitField=0,this._fulfillmentHandler0=undefined,this._rejectionHandler0=undefined,this._progressHandler0=undefined,this._promise0=undefined,this._receiver0=undefined,this._settledValue=undefined,e!==f&&this._resolveFromResolver(e)}function x(e){var t=new S(f);t._fulfillmentHandler0=e,t._rejectionHandler0=e,t._progressHandler0=e,t._promise0=e,t._receiver0=e,t._settledValue=e}var t=function(){return new a("circular promise resolution chain\n\n    See http://goo.gl/LhFpo0\n")},n=function(){return new S.PromiseInspection(this._target())},r=function(e){return S.reject(new a(e))},i=e("./util.js"),s;i.isNode?s=function(){var e=process.domain;return e===undefined&&(e=null),e}:s=function(){return null},i.notEnumerableProp(S,"_getDomain",s);var o=e("./async.js"),u=e("./errors.js"),a=S.TypeError=u.TypeError;S.RangeError=u.RangeError,S.CancellationError=u.CancellationError,S.TimeoutError=u.TimeoutError,S.OperationalError=u.OperationalError,S.RejectionError=u.OperationalError,S.AggregateError=u.AggregateError;var f=function(){},l={},c={e:null},h=e("./thenables.js")(S,f),p=e("./promise_array.js")(S,f,h,r),d=e("./captured_trace.js")(),v=e("./debuggability.js")(S,d),m=e("./context.js")(S,d,v),g=e("./catch_filter.js")(c),y=e("./promise_resolver.js"),b=y._nodebackForPromise,w=i.errorObj,E=i.tryCatch;return S.prototype.toString=function(){return"[object Promise]"},S.prototype.caught=S.prototype["catch"]=function(e){var t=arguments.length;if(t>1){var n=new Array(t-1),r=0,i;for(i=0;i<t-1;++i){var s=arguments[i];if(typeof s!="function")return S.reject(new a("Catch filter must inherit from Error or be a simple predicate function\n\n    See http://goo.gl/o84o68\n"));n[r++]=s}n.length=r,e=arguments[i];var o=new g(n,e,this);return this._then(undefined,o.doFilter,undefined,o,undefined)}return this._then(undefined,e,undefined,undefined,undefined)},S.prototype.reflect=function(){return this._then(n,n,undefined,this,undefined)},S.prototype.then=function(e,t,n){if(v()&&arguments.length>0&&typeof e!="function"&&typeof t!="function"){var r=".then() only accepts functions but was passed: "+i.classString(e);arguments.length>1&&(r+=", "+i.classString(t)),this._warn(r)}return this._then(e,t,n,undefined,undefined)},S.prototype.done=function(e,t,n){var r=this._then(e,t,n,undefined,undefined);r._setIsFinal()},S.prototype.spread=function(e,t){return this.all()._then(e,t,undefined,l,undefined)},S.prototype.isCancellable=function(){return!this.isResolved()&&this._cancellable()},S.prototype.toJSON=function(){var e={isFulfilled:!1,isRejected:!1,fulfillmentValue:undefined,rejectionReason:undefined};return this.isFulfilled()?(e.fulfillmentValue=this.value(),e.isFulfilled=!0):this.isRejected()&&(e.rejectionReason=this.reason(),e.isRejected=!0),e},S.prototype.all=function(){return(new p(this)).promise()},S.prototype.error=function(e){return this.caught(i.originatesFromRejection,e)},S.is=function(e){return e instanceof S},S.fromNode=function(e){var t=new S(f),n=E(e)(b(t));return n===w&&t._rejectCallback(n.e,!0,!0),t},S.all=function(e){return(new p(e)).promise()},S.defer=S.pending=function(){var e=new S(f);return new y(e)},S.cast=function(e){var t=h(e);if(!(t instanceof S)){var n=t;t=new S(f),t._fulfillUnchecked(n)}return t},S.resolve=S.fulfilled=S.cast,S.reject=S.rejected=function(e){var t=new S(f);return t._captureStackTrace(),t._rejectCallback(e,!0),t},S.setScheduler=function(e){if(typeof e!="function")throw new a("fn must be a function\n\n    See http://goo.gl/916lJJ\n");var t=o._schedule;return o._schedule=e,t},S.prototype._then=function(e,t,n,r,i){var u=i!==undefined,a=u?i:new S(f);u||(a._propagateFrom(this,5),a._captureStackTrace());var l=this._target();l!==this&&(r===undefined&&(r=this._boundTo),u||a._setIsMigrated());var c=l._addCallbacks(e,t,n,a,r,s());return l._isResolved()&&!l._isSettlePromisesQueued()&&o.invoke(l._settlePromiseAtPostResolution,l,c),a},S.prototype._settlePromiseAtPostResolution=function(e){this._isRejectionUnhandled()&&this._unsetRejectionIsUnhandled(),this._settlePromiseAt(e)},S.prototype._length=function(){return this._bitField&131071},S.prototype._isFollowingOrFulfilledOrRejected=function(){return(this._bitField&939524096)>0},S.prototype._isFollowing=function(){return(this._bitField&536870912)===536870912},S.prototype._setLength=function(e){this._bitField=this._bitField&-131072|e&131071},S.prototype._setFulfilled=function(){this._bitField=this._bitField|268435456},S.prototype._setRejected=function(){this._bitField=this._bitField|134217728},S.prototype._setFollowing=function(){this._bitField=this._bitField|536870912},S.prototype._setIsFinal=function(){this._bitField=this._bitField|33554432},S.prototype._isFinal=function(){return(this._bitField&33554432)>0},S.prototype._cancellable=function(){return(this._bitField&67108864)>0},S.prototype._setCancellable=function(){this._bitField=this._bitField|67108864},S.prototype._unsetCancellable=function(){this._bitField=this._bitField&-67108865},S.prototype._setIsMigrated=function(){this._bitField=this._bitField|4194304},S.prototype._unsetIsMigrated=function(){this._bitField=this._bitField&-4194305},S.prototype._isMigrated=function(){return(this._bitField&4194304)>0},S.prototype._receiverAt=function(e){var t=e===0?this._receiver0:this[e*5-5+4];return t===undefined&&this._isBound()?this._boundValue():t},S.prototype._promiseAt=function(e){return e===0?this._promise0:this[e*5-5+3]},S.prototype._fulfillmentHandlerAt=function(e){return e===0?this._fulfillmentHandler0:this[e*5-5+0]},S.prototype._rejectionHandlerAt=function(e){return e===0?this._rejectionHandler0:this[e*5-5+1]},S.prototype._boundValue=function(){var e=this._boundTo;return e!==undefined&&e instanceof S?e.isFulfilled()?e.value():undefined:e},S.prototype._migrateCallbacks=function(e,t){var n=e._fulfillmentHandlerAt(t),r=e._rejectionHandlerAt(t),i=e._progressHandlerAt(t),s=e._promiseAt(t),o=e._receiverAt(t);s instanceof S&&s._setIsMigrated(),this._addCallbacks(n,r,i,s,o,null)},S.prototype._addCallbacks=function(e,t,n,r,i,s){var o=this._length();o>=131066&&(o=0,this._setLength(0));if(o===0)this._promise0=r,i!==undefined&&(this._receiver0=i),typeof e=="function"&&!this._isCarryingStackTrace()&&(this._fulfillmentHandler0=s===null?e:s.bind(e)),typeof t=="function"&&(this._rejectionHandler0=s===null?t:s.bind(t)),typeof n=="function"&&(this._progressHandler0=s===null?n:s.bind(n));else{var u=o*5-5;this[u+3]=r,this[u+4]=i,typeof e=="function"&&(this[u+0]=s===null?e:s.bind(e)),typeof t=="function"&&(this[u+1]=s===null?t:s.bind(t)),typeof n=="function"&&(this[u+2]=s===null?n:s.bind(n))}return this._setLength(o+1),o},S.prototype._setProxyHandlers=function(e,t){var n=this._length();n>=131066&&(n=0,this._setLength(0));if(n===0)this._promise0=t,this._receiver0=e;else{var r=n*5-5;this[r+3]=t,this[r+4]=e}this._setLength(n+1)},S.prototype._proxyPromiseArray=function(e,t){this._setProxyHandlers(e,t)},S.prototype._resolveCallback=function(e,n){if(this._isFollowingOrFulfilledOrRejected())return;if(e===this)return this._rejectCallback(t(),!1,!0);var r=h(e,this);if(!(r instanceof S))return this._fulfill(e);var i=1|(n?4:0);this._propagateFrom(r,i);var s=r._target();if(s._isPending()){var o=this._length();for(var u=0;u<o;++u)s._migrateCallbacks(this,u);this._setFollowing(),this._setLength(0),this._setFollowee(s)}else s._isFulfilled()?this._fulfillUnchecked(s._value()):this._rejectUnchecked(s._reason(),s._getCarriedStackTrace())},S.prototype._rejectCallback=function(e,t,n){n||i.markAsOriginatingFromRejection(e);var r=i.ensureErrorObject(e),s=r===e;this._attachExtraTrace(r,t?s:!1),this._reject(e,s?undefined:r)},S.prototype._resolveFromResolver=function(e){var t=this;this._captureStackTrace(),this._pushContext();var n=!0,r=E(e)(function(e){if(t===null)return;t._resolveCallback(e),t=null},function(e){if(t===null)return;t._rejectCallback(e,n),t=null});n=!1,this._popContext(),r!==undefined&&r===w&&t!==null&&(t._rejectCallback(r.e,!0,!0),t=null)},S.prototype._settlePromiseFromHandler=function(e,n,r,i){if(i._isRejected())return;i._pushContext();var s;n===l&&!this._isRejected()?s=E(e).apply(this._boundValue(),r):s=E(e).call(n,r),i._popContext();if(s===w||s===i||s===c){var o=s===i?t():s.e;i._rejectCallback(o,!1,!0)}else i._resolveCallback(s)},S.prototype._target=function(){var e=this;while(e._isFollowing())e=e._followee();return e},S.prototype._followee=function(){return this._rejectionHandler0},S.prototype._setFollowee=function(e){this._rejectionHandler0=e},S.prototype._cleanValues=function(){this._cancellable()&&(this._cancellationParent=undefined)},S.prototype._propagateFrom=function(e,t){(t&1)>0&&e._cancellable()&&(this._setCancellable(),this._cancellationParent=e),(t&4)>0&&e._isBound()&&this._setBoundTo(e._boundTo)},S.prototype._fulfill=function(e){if(this._isFollowingOrFulfilledOrRejected())return;this._fulfillUnchecked(e)},S.prototype._reject=function(e,t){if(this._isFollowingOrFulfilledOrRejected())return;this._rejectUnchecked(e,t)},S.prototype._settlePromiseAt=function(e){var t=this._promiseAt(e),n=t instanceof S;if(n&&t._isMigrated())return t._unsetIsMigrated(),o.invoke(this._settlePromiseAt,this,e);var r=this._isFulfilled()?this._fulfillmentHandlerAt(e):this._rejectionHandlerAt(e),i=this._isCarryingStackTrace()?this._getCarriedStackTrace():undefined,s=this._settledValue,u=this._receiverAt(e);this._clearCallbackDataAtIndex(e),typeof r=="function"?n?this._settlePromiseFromHandler(r,u,s,t):r.call(u,s,t):u instanceof p?u._isResolved()||(this._isFulfilled()?u._promiseFulfilled(s,t):u._promiseRejected(s,t)):n&&(this._isFulfilled()?t._fulfill(s):t._reject(s,i)),e>=4&&(e&31)===4&&o.invokeLater(this._setLength,this,0)},S.prototype._clearCallbackDataAtIndex=function(e){if(e===0)this._isCarryingStackTrace()||(this._fulfillmentHandler0=undefined),this._rejectionHandler0=this._progressHandler0=this._receiver0=this._promise0=undefined;else{var t=e*5-5;this[t+3]=this[t+4]=this[t+0]=this[t+1]=this[t+2]=undefined}},S.prototype._isSettlePromisesQueued=function(){return(this._bitField&-1073741824)===-1073741824},S.prototype._setSettlePromisesQueued=function(){this._bitField=this._bitField|-1073741824},S.prototype._unsetSettlePromisesQueued=function(){this._bitField=this._bitField&1073741823},S.prototype._queueSettlePromises=function(){o.settlePromises(this),this._setSettlePromisesQueued()},S.prototype._fulfillUnchecked=function(e){if(e===this){var n=t();return this._attachExtraTrace(n),this._rejectUnchecked(n,undefined)}this._setFulfilled(),this._settledValue=e,this._cleanValues(),this._length()>0&&this._queueSettlePromises()},S.prototype._rejectUncheckedCheckError=function(e){var t=i.ensureErrorObject(e);this._rejectUnchecked(e,t===e?undefined:t)},S.prototype._rejectUnchecked=function(e,n){if(e===this){var r=t();return this._attachExtraTrace(r),this._rejectUnchecked(r)}this._setRejected(),this._settledValue=e,this._cleanValues();if(this._isFinal()){o.throwLater(function(e){throw"stack"in e&&o.invokeFirst(d.unhandledRejection,undefined,e),e},n===undefined?e:n);return}n!==undefined&&n!==e&&this._setCarriedStackTrace(n),this._length()>0?this._queueSettlePromises():this._ensurePossibleRejectionHandled()},S.prototype._settlePromises=function(){this._unsetSettlePromisesQueued();var e=this._length();for(var t=0;t<e;t++)this._settlePromiseAt(t)},i.notEnumerableProp(S,"_makeSelfResolutionError",t),e("./progress.js")(S,p),e("./method.js")(S,f,h,r),e("./bind.js")(S,f,h),e("./finally.js")(S,c,h),e("./direct_resolve.js")(S),e("./synchronous_inspection.js")(S),e("./join.js")(S,p,h,f),S.Promise=S,e("./map.js")(S,p,r,h,f),e("./cancel.js")(S),e("./using.js")(S,r,h,m),e("./generators.js")(S,r,f,h),e("./nodeify.js")(S),e("./call_get.js")(S),e("./props.js")(S,p,h,r),e("./race.js")(S,f,h,r),e("./reduce.js")(S,p,r,h,f),e("./settle.js")(S,p),e("./some.js")(S,p,r),e("./promisify.js")(S,f),e("./any.js")(S),e("./each.js")(S,f),e("./timers.js")(S,f),e("./filter.js")(S,f),i.toFastProperties(S),i.toFastProperties(S.prototype),x({a:1}),x({b:2}),x({c:3}),x(1),x(function(){}),x(undefined),x(!1),x(new S(f)),d.setBounds(o.firstLineError,i.lastLineError),S}},{"./any.js":1,"./async.js":2,"./bind.js":3,"./call_get.js":5,"./cancel.js":6,"./captured_trace.js":7,"./catch_filter.js":8,"./context.js":9,"./debuggability.js":10,"./direct_resolve.js":11,"./each.js":12,"./errors.js":13,"./filter.js":15,"./finally.js":16,"./generators.js":17,"./join.js":18,"./map.js":19,"./method.js":20,"./nodeify.js":21,"./progress.js":22,"./promise_array.js":24,"./promise_resolver.js":25,"./promisify.js":26,"./props.js":27,"./race.js":29,"./reduce.js":30,"./settle.js":32,"./some.js":33,"./synchronous_inspection.js":34,"./thenables.js":35,"./timers.js":36,"./using.js":37,"./util.js":38}],24:[function(e,t,n){"use strict";t.exports=function(t,n,r,i){function u(e){switch(e){case-2:return[];case-3:return{}}}function a(e){var r=this._promise=new t(n),i;e instanceof t&&(i=e,r._propagateFrom(i,5)),this._values=e,this._length=0,this._totalResolved=0,this._init(undefined,-2)}var s=e("./util.js"),o=s.isArray;return a.prototype.length=function(){return this._length},a.prototype.promise=function(){return this._promise},a.prototype._init=function f(e,n){var s=r(this._values,this._promise);if(s instanceof t){s=s._target(),this._values=s;if(!s._isFulfilled()){if(s._isPending()){s._then(f,this._reject,undefined,this,n);return}this._reject(s._reason());return}s=s._value();if(!o(s)){var a=new t.TypeError("expecting an array, a promise or a thenable\n\n    See http://goo.gl/s8MMhc\n");this.__hardReject__(a);return}}else if(!o(s)){this._promise._reject(i("expecting an array, a promise or a thenable\n\n    See http://goo.gl/s8MMhc\n")._reason());return}if(s.length===0){n===-5?this._resolveEmptyArray():this._resolve(u(n));return}var l=this.getActualLength(s.length);this._length=l,this._values=this.shouldCopyValues()?new Array(l):this._values;var c=this._promise;for(var h=0;h<l;++h){var p=this._isResolved(),d=r(s[h],c);d instanceof t?(d=d._target(),p?d._ignoreRejections():d._isPending()?d._proxyPromiseArray(this,h):d._isFulfilled()?this._promiseFulfilled(d._value(),h):this._promiseRejected(d._reason(),h)):p||this._promiseFulfilled(d,h)}},a.prototype._isResolved=function(){return this._values===null},a.prototype._resolve=function(e){this._values=null,this._promise._fulfill(e)},a.prototype.__hardReject__=a.prototype._reject=function(e){this._values=null,this._promise._rejectCallback(e,!1,!0)},a.prototype._promiseProgressed=function(e,t){this._promise._progress({index:t,value:e})},a.prototype._promiseFulfilled=function(e,t){this._values[t]=e;var n=++this._totalResolved;n>=this._length&&this._resolve(this._values)},a.prototype._promiseRejected=function(e,t){this._totalResolved++,this._reject(e)},a.prototype.shouldCopyValues=function(){return!0},a.prototype.getActualLength=function(e){return e},a}},{"./util.js":38}],25:[function(e,t,n){"use strict";function l(e){return e instanceof Error&&f.getPrototypeOf(e)===Error.prototype}function h(e){var t;if(l(e)){t=new u(e),t.name=e.name,t.message=e.message,t.stack=e.stack;var n=f.keys(e);for(var i=0;i<n.length;++i){var s=n[i];c.test(s)||(t[s]=e[s])}return t}return r.markAsOriginatingFromRejection(e),e}function p(e){return function(t,n){if(e===null)return;if(t){var r=h(i(t));e._attachExtraTrace(r),e._reject(r)}else if(arguments.length>2){var s=arguments.length,o=new Array(s-1);for(var u=1;u<s;++u)o[u-1]=arguments[u];e._fulfill(o)}else e._fulfill(n);e=null}}var r=e("./util.js"),i=r.maybeWrapAsError,s=e("./errors.js"),o=s.TimeoutError,u=s.OperationalError,a=r.haveGetters,f=e("./es5.js"),c=/^(?:name|message|stack|cause)$/,d;a?d=function(e){this.promise=e}:d=function(e){this.promise=e,this.asCallback=p(e),this.callback=this.asCallback};if(a){var v={get:function(){return p(this.promise)}};f.defineProperty(d.prototype,"asCallback",v),f.defineProperty(d.prototype,"callback",v)}d._nodebackForPromise=p,d.prototype.toString=function(){return"[object PromiseResolver]"},d.prototype.resolve=d.prototype.fulfill=function(e){if(!(this instanceof d))throw new TypeError("Illegal invocation, resolver resolve/reject must be called within a resolver context. Consider using the promise constructor instead.\n\n    See http://goo.gl/sdkXL9\n");this.promise._resolveCallback(e)},d.prototype.reject=function(e){if(!(this instanceof d))throw new TypeError("Illegal invocation, resolver resolve/reject must be called within a resolver context. Consider using the promise constructor instead.\n\n    See http://goo.gl/sdkXL9\n");this.promise._rejectCallback(e)},d.prototype.progress=function(e){if(!(this instanceof d))throw new TypeError("Illegal invocation, resolver resolve/reject must be called within a resolver context. Consider using the promise constructor instead.\n\n    See http://goo.gl/sdkXL9\n");this.promise._progress(e)},d.prototype.cancel=function(e){this.promise.cancel(e)},d.prototype.timeout=function(){this.reject(new o("timeout"))},d.prototype.isResolved=function(){return this.promise.isResolved()},d.prototype.toJSON=function(){return this.promise.toJSON()},t.exports=d},{"./errors.js":13,"./es5.js":14,"./util.js":38}],26:[function(e,t,n){"use strict";t.exports=function(t,n){function v(e){return!p.test(e)}function m(e){try{return e.__isPromisified__===!0}catch(t){return!1}}function g(e,t,n){var r=i.getDataPropertyOrDefault(e,t+n,c);return r?m(r):!1}function y(e,t,n){for(var r=0;r<e.length;r+=2){var i=e[r];if(n.test(i)){var s=i.replace(n,"");for(var o=0;o<e.length;o+=2)if(e[o]===s)throw new f("Cannot promisify an API that has normal methods with '%s'-suffix\n\n    See http://goo.gl/iWrZbw\n".replace("%s",t))}}}function b(e,t,n,r){var s=i.inheritedDataKeys(e),o=[];for(var u=0;u<s.length;++u){var a=s[u],f=e[a],l=r===d?!0:d(a,f,e);typeof f=="function"&&!m(f)&&!g(e,a,t)&&r(a,f,e,l)&&o.push(a,f)}return y(o,t,n),o}function C(e,a,f,l){function p(){var i=a;a===r&&(i=this);var f=new t(n);f._captureStackTrace();var l=typeof h=="string"&&this!==c?this[h]:e,p=s(f);try{l.apply(i,o(arguments,p))}catch(d){f._rejectCallback(u(d),!0,!0)}return f}var c=function(){return this}(),h=e;return typeof h=="string"&&(e=l),i.notEnumerableProp(p,"__isPromisified__",!0),p}function L(e,t,n,s){var o=new RegExp(w(t)+"$"),u=b(e,t,o,n);for(var a=0,f=u.length;a<f;a+=2){var l=u[a],c=u[a+1],h=l+t;e[h]=s===k?k(l,r,l,c,t):s(c,function(){return k(l,r,l,c,t)})}return i.toFastProperties(e),e}function A(e,t){return k(e,t,undefined,e)}var r={},i=e("./util.js"),s=e("./promise_resolver.js")._nodebackForPromise,o=i.withAppended,u=i.maybeWrapAsError,a=i.canEvaluate,f=e("./errors").TypeError,l="Async",c={__isPromisified__:!0},h=["arity","length","name","arguments","caller","callee","prototype","__isPromisified__"],p=new RegExp("^(?:"+h.join("|")+")$"),d=function(e){return i.isIdentifier(e)&&e.charAt(0)!=="_"&&e!=="constructor"},w=function(e){return e.replace(/([$])/,"\\$")},E,k=a?E:C;t.promisify=function(e,t){if(typeof e!="function")throw new f("fn must be a function\n\n    See http://goo.gl/916lJJ\n");if(m(e))return e;var n=A(e,arguments.length<2?r:t);return i.copyDescriptors(e,n,v),n},t.promisifyAll=function(e,t){if(typeof e!="function"&&typeof e!="object")throw new f("the target of promisifyAll must be an object or a function\n\n    See http://goo.gl/9ITlV0\n");t=Object(t);var n=t.suffix;typeof n!="string"&&(n=l);var r=t.filter;typeof r!="function"&&(r=d);var s=t.promisifier;typeof s!="function"&&(s=k);if(!i.isIdentifier(n))throw new RangeError("suffix must be a valid identifier\n\n    See http://goo.gl/8FZo5V\n");var o=i.inheritedDataKeys(e);for(var u=0;u<o.length;++u){var a=e[o[u]];o[u]!=="constructor"&&i.isClass(a)&&(L(a.prototype,n,r,s),L(a,n,r,s))}return L(e,n,r,s)}}},{"./errors":13,"./promise_resolver.js":25,"./util.js":38}],27:[function(e,t,n){"use strict";t.exports=function(t,n,r,i){function a(e){var t=u.keys(e),n=t.length,r=new Array(n*2);for(var i=0;i<n;++i){var s=t[i];r[i]=e[s],r[i+n]=s}this.constructor$(r)}function f(e){var n,s=r(e);return o(s)?(s instanceof t?n=s._then(t.props,undefined,undefined,undefined,undefined):n=(new a(s)).promise(),s instanceof t&&n._propagateFrom(s,4),n):i("cannot await properties of a non-object\n\n    See http://goo.gl/OsFKC8\n")}var s=e("./util.js"),o=s.isObject,u=e("./es5.js");s.inherits(a,n),a.prototype._init=function(){this._init$(undefined,-3)},a.prototype._promiseFulfilled=function(e,t){this._values[t]=e;var n=++this._totalResolved;if(n>=this._length){var r={},i=this.length();for(var s=0,o=this.length();s<o;++s)r[this._values[s+i]]=this._values[s];this._resolve(r)}},a.prototype._promiseProgressed=function(e,t){this._promise._progress({key:this._values[t+this.length()],value:e})},a.prototype.shouldCopyValues=function(){return!1},a.prototype.getActualLength=function(e){return e>>1},t.prototype.props=function(){return f(this)},t.props=function(e){return f(e)}}},{"./es5.js":14,"./util.js":38}],28:[function(e,t,n){"use strict";function r(e,t,n,r,i){for(var s=0;s<i;++s)n[s+r]=e[s+t],e[s+t]=void 0}function i(e){this._capacity=e,this._length=0,this._front=0}i.prototype._willBeOverCapacity=function(e){return this._capacity<e},i.prototype._pushOne=function(e){var t=this.length();this._checkCapacity(t+1);var n=this._front+t&this._capacity-1;this[n]=e,this._length=t+1},i.prototype._unshiftOne=function(e){var t=this._capacity;this._checkCapacity(this.length()+1);var n=this._front,r=(n-1&t-1^t)-t;this[r]=e,this._front=r,this._length=this.length()+1},i.prototype.unshift=function(e,t,n){this._unshiftOne(n),this._unshiftOne(t),this._unshiftOne(e)},i.prototype.push=function(e,t,n){var r=this.length()+3;if(this._willBeOverCapacity(r)){this._pushOne(e),this._pushOne(t),this._pushOne(n);return}var i=this._front+r-3;this._checkCapacity(r);var s=this._capacity-1;this[i+0&s]=e,this[i+1&s]=t,this[i+2&s]=n,this._length=r},i.prototype.shift=function(){var e=this._front,t=this[e];return this[e]=undefined,this._front=e+1&this._capacity-1,this._length--,t},i.prototype.length=function(){return this._length},i.prototype._checkCapacity=function(e){this._capacity<e&&this._resizeTo(this._capacity<<1)},i.prototype._resizeTo=function(e){var t=this._capacity;this._capacity=e;var n=this._front,i=this._length,s=n+i&t-1;r(this,0,this,t,s)},t.exports=i},{}],29:[function(e,t,n){"use strict";t.exports=function(t,n,r,i){function u(e,u){var a=r(e);if(a instanceof t)return o(a);if(!s(e))return i("expecting an array, a promise or a thenable\n\n    See http://goo.gl/s8MMhc\n");var f=new t(n);u!==undefined&&f._propagateFrom(u,5);var l=f._fulfill,c=f._reject;for(var h=0,p=e.length;h<p;++h){var d=e[h];if(!(d!==undefined||h in e))continue;t.cast(d)._then(l,c,undefined,f,null)}return f}var s=e("./util.js").isArray,o=function(e){return e.then(function(t){return u(t,e)})};t.race=function(e){return u(e,undefined)},t.prototype.race=function(){return u(this,undefined)}}},{"./util.js":38}],30:[function(e,t,n){"use strict";t.exports=function(t,n,r,i,s){function c(e,n,r,a){this.constructor$(e),this._promise._captureStackTrace(),this._preservedValues=a===s?[]:null,this._zerothIsAccum=r===undefined,this._gotAccum=!1,this._reducingIndex=this._zerothIsAccum?1:0,this._valuesPhase=undefined;var f=i(r,this._promise),l=!1,c=f instanceof t;c&&(f=f._target(),f._isPending()?f._proxyPromiseArray(this,-1):f._isFulfilled()?(r=f._value(),this._gotAccum=!0):(this._reject(f._reason()),l=!0)),!c&&!this._zerothIsAccum&&(this._gotAccum=!0);var p=o();this._callback=p===null?n:p.bind(n),this._accum=r,l||u.invoke(h,this,undefined)}function h(){this._init$(undefined,-5)}function p(e,t,n,i){if(typeof t!="function")return r("fn must be a function\n\n    See http://goo.gl/916lJJ\n");var s=new c(e,t,n,i);return s.promise()}var o=t._getDomain,u=e("./async.js"),a=e("./util.js"),f=a.tryCatch,l=a.errorObj;a.inherits(c,n),c.prototype._init=function(){},c.prototype._resolveEmptyArray=function(){(this._gotAccum||this._zerothIsAccum)&&this._resolve(this._preservedValues!==null?[]:this._accum)},c.prototype._promiseFulfilled=function(e,n){var r=this._values;r[n]=e;var s=this.length(),o=this._preservedValues,u=o!==null,a=this._gotAccum,c=this._valuesPhase,h;if(!c){c=this._valuesPhase=new Array(s);for(h=0;h<s;++h)c[h]=0}h=c[n],n===0&&this._zerothIsAccum?(this._accum=e,this._gotAccum=a=!0,c[n]=h===0?1:2):n===-1?(this._accum=e,this._gotAccum=a=!0):h===0?c[n]=1:(c[n]=2,this._accum=e);if(!a)return;var p=this._callback,d=this._promise._boundValue(),v;for(var m=this._reducingIndex;m<s;++m){h=c[m];if(h===2){this._reducingIndex=m+1;continue}if(h!==1)return;e=r[m],this._promise._pushContext(),u?(o.push(e),v=f(p).call(d,e,m,s)):v=f(p).call(d,this._accum,e,m,s),this._promise._popContext();if(v===l)return this._reject(v.e);var g=i(v,this._promise);if(g instanceof t){g=g._target();if(g._isPending())return c[m]=4,g._proxyPromiseArray(this,m);if(!g._isFulfilled())return this._reject(g._reason());v=g._value()}this._reducingIndex=m+1,this._accum=v}this._resolve(u?o:this._accum)},t.prototype.reduce=function(e,t){return p(this,e,t,null)},t.reduce=function(e,t,n,r){return p(e,t,n,r)}}},{"./async.js":2,"./util.js":38}],31:[function(e,t,n){"use strict";var r,i=e("./util"),s=function(){throw new Error("No async scheduler available\n\n    See http://goo.gl/m3OTXk\n")};if(i.isNode&&typeof MutationObserver=="undefined"){var o=global.setImmediate,u=process.nextTick;r=i.isRecentNode?function(e){o.call(global,e)}:function(e){u.call(process,e)}}else typeof MutationObserver!="undefined"&&(typeof window=="undefined"||!window.navigator||!window.navigator.standalone)?(r=function(e){var t=document.createElement("div"),n=new MutationObserver(e);return n.observe(t,{attributes:!0}),function(){t.classList.toggle("foo")}},r.isStatic=!0):typeof setImmediate!="undefined"?r=function(e){setImmediate(e)}:typeof setTimeout!="undefined"?r=function(e){setTimeout(e,0)}:r=s;t.exports=r},{"./util":38}],32:[function(e,t,n){"use strict";t.exports=function(t,n){function s(e){this.constructor$(e)}var r=t.PromiseInspection,i=e("./util.js");i.inherits(s,n),s.prototype._promiseResolved=function(e,t){this._values[e]=t;var n=++this._totalResolved;n>=this._length&&this._resolve(this._values)},s.prototype._promiseFulfilled=function(e,t){var n=new r;n._bitField=268435456,n._settledValue=e,this._promiseResolved(t,n)},s.prototype._promiseRejected=function(e,t){var n=new r;n._bitField=134217728,n._settledValue=e,this._promiseResolved(t,n)},t.settle=function(e){return(new s(e)).promise()},t.prototype.settle=function(){return(new s(this)).promise()}}},{"./util.js":38}],33:[function(e,t,n){"use strict";t.exports=function(t,n,r){function a(e){this.constructor$(e),this._howMany=0,this._unwrap=!1,this._initialized=!1}function f(e,t){if((t|0)!==t||t<0)return r("expecting a positive integer\n\n    See http://goo.gl/1wAmHx\n");var n=new a(e),i=n.promise();return n.setHowMany(t),n.init(),i}var i=e("./util.js"),s=e("./errors.js").RangeError,o=e("./errors.js").AggregateError,u=i.isArray;i.inherits(a,n),a.prototype._init=function(){if(!this._initialized)return;if(this._howMany===0){this._resolve([]);return}this._init$(undefined,-5);var e=u(this._values);!this._isResolved()&&e&&this._howMany>this._canPossiblyFulfill()&&this._reject(this._getRangeError(this.length()))},a.prototype.init=function(){this._initialized=!0,this._init()},a.prototype.setUnwrap=function(){this._unwrap=!0},a.prototype.howMany=function(){return this._howMany},a.prototype.setHowMany=function(e){this._howMany=e},a.prototype._promiseFulfilled=function(e){this._addFulfilled(e),this._fulfilled()===this.howMany()&&(this._values.length=this.howMany(),this.howMany()===1&&this._unwrap?this._resolve(this._values[0]):this._resolve(this._values))},a.prototype._promiseRejected=function(e){this._addRejected(e);if(this.howMany()>this._canPossiblyFulfill()){var t=new o;for(var n=this.length();n<this._values.length;++n)t.push(this._values[n]);this._reject(t)}},a.prototype._fulfilled=function(){return this._totalResolved},a.prototype._rejected=function(){return this._values.length-this.length()},a.prototype._addRejected=function(e){this._values.push(e)},a.prototype._addFulfilled=function(e){this._values[this._totalResolved++]=e},a.prototype._canPossiblyFulfill=function(){return this.length()-this._rejected()},a.prototype._getRangeError=function(e){var t="Input array must contain at least "+this._howMany+" items but contains only "+e+" items";return new s(t)},a.prototype._resolveEmptyArray=function(){this._reject(this._getRangeError(0))},t.some=function(e,t){return f(e,t)},t.prototype.some=function(e){return f(this,e)},t._SomePromiseArray=a}},{"./errors.js":13,"./util.js":38}],34:[function(e,t,n){"use strict";t.exports=function(e){function t(e){e!==undefined?(e=e._target(),this._bitField=e._bitField,this._settledValue=e._settledValue):(this._bitField=0,this._settledValue=undefined)}t.prototype.value=function(){if(!this.isFulfilled())throw new TypeError("cannot get fulfillment value of a non-fulfilled promise\n\n    See http://goo.gl/hc1DLj\n");return this._settledValue},t.prototype.error=t.prototype.reason=function(){if(!this.isRejected())throw new TypeError("cannot get rejection reason of a non-rejected promise\n\n    See http://goo.gl/hPuiwB\n");return this._settledValue},t.prototype.isFulfilled=e.prototype._isFulfilled=function(){return(this._bitField&268435456)>0},t.prototype.isRejected=e.prototype._isRejected=function(){return(this._bitField&134217728)>0},t.prototype.isPending=e.prototype._isPending=function(){return(this._bitField&402653184)===0},t.prototype.isResolved=e.prototype._isResolved=function(){return(this._bitField&402653184)>0},e.prototype.isPending=function(){return this._target()._isPending()},e.prototype.isRejected=function(){return this._target()._isRejected()},e.prototype.isFulfilled=function(){return this._target()._isFulfilled()},e.prototype.isResolved=function(){return this._target()._isResolved()},e.prototype._value=function(){return this._settledValue},e.prototype._reason=function(){return this._unsetRejectionIsUnhandled(),this._settledValue},e.prototype.value=function(){var e=this._target();if(!e.isFulfilled())throw new TypeError("cannot get fulfillment value of a non-fulfilled promise\n\n    See http://goo.gl/hc1DLj\n");return e._settledValue},e.prototype.reason=function(){var e=this._target();if(!e.isRejected())throw new TypeError("cannot get rejection reason of a non-rejected promise\n\n    See http://goo.gl/hPuiwB\n");return e._unsetRejectionIsUnhandled(),e._settledValue},e.PromiseInspection=t}},{}],35:[function(e,t,n){"use strict";t.exports=function(t,n){function o(e,o){if(s(e)){if(e instanceof t)return e;if(f(e)){var a=new t(n);return e._then(a._fulfillUnchecked,a._rejectUncheckedCheckError,a._progressUnchecked,a,null),a}var c=r.tryCatch(u)(e);if(c===i){o&&o._pushContext();var a=t.reject(c.e);return o&&o._popContext(),a}if(typeof c=="function")return l(e,c,o)}return e}function u(e){return e.then}function f(e){return a.call(e,"_promise0")}function l(e,s,o){function c(e){if(!u)return;u._resolveCallback(e),u=null}function h(e){if(!u)return;u._rejectCallback(e,f,!0),u=null}function p(e){if(!u)return;typeof u._progress=="function"&&u._progress(e)}var u=new t(n),a=u;o&&o._pushContext(),u._captureStackTrace(),o&&o._popContext();var f=!0,l=r.tryCatch(s).call(e,c,h,p);return f=!1,u&&l===i&&(u._rejectCallback(l.e,!0,!0),u=null),a}var r=e("./util.js"),i=r.errorObj,s=r.isObject,a={}.hasOwnProperty;return o}},{"./util.js":38}],36:[function(e,t,n){"use strict";t.exports=function(t,n){function a(e){var t=this;return t instanceof Number&&(t=+t),clearTimeout(t),e}function f(e){var t=this;throw t instanceof Number&&(t=+t),clearTimeout(t),e}var r=e("./util.js"),i=t.TimeoutError,s=function(e,t){if(!e.isPending())return;typeof t!="string"&&(t="operation timed out");var n=new i(t);r.markAsOriginatingFromRejection(n),e._attachExtraTrace(n),e._cancel(n)},o=function(e){return u(+this).thenReturn(e)},u=t.delay=function(e,r){if(r===undefined){r=e,e=undefined;var i=new t(n);return setTimeout(function(){i._fulfill()},r),i}return r=+r,t.resolve(e)._then(o,null,null,r,undefined)};t.prototype.delay=function(e){return u(this,e)},t.prototype.timeout=function(e,t){e=+e;var n=this.then().cancellable();n._cancellationParent=this;var r=setTimeout(function(){s(n,t)},e);return n._then(a,f,undefined,r,undefined)}}},{"./util.js":38}],37:[function(e,t,n){"use strict";t.exports=function(t,n,r,i){function a(e){var n=e.length;for(var r=0;r<n;++r){var i=e[r];if(i.isRejected())return t.reject(i.error());e[r]=i._settledValue}return e}function f(e){setTimeout(function(){throw e},0)}function l(e){var t=r(e);return t!==e&&typeof e._isDisposable=="function"&&typeof e._getDisposer=="function"&&e._isDisposable()&&t._setDisposable(e._getDisposer()),t}function c(e,n){function u(){if(i>=s)return o.resolve();var a=l(e[i++]);if(a instanceof t&&a._isDisposable()){try{a=r(a._getDisposer().tryDispose(n),e.promise)}catch(c){return f(c)}if(a instanceof t)return a._then(u,f,null,null,null)}u()}var i=0,s=e.length,o=t.defer();return u(),o.promise}function h(e){var t=new u;return t._settledValue=e,t._bitField=268435456,c(this,t).thenReturn(e)}function p(e){var t=new u;return t._settledValue=e,t._bitField=134217728,c(this,t).thenThrow(e)}function d(e,t,n){this._data=e,this._promise=t,this._context=n}function v(e,t,n){this.constructor$(e,t,n)}function m(e){return d.isDisposer(e)?(this.resources[this.index]._setDisposable(e),e.promise()):e}var s=e("./errors.js").TypeError,o=e("./util.js").inherits,u=t.PromiseInspection;d.prototype.data=function(){return this._data},d.prototype.promise=function(){return this._promise},d.prototype.resource=function(){return this.promise().isFulfilled()?this.promise().value():null},d.prototype.tryDispose=function(e){var t=this.resource(),n=this._context;n!==undefined&&n._pushContext();var r=t!==null?this.doDispose(t,e):null;return n!==undefined&&n._popContext(),this._promise._unsetDisposable(),this._data=null,r},d.isDisposer=function(e){return e!=null&&typeof e.resource=="function"&&typeof e.tryDispose=="function"},o(v,d),v.prototype.doDispose=function(e,t){var n=this.data();return n.call(e,e,t)},t.using=function(){var e=arguments.length;if(e<2)return n("you must pass at least 2 arguments to Promise.using");var i=arguments[e-1];if(typeof i!="function")return n("fn must be a function\n\n    See http://goo.gl/916lJJ\n");e--;var s=new Array(e);for(var o=0;o<e;++o){var u=arguments[o];if(d.isDisposer(u)){var f=u;u=u.promise(),u._setDisposable(f)}else{var l=r(u);l instanceof t&&(u=l._then(m,null,null,{resources:s,index:o},undefined))}s[o]=u}var c=t.settle(s).then(a).then(function(e){c._pushContext();var t;try{t=i.apply(undefined,e)}finally{c._popContext()}return t})._then(h,p,undefined,s,undefined);return s.promise=c,c},t.prototype._setDisposable=function(e){this._bitField=this._bitField|262144,this._disposer=e},t.prototype._isDisposable=function(){return(this._bitField&262144)>0},t.prototype._getDisposer=function(){return this._disposer},t.prototype._unsetDisposable=function(){this._bitField=this._bitField&-262145,this._disposer=undefined},t.prototype.disposer=function(e){if(typeof e=="function")return new v(e,this,i());throw new s}}},{"./errors.js":13,"./util.js":38}],38:[function(_dereq_,module,exports){"use strict";function tryCatcher(){try{var e=tryCatchTarget;return tryCatchTarget=null,e.apply(this,arguments)}catch(t){return errorObj.e=t,errorObj}}function tryCatch(e){return tryCatchTarget=e,tryCatcher}function isPrimitive(e){return e==null||e===!0||e===!1||typeof e=="string"||typeof e=="number"}function isObject(e){return!isPrimitive(e)}function maybeWrapAsError(e){return isPrimitive(e)?new Error(safeToString(e)):e}function withAppended(e,t){var n=e.length,r=new Array(n+1),i;for(i=0;i<n;++i)r[i]=e[i];return r[i]=t,r}function getDataPropertyOrDefault(e,t,n){if(!es5.isES5)return{}.hasOwnProperty.call(e,t)?e[t]:undefined;var r=Object.getOwnPropertyDescriptor(e,t);if(r!=null)return r.get==null&&r.set==null?r.value:n}function notEnumerableProp(e,t,n){if(isPrimitive(e))return e;var r={value:n,configurable:!0,enumerable:!1,writable:!0};return es5.defineProperty(e,t,r),e}function thrower(e){throw e}function isClass(e){try{if(typeof e=="function"){var t=es5.names(e.prototype),n=es5.isES5&&t.length>1,r=t.length>0&&(t.length!==1||t[0]!=="constructor"),i=thisAssignmentPattern.test(e+"")&&es5.names(e).length>0;if(n||r||i)return!0}return!1}catch(s){return!1}}function toFastProperties(obj){function f(){}f.prototype=obj;var l=8;while(l--)new f;return obj}function isIdentifier(e){return rident.test(e)}function filledRange(e,t,n){var r=new Array(e);for(var i=0;i<e;++i)r[i]=t+i+n;return r}function safeToString(e){try{return e+""}catch(t){return"[no string representation]"}}function markAsOriginatingFromRejection(e){try{notEnumerableProp(e,"isOperational",!0)}catch(t){}}function originatesFromRejection(e){return e==null?!1:e instanceof Error.__BluebirdErrorTypes__.OperationalError||e.isOperational===!0}function canAttachTrace(e){return e instanceof Error&&es5.propertyIsWritable(e,"stack")}function classString(e){return{}.toString.call(e)}function copyDescriptors(e,t,n){var r=es5.names(e);for(var i=0;i<r.length;++i){var s=r[i];if(n(s))try{es5.defineProperty(t,s,es5.getDescriptor(e,s))}catch(o){}}}var es5=_dereq_("./es5.js"),canEvaluate=typeof navigator=="undefined",haveGetters=function(){try{var e={};return es5.defineProperty(e,"f",{get:function(){return 3}}),e.f===3}catch(t){return!1}}(),errorObj={e:{}},tryCatchTarget,inherits=function(e,t){function r(){this.constructor=e,this.constructor$=t;for(var r in t.prototype)n.call(t.prototype,r)&&r.charAt(r.length-1)!=="$"&&(this[r+"$"]=t.prototype[r])}var n={}.hasOwnProperty;return r.prototype=t.prototype,e.prototype=new r,e.prototype},inheritedDataKeys=function(){var e=[Array.prototype,Object.prototype,Function.prototype],t=function(t){for(var n=0;n<e.length;++n)if(e[n]===t)return!0;return!1};if(es5.isES5){var n=Object.getOwnPropertyNames;return function(e){var r=[],i=Object.create(null);while(e!=null&&!t(e)){var s;try{s=n(e)}catch(o){return r}for(var u=0;u<s.length;++u){var a=s[u];if(i[a])continue;i[a]=!0;var f=Object.getOwnPropertyDescriptor(e,a);f!=null&&f.get==null&&f.set==null&&r.push(a)}e=es5.getPrototypeOf(e)}return r}}var r={}.hasOwnProperty;return function(n){if(t(n))return[];var i=[];e:for(var s in n)if(r.call(n,s))i.push(s);else{for(var o=0;o<e.length;++o)if(r.call(e[o],s))continue e;i.push(s)}return i}}(),thisAssignmentPattern=/this\s*\.\s*\S+\s*=/,rident=/^[a-z$_][a-z$_0-9]*$/i,ensureErrorObject=function(){return"stack"in new Error?function(e){return canAttachTrace(e)?e:new Error(safeToString(e))}:function(e){if(canAttachTrace(e))return e;try{throw new Error(safeToString(e))}catch(t){return t}}}(),ret={isClass:isClass,isIdentifier:isIdentifier,inheritedDataKeys:inheritedDataKeys,getDataPropertyOrDefault:getDataPropertyOrDefault,thrower:thrower,isArray:es5.isArray,haveGetters:haveGetters,notEnumerableProp:notEnumerableProp,isPrimitive:isPrimitive,isObject:isObject,canEvaluate:canEvaluate,errorObj:errorObj,tryCatch:tryCatch,inherits:inherits,withAppended:withAppended,maybeWrapAsError:maybeWrapAsError,toFastProperties:toFastProperties,filledRange:filledRange,toString:safeToString,canAttachTrace:canAttachTrace,ensureErrorObject:ensureErrorObject,originatesFromRejection:originatesFromRejection,markAsOriginatingFromRejection:markAsOriginatingFromRejection,classString:classString,copyDescriptors:copyDescriptors,hasDevTools:typeof chrome!="undefined"&&chrome&&typeof chrome.loadTimes=="function",isNode:typeof process!="undefined"&&classString(process).toLowerCase()==="[object process]"};ret.isRecentNode=ret.isNode&&function(){var e=process.versions.node.split(".").map(Number);return e[0]===0&&e[1]>10||e[0]>0}(),ret.isNode&&ret.toFastProperties(process);try{throw new Error}catch(e){ret.lastLineError=e}module.exports=ret},{"./es5.js":14}]},{},[4])(4)}),typeof window!="undefined"&&window!==null?window.P=window.Promise:typeof self!="undefined"&&self!==null&&(self.P=self.Promise),function(e,t){typeof define=="function"&&define.amd?define("forge",[],t):e.forge=t()}(this,function(){var e,t,n;return function(r){function i(e,t){return w.call(e,t)}function s(e,t){var n,r,i,s,o,u,a,f,l,c,h,p=t&&t.split("/"),d=y.map,v=d&&d["*"]||{};if(e&&e.charAt(0)===".")if(t){p=p.slice(0,p.length-1),e=e.split("/"),o=e.length-1,y.nodeIdCompat&&S.test(e[o])&&(e[o]=e[o].replace(S,"")),e=p.concat(e);for(l=0;l<e.length;l+=1){h=e[l];if(h===".")e.splice(l,1),l-=1;else if(h===".."){if(l===1&&(e[2]===".."||e[0]===".."))break;l>0&&(e.splice(l-1,2),l-=2)}}e=e.join("/")}else e.indexOf("./")===0&&(e=e.substring(2));if((p||v)&&d){n=e.split("/");for(l=n.length;l>0;l-=1){r=n.slice(0,l).join("/");if(p)for(c=p.length;c>0;c-=1){i=d[p.slice(0,c).join("/")];if(i){i=i[r];if(i){s=i,u=l;break}}}if(s)break;!a&&v&&v[r]&&(a=v[r],f=l)}!s&&a&&(s=a,u=f),s&&(n.splice(0,u,s),e=n.join("/"))}return e}function o(e,t){return function(){return p.apply(r,E.call(arguments,0).concat([e,t]))}}function u(e){return function(t){return s(t,e)}}function a(e){return function(t){m[e]=t}}function f(e){if(i(g,e)){var t=g[e];delete g[e],b[e]=!0,h.apply(r,t)}if(!i(m,e)&&!i(b,e))throw new Error("No "+e);return m[e]}function l(e){var t,n=e?e.indexOf("!"):-1;return n>-1&&(t=e.substring(0,n),e=e.substring(n+1,e.length)),[t,e]}function c(e){return function(){return y&&y.config&&y.config[e]||{}}}var h,p,d,v,m={},g={},y={},b={},w=Object.prototype.hasOwnProperty,E=[].slice,S=/\.js$/;d=function(e,t){var n,r=l(e),i=r[0];return e=r[1],i&&(i=s(i,t),n=f(i)),i?n&&n.normalize?e=n.normalize(e,u(t)):e=s(e,t):(e=s(e,t),r=l(e),i=r[0],e=r[1],i&&(n=f(i))),{f:i?i+"!"+e:e,n:e,pr:i,p:n}},v={require:function(e){return o(e)},exports:function(e){var t=m[e];return typeof t!="undefined"?t:m[e]={}},module:function(e){return{id:e,uri:"",exports:m[e],config:c(e)}}},h=function(e,t,n,s){var u,l,c,h,p,y=[],w=typeof n,E;s=s||e;if(w==="undefined"||w==="function"){t=!t.length&&n.length?["require","exports","module"]:t;for(p=0;p<t.length;p+=1){h=d(t[p],s),l=h.f;if(l==="require")y[p]=v.require(e);else if(l==="exports")y[p]=v.exports(e),E=!0;else if(l==="module")u=y[p]=v.module(e);else if(i(m,l)||i(g,l)||i(b,l))y[p]=f(l);else{if(!h.p)throw new Error(e+" missing "+l);h.p.load(h.n,o(s,!0),a(l),{}),y[p]=m[l]}}c=n?n.apply(m[e],y):undefined;if(e)if(u&&u.exports!==r&&u.exports!==m[e])m[e]=u.exports;else if(c!==r||!E)m[e]=c}else e&&(m[e]=n)},e=t=p=function(e,t,n,i,s){if(typeof e=="string")return v[e]?v[e](t):f(d(e,t).f);if(!e.splice){y=e,y.deps&&p(y.deps,y.callback);if(!t)return;t.splice?(e=t,t=n,n=null):e=r}return t=t||function(){},typeof n=="function"&&(n=i,i=s),i?h(r,e,t,n):setTimeout(function(){h(r,e,t,n)},4),p},p.config=function(e){return p(e)},e._defined=m,n=function(e,t,n){t.splice||(n=t,t=[]),!i(m,e)&&!i(g,e)&&(g[e]=[e,t,n])},n.amd={jQuery:!0}}(),n("node_modules/almond/almond",function(){}),function(){function e(e){function t(e){this.data="",this.read=0;if(typeof e=="string")this.data=e;else if(r.isArrayBuffer(e)||r.isArrayBufferView(e)){var n=new Uint8Array(e);try{this.data=String.fromCharCode.apply(null,n)}catch(i){for(var s=0;s<n.length;++s)this.putByte(n[s])}}else if(e instanceof t||typeof e=="object"&&typeof e.data=="string"&&typeof e.read=="number")this.data=e.data,this.read=e.read;this._constructedStringLength=0}function n(e,t){t=t||{},this.read=t.readOffset||0,this.growSize=t.growSize||1024;var n=r.isArrayBuffer(e),i=r.isArrayBufferView(e);if(n||i){n?this.data=new DataView(e):this.data=new DataView(e.buffer,e.byteOffset,e.byteLength),this.write="writeOffset"in t?t.writeOffset:this.data.byteLength;return}this.data=new DataView(new ArrayBuffer(0)),this.write=0,e!==null&&e!==undefined&&this.putBytes(e),"writeOffset"in t&&(this.write=t.writeOffset)}var r=e.util=e.util||{};(function(){if(typeof process!="undefined"&&process.nextTick){r.nextTick=process.nextTick,typeof setImmediate=="function"?r.setImmediate=setImmediate:r.setImmediate=r.nextTick;return}if(typeof setImmediate=="function"){r.setImmediate=setImmediate,r.nextTick=function(e){return setImmediate(e)};return}r.setImmediate=function(e){setTimeout(e,0)};if(typeof window!="undefined"&&typeof window.postMessage=="function"){var e="forge.setImmediate",t=[];r.setImmediate=function(n){t.push(n),t.length===1&&window.postMessage(e,"*")};function n(n){if(n.source===window&&n.data===e){n.stopPropagation();var r=t.slice();t.length=0,r.forEach(function(e){e()})}}window.addEventListener("message",n,!0)}if(typeof MutationObserver!="undefined"){var i=Date.now(),s=!0,o=document.createElement("div"),t=[];(new MutationObserver(function(){var e=t.slice();t.length=0,e.forEach(function(e){e()})})).observe(o,{attributes:!0});var u=r.setImmediate;r.setImmediate=function(e){Date.now()-i>15?(i=Date.now(),u(e)):(t.push(e),t.length===1&&o.setAttribute("a",s=!s))}}r.nextTick=r.setImmediate})(),r.isArray=Array.isArray||function(e){return Object.prototype.toString.call(e)==="[object Array]"},r.isArrayBuffer=function(e){return typeof ArrayBuffer!="undefined"&&e instanceof ArrayBuffer},r.isArrayBufferView=function(e){return e&&r.isArrayBuffer(e.buffer)&&e.byteLength!==undefined},r.ByteBuffer=t,r.ByteStringBuffer=t;var i=4096;r.ByteStringBuffer.prototype._optimizeConstructedString=function(e){this._constructedStringLength+=e,this._constructedStringLength>i&&(this.data.substr(0,1),this._constructedStringLength=0)},r.ByteStringBuffer.prototype.length=function(){return this.data.length-this.read},r.ByteStringBuffer.prototype.isEmpty=function(){return this.length()<=0},r.ByteStringBuffer.prototype.putByte=function(e){return this.putBytes(String.fromCharCode(e))},r.ByteStringBuffer.prototype.fillWithByte=function(e,t){e=String.fromCharCode(e);var n=this.data;while(t>0)t&1&&(n+=e),t>>>=1,t>0&&(e+=e);return this.data=n,this._optimizeConstructedString(t),this},r.ByteStringBuffer.prototype.putBytes=function(e){return this.data+=e,this._optimizeConstructedString(e.length),this},r.ByteStringBuffer.prototype.putString=function(e){return this.putBytes(r.encodeUtf8(e))},r.ByteStringBuffer.prototype.putInt16=function(e){return this.putBytes(String.fromCharCode(e>>8&255)+String.fromCharCode(e&255))},r.ByteStringBuffer.prototype.putInt24=function(e){return this.putBytes(String.fromCharCode(e>>16&255)+String.fromCharCode(e>>8&255)+String.fromCharCode(e&255))},r.ByteStringBuffer.prototype.putInt32=function(e){return this.putBytes(String.fromCharCode(e>>24&255)+String.fromCharCode(e>>16&255)+String.fromCharCode(e>>8&255)+String.fromCharCode(e&255))},r.ByteStringBuffer.prototype.putInt16Le=function(e){return this.putBytes(String.fromCharCode(e&255)+String.fromCharCode(e>>8&255))},r.ByteStringBuffer.prototype.putInt24Le=function(e){return this.putBytes(String.fromCharCode(e&255)+String.fromCharCode(e>>8&255)+String.fromCharCode(e>>16&255))},r.ByteStringBuffer.prototype.putInt32Le=function(e){return this.putBytes(String.fromCharCode(e&255)+String.fromCharCode(e>>8&255)+String.fromCharCode(e>>16&255)+String.fromCharCode(e>>24&255))},r.ByteStringBuffer.prototype.putInt=function(e,t){var n="";do t-=8,n+=String.fromCharCode(e>>t&255);while(t>0);return this.putBytes(n)},r.ByteStringBuffer.prototype.putSignedInt=function(e,t){return e<0&&(e+=2<<t-1),this.putInt(e,t)},r.ByteStringBuffer.prototype.putBuffer=function(e){return this.putBytes(e.getBytes())},r.ByteStringBuffer.prototype.getByte=function(){return this.data.charCodeAt(this.read++)},r.ByteStringBuffer.prototype.getInt16=function(){var e=this.data.charCodeAt(this.read)<<8^this.data.charCodeAt(this.read+1);return this.read+=2,e},r.ByteStringBuffer.prototype.getInt24=function(){var e=this.data.charCodeAt(this.read)<<16^this.data.charCodeAt(this.read+1)<<8^this.data.charCodeAt(this.read+2);return this.read+=3,e},r.ByteStringBuffer.prototype.getInt32=function(){var e=this.data.charCodeAt(this.read)<<24^this.data.charCodeAt(this.read+1)<<16^this.data.charCodeAt(this.read+2)<<8^this.data.charCodeAt(this.read+3);return this.read+=4,e},r.ByteStringBuffer.prototype.getInt16Le=function(){var e=this.data.charCodeAt(this.read)^this.data.charCodeAt(this.read+1)<<8;return this.read+=2,e},r.ByteStringBuffer.prototype.getInt24Le=function(){var e=this.data.charCodeAt(this.read)^this.data.charCodeAt(this.read+1)<<8^this.data.charCodeAt(this.read+2)<<16;return this.read+=3,e},r.ByteStringBuffer.prototype.getInt32Le=function(){var e=this.data.charCodeAt(this.read)^this.data.charCodeAt(this.read+1)<<8^this.data.charCodeAt(this.read+2)<<16^this.data.charCodeAt(this.read+3)<<24;return this.read+=4,e},r.ByteStringBuffer.prototype.getInt=function(e){var t=0;do t=(t<<8)+this.data.charCodeAt(this.read++),e-=8;while(e>0);return t},r.ByteStringBuffer.prototype.getSignedInt=function(e){var t=this.getInt(e),n=2<<e-2;return t>=n&&(t-=n<<1),t},r.ByteStringBuffer.prototype.getBytes=function(e){var t;return e?(e=Math.min(this.length(),e),t=this.data.slice(this.read,this.read+e),this.read+=e):e===0?t="":(t=this.read===0?this.data:this.data.slice(this.read),this.clear()),t},r.ByteStringBuffer.prototype.bytes=function(e){return typeof e=="undefined"?this.data.slice(this.read):this.data.slice(this.read,this.read+e)},r.ByteStringBuffer.prototype.at=function(e){return this.data.charCodeAt(this.read+e)},r.ByteStringBuffer.prototype.setAt=function(e,t){return this.data=this.data.substr(0,this.read+e)+String.fromCharCode(t)+this.data.substr(this.read+e+1),this},r.ByteStringBuffer.prototype.last=function(){return this.data.charCodeAt(this.data.length-1)},r.ByteStringBuffer.prototype.copy=function(){var e=r.createBuffer(this.data);return e.read=this.read,e},r.ByteStringBuffer.prototype.compact=function(){return this.read>0&&(this.data=this.data.slice(this.read),this.read=0),this},r.ByteStringBuffer.prototype.clear=function(){return this.data="",this.read=0,this},r.ByteStringBuffer.prototype.truncate=function(e){var t=Math.max(0,this.length()-e);return this.data=this.data.substr(this.read,t),this.read=0,this},r.ByteStringBuffer.prototype.toHex=function(){var e="";for(var t=this.read;t<this.data.length;++t){var n=this.data.charCodeAt(t);n<16&&(e+="0"),e+=n.toString(16)}return e},r.ByteStringBuffer.prototype.toString=function(){return r.decodeUtf8(this.bytes())},r.DataBuffer=n,r.DataBuffer.prototype.length=function(){return this.write-this.read},r.DataBuffer.prototype.isEmpty=function(){return this.length()<=0},r.DataBuffer.prototype.accommodate=function(e,t){if(this.length()>=e)return this;t=Math.max(t||this.growSize,e);var n=new Uint8Array(this.data.buffer,this.data.byteOffset,this.data.byteLength),r=new Uint8Array(this.length()+t);return r.set(n),this.data=new DataView(r.buffer),this},r.DataBuffer.prototype.putByte=function(e){return this.accommodate(1),this.data.setUint8(this.write++,e),this},r.DataBuffer.prototype.fillWithByte=function(e,t){this.accommodate(t);for(var n=0;n<t;++n)this.data.setUint8(e);return this},r.DataBuffer.prototype.putBytes=function(e,t){if(r.isArrayBufferView(e)){var n=new Uint8Array(e.buffer,e.byteOffset,e.byteLength),i=n.byteLength-n.byteOffset;this.accommodate(i);var s=new Uint8Array(this.data.buffer,this.write);return s.set(n),this.write+=i,this}if(r.isArrayBuffer(e)){var n=new Uint8Array(e);this.accommodate(n.byteLength);var s=new Uint8Array(this.data.buffer);return s.set(n,this.write),this.write+=n.byteLength,this}if(e instanceof r.DataBuffer||typeof e=="object"&&typeof e.read=="number"&&typeof e.write=="number"&&r.isArrayBufferView(e.data)){var n=new Uint8Array(e.data.byteLength,e.read,e.length());this.accommodate(n.byteLength);var s=new Uint8Array(e.data.byteLength,this.write);return s.set(n),this.write+=n.byteLength,this}e instanceof r.ByteStringBuffer&&(e=e.data,t="binary"),t=t||"binary";if(typeof e=="string"){var o;if(t==="hex")return this.accommodate(Math.ceil(e.length/2)),o=new Uint8Array(this.data.buffer,this.write),this.write+=r.binary.hex.decode(e,o,this.write),this;if(t==="base64")return this.accommodate(Math.ceil(e.length/4)*3),o=new Uint8Array(this.data.buffer,this.write),this.write+=r.binary.base64.decode(e,o,this.write),this;t==="utf8"&&(e=r.encodeUtf8(e),t="binary");if(t==="binary"||t==="raw")return this.accommodate(e.length),o=new Uint8Array(this.data.buffer,this.write),this.write+=r.binary.raw.decode(o),this;if(t==="utf16")return this.accommodate(e.length*2),o=new Uint16Array(this.data.buffer,this.write),this.write+=r.text.utf16.encode(o),this;throw new Error("Invalid encoding: "+t)}throw Error("Invalid parameter: "+e)},r.DataBuffer.prototype.putBuffer=function(e){return this.putBytes(e),e.clear(),this},r.DataBuffer.prototype.putString=function(e){return this.putBytes(e,"utf16")},r.DataBuffer.prototype.putInt16=function(e){return this.accommodate(2),this.data.setInt16(this.write,e),this.write+=2,this},r.DataBuffer.prototype.putInt24=function(e){return this.accommodate(3),this.data.setInt16(this.write,e>>8&65535),this.data.setInt8(this.write,e>>16&255),this.write+=3,this},r.DataBuffer.prototype.putInt32=function(e){return this.accommodate(4),this.data.setInt32(this.write,e),this.write+=4,this},r.DataBuffer.prototype.putInt16Le=function(e){return this.accommodate(2),this.data.setInt16(this.write,e,!0),this.write+=2,this},r.DataBuffer.prototype.putInt24Le=function(e){return this.accommodate(3),this.data.setInt8(this.write,e>>16&255),this.data.setInt16(this.write,e>>8&65535,!0),this.write+=3,this},r.DataBuffer.prototype.putInt32Le=function(e){return this.accommodate(4),this.data.setInt32(this.write,e,!0),this.write+=4,this},r.DataBuffer.prototype.putInt=function(e,t){this.accommodate(t/8);do t-=8,this.data.setInt8(this.write++,e>>t&255);while(t>0);return this},r.DataBuffer.prototype.putSignedInt=function(e,t){return this.accommodate(t/8),e<0&&(e+=2<<t-1),this.putInt(e,t)},r.DataBuffer.prototype.getByte=function(){return this.data.getInt8(this.read++)},r.DataBuffer.prototype.getInt16=function(){var e=this.data.getInt16(this.read);return this.read+=2,e},r.DataBuffer.prototype.getInt24=function(){var e=this.data.getInt16(this.read)<<8^this.data.getInt8(this.read+2);return this.read+=3,e},r.DataBuffer.prototype.getInt32=function(){var e=this.data.getInt32(this.read);return this.read+=4,e},r.DataBuffer.prototype.getInt16Le=function(){var e=this.data.getInt16(this.read,!0);return this.read+=2,e},r.DataBuffer.prototype.getInt24Le=function(){var e=this.data.getInt8(this.read)^this.data.getInt16(this.read+1,!0)<<8;return this.read+=3,e},r.DataBuffer.prototype.getInt32Le=function(){var e=this.data.getInt32(this.read,!0);return this.read+=4,e},r.DataBuffer.prototype.getInt=function(e){var t=0;do t=(t<<8)+this.data.getInt8(this.read++),e-=8;while(e>0);return t},r.DataBuffer.prototype.getSignedInt=function(e){var t=this.getInt(e),n=2<<e-2;return t>=n&&(t-=n<<1),t},r.DataBuffer.prototype.getBytes=function(e){var t;return e?(e=Math.min(this.length(),e),t=this.data.slice(this.read,this.read+e),this.read+=e):e===0?t="":(t=this.read===0?this.data:this.data.slice(this.read),this.clear()),t},r.DataBuffer.prototype.bytes=function(e){return typeof e=="undefined"?this.data.slice(this.read):this.data.slice(this.read,this.read+e)},r.DataBuffer.prototype.at=function(e){return this.data.getUint8(this.read+e)},r.DataBuffer.prototype.setAt=function(e,t){return this.data.setUint8(e,t),this},r.DataBuffer.prototype.last=function(){return this.data.getUint8(this.write-1)},r.DataBuffer.prototype.copy=function(){return new r.DataBuffer(this)},r.DataBuffer.prototype.compact=function(){if(this.read>0){var e=new Uint8Array(this.data.buffer,this.read),t=new Uint8Array(e.byteLength);t.set(e),this.data=new DataView(t),this.write-=this.read,this.read=0}return this},r.DataBuffer.prototype.clear=function(){return this.data=new DataView(new ArrayBuffer(0)),this.read=this.write=0,this},r.DataBuffer.prototype.truncate=function(e){return this.write=Math.max(0,this.length()-e),this.read=Math.min(this.read,this.write),this},r.DataBuffer.prototype.toHex=function(){var e="";for(var t=this.read;t<this.data.byteLength;++t){var n=this.data.getUint8(t);n<16&&(e+="0"),e+=n.toString(16)}return e},r.DataBuffer.prototype.toString=function(e){var t=new Uint8Array(this.data,this.read,this.length());e=e||"utf8";if(e==="binary"||e==="raw")return r.binary.raw.encode(t);if(e==="hex")return r.binary.hex.encode(t);if(e==="base64")return r.binary.base64.encode(t);if(e==="utf8")return r.text.utf8.decode(t);if(e==="utf16")return r.text.utf16.decode(t);throw new Error("Invalid encoding: "+e)},r.createBuffer=function(e,t){return t=t||"raw",e!==undefined&&t==="utf8"&&(e=r.encodeUtf8(e)),new r.ByteBuffer(e)},r.fillString=function(e,t){var n="";while(t>0)t&1&&(n+=e),t>>>=1,t>0&&(e+=e);return n},r.xorBytes=function(e,t,n){var r="",i="",s="",o=0,u=0;for(;n>0;--n,++o)i=e.charCodeAt(o)^t.charCodeAt(o),u>=10&&(r+=s,s="",u=0),s+=String.fromCharCode(i),++u;return r+=s,r},r.hexToBytes=function(e){var t="",n=0;e.length&!0&&(n=1,t+=String.fromCharCode(parseInt(e[0],16)));for(;n<e.length;n+=2)t+=String.fromCharCode(parseInt(e.substr(n,2),16));return t},r.bytesToHex=function(e){return r.createBuffer(e).toHex()},r.int32ToBytes=function(e){return String.fromCharCode(e>>24&255)+String.fromCharCode(e>>16&255)+String.fromCharCode(e>>8&255)+String.fromCharCode(e&255)};var s="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=",o=[62,-1,-1,-1,63,52,53,54,55,56,57,58,59,60,61,-1,-1,-1,64,-1,-1,-1,0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,-1,-1,-1,-1,-1,-1,26,27,28,29,30,31,32,33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,51];r.encode64=function(e,t){var n="",r="",i,o,u,a=0;while(a<e.length)i=e.charCodeAt(a++),o=e.charCodeAt(a++),u=e.charCodeAt(a++),n+=s.charAt(i>>2),n+=s.charAt((i&3)<<4|o>>4),isNaN(o)?n+="==":(n+=s.charAt((o&15)<<2|u>>6),n+=isNaN(u)?"=":s.charAt(u&63)),t&&n.length>t&&(r+=n.substr(0,t)+"\r\n",n=n.substr(t));return r+=n,r},r.decode64=function(e){e=e.replace(/[^A-Za-z0-9\+\/\=]/g,"");var t="",n,r,i,s,u=0;while(u<e.length)n=o[e.charCodeAt(u++)-43],r=o[e.charCodeAt(u++)-43],i=o[e.charCodeAt(u++)-43],s=o[e.charCodeAt(u++)-43],t+=String.fromCharCode(n<<2|r>>4),i!==64&&(t+=String.fromCharCode((r&15)<<4|i>>2),s!==64&&(t+=String.fromCharCode((i&3)<<6|s)));return t},r.encodeUtf8=function(e){return unescape(encodeURIComponent(e))},r.decodeUtf8=function(e){return decodeURIComponent(escape(e))},r.binary={raw:{},hex:{},base64:{}},r.binary.raw.encode=function(e){return String.fromCharCode.apply(null,e)},r.binary.raw.decode=function(e,t,n){var r=t;r||(r=new Uint8Array(e.length)),n=n||0;var i=n;for(var s=0;s<e.length;++s)r[i++]=e.charCodeAt(s);return t?i-n:r},r.binary.hex.encode=r.bytesToHex,r.binary.hex.decode=function(e,t,n){var r=t;r||(r=new Uint8Array(Math.ceil(e.length/2))),n=n||0;var i=0,s=n;e.length&1&&(i=1,r[s++]=parseInt(e[0],16));for(;i<e.length;i+=2)r[s++]=parseInt(e.substr(i,2),16);return t?s-n:r},r.binary.base64.encode=function(e,t){var n="",r="",i,o,u,a=0;while(a<e.byteLength)i=e[a++],o=e[a++],u=e[a++],n+=s.charAt(i>>2),n+=s.charAt((i&3)<<4|o>>4),isNaN(o)?n+="==":(n+=s.charAt((o&15)<<2|u>>6),n+=isNaN(u)?"=":s.charAt(u&63)),t&&n.length>t&&(r+=n.substr(0,t)+"\r\n",n=n.substr(t));return r+=n,r},r.binary.base64.decode=function(e,t,n){var r=t;r||(r=new Uint8Array(Math.ceil(e.length/4)*3)),e=e.replace(/[^A-Za-z0-9\+\/\=]/g,""),n=n||0;var i,s,u,a,f=0,l=n;while(f<e.length)i=o[e.charCodeAt(f++)-43],s=o[e.charCodeAt(f++)-43],u=o[e.charCodeAt(f++)-43],a=o[e.charCodeAt(f++)-43],r[l++]=i<<2|s>>4,u!==64&&(r[l++]=(s&15)<<4|u>>2,a!==64&&(r[l++]=(u&3)<<6|a));return t?l-n:r.subarray(0,l)},r.text={utf8:{},utf16:{}},r.text.utf8.encode=function(e,t,n){e=r.encodeUtf8(e);var i=t;i||(i=new Uint8Array(e.length)),n=n||0;var s=n;for(var o=0;o<e.length;++o)i[s++]=e.charCodeAt(o);return t?s-n:i},r.text.utf8.decode=function(e){return r.decodeUtf8(String.fromCharCode.apply(null,e))},r.text.utf16.encode=function(e,t,n){var r=t;r||(r=new Uint8Array(e.length));var i=new Uint16Array(r);n=n||0;var s=n,o=n;for(var u=0;u<e.length;++u)i[o++]=e.charCodeAt(u),s+=2;return t?s-n:r},r.text.utf16.decode=function(e){return String.fromCharCode.apply(null,new Uint16Array(e))},r.deflate=function(e,t,n){t=r.decode64(e.deflate(r.encode64(t)).rval);if(n){var i=2,s=t.charCodeAt(1);s&32&&(i=6),t=t.substring(i,t.length-4)}return t},r.inflate=function(e,t,n){var i=e.inflate(r.encode64(t)).rval;return i===null?null:r.decode64(i)};var u=function(e,t,n){if(!e)throw new Error("WebStorage not available.");var i;n===null?i=e.removeItem(t):(n=r.encode64(JSON.stringify(n)),i=e.setItem(t,n));if(typeof i!="undefined"&&i.rval!==!0){var s=new Error(i.error.message);throw s.id=i.error.id,s.name=i.error.name,s}},a=function(e,t){if(!e)throw new Error("WebStorage not available.");var n=e.getItem(t);if(e.init)if(n.rval===null){if(n.error){var i=new Error(n.error.message);throw i.id=n.error.id,i.name=n.error.name,i}n=null}else n=n.rval;return n!==null&&(n=JSON.parse(r.decode64(n))),n},f=function(e,t,n,r){var i=a(e,t);i===null&&(i={}),i[n]=r,u(e,t,i)},l=function(e,t,n){var r=a(e,t);return r!==null&&(r=n in r?r[n]:null),r},c=function(e,t,n){var r=a(e,t);if(r!==null&&n in r){delete r[n];var i=!0;for(var s in r){i=!1;break}i&&(r=null),u(e,t,r)}},h=function(e,t){u(e,t,null)},p=function(e,t,n){var r=null;typeof n=="undefined"&&(n=["web","flash"]);var i,s=!1,o=null;for(var u in n){i=n[u];try{if(i==="flash"||i==="both"){if(t[0]===null)throw new Error("Flash local storage not available.");r=e.apply(this,t),s=i==="flash"}if(i==="web"||i==="both")t[0]=localStorage,r=e.apply(this,t),s=!0}catch(a){o=a}if(s)break}if(!s)throw o;return r};r.setItem=function(e,t,n,r,i){p(f,arguments,i)},r.getItem=function(e,t,n,r){return p(l,arguments,r)},r.removeItem=function(e,t,n,r){p(c,arguments,r)},r.clearItems=function(e,t,n){p(h,arguments,n)},r.parseUrl=function(e){var t=/^(https?):\/\/([^:&^\/]*):?(\d*)(.*)$/g;t.lastIndex=0;var n=t.exec(e),r=n===null?null:{full:e,scheme:n[1],host:n[2],port:n[3],path:n[4]};return r&&(r.fullHost=r.host,r.port?r.port!==80&&r.scheme==="http"?r.fullHost+=":"+r.port:r.port!==443&&r.scheme==="https"&&(r.fullHost+=":"+r.port):r.scheme==="http"?r.port=80:r.scheme==="https"&&(r.port=443),r.full=r.scheme+"://"+r.fullHost),r};var d=null;r.getQueryVariables=function(e){var t=function(e){var t={},n=e.split("&");for(var r=0;r<n.length;r++){var i=n[r].indexOf("="),s,o;i>0?(s=n[r].substring(0,i),o=n[r].substring(i+1)):(s=n[r],o=null),s in t||(t[s]=[]),!(s in Object.prototype)&&o!==null&&t[s].push(unescape(o))}return t},n;return typeof e=="undefined"?(d===null&&(typeof window!="undefined"&&window.location&&window.location.search?d=t(window.location.search.substring(1)):d={}),n=d):n=t(e),n},r.parseFragment=function(e){var t=e,n="",i=e.indexOf("?");i>0&&(t=e.substring(0,i),n=e.substring(i+1));var s=t.split("/");s.length>0&&s[0]===""&&s.shift();var o=n===""?{}:r.getQueryVariables(n);return{pathString:t,queryString:n,path:s,query:o}},r.makeRequest=function(e){var t=r.parseFragment(e),n={path:t.pathString,query:t.queryString,getPath:function(e){return typeof e=="undefined"?t.path:t.path[e]},getQuery:function(e,n){var r;return typeof e=="undefined"?r=t.query:(r=t.query[e],r&&typeof n!="undefined"&&(r=r[n])),r},getQueryLast:function(e,t){var r,i=n.getQuery(e);return i?r=i[i.length-1]:r=t,r}};return n},r.makeLink=function(e,t,n){e=jQuery.isArray(e)?e.join("/"):e;var r=jQuery.param(t||{});return n=n||"",e+(r.length>0?"?"+r:"")+(n.length>0?"#"+n:"")},r.setPath=function(e,t,n){if(typeof e=="object"&&e!==null){var r=0,i=t.length;while(r<i){var s=t[r++];if(r==i)e[s]=n;else{var o=s in e;if(!o||o&&typeof e[s]!="object"||o&&e[s]===null)e[s]={};e=e[s]}}}},r.getPath=function(e,t,n){var r=0,i=t.length,s=!0;while(s&&r<i&&typeof e=="object"&&e!==null){var o=t[r++];s=o in e,s&&(e=e[o])}return s?e:n},r.deletePath=function(e,t){if(typeof e=="object"&&e!==null){var n=0,r=t.length;while(n<r){var i=t[n++];if(n==r)delete e[i];else{if(!(i in e&&typeof e[i]=="object"&&e[i]!==null))break;e=e[i]}}}},r.isEmpty=function(e){for(var t in e)if(e.hasOwnProperty(t))return!1;return!0},r.format=function(e){var t=/%./g,n,r,i=0,s=[],o=0;while(n=t.exec(e)){r=e.substring(o,t.lastIndex-2),r.length>0&&s.push(r),o=t.lastIndex;var u=n[0][1];switch(u){case"s":case"o":i<arguments.length?s.push(arguments[i++ +1]):s.push("<?>");break;case"%":s.push("%");break;default:s.push("<%"+u+"?>")}}return s.push(e.substring(o)),s.join("")},r.formatNumber=function(e,t,n,r){var i=e,s=isNaN(t=Math.abs(t))?2:t,o=n===undefined?",":n,u=r===undefined?".":r,a=i<0?"-":"",f=parseInt(i=Math.abs(+i||0).toFixed(s),10)+"",l=f.length>3?f.length%3:0;return a+(l?f.substr(0,l)+u:"")+f.substr(l).replace(/(\d{3})(?=\d)/g,"$1"+u)+(s?o+Math.abs(i-f).toFixed(s).slice(2):"")},r.formatSize=function(e){return e>=1073741824?e=r.formatNumber(e/1073741824,2,".","")+" GiB":e>=1048576?e=r.formatNumber(e/1048576,2,".","")+" MiB":e>=1024?e=r.formatNumber(e/1024,0)+" KiB":e=r.formatNumber(e,0)+" bytes",e},r.bytesFromIP=function(e){return e.indexOf(".")!==-1?r.bytesFromIPv4(e):e.indexOf(":")!==-1?r.bytesFromIPv6(e):null},r.bytesFromIPv4=function(e){e=e.split(".");if(e.length!==4)return null;var t=r.createBuffer();for(var n=0;n<e.length;++n){var i=parseInt(e[n],10);if(isNaN(i))return null;t.putByte(i)}return t.getBytes()},r.bytesFromIPv6=function(e){var t=0;e=e.split(":").filter(function(e){return e.length===0&&++t,!0});var n=(8-e.length+t)*2,i=r.createBuffer();for(var s=0;s<8;++s){if(!e[s]||e[s].length===0){i.fillWithByte(0,n),n=0;continue}var o=r.hexToBytes(e[s]);o.length<2&&i.putByte(0),i.putBytes(o)}return i.getBytes()},r.bytesToIP=function(e){return e.length===4?r.bytesToIPv4(e):e.length===16?r.bytesToIPv6(e):null},r.bytesToIPv4=function(e){if(e.length!==4)return null;var t=[];for(var n=0;n<e.length;++n)t.push(e.charCodeAt(n));return t.join(".")},r.bytesToIPv6=function(e){if(e.length!==16)return null;var t=[],n=[],i=0;for(var s=0;s<e.length;s+=2){var o=r.bytesToHex(e[s]+e[s+1]);while(o[0]==="0"&&o!=="0")o=o.substr(1);if(o==="0"){var u=n[n.length-1],a=t.length;!u||a!==u.end+1?n.push({start:a,end:a}):(u.end=a,u.end-u.start>n[i].end-n[i].start&&(i=n.length-1))}t.push(o)}if(n.length>0){var f=n[i];f.end-f.start>0&&(t.splice(f.start,f.end-f.start+1,""),f.start===0&&t.unshift(""),f.end===7&&t.push(""))}return t.join(":")},r.estimateCores=function(e,t){function n(e,u,a){if(u===0){var f=Math.floor(e.reduce(function(e,t){return e+t},0)/e.length);return r.cores=Math.max(1,f),URL.revokeObjectURL(o),t(null,r.cores)}i(a,function(t,r){e.push(s(a,r)),n(e,u-1,a)})}function i(e,t){var n=[],r=[];for(var i=0;i<e;++i){var s=new Worker(o);s.addEventListener("message",function(i){r.push(i.data);if(r.length===e){for(var s=0;s<e;++s)n[s].terminate();t(null,r)}}),n.push(s)}for(var i=0;i<e;++i)n[i].postMessage(i)}function s(e,t){var n=[];for(var r=0;r<e;++r){var i=t[r],s=n[r]=[];for(var o=0;o<e;++o){if(r===o)continue;var u=t[o];(i.st>u.st&&i.st<u.et||u.st>i.st&&u.st<i.et)&&s.push(o)}}return n.reduce(function(e,t){return Math.max(e,t.length)},0)}typeof e=="function"&&(t=e,e={}),e=e||{};if("cores"in r&&!e.update)return t(null,r.cores);if(typeof navigator!="undefined"&&"hardwareConcurrency"in navigator&&navigator.hardwareConcurrency>0)return r.cores=navigator.hardwareConcurrency,t(null,r.cores);if(typeof Worker=="undefined")return r.cores=1,t(null,r.cores);if(typeof Blob=="undefined")return r.cores=2,t(null,r.cores);var o=URL.createObjectURL(new Blob(["(",function(){self.addEventListener("message",function(e){var t=Date.now(),n=t+4;while(Date.now()<n);self.postMessage({st:t,et:n})})}.toString(),")()"],{type:"application/javascript"}));n([],5,16)}}var r="util";if(typeof n!="function"){if(typeof module!="object"||!module.exports)return typeof forge=="undefined"&&(forge={}),e(forge);var i=!0;n=function(e,n){n(t,module)}}var s,o=function(t,n){n.exports=function(n){var i=s.map(function(e){return t(e)}).concat(e);n=n||{},n.defined=n.defined||{};if(n.defined[r])return n[r];n.defined[r]=!0;for(var o=0;o<i.length;++o)i[o](n);return n[r]}},u=n;n=function(e,t){return s=typeof e=="string"?t.slice(2):e.slice(2),i?(delete n,u.apply(null,Array.prototype.slice.call(arguments,0))):(n=u,n.apply(null,Array.prototype.slice.call(arguments,0)))},n("js/util",["require","module"],function(){o.apply(null,Array.prototype.slice.call(arguments,0))})}(),function(){function e(e){e.cipher=e.cipher||{},e.cipher.algorithms=e.cipher.algorithms||{},e.cipher.createCipher=function(t,n){var r=t;typeof r=="string"&&(r=e.cipher.getAlgorithm(r),r&&(r=r()));if(!r)throw new Error("Unsupported algorithm: "+t);return new e.cipher.BlockCipher({algorithm:r,key:n,decrypt:!1})},e.cipher.createDecipher=function(t,n){var r=t;typeof r=="string"&&(r=e.cipher.getAlgorithm(r),r&&(r=r()));if(!r)throw new Error("Unsupported algorithm: "+t);return new e.cipher.BlockCipher({algorithm:r,key:n,decrypt:!0})},e.cipher.registerAlgorithm=function(t,n){t=t.toUpperCase(),e.cipher.algorithms[t]=n},e.cipher.getAlgorithm=function(t){return t=t.toUpperCase(),t in e.cipher.algorithms?e.cipher.algorithms[t]:null};var t=e.cipher.BlockCipher=function(e){this.algorithm=e.algorithm,this.mode=this.algorithm.mode,this.blockSize=this.mode.blockSize,this._finish=!1,this._input=null,this.output=null,this._op=e.decrypt?this.mode.decrypt:this.mode.encrypt,this._decrypt=e.decrypt,this.algorithm.initialize(e)};t.prototype.start=function(t){t=t||{};var n={};for(var r in t)n[r]=t[r];n.decrypt=this._decrypt,this._finish=!1,this._input=e.util.createBuffer(),this.output=t.output||e.util.createBuffer(),this.mode.start(n)},t.prototype.update=function(e){e&&this._input.putBuffer(e);while(!this._op.call(this.mode,this._input,this.output,this._finish)&&!this._finish);this._input.compact()},t.prototype.finish=function(e){e&&(this.mode.name==="ECB"||this.mode.name==="CBC")&&(this.mode.pad=function(t){return e(this.blockSize,t,!1)},this.mode.unpad=function(t){return e(this.blockSize,t,!0)});var t={};return t.decrypt=this._decrypt,t.overflow=this._input.length()%this.blockSize,!this._decrypt&&this.mode.pad&&!this.mode.pad(this._input,t)?!1:(this._finish=!0,this.update(),this._decrypt&&this.mode.unpad&&!this.mode.unpad(this.output,t)?!1:this.mode.afterFinish&&!this.mode.afterFinish(this.output,t)?!1:!0)}}var r="cipher";if(typeof n!="function"){if(typeof module!="object"||!module.exports)return typeof forge=="undefined"&&(forge={}),e(forge);var i=!0;n=function(e,n){n(t,module)}}var s,o=function(t,n){n.exports=function(n){var i=s.map(function(e){return t(e)}).concat(e);n=n||{},n.defined=n.defined||{};if(n.defined[r])return n[r];n.defined[r]=!0;for(var o=0;o<i.length;++o)i[o](n);return n[r]}},u=n;n=function(e,t){return s=typeof e=="string"?t.slice(2):e.slice(2),i?(delete n,u.apply(null,Array.prototype.slice.call(arguments,0))):(n=u,n.apply(null,Array.prototype.slice.call(arguments,0)))},n("js/cipher",["require","module","./util"],function(){o.apply(null,Array.prototype.slice.call(arguments,0))})}(),function(){function e(e){function t(t){typeof t=="string"&&(t=e.util.createBuffer(t));if(e.util.isArray(t)&&t.length>4){var n=t;t=e.util.createBuffer();for(var r=0;r<n.length;++r)t.putByte(n[r])}return e.util.isArray(t)||(t=[t.getInt32(),t.getInt32(),t.getInt32(),t.getInt32()]),t}function n(e){e[e.length-1]=e[e.length-1]+1&4294967295}function r(e){return[e/4294967296|0,e&4294967295]}e.cipher=e.cipher||{};var i=e.cipher.modes=e.cipher.modes||{};i.ecb=function(e){e=e||{},this.name="ECB",this.cipher=e.cipher,this.blockSize=e.blockSize||16,this._ints=this.blockSize/4,this._inBlock=new Array(this._ints),this._outBlock=new Array(this._ints)},i.ecb.prototype.start=function(e){},i.ecb.prototype.encrypt=function(e,t,n){if(e.length()<this.blockSize&&!(n&&e.length()>0))return!0;for(var r=0;r<this._ints;++r)this._inBlock[r]=e.getInt32();this.cipher.encrypt(this._inBlock,this._outBlock);for(var r=0;r<this._ints;++r)t.putInt32(this._outBlock[r])},i.ecb.prototype.decrypt=function(e,t,n){if(e.length()<this.blockSize&&!(n&&e.length()>0))return!0;for(var r=0;r<this._ints;++r)this._inBlock[r]=e.getInt32();this.cipher.decrypt(this._inBlock,this._outBlock);for(var r=0;r<this._ints;++r)t.putInt32(this._outBlock[r])},i.ecb.prototype.pad=function(e,t){var n=e.length()===this.blockSize?this.blockSize:this.blockSize-e.length();return e.fillWithByte(n,n),!0},i.ecb.prototype.unpad=function(e,t){if(t.overflow>0)return!1;var n=e.length(),r=e.at(n-1);return r>this.blockSize<<2?!1:(e.truncate(r),!0)},i.cbc=function(e){e=e||{},this.name="CBC",this.cipher=e.cipher,this.blockSize=e.blockSize||16,this._ints=this.blockSize/4,this._inBlock=new Array(this._ints),this._outBlock=new Array(this._ints)},i.cbc.prototype.start=function(e){if(e.iv===null){if(!this._prev)throw new Error("Invalid IV parameter.");this._iv=this._prev.slice(0)}else{if(!("iv"in e))throw new Error("Invalid IV parameter.");this._iv=t(e.iv),this._prev=this._iv.slice(0)}},i.cbc.prototype.encrypt=function(e,t,n){if(e.length()<this.blockSize&&!(n&&e.length()>0))return!0;for(var r=0;r<this._ints;++r)this._inBlock[r]=this._prev[r]^e.getInt32();this.cipher.encrypt(this._inBlock,this._outBlock);for(var r=0;r<this._ints;++r)t.putInt32(this._outBlock[r]);this._prev=this._outBlock},i.cbc.prototype.decrypt=function(e,t,n){if(e.length()<this.blockSize&&!(n&&e.length()>0))return!0;for(var r=0;r<this._ints;++r)this._inBlock[r]=e.getInt32();this.cipher.decrypt(this._inBlock,this._outBlock);for(var r=0;r<this._ints;++r)t.putInt32(this._prev[r]^this._outBlock[r]);this._prev=this._inBlock.slice(0)},i.cbc.prototype.pad=function(e,t){var n=e.length()===this.blockSize?this.blockSize:this.blockSize-e.length();return e.fillWithByte(n,n),!0},i.cbc.prototype.unpad=function(e,t){if(t.overflow>0)return!1;var n=e.length(),r=e.at(n-1);return r>this.blockSize<<2?!1:(e.truncate(r),!0)},i.cfb=function(t){t=t||{},this.name="CFB",this.cipher=t.cipher,this.blockSize=t.blockSize||16,this._ints=this.blockSize/4,this._inBlock=null,this._outBlock=new Array(this._ints),this._partialBlock=new Array(this._ints),this._partialOutput=e.util.createBuffer(),this._partialBytes=0},i.cfb.prototype.start=function(e){if(!("iv"in e))throw new Error("Invalid IV parameter.");this._iv=t(e.iv),this._inBlock=this._iv.slice(0),this._partialBytes=0},i.cfb.prototype.encrypt=function(e,t,n){var r=e.length();if(r===0)return!0;this.cipher.encrypt(this._inBlock,this._outBlock);if(this._partialBytes===0&&r>=this.blockSize){for(var i=0;i<this._ints;++i)this._inBlock[i]=e.getInt32()^this._outBlock[i],t.putInt32(this._inBlock[i]);return}var s=(this.blockSize-r)%this.blockSize;s>0&&(s=this.blockSize-s),this._partialOutput.clear();for(var i=0;i<this._ints;++i)this._partialBlock[i]=e.getInt32()^this._outBlock[i],this._partialOutput.putInt32(this._partialBlock[i]);if(s>0)e.read-=this.blockSize;else for(var i=0;i<this._ints;++i)this._inBlock[i]=this._partialBlock[i];this._partialBytes>0&&this._partialOutput.getBytes(this._partialBytes);if(s>0&&!n)return t.putBytes(this._partialOutput.getBytes(s-this._partialBytes)),this._partialBytes=s,!0;t.putBytes(this._partialOutput.getBytes(r-this._partialBytes)),this._partialBytes=0},i.cfb.prototype.decrypt=function(e,t,n){var r=e.length();if(r===0)return!0;this.cipher.encrypt(this._inBlock,this._outBlock);if(this._partialBytes===0&&r>=this.blockSize){for(var i=0;i<this._ints;++i)this._inBlock[i]=e.getInt32(),t.putInt32(this._inBlock[i]^this._outBlock[i]);return}var s=(this.blockSize-r)%this.blockSize;s>0&&(s=this.blockSize-s),this._partialOutput.clear();for(var i=0;i<this._ints;++i)this._partialBlock[i]=e.getInt32(),this._partialOutput.putInt32(this._partialBlock[i]^this._outBlock[i]);if(s>0)e.read-=this.blockSize;else for(var i=0;i<this._ints;++i)this._inBlock[i]=this._partialBlock[i];this._partialBytes>0&&this._partialOutput.getBytes(this._partialBytes);if(s>0&&!n)return t.putBytes(this._partialOutput.getBytes(s-this._partialBytes)),this._partialBytes=s,!0;t.putBytes(this._partialOutput.getBytes(r-this._partialBytes)),this._partialBytes=0},i.ofb=function(t){t=t||{},this.name="OFB",this.cipher=t.cipher,this.blockSize=t.blockSize||16,this._ints=this.blockSize/4,this._inBlock=null,this._outBlock=new Array(this._ints),this._partialOutput=e.util.createBuffer(),this._partialBytes=0},i.ofb.prototype.start=function(e){if(!("iv"in e))throw new Error("Invalid IV parameter.");this._iv=t(e.iv),this._inBlock=this._iv.slice(0),this._partialBytes=0},i.ofb.prototype.encrypt=function(e,t,n){var r=e.length();if(e.length()===0)return!0;this.cipher.encrypt(this._inBlock,this._outBlock);if(this._partialBytes===0&&r>=this.blockSize){for(var i=0;i<this._ints;++i)t.putInt32(e.getInt32()^this._outBlock[i]),this._inBlock[i]=this._outBlock[i];return}var s=(this.blockSize-r)%this.blockSize;s>0&&(s=this.blockSize-s),this._partialOutput.clear();for(var i=0;i<this._ints;++i)this._partialOutput.putInt32(e.getInt32()^this._outBlock[i]);if(s>0)e.read-=this.blockSize;else for(var i=0;i<this._ints;++i)this._inBlock[i]=this._outBlock[i];this._partialBytes>0&&this._partialOutput.getBytes(this._partialBytes);if(s>0&&!n)return t.putBytes(this._partialOutput.getBytes(s-this._partialBytes)),this._partialBytes=s,!0;t.putBytes(this._partialOutput.getBytes(r-this._partialBytes)),this._partialBytes=0},i.ofb.prototype.decrypt=i.ofb.prototype.encrypt,i.ctr=function(t){t=t||{},this.name="CTR",this.cipher=t.cipher,this.blockSize=t.blockSize||16,this._ints=this.blockSize/4,this._inBlock=null,this._outBlock=new Array(this._ints),this._partialOutput=e.util.createBuffer(),this._partialBytes=0},i.ctr.prototype.start=function(e){if(!("iv"in e))throw new Error("Invalid IV parameter.");this._iv=t(e.iv),this._inBlock=this._iv.slice(0),this._partialBytes=0},i.ctr.prototype.encrypt=function(e,t,r){var i=e.length();if(i===0)return!0;this.cipher.encrypt(this._inBlock,this._outBlock);if(this._partialBytes===0&&i>=this.blockSize)for(var s=0;s<this._ints;++s)t.putInt32(e.getInt32()^this._outBlock[s]);else{var o=(this.blockSize-i)%this.blockSize;o>0&&(o=this.blockSize-o),this._partialOutput.clear();for(var s=0;s<this._ints;++s)this._partialOutput.putInt32(e.getInt32()^this._outBlock[s]);o>0&&(e.read-=this.blockSize),this._partialBytes>0&&this._partialOutput.getBytes(this._partialBytes);if(o>0&&!r)return t.putBytes(this._partialOutput.getBytes(o-this._partialBytes)),this._partialBytes=o,!0;t.putBytes(this._partialOutput.getBytes(i-this._partialBytes)),this._partialBytes=0}n(this._inBlock)},i.ctr.prototype.decrypt=i.ctr.prototype.encrypt,i.gcm=function(t){t=t||{},this.name="GCM",this.cipher=t.cipher,this.blockSize=t.blockSize||16,this._ints=this.blockSize/4,this._inBlock=new Array(this._ints),this._outBlock=new Array(this._ints),this._partialOutput=e.util.createBuffer(),this._partialBytes=0,this._R=3774873600},i.gcm.prototype.start=function(t){if(!("iv"in t))throw new Error("Invalid IV parameter.");var i=e.util.createBuffer(t.iv);this._cipherLength=0;var s;"additionalData"in t?s=e.util.createBuffer(t.additionalData):s=e.util.createBuffer(),"tagLength"in t?this._tagLength=t.tagLength:this._tagLength=128,this._tag=null;if(t.decrypt){this._tag=e.util.createBuffer(t.tag).getBytes();if(this._tag.length!==this._tagLength/8)throw new Error("Authentication tag does not match tag length.")}this._hashBlock=new Array(this._ints),this.tag=null,this._hashSubkey=new Array(this._ints),this.cipher.encrypt([0,0,0,0],this._hashSubkey),this.componentBits=4,this._m=this.generateHashTable(this._hashSubkey,this.componentBits);var o=i.length();if(o===12)this._j0=[i.getInt32(),i.getInt32(),i.getInt32(),1];else{this._j0=[0,0,0,0];while(i.length()>0)this._j0=this.ghash(this._hashSubkey,this._j0,[i.getInt32(),i.getInt32(),i.getInt32(),i.getInt32()]);this._j0=this.ghash(this._hashSubkey,this._j0,[0,0].concat(r(o*8)))}this._inBlock=this._j0.slice(0),n(this._inBlock),this._partialBytes=0,s=e.util.createBuffer(s),this._aDataLength=r(s.length()*8);var u=s.length()%this.blockSize;u&&s.fillWithByte(0,this.blockSize-u),this._s=[0,0,0,0];while(s.length()>0)this._s=this.ghash(this._hashSubkey,this._s,[s.getInt32(),s.getInt32(),s.getInt32(),s.getInt32()])},i.gcm.prototype.encrypt=function(e,t,r){var i=e.length();if(i===0)return!0;this.cipher.encrypt(this._inBlock,this._outBlock);if(this._partialBytes===0&&i>=this.blockSize){for(var s=0;s<this._ints;++s)t.putInt32(this._outBlock[s]^=e.getInt32());this._cipherLength+=this.blockSize}else{var o=(this.blockSize-i)%this.blockSize;o>0&&(o=this.blockSize-o),this._partialOutput.clear();for(var s=0;s<this._ints;++s)this._partialOutput.putInt32(e.getInt32()^this._outBlock[s]);if(o===0||r){if(r){var u=i%this.blockSize;this._cipherLength+=u,this._partialOutput.truncate(this.blockSize-u)}else this._cipherLength+=this.blockSize;for(var s=0;s<this._ints;++s)this._outBlock[s]=this._partialOutput.getInt32();this._partialOutput.read-=this.blockSize}this._partialBytes>0&&this._partialOutput.getBytes(this._partialBytes);if(o>0&&!r)return e.read-=this.blockSize,t.putBytes(this._partialOutput.getBytes(o-this._partialBytes)),this._partialBytes=o,!0;t.putBytes(this._partialOutput.getBytes(i-this._partialBytes)),this._partialBytes=0}this._s=this.ghash(this._hashSubkey,this._s,this._outBlock),n(this._inBlock)},i.gcm.prototype.decrypt=function(e,t,r){var i=e.length();if(i<this.blockSize&&!(r&&i>0))return!0;this.cipher.encrypt(this._inBlock,this._outBlock),n(this._inBlock),this._hashBlock[0]=e.getInt32(),this._hashBlock[1]=e.getInt32(),this._hashBlock[2]=e.getInt32(),this._hashBlock[3]=e.getInt32(),this._s=this.ghash(this._hashSubkey,this._s,this._hashBlock);for(var s=0;s<this._ints;++s)t.putInt32(this._outBlock[s]^this._hashBlock[s]);i<this.blockSize?this._cipherLength+=i%this.blockSize:this._cipherLength+=this.blockSize},i.gcm.prototype.afterFinish=function(t,n){var i=!0;n.decrypt&&n.overflow&&t.truncate(this.blockSize-n.overflow),this.tag=e.util.createBuffer();var s=this._aDataLength.concat(r(this._cipherLength*8));this._s=this.ghash(this._hashSubkey,this._s,s);var o=[];this.cipher.encrypt(this._j0,o);for(var u=0;u<this._ints;++u)this.tag.putInt32(this._s[u]^o[u]);return this.tag.truncate(this.tag.length()%(this._tagLength/8)),n.decrypt&&this.tag.bytes()!==this._tag&&(i=!1),i},i.gcm.prototype.multiply=function(e,t){var n=[0,0,0,0],r=t.slice(0);for(var i=0;i<128;++i){var s=e[i/32|0]&1<<31-i%32;s&&(n[0]^=r[0],n[1]^=r[1],n[2]^=r[2],n[3]^=r[3]),this.pow(r,r)}return n},i.gcm.prototype.pow=function(e,t){var n=e[3]&1;for(var r=3;r>0;--r)t[r]=e[r]>>>1|(e[r-1]&1)<<31;t[0]=e[0]>>>1,n&&(t[0]^=this._R)},i.gcm.prototype.tableMultiply=function(e){var t=[0,0,0,0];for(var n=0;n<32;++n){var r=n/8|0,i=e[r]>>>(7-n%8)*4&15,s=this._m[n][i];t[0]^=s[0],t[1]^=s[1],t[2]^=s[2],t[3]^=s[3]}return t},i.gcm.prototype.ghash=function(e,t,n){return t[0]^=n[0],t[1]^=n[1],t[2]^=n[2],t[3]^=n[3],this.tableMultiply(t)},i.gcm.prototype.generateHashTable=function(e,t){var n=8/t,r=4*n,i=16*n,s=new Array(i);for(var o=0;o<i;++o){var u=[0,0,0,0],a=o/r|0,f=(r-1-o%r)*t;u[a]=1<<t-1<<f,s[o]=this.generateSubHashTable(this.multiply(u,e),t)}return s},i.gcm.prototype.generateSubHashTable=function(e,t){var n=1<<t,r=n>>>1,i=new Array(n);i[r]=e.slice(0);var s=r>>>1;while(s>0)this.pow(i[2*s],i[s]=[]),s>>=1;s=2;while(s<r){for(var o=1;o<s;++o){var u=i[s],a=i[o];i[s+o]=[u[0]^a[0],u[1]^a[1],u[2]^a[2],u[3]^a[3]]}s*=2}i[0]=[0,0,0,0];for(s=r+1;s<n;++s){var f=i[s^r];i[s]=[e[0]^f[0],e[1]^f[1],e[2]^f[2],e[3]^f[3]]}return i}}var r="cipherModes";if(typeof n!="function"){if(typeof module!="object"||!module.exports)return typeof forge=="undefined"&&(forge={}),e(forge);var i=!0;n=function(e,n){n(t,module)}}var s,o=function(t,n){n.exports=function(n){var i=s.map(function(e){return t(e)}).concat(e);n=n||{},n.defined=n.defined||{};if(n.defined[r])return n[r];n.defined[r]=!0;for(var o=0;o<i.length;++o)i[o](n);return n[r]}},u=n;n=function(e,t){return s=typeof e=="string"?t.slice(2):e.slice(2),i?(delete n,u.apply(null,Array.prototype.slice.call(arguments,0))):(n=u,n.apply(null,Array.prototype.slice.call(arguments,0)))},n("js/cipherModes",["require","module","./util"],function(){o.apply(null,Array.prototype.slice.call(arguments,0))})}(),function(){function e(e){function t(t,n){var r=function(){return new e.aes.Algorithm(t,n)};e.cipher.registerAlgorithm(t,r)}function n(){o=!0,l=[0,1,2,4,8,16,32,64,128,27,54];var e=new Array(256);for(var t=0;t<128;++t)e[t]=t<<1,e[t+128]=t+128<<1^283;a=new Array(256),f=new Array(256),c=new Array(4),h=new Array(4);for(var t=0;t<4;++t)c[t]=new Array(256),h[t]=new Array(256);var n=0,r=0,i,s,u,p,d,v,m;for(var t=0;t<256;++t){p=r^r<<1^r<<2^r<<3^r<<4,p=p>>8^p&255^99,a[n]=p,f[p]=n,d=e[p],i=e[n],s=e[i],u=e[s],v=d<<24^p<<16^p<<8^(p^d),m=(i^s^u)<<24^(n^u)<<16^(n^s^u)<<8^(n^i^u);for(var g=0;g<4;++g)c[g][n]=v,h[g][p]=m,v=v<<24|v>>>8,m=m<<24|m>>>8;n===0?n=r=1:(n=i^e[e[e[i^u]]],r^=e[e[r]])}}function r(e,t){var n=e.slice(0),r,i=1,s=n.length,o=s+6+1,f=u*o;for(var c=s;c<f;++c)r=n[c-1],c%s===0?(r=a[r>>>16&255]<<24^a[r>>>8&255]<<16^a[r&255]<<8^a[r>>>24]^l[i]<<24,i++):s>6&&c%s===4&&(r=a[r>>>24]<<24^a[r>>>16&255]<<16^a[r>>>8&255]<<8^a[r&255]),n[c]=n[c-s]^r;if(t){var p,d=h[0],v=h[1],m=h[2],g=h[3],y=n.slice(0);f=n.length;for(var c=0,b=f-u;c<f;c+=u,b-=u)if(c===0||c===f-u)y[c]=n[b],y[c+1]=n[b+3],y[c+2]=n[b+2],y[c+3]=n[b+1];else for(var w=0;w<u;++w)p=n[b+w],y[c+(3&-w)]=d[a[p>>>24]]^v[a[p>>>16&255]]^m[a[p>>>8&255]]^g[a[p&255]];n=y}return n}function i(e,t,n,r){var i=e.length/4-1,s,o,u,l,p;r?(s=h[0],o=h[1],u=h[2],l=h[3],p=f):(s=c[0],o=c[1],u=c[2],l=c[3],p=a);var d,v,m,g,y,b,w;d=t[0]^e[0],v=t[r?3:1]^e[1],m=t[2]^e[2],g=t[r?1:3]^e[3];var E=3;for(var S=1;S<i;++S)y=s[d>>>24]^o[v>>>16&255]^u[m>>>8&255]^l[g&255]^e[++E],b=s[v>>>24]^o[m>>>16&255]^u[g>>>8&255]^l[d&255]^e[++E],w=s[m>>>24]^o[g>>>16&255]^u[d>>>8&255]^l[v&255]^e[++E],g=s[g>>>24]^o[d>>>16&255]^u[v>>>8&255]^l[m&255]^e[++E],d=y,v=b,m=w;n[0]=p[d>>>24]<<24^p[v>>>16&255]<<16^p[m>>>8&255]<<8^p[g&255]^e[++E],n[r?3:1]=p[v>>>24]<<24^p[m>>>16&255]<<16^p[g>>>8&255]<<8^p[d&255]^e[++E],n[2]=p[m>>>24]<<24^p[g>>>16&255]<<16^p[d>>>8&255]<<8^p[v&255]^e[++E],n[r?1:3]=p[g>>>24]<<24^p[d>>>16&255]<<16^p[v>>>8&255]<<8^p[m&255]^e[++E]}function s(t){t=t||{};var n=(t.mode||"CBC").toUpperCase(),r="AES-"+n,i;t.decrypt?i=e.cipher.createDecipher(r,t.key):i=e.cipher.createCipher(r,t.key);var s=i.start;return i.start=function(t,n){var r=null;n instanceof e.util.ByteBuffer&&(r=n,n={}),n=n||{},n.output=r,n.iv=t,s.call(i,n)},i}e.aes=e.aes||{},e.aes.startEncrypting=function(e,t,n,r){var i=s({key:e,output:n,decrypt:!1,mode:r});return i.start(t),i},e.aes.createEncryptionCipher=function(e,t){return s({key:e,output:null,decrypt:!1,mode:t})},e.aes.startDecrypting=function(e,t,n,r){var i=s({key:e,output:n,decrypt:!0,mode:r});return i.start(t),i},e.aes.createDecryptionCipher=function(e,t){return s({key:e,output:null,decrypt:!0,mode:t})},e.aes.Algorithm=function(e,t){o||n();var r=this;r.name=e,r.mode=new t({blockSize:16,cipher:{encrypt:function(e,t){return i(r._w,e,t,!1)},decrypt:function(e,t){return i(r._w,e,t,!0)}}}),r._init=!1},e.aes.Algorithm.prototype.initialize=function(t){if(this._init)return;var n=t.key,i;if(typeof n!="string"||n.length!==16&&n.length!==24&&n.length!==32){if(e.util.isArray(n)&&(n.length===16||n.length===24||n.length===32)){i=n,n=e.util.createBuffer();for(var s=0;s<i.length;++s)n.putByte(i[s])}}else n=e.util.createBuffer(n);if(!e.util.isArray(n)){i=n,n=[];var o=i.length();if(o===16||o===24||o===32){o>>>=2;for(var s=0;s<o;++s)n.push(i.getInt32())}}if(!e.util.isArray(n)||n.length!==4&&n.length!==6&&n.length!==8)throw new Error("Invalid key parameter.");var u=this.mode.name,a=["CFB","OFB","CTR","GCM"].indexOf(u)!==-1;this._w=r(n,t.decrypt&&!a),this._init=!0},e.aes._expandKey=function(e,t){return o||n(),r(e,t)},e.aes._updateBlock=i,t("AES-ECB",e.cipher.modes.ecb),t("AES-CBC",e.cipher.modes.cbc),t("AES-CFB",e.cipher.modes.cfb),t("AES-OFB",e.cipher.modes.ofb),t("AES-CTR",e.cipher.modes.ctr),t("AES-GCM",e.cipher.modes.gcm);var o=!1,u=4,a,f,l,c,h}var r="aes";if(typeof n!="function"){if(typeof module!="object"||!module.exports)return typeof forge=="undefined"&&(forge={}),e(forge);var i=!0;n=function(e,n){n(t,module)}}var s,o=function(t,n){n.exports=function(n){var i=s.map(function(e){return t(e)}).concat(e);n=n||{},n.defined=n.defined||{};if(n.defined[r])return n[r];n.defined[r]=!0;for(var o=0;o<i.length;++o)i[o](n);return n[r]}},u=n;n=function(e,t){return s=typeof e=="string"?t.slice(2):e.slice(2),i?(delete n,u.apply(null,Array.prototype.slice.call(arguments,0))):(n=u,n.apply(null,Array.prototype.slice.call(arguments,0)))},n("js/aes",["require","module","./cipher","./cipherModes","./util"],function(){o.apply(null,Array.prototype.slice.call(arguments,0))})}(),function(){function e(e){e.pki=e.pki||{};var t=e.pki.oids=e.oids=e.oids||{};t["1.2.840.113549.1.1.1"]="rsaEncryption",t.rsaEncryption="1.2.840.113549.1.1.1",t["1.2.840.113549.1.1.4"]="md5WithRSAEncryption",t.md5WithRSAEncryption="1.2.840.113549.1.1.4",t["1.2.840.113549.1.1.5"]="sha1WithRSAEncryption",t.sha1WithRSAEncryption="1.2.840.113549.1.1.5",t["1.2.840.113549.1.1.7"]="RSAES-OAEP",t["RSAES-OAEP"]="1.2.840.113549.1.1.7",t["1.2.840.113549.1.1.8"]="mgf1",t.mgf1="1.2.840.113549.1.1.8",t["1.2.840.113549.1.1.9"]="pSpecified",t.pSpecified="1.2.840.113549.1.1.9",t["1.2.840.113549.1.1.10"]="RSASSA-PSS",t["RSASSA-PSS"]="1.2.840.113549.1.1.10",t["1.2.840.113549.1.1.11"]="sha256WithRSAEncryption",t.sha256WithRSAEncryption="1.2.840.113549.1.1.11",t["1.2.840.113549.1.1.12"]="sha384WithRSAEncryption",t.sha384WithRSAEncryption="1.2.840.113549.1.1.12",t["1.2.840.113549.1.1.13"]="sha512WithRSAEncryption",t.sha512WithRSAEncryption="1.2.840.113549.1.1.13",t["1.3.14.3.2.7"]="desCBC",t.desCBC="1.3.14.3.2.7",t["1.3.14.3.2.26"]="sha1",t.sha1="1.3.14.3.2.26",t["2.16.840.1.101.3.4.2.1"]="sha256",t.sha256="2.16.840.1.101.3.4.2.1",t["2.16.840.1.101.3.4.2.2"]="sha384",t.sha384="2.16.840.1.101.3.4.2.2",t["2.16.840.1.101.3.4.2.3"]="sha512",t.sha512="2.16.840.1.101.3.4.2.3",t["1.2.840.113549.2.5"]="md5",t.md5="1.2.840.113549.2.5",t["1.2.840.113549.1.7.1"]="data",t.data="1.2.840.113549.1.7.1",t["1.2.840.113549.1.7.2"]="signedData",t.signedData="1.2.840.113549.1.7.2",t["1.2.840.113549.1.7.3"]="envelopedData",t.envelopedData="1.2.840.113549.1.7.3",t["1.2.840.113549.1.7.4"]="signedAndEnvelopedData",t.signedAndEnvelopedData="1.2.840.113549.1.7.4",t["1.2.840.113549.1.7.5"]="digestedData",t.digestedData="1.2.840.113549.1.7.5",t["1.2.840.113549.1.7.6"]="encryptedData",t.encryptedData="1.2.840.113549.1.7.6",t["1.2.840.113549.1.9.1"]="emailAddress",t.emailAddress="1.2.840.113549.1.9.1",t["1.2.840.113549.1.9.2"]="unstructuredName",t.unstructuredName="1.2.840.113549.1.9.2",t["1.2.840.113549.1.9.3"]="contentType",t.contentType="1.2.840.113549.1.9.3",t["1.2.840.113549.1.9.4"]="messageDigest",t.messageDigest="1.2.840.113549.1.9.4",t["1.2.840.113549.1.9.5"]="signingTime",t.signingTime="1.2.840.113549.1.9.5",t["1.2.840.113549.1.9.6"]="counterSignature",t.counterSignature="1.2.840.113549.1.9.6",t["1.2.840.113549.1.9.7"]="challengePassword",t.challengePassword="1.2.840.113549.1.9.7",t["1.2.840.113549.1.9.8"]="unstructuredAddress",t.unstructuredAddress="1.2.840.113549.1.9.8",t["1.2.840.113549.1.9.14"]="extensionRequest",t.extensionRequest="1.2.840.113549.1.9.14",t["1.2.840.113549.1.9.20"]="friendlyName",t.friendlyName="1.2.840.113549.1.9.20",t["1.2.840.113549.1.9.21"]="localKeyId",t.localKeyId="1.2.840.113549.1.9.21",t["1.2.840.113549.1.9.22.1"]="x509Certificate",t.x509Certificate="1.2.840.113549.1.9.22.1",t["1.2.840.113549.1.12.10.1.1"]="keyBag",t.keyBag="1.2.840.113549.1.12.10.1.1",t["1.2.840.113549.1.12.10.1.2"]="pkcs8ShroudedKeyBag",t.pkcs8ShroudedKeyBag="1.2.840.113549.1.12.10.1.2",t["1.2.840.113549.1.12.10.1.3"]="certBag",t.certBag="1.2.840.113549.1.12.10.1.3",t["1.2.840.113549.1.12.10.1.4"]="crlBag",t.crlBag="1.2.840.113549.1.12.10.1.4",t["1.2.840.113549.1.12.10.1.5"]="secretBag",t.secretBag="1.2.840.113549.1.12.10.1.5",t["1.2.840.113549.1.12.10.1.6"]="safeContentsBag",t.safeContentsBag="1.2.840.113549.1.12.10.1.6",t["1.2.840.113549.1.5.13"]="pkcs5PBES2",t.pkcs5PBES2="1.2.840.113549.1.5.13",t["1.2.840.113549.1.5.12"]="pkcs5PBKDF2",t.pkcs5PBKDF2="1.2.840.113549.1.5.12",t["1.2.840.113549.1.12.1.1"]="pbeWithSHAAnd128BitRC4",t.pbeWithSHAAnd128BitRC4="1.2.840.113549.1.12.1.1",t["1.2.840.113549.1.12.1.2"]="pbeWithSHAAnd40BitRC4",t.pbeWithSHAAnd40BitRC4="1.2.840.113549.1.12.1.2",t["1.2.840.113549.1.12.1.3"]="pbeWithSHAAnd3-KeyTripleDES-CBC",t["pbeWithSHAAnd3-KeyTripleDES-CBC"]="1.2.840.113549.1.12.1.3",t["1.2.840.113549.1.12.1.4"]="pbeWithSHAAnd2-KeyTripleDES-CBC",t["pbeWithSHAAnd2-KeyTripleDES-CBC"]="1.2.840.113549.1.12.1.4",t["1.2.840.113549.1.12.1.5"]="pbeWithSHAAnd128BitRC2-CBC",t["pbeWithSHAAnd128BitRC2-CBC"]="1.2.840.113549.1.12.1.5",t["1.2.840.113549.1.12.1.6"]="pbewithSHAAnd40BitRC2-CBC",t["pbewithSHAAnd40BitRC2-CBC"]="1.2.840.113549.1.12.1.6",t["1.2.840.113549.3.7"]="des-EDE3-CBC",t["des-EDE3-CBC"]="1.2.840.113549.3.7",t["2.16.840.1.101.3.4.1.2"]="aes128-CBC",t["aes128-CBC"]="2.16.840.1.101.3.4.1.2",t["2.16.840.1.101.3.4.1.22"]="aes192-CBC",t["aes192-CBC"]="2.16.840.1.101.3.4.1.22",t["2.16.840.1.101.3.4.1.42"]="aes256-CBC",t["aes256-CBC"]="2.16.840.1.101.3.4.1.42",t["2.5.4.3"]="commonName",t.commonName="2.5.4.3",t["2.5.4.5"]="serialName",t.serialName="2.5.4.5",t["2.5.4.6"]="countryName",t.countryName="2.5.4.6",t["2.5.4.7"]="localityName",t.localityName="2.5.4.7",t["2.5.4.8"]="stateOrProvinceName",t.stateOrProvinceName="2.5.4.8",t["2.5.4.10"]="organizationName",t.organizationName="2.5.4.10",t["2.5.4.11"]="organizationalUnitName",t.organizationalUnitName="2.5.4.11",t["2.16.840.1.113730.1.1"]="nsCertType",t.nsCertType="2.16.840.1.113730.1.1",t["2.5.29.1"]="authorityKeyIdentifier",t["2.5.29.2"]="keyAttributes",t["2.5.29.3"]="certificatePolicies",t["2.5.29.4"]="keyUsageRestriction",t["2.5.29.5"]="policyMapping",t["2.5.29.6"]="subtreesConstraint",t["2.5.29.7"]="subjectAltName",t["2.5.29.8"]="issuerAltName",t["2.5.29.9"]="subjectDirectoryAttributes",t["2.5.29.10"]="basicConstraints",t["2.5.29.11"]="nameConstraints",t["2.5.29.12"]="policyConstraints",t["2.5.29.13"]="basicConstraints",t["2.5.29.14"]="subjectKeyIdentifier",t.subjectKeyIdentifier="2.5.29.14",t["2.5.29.15"]="keyUsage",t.keyUsage="2.5.29.15",t["2.5.29.16"]="privateKeyUsagePeriod",t["2.5.29.17"]="subjectAltName",t.subjectAltName="2.5.29.17",t["2.5.29.18"]="issuerAltName",t.issuerAltName="2.5.29.18",t["2.5.29.19"]="basicConstraints",t.basicConstraints="2.5.29.19",t["2.5.29.20"]="cRLNumber",t["2.5.29.21"]="cRLReason",t["2.5.29.22"]="expirationDate",t["2.5.29.23"]="instructionCode",t["2.5.29.24"]="invalidityDate",t["2.5.29.25"]="cRLDistributionPoints",t["2.5.29.26"]="issuingDistributionPoint",t["2.5.29.27"]="deltaCRLIndicator",t["2.5.29.28"]="issuingDistributionPoint",t["2.5.29.29"]="certificateIssuer",t["2.5.29.30"]="nameConstraints",t["2.5.29.31"]="cRLDistributionPoints",t["2.5.29.32"]="certificatePolicies",t["2.5.29.33"]="policyMappings",t["2.5.29.34"]="policyConstraints",t["2.5.29.35"]="authorityKeyIdentifier",t["2.5.29.36"]="policyConstraints",t["2.5.29.37"]="extKeyUsage",t.extKeyUsage="2.5.29.37",t["2.5.29.46"]="freshestCRL",t["2.5.29.54"]="inhibitAnyPolicy",t["1.3.6.1.5.5.7.3.1"]="serverAuth",t.serverAuth="1.3.6.1.5.5.7.3.1",t["1.3.6.1.5.5.7.3.2"]="clientAuth",t.clientAuth="1.3.6.1.5.5.7.3.2",t["1.3.6.1.5.5.7.3.3"]="codeSigning",t.codeSigning="1.3.6.1.5.5.7.3.3",t["1.3.6.1.5.5.7.3.4"]="emailProtection",t.emailProtection="1.3.6.1.5.5.7.3.4",t["1.3.6.1.5.5.7.3.8"]="timeStamping",t.timeStamping="1.3.6.1.5.5.7.3.8"}var r="oids";if(typeof n!="function"){if(typeof module!="object"||!module.exports)return typeof forge=="undefined"&&(forge={}),e(forge);var i=!0;n=function(e,n){n(t,module)}}var s,o=function(t,n){n.exports=function(n){var i=s.map(function(e){return t(e)}).concat(e);n=n||{},n.defined=n.defined||{};if(n.defined[r])return n[r];n.defined[r]=!0;for(var o=0;o<i.length;++o)i[o](n);return n[r]}},u=n;n=function(e,t){return s=typeof e=="string"?t.slice(2):e.slice(2),i?(delete n,u.apply(null,Array.prototype.slice.call(arguments,0))):(n=u,n.apply(null,Array.prototype.slice.call(arguments,0)))},n("js/oids",["require","module"],function(){o.apply(null,Array.prototype.slice.call(arguments,0))})}(),function(){function e(e){var t=e.asn1=e.asn1||{};t.Class={UNIVERSAL:0,APPLICATION:64,CONTEXT_SPECIFIC:128,PRIVATE:192},t.Type={NONE:0,BOOLEAN:1,INTEGER:2,BITSTRING:3,OCTETSTRING:4,NULL:5,OID:6,ODESC:7,EXTERNAL:8,REAL:9,ENUMERATED:10,EMBEDDED:11,UTF8:12,ROID:13,SEQUENCE:16,SET:17,PRINTABLESTRING:19,IA5STRING:22,UTCTIME:23,GENERALIZEDTIME:24,BMPSTRING:30},t.create=function(t,n,r,i){if(e.util.isArray(i)){var s=[];for(var o=0;o<i.length;++o)i[o]!==undefined&&s.push(i[o]);i=s}return{tagClass:t,type:n,constructed:r,composed:r||e.util.isArray(i),value:i}};var n=function(e){var t=e.getByte();if(t===128)return undefined;var n,r=t&128;return r?n=e.getInt((t&127)<<3):n=t,n};t.fromDer=function(r,i){i===undefined&&(i=!0),typeof r=="string"&&(r=e.util.createBuffer(r));if(r.length()<2){var s=new Error("Too few bytes to parse DER.");throw s.bytes=r.length(),s}var o=r.getByte(),u=o&192,a=o&31,f=n(r);if(r.length()<f){if(i){var s=new Error("Too few bytes to read ASN.1 value.");throw s.detail=r.length()+" < "+f,s}f=r.length()}var l,c=(o&32)===32,h=c;if(!h&&u===t.Class.UNIVERSAL&&a===t.Type.BITSTRING&&f>1){var p=r.read,d=r.getByte();if(d===0){o=r.getByte();var v=o&192;if(v===t.Class.UNIVERSAL||v===t.Class.CONTEXT_SPECIFIC)try{var m=n(r);h=m===f-(r.read-p),h&&(++p,--f)}catch(g){}}r.read=p}if(h){l=[];if(f===undefined)for(;;){if(r.bytes(2)===String.fromCharCode(0,0)){r.getBytes(2);break}l.push(t.fromDer(r,i))}else{var y=r.length();while(f>0)l.push(t.fromDer(r,i)),f-=y-r.length(),y=r.length()}}else{if(f===undefined){if(i)throw new Error("Non-constructed ASN.1 object of indefinite length.");f=r.length()}if(a===t.Type.BMPSTRING){l="";for(var b=0;b<f;b+=2)l+=String.fromCharCode(r.getInt16())}else l=r.getBytes(f)}return t.create(u,a,c,l)},t.toDer=function(n){var r=e.util.createBuffer(),i=n.tagClass|n.type,s=e.util.createBuffer();if(n.composed){n.constructed?i|=32:s.putByte(0);for(var o=0;o<n.value.length;++o)n.value[o]!==undefined&&s.putBuffer(t.toDer(n.value[o]))}else if(n.type===t.Type.BMPSTRING)for(var o=0;o<n.value.length;++o)s.putInt16(n.value.charCodeAt(o));else s.putBytes(n.value);r.putByte(i);if(s.length()<=127)r.putByte(s.length()&127);else{var u=s.length(),a="";do a+=String.fromCharCode(u&255),u>>>=8;while(u>0);r.putByte(a.length|128);for(var o=a.length-1;o>=0;--o)r.putByte(a.charCodeAt(o))}return r.putBuffer(s),r},t.oidToDer=function(t){var n=t.split("."),r=e.util.createBuffer();r.putByte(40*parseInt(n[0],10)+parseInt(n[1],10));var i,s,o,u;for(var a=2;a<n.length;++a){i=!0,s=[],o=parseInt(n[a],10);do u=o&127,o>>>=7,i||(u|=128),s.push(u),i=!1;while(o>0);for(var f=s.length-1;f>=0;--f)r.putByte(s[f])}return r},t.derToOid=function(t){var n;typeof t=="string"&&(t=e.util.createBuffer(t));var r=t.getByte();n=Math.floor(r/40)+"."+r%40;var i=0;while(t.length()>0)r=t.getByte(),i<<=7,r&128?i+=r&127:(n+="."+(i+r),i=0);return n},t.utcTimeToDate=function(e){var t=new Date,n=parseInt(e.substr(0,2),10);n=n>=50?1900+n:2e3+n;var r=parseInt(e.substr(2,2),10)-1,i=parseInt(e.substr(4,2),10),s=parseInt(e.substr(6,2),10),o=parseInt(e.substr(8,2),10),u=0;if(e.length>11){var a=e.charAt(10),f=10;a!=="+"&&a!=="-"&&(u=parseInt(e.substr(10,2),10),f+=2)}t.setUTCFullYear(n,r,i),t.setUTCHours(s,o,u,0);if(f){a=e.charAt(f);if(a==="+"||a==="-"){var l=parseInt(e.substr(f+1,2),10),c=parseInt(e.substr(f+4,2),10),h=l*60+c;h*=6e4,a==="+"?t.setTime(+t-h):t.setTime(+t+h)}}return t},t.generalizedTimeToDate=function(e){var t=new Date,n=parseInt(e.substr(0,4),10),r=parseInt(e.substr(4,2),10)-1,i=parseInt(e.substr(6,2),10),s=parseInt(e.substr(8,2),10),o=parseInt(e.substr(10,2),10),u=parseInt(e.substr(12,2),10),a=0,f=0,l=!1;e.charAt(e.length-1)==="Z"&&(l=!0);var c=e.length-5,h=e.charAt(c);if(h==="+"||h==="-"){var p=parseInt(e.substr(c+1,2),10),d=parseInt(e.substr(c+4,2),10);f=p*60+d,f*=6e4,h==="+"&&(f*=-1),l=!0}return e.charAt(14)==="."&&(a=parseFloat(e.substr(14),10)*1e3),l?(t.setUTCFullYear(n,r,i),t.setUTCHours(s,o,u,a),t.setTime(+t+f)):(t.setFullYear(n,r,i),t.setHours(s,o,u,a)),t},t.dateToUtcTime=function(e){var t="",n=[];n.push((""+e.getUTCFullYear()).substr(2)),n.push(""+(e.getUTCMonth()+1)),n.push(""+e.getUTCDate()),n.push(""+e.getUTCHours()),n.push(""+e.getUTCMinutes()),n.push(""+e.getUTCSeconds());for(var r=0;r<n.length;++r)n[r].length<2&&(t+="0"),t+=n[r];return t+="Z",t},t.integerToDer=function(t){var n=e.util.createBuffer();if(t>=-128&&t<128)return n.putSignedInt(t,8);if(t>=-32768&&t<32768)return n.putSignedInt(t,16);if(t>=-8388608&&t<8388608)return n.putSignedInt(t,24);if(t>=-2147483648&&t<2147483648)return n.putSignedInt(t,32);var r=new Error("Integer too large; max is 32-bits.");throw r.integer=t,r},t.derToInteger=function(t){typeof t=="string"&&(t=e.util.createBuffer(t));var n=t.length()*8;if(n>32)throw new Error("Integer too large; max is 32-bits.");return t.getSignedInt(n)},t.validate=function(n,r,i,s){var o=!1;if(n.tagClass!==r.tagClass&&typeof r.tagClass!="undefined"||n.type!==r.type&&typeof r.type!="undefined")s&&(n.tagClass!==r.tagClass&&s.push("["+r.name+"] "+'Expected tag class "'+r.tagClass+'", got "'+n.tagClass+'"'),n.type!==r.type&&s.push("["+r.name+"] "+'Expected type "'+r.type+'", got "'+n.type+'"'));else if(n.constructed===r.constructed||typeof r.constructed=="undefined"){o=!0;if(r.value&&e.util.isArray(r.value)){var u=0;for(var a=0;o&&a<r.value.length;++a)o=r.value[a].optional||!1,n.value[u]&&(o=t.validate(n.value[u],r.value[a],i,s),o?++u:r.value[a].optional&&(o=!0)),!o&&s&&s.push("["+r.name+"] "+'Tag class "'+r.tagClass+'", type "'+r.type+'" expected value length "'+r.value.length+'", got "'+n.value.length+'"')}o&&i&&(r.capture&&(i[r.capture]=n.value),r.captureAsn1&&(i[r.captureAsn1]=n))}else s&&s.push("["+r.name+"] "+'Expected constructed "'+r.constructed+'", got "'+n.constructed+'"');return o};var r=/[^\\u0000-\\u00ff]/;t.prettyPrint=function(n,i,s){var o="";i=i||0,s=s||2,i>0&&(o+="\n");var u="";for(var a=0;a<i*s;++a)u+=" ";o+=u+"Tag: ";switch(n.tagClass){case t.Class.UNIVERSAL:o+="Universal:";break;case t.Class.APPLICATION:o+="Application:";break;case t.Class.CONTEXT_SPECIFIC:o+="Context-Specific:";break;case t.Class.PRIVATE:o+="Private:"}if(n.tagClass===t.Class.UNIVERSAL){o+=n.type;switch(n.type){case t.Type.NONE:o+=" (None)";break;case t.Type.BOOLEAN:o+=" (Boolean)";break;case t.Type.BITSTRING:o+=" (Bit string)";break;case t.Type.INTEGER:o+=" (Integer)";break;case t.Type.OCTETSTRING:o+=" (Octet string)";break;case t.Type.NULL:o+=" (Null)";break;case t.Type.OID:o+=" (Object Identifier)";break;case t.Type.ODESC:o+=" (Object Descriptor)";break;case t.Type.EXTERNAL:o+=" (External or Instance of)";break;case t.Type.REAL:o+=" (Real)";break;case t.Type.ENUMERATED:o+=" (Enumerated)";break;case t.Type.EMBEDDED:o+=" (Embedded PDV)";break;case t.Type.UTF8:o+=" (UTF8)";break;case t.Type.ROID:o+=" (Relative Object Identifier)";break;case t.Type.SEQUENCE:o+=" (Sequence)";break;case t.Type.SET:o+=" (Set)";break;case t.Type.PRINTABLESTRING:o+=" (Printable String)";break;case t.Type.IA5String:o+=" (IA5String (ASCII))";break;case t.Type.UTCTIME:o+=" (UTC time)";break;case t.Type.GENERALIZEDTIME:o+=" (Generalized time)";break;case t.Type.BMPSTRING:o+=" (BMP String)"}}else o+=n.type;o+="\n",o+=u+"Constructed: "+n.constructed+"\n";if(n.composed){var f=0,l="";for(var a=0;a<n.value.length;++a)n.value[a]!==undefined&&(f+=1,l+=t.prettyPrint(n.value[a],i+1,s),a+1<n.value.length&&(l+=","));o+=u+"Sub values: "+f+l}else{o+=u+"Value: ";if(n.type===t.Type.OID){var c=t.derToOid(n.value);o+=c,e.pki&&e.pki.oids&&c in e.pki.oids&&(o+=" ("+e.pki.oids[c]+") ")}if(n.type===t.Type.INTEGER)try{o+=t.derToInteger(n.value)}catch(h){o+="0x"+e.util.bytesToHex(n.value)}else n.type===t.Type.OCTETSTRING?(r.test(n.value)||(o+="("+n.value+") "),o+="0x"+e.util.bytesToHex(n.value)):n.type===t.Type.UTF8?o+=e.util.decodeUtf8(n.value):n.type===t.Type.PRINTABLESTRING||n.type===t.Type.IA5String?o+=n.value:r.test(n.value)?o+="0x"+e.util.bytesToHex(n.value):n.value.length===0?o+="[null]":o+=n.value}return o}}var r="asn1";if(typeof n!="function"){if(typeof module!="object"||!module.exports)return typeof forge=="undefined"&&(forge={}),e(forge);var i=!0;n=function(e,n){n(t,module)}}var s,o=function(t,n){n.exports=function(n){var i=s.map(function(e){return t(e)}).concat(e);n=n||{},n.defined=n.defined||{};if(n.defined[r])return n[r];n.defined[r]=!0;for(var o=0;o<i.length;++o)i[o](n);return n[r]}},u=n;n=function(e,t){return s=typeof e=="string"?t.slice(2):e.slice(2),i?(delete n,u.apply(null,Array.prototype.slice.call(arguments,0))):(n=u,n.apply(null,Array.prototype.slice.call(arguments,0)))},n("js/asn1",["require","module","./util","./oids"],function(){o.apply(null,Array.prototype.slice.call(arguments,0))})}(),function(){function e(e){function t(){i=String.fromCharCode(128),i+=e.util.fillString(String.fromCharCode(0),64),s=[0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,1,6,11,0,5,10,15,4,9,14,3,8,13,2,7,12,5,8,11,14,1,4,7,10,13,0,3,6,9,12,15,2,0,7,14,5,12,3,10,1,8,15,6,13,4,11,2,9],o=[7,12,17,22,7,12,17,22,7,12,17,22,7,12,17,22,5,9,14,20,5,9,14,20,5,9,14,20,5,9,14,20,4,11,16,23,4,11,16,23,4,11,16,23,4,11,16,23,6,10,15,21,6,10,15,21,6,10,15,21,6,10,15,21],u=new Array(64);for(var t=0;t<64;++t)u[t]=Math.floor(Math.abs(Math.sin(t+1))*4294967296);a=!0}function n(e,t,n){var r,i,a,f,l,c,h,p,d=n.length();while(d>=64){i=e.h0,a=e.h1,f=e.h2,l=e.h3;for(p=0;p<16;++p)t[p]=n.getInt32Le(),c=l^a&(f^l),r=i+c+u[p]+t[p],h=o[p],i=l,l=f,f=a,a+=r<<h|r>>>32-h;for(;p<32;++p)c=f^l&(a^f),r=i+c+u[p]+t[s[p]],h=o[p],i=l,l=f,f=a,a+=r<<h|r>>>32-h;for(;p<48;++p)c=a^f^l,r=i+c+u[p]+t[s[p]],h=o[p],i=l,l=f,f=a,a+=r<<h|r>>>32-h;for(;p<64;++p)c=f^(a|~l),r=i+c+u[p]+t[s[p]],h=o[p],i=l,l=f,f=a,a+=r<<h|r>>>32-h;e.h0=e.h0+i|0,e.h1=e.h1+a|0,e.h2=e.h2+f|0,e.h3=e.h3+l|0,d-=64}}var r=e.md5=e.md5||{};e.md=e.md||{},e.md.algorithms=e.md.algorithms||{},e.md.md5=e.md.algorithms.md5=r,r.create=function(){a||t();var r=null,s=e.util.createBuffer(),o=new Array(16),u={algorithm:"md5",blockLength:64,digestLength:16,messageLength:0,messageLength64:[0,0]};return u.start=function(){return u.messageLength=0,u.messageLength64=[0,0],s=e.util.createBuffer(),r={h0:1732584193,h1:4023233417,h2:2562383102,h3:271733878},u},u.start(),u.update=function(t,i){return i==="utf8"&&(t=e.util.encodeUtf8(t)),u.messageLength+=t.length,u.messageLength64[0]+=t.length/4294967296>>>0,u.messageLength64[1]+=t.length>>>0,s.putBytes(t),n(r,o,s),(s.read>2048||s.length()===0)&&s.compact(),u},u.digest=function(){var t=e.util.createBuffer();t.putBytes(s.bytes()),t.putBytes(i.substr(0,64-(u.messageLength64[1]+8&63))),t.putInt32Le(u.messageLength64[1]<<3),t.putInt32Le(u.messageLength64[0]<<3|u.messageLength64[0]>>>28);var a={h0:r.h0,h1:r.h1,h2:r.h2,h3:r.h3};n(a,o,t);var f=e.util.createBuffer();return f.putInt32Le(a.h0),f.putInt32Le(a.h1),f.putInt32Le(a.h2),f.putInt32Le(a.h3),f},u};var i=null,s=null,o=null,u=null,a=!1}var r="md5";if(typeof n!="function"){if(typeof module!="object"||!module.exports)return typeof forge=="undefined"&&(forge={}),e(forge);var i=!0;n=function(e,n){n(t,module)}}var s,o=function(t,n){n.exports=function(n){var i=s.map(function(e){return t(e)}).concat(e);n=n||{},n.defined=n.defined||{};if(n.defined[r])return n[r];n.defined[r]=!0;for(var o=0;o<i.length;++o)i[o](n);return n[r]}},u=n;n=function(e,t){return s=typeof e=="string"?t.slice(2):e.slice(2),i?(delete n,u.apply(null,Array.prototype.slice.call(arguments,0))):(n=u,n.apply(null,Array.prototype.slice.call(arguments,0)))},n("js/md5",["require","module","./util"],function(){o.apply(null,Array.prototype.slice.call(arguments,0))})}(),function(){function e(e){function t(){i=String.fromCharCode(128),i+=e.util.fillString(String.fromCharCode(0),64),s=!0}function n(e,t,n){var r,i,s,o,u,a,f,l,c=n.length();while(c>=64){i=e.h0,s=e.h1,o=e.h2,u=e.h3,a=e.h4;for(l=0;l<16;++l)r=n.getInt32(),t[l]=r,f=u^s&(o^u),r=(i<<5|i>>>27)+f+a+1518500249+r,a=u,u=o,o=s<<30|s>>>2,s=i,i=r;for(;l<20;++l)r=t[l-3]^t[l-8]^t[l-14]^t[l-16],r=r<<1|r>>>31,t[l]=r,f=u^s&(o^u),r=(i<<5|i>>>27)+f+a+1518500249+r,a=u,u=o,o=s<<30|s>>>2,s=i,i=r;for(;l<32;++l)r=t[l-3]^t[l-8]^t[l-14]^t[l-16],r=r<<1|r>>>31,t[l]=r,f=s^o^u,r=(i<<5|i>>>27)+f+a+1859775393+r,a=u,u=o,o=s<<30|s>>>2,s=i,i=r;for(;l<40;++l)r=t[l-6]^t[l-16]^t[l-28]^t[l-32],r=r<<2|r>>>30,t[l]=r,f=s^o^u,r=(i<<5|i>>>27)+f+a+1859775393+r,a=u,u=o,o=s<<30|s>>>2,s=i,i=r;for(;l<60;++l)r=t[l-6]^t[l-16]^t[l-28]^t[l-32],r=r<<2|r>>>30,t[l]=r,f=s&o|u&(s^o),r=(i<<5|i>>>27)+f+a+2400959708+r,a=u,u=o,o=s<<30|s>>>2,s=i,i=r;for(;l<80;++l)r=t[l-6]^t[l-16]^t[l-28]^t[l-32],r=r<<2|r>>>30,t[l]=r,f=s^o^u,r=(i<<5|i>>>27)+f+a+3395469782+r,a=u,u=o,o=s<<30|s>>>2,s=i,i=r;e.h0=e.h0+i|0,e.h1=e.h1+s|0,e.h2=e.h2+o|0,e.h3=e.h3+u|0,e.h4=e.h4+a|0,c-=64}}var r=e.sha1=e.sha1||{};e.md=e.md||{},e.md.algorithms=e.md.algorithms||{},e.md.sha1=e.md.algorithms.sha1=r,r.create=function(){s||t();var r=null,o=e.util.createBuffer(),u=new Array(80),a={algorithm:"sha1",blockLength:64,digestLength:20,messageLength:0,messageLength64:[0,0]};return a.start=function(){return a.messageLength=0,a.messageLength64=[0,0],o=e.util.createBuffer(),r={h0:1732584193,h1:4023233417,h2:2562383102,h3:271733878,h4:3285377520},a},a.start(),a.update=function(t,i){return i==="utf8"&&(t=e.util.encodeUtf8(t)),a.messageLength+=t.length,a.messageLength64[0]+=t.length/4294967296>>>0,a.messageLength64[1]+=t.length>>>0,o.putBytes(t),n(r,u,o),(o.read>2048||o.length()===0)&&o.compact(),a},a.digest=function(){var t=e.util.createBuffer();t.putBytes(o.bytes()),t.putBytes(i.substr(0,64-(a.messageLength64[1]+8&63))),t.putInt32(a.messageLength64[0]<<3|a.messageLength64[0]>>>28),t.putInt32(a.messageLength64[1]<<3);var s={h0:r.h0,h1:r.h1,h2:r.h2,h3:r.h3,h4:r.h4};n(s,u,t);var f=e.util.createBuffer();return f.putInt32(s.h0),f.putInt32(s.h1),f.putInt32(s.h2),f.putInt32(s.h3),f.putInt32(s.h4),f},a};var i=null,s=!1}var r="sha1";if(typeof n!="function"){if(typeof module!="object"||!module.exports)return typeof forge=="undefined"&&(forge={}),e(forge);var i=!0;n=function(e,n){n(t,module)}}var s,o=function(t,n){n.exports=function(n){var i=s.map(function(e){return t(e)}).concat(e);n=n||{},n.defined=n.defined||{};if(n.defined[r])return n[r];n.defined[r]=!0;for(var o=0;o<i.length;++o)i[o](n);return n[r]}},u=n;n=function(e,t){return s=typeof e=="string"?t.slice(2):e.slice(2),i?(delete n,u.apply(null,Array.prototype.slice.call(arguments,0))):(n=u,n.apply(null,Array.prototype.slice.call(arguments,0)))},n("js/sha1",["require","module","./util"],function(){o.apply(null,Array.prototype.slice.call(arguments,0))})}(),function(){function e(e){function t(){i=String.fromCharCode(128),i+=e.util.fillString(String.fromCharCode(0),64),o=[1116352408,1899447441,3049323471,3921009573,961987163,1508970993,2453635748,2870763221,3624381080,310598401,607225278,1426881987,1925078388,2162078206,2614888103,3248222580,3835390401,4022224774,264347078,604807628,770255983,1249150122,1555081692,1996064986,2554220882,2821834349,2952996808,3210313671,3336571891,3584528711,113926993,338241895,666307205,773529912,1294757372,1396182291,1695183700,1986661051,2177026350,2456956037,2730485921,2820302411,3259730800,3345764771,3516065817,3600352804,4094571909,275423344,430227734,506948616,659060556,883997877,958139571,1322822218,1537002063,1747873779,1955562222,2024104815,2227730452,2361852424,2428436474,2756734187,3204031479,3329325298],s=!0}function n(e,t,n){var r,i,s,u,a,f,l,c,h,p,d,v,m,g,y,b=n.length();while(b>=64){for(l=0;l<16;++l)t[l]=n.getInt32();for(;l<64;++l)r=t[l-2],r=(r>>>17|r<<15)^(r>>>19|r<<13)^r>>>10,i=t[l-15],i=(i>>>7|i<<25)^(i>>>18|i<<14)^i>>>3,t[l]=r+t[l-7]+i+t[l-16]|0;c=e.h0,h=e.h1,p=e.h2,d=e.h3,v=e.h4,m=e.h5,g=e.h6,y=e.h7;for(l=0;l<64;++l)u=(v>>>6|v<<26)^(v>>>11|v<<21)^(v>>>25|v<<7),a=g^v&(m^g),s=(c>>>2|c<<30)^(c>>>13|c<<19)^(c>>>22|c<<10),f=c&h|p&(c^h),r=y+u+a+o[l]+t[l],i=s+f,y=g,g=m,m=v,v=d+r|0,d=p,p=h,h=c,c=r+i|0;e.h0=e.h0+c|0,e.h1=e.h1+h|0,e.h2=e.h2+p|0,e.h3=e.h3+d|0,e.h4=e.h4+v|0,e.h5=e.h5+m|0,e.h6=e.h6+g|0,e.h7=e.h7+y|0,b-=64}}var r=e.sha256=e.sha256||{};e.md=e.md||{},e.md.algorithms=e.md.algorithms||{},e.md.sha256=e.md.algorithms.sha256=r,r.create=function(){s||t();var r=null,o=e.util.createBuffer(),u=new Array(64),a={algorithm:"sha256",blockLength:64,digestLength:32,messageLength:0,messageLength64:[0,0]};return a.start=function(){return a.messageLength=0,a.messageLength64=[0,0],o=e.util.createBuffer(),r={h0:1779033703,h1:3144134277,h2:1013904242,h3:2773480762,h4:1359893119,h5:2600822924,h6:528734635,h7:1541459225},a},a.start(),a.update=function(t,i){return i==="utf8"&&(t=e.util.encodeUtf8(t)),a.messageLength+=t.length,a.messageLength64[0]+=t.length/4294967296>>>0,a.messageLength64[1]+=t.length>>>0,o.putBytes(t),n(r,u,o),(o.read>2048||o.length()===0)&&o.compact(),a},a.digest=function(){var t=e.util.createBuffer();t.putBytes(o.bytes()),t.putBytes(i.substr(0,64-(a.messageLength64[1]+8&63))),t.putInt32(a.messageLength64[0]<<3|a.messageLength64[0]>>>28),t.putInt32(a.messageLength64[1]<<3);var s={h0:r.h0,h1:r.h1,h2:r.h2,h3:r.h3,h4:r.h4,h5:r.h5,h6:r.h6,h7:r.h7};n(s,u,t);var f=e.util.createBuffer();return f.putInt32(s.h0),f.putInt32(s.h1),f.putInt32(s.h2),f.putInt32(s.h3),f.putInt32(s.h4),f.putInt32(s.h5),f.putInt32(s.h6),f.putInt32(s.h7),f},a};var i=null,s=!1,o=null}var r="sha256";if(typeof n!="function"){if(typeof module!="object"||!module.exports)return typeof forge=="undefined"&&(forge={}),e(forge);var i=!0;n=function(e,n){n(t,module)}}var s,o=function(t,n){n.exports=function(n){var i=s.map(function(e){return t(e)}).concat(e);n=n||{},n.defined=n.defined||{};if(n.defined[r])return n[r];n.defined[r]=!0;for(var o=0;o<i.length;++o)i[o](n);return n[r]}},u=n;n=function(e,t){return s=typeof e=="string"?t.slice(2):e.slice(2),i?(delete n,u.apply(null,Array.prototype.slice.call(arguments,0))):(n=u,n.apply(null,Array.prototype.slice.call(arguments,0)))},n("js/sha256",["require","module","./util"],function(){o.apply(null,Array.prototype.slice.call(arguments,0))})}(),function(){function e(e){function t(){s=String.fromCharCode(128),s+=e.util.fillString(String.fromCharCode(0),128),u=[[1116352408,3609767458],[1899447441,602891725],[3049323471,3964484399],[3921009573,2173295548],[961987163,4081628472],[1508970993,3053834265],[2453635748,2937671579],[2870763221,3664609560],[3624381080,2734883394],[310598401,1164996542],[607225278,1323610764],[1426881987,3590304994],[1925078388,4068182383],[2162078206,991336113],[2614888103,633803317],[3248222580,3479774868],[3835390401,2666613458],[4022224774,944711139],[264347078,2341262773],[604807628,2007800933],[770255983,1495990901],[1249150122,1856431235],[1555081692,3175218132],[1996064986,2198950837],[2554220882,3999719339],[2821834349,766784016],[2952996808,2566594879],[3210313671,3203337956],[3336571891,1034457026],[3584528711,2466948901],[113926993,3758326383],[338241895,168717936],[666307205,1188179964],[773529912,1546045734],[1294757372,1522805485],[1396182291,2643833823],[1695183700,2343527390],[1986661051,1014477480],[2177026350,1206759142],[2456956037,344077627],[2730485921,1290863460],[2820302411,3158454273],[3259730800,3505952657],[3345764771,106217008],[3516065817,3606008344],[3600352804,1432725776],[4094571909,1467031594],[275423344,851169720],[430227734,3100823752],[506948616,1363258195],[659060556,3750685593],[883997877,3785050280],[958139571,3318307427],[1322822218,3812723403],[1537002063,2003034995],[1747873779,3602036899],[1955562222,1575990012],[2024104815,1125592928],[2227730452,2716904306],[2361852424,442776044],[2428436474,593698344],[2756734187,3733110249],[3204031479,2999351573],[3329325298,3815920427],[3391569614,3928383900],[3515267271,566280711],[3940187606,3454069534],[4118630271,4000239992],[116418474,1914138554],[174292421,2731055270],[289380356,3203993006],[460393269,320620315],[685471733,587496836],[852142971,1086792851],[1017036298,365543100],[1126000580,2618297676],[1288033470,3409855158],[1501505948,4234509866],[1607167915,987167468],[1816402316,1246189591]],a={},a["SHA-512"]=[[1779033703,4089235720],[3144134277,2227873595],[1013904242,4271175723],[2773480762,1595750129],[1359893119,2917565137],[2600822924,725511199],[528734635,4215389547],[1541459225,327033209]],a["SHA-384"]=[[3418070365,3238371032],[1654270250,914150663],[2438529370,812702999],[355462360,4144912697],[1731405415,4290775857],[2394180231,1750603025],[3675008525,1694076839],[1203062813,3204075428]],a["SHA-512/256"]=[[573645204,4230739756],[2673172387,3360449730],[596883563,1867755857],[2520282905,1497426621],[2519219938,2827943907],[3193839141,1401305490],[721525244,746961066],[246885852,2177182882]],a["SHA-512/224"]=[[2352822216,424955298],[1944164710,2312950998],[502970286,855612546],[1738396948,1479516111],[258812777,2077511080],[2011393907,79989058],[1067287976,1780299464],[286451373,2446758561]],o=!0}function n(e,t,n){var r,i,s,o,a,f,l,c,h,p,d,v,m,g,y,b,w,E,S,x,T,N,C,k,L,A,O,M,_,D,P,H,B,j,F,I=n.length();while(I>=128){for(_=0;_<16;++_)t[_][0]=n.getInt32()>>>0,t[_][1]=n.getInt32()>>>0;for(;_<80;++_)H=t[_-2],D=H[0],P=H[1],r=((D>>>19|P<<13)^(P>>>29|D<<3)^D>>>6)>>>0,i=((D<<13|P>>>19)^(P<<3|D>>>29)^(D<<26|P>>>6))>>>0,j=t[_-15],D=j[0],P=j[1],s=((D>>>1|P<<31)^(D>>>8|P<<24)^D>>>7)>>>0,o=((D<<31|P>>>1)^(D<<24|P>>>8)^(D<<25|P>>>7))>>>0,B=t[_-7],F=t[_-16],P=i+B[1]+o+F[1],t[_][0]=r+B[0]+s+F[0]+(P/4294967296>>>0)>>>0,t[_][1]=P>>>0;m=e[0][0],g=e[0][1],y=e[1][0],b=e[1][1],w=e[2][0],E=e[2][1],S=e[3][0],x=e[3][1],T=e[4][0],N=e[4][1],C=e[5][0],k=e[5][1],L=e[6][0],A=e[6][1],O=e[7][0],M=e[7][1];for(_=0;_<80;++_)l=((T>>>14|N<<18)^(T>>>18|N<<14)^(N>>>9|T<<23))>>>0,c=((T<<18|N>>>14)^(T<<14|N>>>18)^(N<<23|T>>>9))>>>0,h=(L^T&(C^L))>>>0,p=(A^N&(k^A))>>>0,a=((m>>>28|g<<4)^(g>>>2|m<<30)^(g>>>7|m<<25))>>>0,f=((m<<4|g>>>28)^(g<<30|m>>>2)^(g<<25|m>>>7))>>>0,d=(m&y|w&(m^y))>>>0,v=(g&b|E&(g^b))>>>0,P=M+c+p+u[_][1]+t[_][1],r=O+l+h+u[_][0]+t[_][0]+(P/4294967296>>>0)>>>0,i=P>>>0,P=f+v,s=a+d+(P/4294967296>>>0)>>>0,o=P>>>0,O=L,M=A,L=C,A=k,C=T,k=N,P=x+i,T=S+r+(P/4294967296>>>0)>>>0,N=P>>>0,S=w,x=E,w=y,E=b,y=m,b=g,P=i+o,m=r+s+(P/4294967296>>>0)>>>0,g=P>>>0;P=e[0][1]+g,e[0][0]=e[0][0]+m+(P/4294967296>>>0)>>>0,e[0][1]=P>>>0,P=e[1][1]+b,e[1][0]=e[1][0]+y+(P/4294967296>>>0)>>>0,e[1][1]=P>>>0,P=e[2][1]+E,e[2][0]=e[2][0]+w+(P/4294967296>>>0)>>>0,e[2][1]=P>>>0,P=e[3][1]+x,e[3][0]=e[3][0]+S+(P/4294967296>>>0)>>>0,e[3][1]=P>>>0,P=e[4][1]+N,e[4][0]=e[4][0]+T+(P/4294967296>>>0)>>>0,e[4][1]=P>>>0,P=e[5][1]+k,e[5][0]=e[5][0]+C+(P/4294967296>>>0)>>>0,e[5][1]=P>>>0,P=e[6][1]+A,e[6][0]=e[6][0]+L+(P/4294967296>>>0)>>>0,e[6][1]=P>>>0,P=e[7][1]+M,e[7][0]=e[7][0]+O+(P/4294967296>>>0)>>>0,e[7][1]=P>>>0,I-=128}}var r=e.sha512=e.sha512||{};e.md=e.md||{},e.md.algorithms=e.md.algorithms||{},e.md.sha512=e.md.algorithms.sha512=r;var i=e.sha384=e.sha512.sha384=e.sha512.sha384||{};i.create=function(){return r.create("SHA-384")},e.md.sha384=e.md.algorithms.sha384=i,e.sha512.sha256=e.sha512.sha256||{create:function(){return r.create("SHA-512/256")}},e.md["sha512/256"]=e.md.algorithms["sha512/256"]=e.sha512.sha256,e.sha512.sha224=e.sha512.sha224||{create:function(){return r.create("SHA-512/224")}},e.md["sha512/224"]=e.md.algorithms["sha512/224"]=e.sha512.sha224,r.create=function(r){o||t(),typeof r=="undefined"&&(r="SHA-512");if(r in a){var i=a[r],u=null,f=e.util.createBuffer(),l=new Array(80);for(var c=0;c<80;++c)l[c]=new Array(2);var h={algorithm:r.replace("-","").toLowerCase(),blockLength:128,digestLength:64,messageLength:0,messageLength128:[0,0,0,0]};return h.start=function(){h.messageLength=0,h.messageLength128=[0,0,0,0],f=e.util.createBuffer(),u=new Array(i.length);for(var t=0;t<i.length;++t)u[t]=i[t].slice(0);return h},h.start(),h.update=function(t,r){r==="utf8"&&(t=e.util.encodeUtf8(t)),h.messageLength+=t.length;var i=t.length;i=[i/4294967296>>>0,i>>>0];for(var s=3;s>=0;--s)h.messageLength128[s]+=i[1],i[1]=i[0]+(h.messageLength128[s]/4294967296>>>0),h.messageLength128[s]=h.messageLength128[s]>>>0,i[0]=i[1]/4294967296>>>0;return f.putBytes(t),n(u,l,f),(f.read>2048||f.length()===0)&&f.compact(),h},h.digest=function(){var t=e.util.createBuffer();t.putBytes(f.bytes()),t.putBytes(s.substr(0,128-(h.messageLength128[3]+16&127)));var i=[];for(var o=0;o<3;++o)i[o]=h.messageLength128[o]<<3|h.messageLength128[o-1]>>>28;i[3]=h.messageLength128[3]<<3,t.putInt32(i[0]),t.putInt32(i[1]),t.putInt32(i[2]),t.putInt32(i[3]);var a=new Array(u.length);for(var o=0;o<u.length;++o)a[o]=u[o].slice(0);n(a,l,t);var c=e.util.createBuffer(),p;r==="SHA-512"?p=a.length:r==="SHA-384"?p=a.length-2:p=a.length-4;for(var o=0;o<p;++o)c.putInt32(a[o][0]),(o!==p-1||r!=="SHA-512/224")&&c.putInt32(a[o][1]);return c},h}throw new Error("Invalid SHA-512 algorithm: "+r)};var s=null,o=!1,u=null,a=null}var r="sha512";if(typeof n!="function"){if(typeof module!="object"||!module.exports)return typeof forge=="undefined"&&(forge={}),e(forge);var i=!0;n=function(e,n){n(t,module)}}var s,o=function(t,n){n.exports=function(n){var i=s.map(function(e){return t(e)}).concat(e);n=n||{},n.defined=n.defined||{};if(n.defined[r])return n[r];n.defined[r]=!0;for(var o=0;o<i.length;++o)i[o](n);return n[r]}},u=n;n=function(e,t){return s=typeof e=="string"?t.slice(2):e.slice(2),i?(delete n,u.apply(null,Array.prototype.slice.call(arguments,0))):(n=u,n.apply(null,Array.prototype.slice.call(arguments,0)))},n("js/sha512",["require","module","./util"],function(){o.apply(null,Array.prototype.slice.call(arguments,0))})}(),function(){function e(e){e.md=e.md||{},e.md.algorithms={md5:e.md5,sha1:e.sha1,sha256:e.sha256},e.md.md5=e.md5,e.md.sha1=e.sha1,e.md.sha256=e.sha256}var r="md";if(typeof n!="function"){if(typeof module!="object"||!module.exports)return typeof forge=="undefined"&&(forge={}),e(forge);var i=!0;n=function(e,n){n(t,module)}}var s,o=function(t,n){n.exports=function(n){var i=s.map(function(e){return t(e)}).concat(e);n=n||{},n.defined=n.defined||{};if(n.defined[r])return n[r];n.defined[r]=!0;for(var o=0;o<i.length;++o)i[o](n);return n[r]}},u=n;n=function(e,t){return s=typeof e=="string"?t.slice(2):e.slice(2),i?(delete n,u.apply(null,Array.prototype.slice.call(arguments,0))):(n=u,n.apply(null,Array.prototype.slice.call(arguments,0)))},n("js/md",["require","module","./md5","./sha1","./sha256","./sha512"],function(){o.apply(null,Array.prototype.slice.call(arguments,0))})}(),function(){function e(e){var t=e.hmac=e.hmac||{};t.create=function(){var t=null,n=null,r=null,i=null,s={};return s.start=function(s,o){if(s!==null)if(typeof s=="string"){s=s.toLowerCase();if(!(s in e.md.algorithms))throw new Error('Unknown hash algorithm "'+s+'"');n=e.md.algorithms[s].create()}else n=s;if(o===null)o=t;else{if(typeof o=="string")o=e.util.createBuffer(o);else if(e.util.isArray(o)){var u=o;o=e.util.createBuffer();for(var a=0;a<u.length;++a)o.putByte(u[a])}var f=o.length();f>n.blockLength&&(n.start(),n.update(o.bytes()),o=n.digest()),r=e.util.createBuffer(),i=e.util.createBuffer(),f=o.length();for(var a=0;a<f;++a){var u=o.at(a);r.putByte(54^u),i.putByte(92^u)}if(f<n.blockLength){var u=n.blockLength-f;for(var a=0;a<u;++a)r.putByte(54),i.putByte(92)}t=o,r=r.bytes(),i=i.bytes()}n.start(),n.update(r)},s.update=function(e){n.update(e)},s.getMac=function(){var e=n.digest().bytes();return n.start(),n.update(i),n.update(e),n.digest()},s.digest=s.getMac,s}}var r="hmac";if(typeof n!="function"){if(typeof module!="object"||!module.exports)return typeof forge=="undefined"&&(forge={}),e(forge);var i=!0;n=function(e,n){n(t,module)}}var s,o=function(t,n){n.exports=function(n){var i=s.map(function(e){return t(e)}).concat(e);n=n||{},n.defined=n.defined||{};if(n.defined[r])return n[r];n.defined[r]=!0;for(var o=0;o<i.length;++o)i[o](n);return n[r]}},u=n;n=function(e,t){return s=typeof e=="string"?t.slice(2):e.slice(2),i?(delete n,u.apply(null,Array.prototype.slice.call(arguments,0))):(n=u,n.apply(null,Array.prototype.slice.call(arguments,0)))},n("js/hmac",["require","module","./md","./util"],function(){o.apply(null,Array.prototype.slice.call(arguments,0))})}(),function(){function e(e){function t(e){var t=e.name+": ",n=[],r=function(e,t){return" "+t};for(var i=0;i<e.values.length;++i)n.push(e.values[i].replace(/^(\S+\r\n)/,r));t+=n.join(",")+"\r\n";var s=0,o=-1;for(var i=0;i<t.length;++i,++s)if(s>65&&o!==-1){var u=t[o];u===","?(++o,t=t.substr(0,o)+"\r\n "+t.substr(o)):t=t.substr(0,o)+"\r\n"+u+t.substr(o+1),s=i-o-1,o=-1,++i}else if(t[i]===" "||t[i]==="	"||t[i]===",")o=i;return t}function n(e){return e.replace(/^\s+/,"")}var r=e.pem=e.pem||{};r.encode=function(n,r){r=r||{};var i="-----BEGIN "+n.type+"-----\r\n",s;n.procType&&(s={name:"Proc-Type",values:[String(n.procType.version),n.procType.type]},i+=t(s)),n.contentDomain&&(s={name:"Content-Domain",values:[n.contentDomain]},i+=t(s)),n.dekInfo&&(s={name:"DEK-Info",values:[n.dekInfo.algorithm]},n.dekInfo.parameters&&s.values.push(n.dekInfo.parameters),i+=t(s));if(n.headers)for(var o=0;o<n.headers.length;++o)i+=t(n.headers[o]);return n.procType&&(i+="\r\n"),i+=e.util.encode64(n.body,r.maxline||64)+"\r\n",i+="-----END "+n.type+"-----\r\n",i},r.decode=function(t){var r=[],i=/\s*-----BEGIN ([A-Z0-9- ]+)-----\r?\n?([\x21-\x7e\s]+?(?:\r?\n\r?\n))?([:A-Za-z0-9+\/=\s]+?)-----END \1-----/g,s=/([\x21-\x7e]+):\s*([\x21-\x7e\s^:]+)/,o=/\r?\n/,u;for(;;){u=i.exec(t);if(!u)break;var a={type:u[1],procType:null,contentDomain:null,dekInfo:null,headers:[],body:e.util.decode64(u[3])};r.push(a);if(!u[2])continue;var f=u[2].split(o),l=0;while(u&&l<f.length){var c=f[l].replace(/\s+$/,"");for(var h=l+1;h<f.length;++h){var p=f[h];if(!/\s/.test(p[0]))break;c+=p,l=h}u=c.match(s);if(u){var d={name:u[1],values:[]},v=u[2].split(",");for(var m=0;m<v.length;++m)d.values.push(n(v[m]));if(!a.procType){if(d.name!=="Proc-Type")throw new Error('Invalid PEM formatted message. The first encapsulated header must be "Proc-Type".');if(d.values.length!==2)throw new Error('Invalid PEM formatted message. The "Proc-Type" header must have two subfields.');a.procType={version:v[0],type:v[1]}}else if(!a.contentDomain&&d.name==="Content-Domain")a.contentDomain=v[0]||"";else if(!a.dekInfo&&d.name==="DEK-Info"){if(d.values.length===0)throw new Error('Invalid PEM formatted message. The "DEK-Info" header must have at least one subfield.');a.dekInfo={algorithm:v[0],parameters:v[1]||null}}else a.headers.push(d)}++l}if(a.procType==="ENCRYPTED"&&!a.dekInfo)throw new Error('Invalid PEM formatted message. The "DEK-Info" header must be present if "Proc-Type" is "ENCRYPTED".')}if(r.length===0)throw new Error("Invalid PEM formatted message.");return r}}var r="pem";if(typeof n!="function"){if(typeof module!="object"||!module.exports)return typeof forge=="undefined"&&(forge={}),e(forge);var i=!0;n=function(e,n){n(t,module)}}var s,o=function(t,n){n.exports=function(n){var i=s.map(function(e){return t(e)}).concat(e);n=n||{},n.defined=n.defined||{};if(n.defined[r])return n[r];n.defined[r]=!0;for(var o=0;o<i.length;++o)i[o](n);return n[r]}},u=n;n=function(e,t){return s=typeof e=="string"?t.slice(2):e.slice(2),i?(delete n,u.apply(null,Array.prototype.slice.call(arguments,0))):(n=u,n.apply(null,Array.prototype.slice.call(arguments,0)))},n("js/pem",["require","module","./util"],function(){o.apply(null,Array.prototype.slice.call(arguments,0))})}(),function(){function e(e){function t(t,n){var r=function(){return new e.des.Algorithm(t,n)};e.cipher.registerAlgorithm(t,r)}function n(e){var t=[0,4,536870912,536870916,65536,65540,536936448,536936452,512,516,536871424,536871428,66048,66052,536936960,536936964],n=[0,1,1048576,1048577,67108864,67108865,68157440,68157441,256,257,1048832,1048833,67109120,67109121,68157696,68157697],r=[0,8,2048,2056,16777216,16777224,16779264,16779272,0,8,2048,2056,16777216,16777224,16779264,16779272],i=[0,2097152,134217728,136314880,8192,2105344,134225920,136323072,131072,2228224,134348800,136445952,139264,2236416,134356992,136454144],s=[0,262144,16,262160,0,262144,16,262160,4096,266240,4112,266256,4096,266240,4112,266256],o=[0,1024,32,1056,0,1024,32,1056,33554432,33555456,33554464,33555488,33554432,33555456,33554464,33555488],u=[0,268435456,524288,268959744,2,268435458,524290,268959746,0,268435456,524288,268959744,2,268435458,524290,268959746],a=[0,65536,2048,67584,536870912,536936448,536872960,536938496,131072,196608,133120,198656,537001984,537067520,537004032,537069568],f=[0,262144,0,262144,2,262146,2,262146,33554432,33816576,33554432,33816576,33554434,33816578,33554434,33816578],l=[0,268435456,8,268435464,0,268435456,8,268435464,1024,268436480,1032,268436488,1024,268436480,1032,268436488],c=[0,32,0,32,1048576,1048608,1048576,1048608,8192,8224,8192,8224,1056768,1056800,1056768,1056800],h=[0,16777216,512,16777728,2097152,18874368,2097664,18874880,67108864,83886080,67109376,83886592,69206016,85983232,69206528,85983744],p=[0,4096,134217728,134221824,524288,528384,134742016,134746112,16,4112,134217744,134221840,524304,528400,134742032,134746128],d=[0,4,256,260,0,4,256,260,1,5,257,261,1,5,257,261],v=e.length()>8?3:1,m=[],g=[0,0,1,1,1,1,1,1,0,1,1,1,1,1,1,0],y=0,b;for(var w=0;w<v;w++){var E=e.getInt32(),S=e.getInt32();b=(E>>>4^S)&252645135,S^=b,E^=b<<4,b=(S>>>-16^E)&65535,E^=b,S^=b<<-16,b=(E>>>2^S)&858993459,S^=b,E^=b<<2,b=(S>>>-16^E)&65535,E^=b,S^=b<<-16,b=(E>>>1^S)&1431655765,S^=b,E^=b<<1,b=(S>>>8^E)&16711935,E^=b,S^=b<<8,b=(E>>>1^S)&1431655765,S^=b,E^=b<<1,b=E<<8|S>>>20&240,E=S<<24|S<<8&16711680|S>>>8&65280|S>>>24&240,S=b;for(var x=0;x<g.length;++x){g[x]?(E=E<<2|E>>>26,S=S<<2|S>>>26):(E=E<<1|E>>>27,S=S<<1|S>>>27),E&=-15,S&=-15;var T=t[E>>>28]|n[E>>>24&15]|r[E>>>20&15]|i[E>>>16&15]|s[E>>>12&15]|o[E>>>8&15]|u[E>>>4&15],N=a[S>>>28]|f[S>>>24&15]|l[S>>>20&15]|c[S>>>16&15]|h[S>>>12&15]|p[S>>>8&15]|d[S>>>4&15];b=(N>>>16^T)&65535,m[y++]=T^b,m[y++]=N^b<<16}}return m}function r(e,t,n,r){var i=e.length===32?3:9,p;i===3?p=r?[30,-2,-2]:[0,32,2]:p=r?[94,62,-2,32,64,2,30,-2,-2]:[0,32,2,62,30,-2,64,96,2];var d,v=t[0],m=t[1];d=(v>>>4^m)&252645135,m^=d,v^=d<<4,d=(v>>>16^m)&65535,m^=d,v^=d<<16,d=(m>>>2^v)&858993459,v^=d,m^=d<<2,d=(m>>>8^v)&16711935,v^=d,m^=d<<8,d=(v>>>1^m)&1431655765,m^=d,v^=d<<1,v=v<<1|v>>>31,m=m<<1|m>>>31;for(var g=0;g<i;g+=3){var y=p[g+1],b=p[g+2];for(var w=p[g];w!=y;w+=b){var E=m^e[w],S=(m>>>4|m<<28)^e[w+1];d=v,v=m,m=d^(o[E>>>24&63]|a[E>>>16&63]|l[E>>>8&63]|h[E&63]|s[S>>>24&63]|u[S>>>16&63]|f[S>>>8&63]|c[S&63])}d=v,v=m,m=d}v=v>>>1|v<<31,m=m>>>1|m<<31,d=(v>>>1^m)&1431655765,m^=d,v^=d<<1,d=(m>>>8^v)&16711935,v^=d,m^=d<<8,d=(m>>>2^v)&858993459,v^=d,m^=d<<2,d=(v>>>16^m)&65535,m^=d,v^=d<<16,d=(v>>>4^m)&252645135,m^=d,v^=d<<4,n[0]=v,n[1]=m}function i(t){t=t||{};var n=(t.mode||"CBC").toUpperCase(),r="DES-"+n,i;t.decrypt?i=e.cipher.createDecipher(r,t.key):i=e.cipher.createCipher(r,t.key);var s=i.start;return i.start=function(t,n){var r=null;n instanceof e.util.ByteBuffer&&(r=n,n={}),n=n||{},n.output=r,n.iv=t,s.call(i,n)},i}e.des=e.des||{},e.des.startEncrypting=function(e,t,n,r){var s=i({key:e,output:n,decrypt:!1,mode:r||(t===null?"ECB":"CBC")});return s.start(t),s},e.des.createEncryptionCipher=function(e,t){return i({key:e,output:null,decrypt:!1,mode:t})},e.des.startDecrypting=function(e,t,n,r){var s=i({key:e,output:n,decrypt:!0,mode:r||(t===null?"ECB":"CBC")});return s.start(t),s},e.des.createDecryptionCipher=function(e,t){return i({key:e,output:null,decrypt:!0,mode:t})},e.des.Algorithm=function(e,t){var n=this;n.name=e,n.mode=new t({blockSize:8,cipher:{encrypt:function(e,t){return r(n._keys,e,t,!1)},decrypt:function(e,t){return r(n._keys,e,t,!0)}}}),n._init=!1},e.des.Algorithm.prototype.initialize=function(t){if(this._init)return;var r=e.util.createBuffer(t.key);if(this.name.indexOf("3DES")===0&&r.length()!==24)throw new Error("Invalid Triple-DES key size: "+r.length()*8);this._keys=n(r),this._init=!0},t("DES-ECB",e.cipher.modes.ecb),t("DES-CBC",e.cipher.modes.cbc),t("DES-CFB",e.cipher.modes.cfb),t("DES-OFB",e.cipher.modes.ofb),t("DES-CTR",e.cipher.modes.ctr),t("3DES-ECB",e.cipher.modes.ecb),t("3DES-CBC",e.cipher.modes.cbc),t("3DES-CFB",e.cipher.modes.cfb),t("3DES-OFB",e.cipher.modes.ofb),t("3DES-CTR",e.cipher.modes.ctr);var s=[16843776,0,65536,16843780,16842756,66564,4,65536,1024,16843776,16843780,1024,16778244,16842756,16777216,4,1028,16778240,16778240,66560,66560,16842752,16842752,16778244,65540,16777220,16777220,65540,0,1028,66564,16777216,65536,16843780,4,16842752,16843776,16777216,16777216,1024,16842756,65536,66560,16777220,1024,4,16778244,66564,16843780,65540,16842752,16778244,16777220,1028,66564,16843776,1028,16778240,16778240,0,65540,66560,0,16842756],o=[-2146402272,-2147450880,32768,1081376,1048576,32,-2146435040,-2147450848,-2147483616,-2146402272,-2146402304,-2147483648,-2147450880,1048576,32,-2146435040,1081344,1048608,-2147450848,0,-2147483648,32768,1081376,-2146435072,1048608,-2147483616,0,1081344,32800,-2146402304,-2146435072,32800,0,1081376,-2146435040,1048576,-2147450848,-2146435072,-2146402304,32768,-2146435072,-2147450880,32,-2146402272,1081376,32,32768,-2147483648,32800,-2146402304,1048576,-2147483616,1048608,-2147450848,-2147483616,1048608,1081344,0,-2147450880,32800,-2147483648,-2146435040,-2146402272,1081344],u=[520,134349312,0,134348808,134218240,0,131592,134218240,131080,134217736,134217736,131072,134349320,131080,134348800,520,134217728,8,134349312,512,131584,134348800,134348808,131592,134218248,131584,131072,134218248,8,134349320,512,134217728,134349312,134217728,131080,520,131072,134349312,134218240,0,512,131080,134349320,134218240,134217736,512,0,134348808,134218248,131072,134217728,134349320,8,131592,131584,134217736,134348800,134218248,520,134348800,131592,8,134348808,131584],a=[8396801,8321,8321,128,8396928,8388737,8388609,8193,0,8396800,8396800,8396929,129,0,8388736,8388609,1,8192,8388608,8396801,128,8388608,8193,8320,8388737,1,8320,8388736,8192,8396928,8396929,129,8388736,8388609,8396800,8396929,129,0,0,8396800,8320,8388736,8388737,1,8396801,8321,8321,128,8396929,129,1,8192,8388609,8193,8396928,8388737,8193,8320,8388608,8396801,128,8388608,8192,8396928],f=[256,34078976,34078720,1107296512,524288,256,1073741824,34078720,1074266368,524288,33554688,1074266368,1107296512,1107820544,524544,1073741824,33554432,1074266112,1074266112,0,1073742080,1107820800,1107820800,33554688,1107820544,1073742080,0,1107296256,34078976,33554432,1107296256,524544,524288,1107296512,256,33554432,1073741824,34078720,1107296512,1074266368,33554688,1073741824,1107820544,34078976,1074266368,256,33554432,1107820544,1107820800,524544,1107296256,1107820800,34078720,0,1074266112,1107296256,524544,33554688,1073742080,524288,0,1074266112,34078976,1073742080],l=[536870928,541065216,16384,541081616,541065216,16,541081616,4194304,536887296,4210704,4194304,536870928,4194320,536887296,536870912,16400,0,4194320,536887312,16384,4210688,536887312,16,541065232,541065232,0,4210704,541081600,16400,4210688,541081600,536870912,536887296,16,541065232,4210688,541081616,4194304,16400,536870928,4194304,536887296,536870912,16400,536870928,541081616,4210688,541065216,4210704,541081600,0,541065232,16,16384,541065216,4210704,16384,4194320,536887312,0,541081600,536870912,4194320,536887312],c=[2097152,69206018,67110914,0,2048,67110914,2099202,69208064,69208066,2097152,0,67108866,2,67108864,69206018,2050,67110912,2099202,2097154,67110912,67108866,69206016,69208064,2097154,69206016,2048,2050,69208066,2099200,2,67108864,2099200,67108864,2099200,2097152,67110914,67110914,69206018,69206018,2,2097154,67108864,67110912,2097152,69208064,2050,2099202,69208064,2050,67108866,69208066,69206016,2099200,0,2,69208066,0,2099202,69206016,2048,67108866,67110912,2048,2097154],h=[268439616,4096,262144,268701760,268435456,268439616,64,268435456,262208,268697600,268701760,266240,268701696,266304,4096,64,268697600,268435520,268439552,4160,266240,262208,268697664,268701696,4160,0,0,268697664,268435520,268439552,266304,262144,266304,262144,268701696,4096,64,268697664,4096,266304,268439552,64,268435520,268697600,268697664,268435456,262144,268439616,0,268701760,262208,268435520,268697600,268439552,268439616,0,268701760,266240,266240,4160,4160,262208,268435456,268701696]}var r="des";if(typeof n!="function"){if(typeof module!="object"||!module.exports)return typeof forge=="undefined"&&(forge={}),e(forge);var i=!0;n=function(e,n){n(t,module)}}var s,o=function(t,n){n.exports=function(n){var i=s.map(function(e){return t(e)}).concat(e);n=n||{},n.defined=n.defined||{};if(n.defined[r])return n[r];n.defined[r]=!0;for(var o=0;o<i.length;++o)i[o](n);return n[r]}},u=n;n=function(e,t){return s=typeof e=="string"?t.slice(2):e.slice(2),i?(delete n,u.apply(null,Array.prototype.slice.call(arguments,0))):(n=u,n.apply(null,Array.prototype.slice.call(arguments,0)))},n("js/des",["require","module","./cipher","./cipherModes","./util"],function(){o.apply(null,Array.prototype.slice.call(arguments,0))})}(),function(){function e(e){var n=e.pkcs5=e.pkcs5||{},r=typeof process!="undefined"&&process.versions&&process.versions.node,i;r&&!e.disableNativeCode&&(i=t("crypto")),e.pbkdf2=n.pbkdf2=function(t,n,s,o,u,a){function f(){if(w>p)return a(null,m);v.start(null,null),v.update(n),v.update(e.util.int32ToBytes(w)),g=b=v.digest().getBytes(),E=2,l()}function l(){if(E<=s)return v.start(null,null),v.update(b),y=v.digest().getBytes(),g=e.util.xorBytes(g,y,c),b=y,++E,e.util.setImmediate(l);m+=w<p?g:g.substr(0,d),++w,f()}typeof u=="function"&&(a=u,u=null);if(r&&!e.disableNativeCode&&i.pbkdf2&&(u===null||typeof u!="object")&&(i.pbkdf2Sync.length>4||!u||u==="sha1"))return typeof u!="string"&&(u="sha1"),n=new Buffer(n,"binary"),a?i.pbkdf2Sync.length===4?i.pbkdf2(t,n,s,o,function(e,t){if(e)return a(e);a(null,t.toString("binary"))}):i.pbkdf2(t,n,s,o,u,function(e,t){if(e)return a(e);a(null,t.toString("binary"))}):i.pbkdf2Sync.length===4?i.pbkdf2Sync(t,n,s,o).toString("binary"):i.pbkdf2Sync(t,n,s,o,u).toString("binary");if(typeof u=="undefined"||u===null)u=e.md.sha1.create();if(typeof u=="string"){if(!(u in e.md.algorithms))throw new Error("Unknown hash algorithm: "+u);u=e.md[u].create()}var c=u.digestLength;if(o>4294967295*c){var h=new Error("Derived key is too long.");if(a)return a(h);throw h}var p=Math.ceil(o/c),d=o-(p-1)*c,v=e.hmac.create();v.start(u,t);var m="",g,y,b;if(!a){for(var w=1;w<=p;++w){v.start(null,null),v.update(n),v.update(e.util.int32ToBytes(w)),g=b=v.digest().getBytes();for(var E=2;E<=s;++E)v.start(null,null),v.update(b),y=v.digest().getBytes(),g=e.util.xorBytes(g,y,c),b=y;m+=w<p?g:g.substr(0,d)}return m}var w=1,E;f()}}var r="pbkdf2";if(typeof n!="function"){if(typeof module!="object"||!module.exports)return typeof forge=="undefined"&&(forge={}),e(forge);var i=!0;n=function(e,n){n(t,module)}}var s,o=function(t,n){n.exports=function(n){var i=s.map(function(e){return t(e)}).concat(e);n=n||{},n.defined=n.defined||{};if(n.defined[r])return n[r];n.defined[r]=!0;for(var o=0;o<i.length;++o)i[o](n);return n[r]}},u=n;n=function(e,t){return s=typeof e=="string"?t.slice(2):e.slice(2),i?(delete n,u.apply(null,Array.prototype.slice.call(arguments,0))):(n=u,n.apply(null,Array.prototype.slice.call(arguments,0)))},n("js/pbkdf2",["require","module","./hmac","./md","./util"],function(){o.apply(null,Array.prototype.slice.call(arguments,0))})}(),function(){function e(e){var n=typeof process!="undefined"&&process.versions&&process.versions.node,r=null;!e.disableNativeCode&&n&&!process.versions["node-webkit"]&&(r=t("crypto"));var i=e.prng=e.prng||{};i.create=function(t){function n(e){if(u.pools[0].messageLength>=32)return s(),e();var t=32-u.pools[0].messageLength<<5;u.seedFile(t,function(t,n){if(t)return e(t);u.collect(n),s(),e()})}function i(){if(u.pools[0].messageLength>=32)return s();var e=32-u.pools[0].messageLength<<5;u.collect(u.seedFileSync(e)),s()}function s(){var e=u.plugin.md.create();e.update(u.pools[0].digest().getBytes()),u.pools[0].start();var t=1;for(var n=1;n<32;++n)t=t===31?2147483648:t<<2,t%u.reseeds===0&&(e.update(u.pools[n].digest().getBytes()),u.pools[n].start());var r=e.digest().getBytes();e.start(),e.update(r);var i=e.digest().getBytes();u.key=u.plugin.formatKey(r),u.seed=u.plugin.formatSeed(i),u.reseeds=u.reseeds===4294967295?0:u.reseeds+1,u.generated=0}function o(t){var n=null;if(typeof window!="undefined"){var r=window.crypto||window.msCrypto;r&&r.getRandomValues&&(n=function(e){return r.getRandomValues(e)})}var i=e.util.createBuffer();if(n)while(i.length()<t){var s=Math.max(1,Math.min(t-i.length(),65536)/4),o=new Uint32Array(Math.floor(s));try{n(o);for(var u=0;u<o.length;++u)i.putInt32(o[u])}catch(a){if(!(typeof QuotaExceededError!="undefined"&&a instanceof QuotaExceededError))throw a}}if(i.length()<t){var f,l,c,h=Math.floor(Math.random()*65536);while(i.length()<t){l=16807*(h&65535),f=16807*(h>>16),l+=(f&32767)<<16,l+=f>>15,l=(l&2147483647)+(l>>31),h=l&4294967295;for(var u=0;u<3;++u)c=h>>>(u<<3),c^=Math.floor(Math.random()*256),i.putByte(String.fromCharCode(c&255))}}return i.getBytes(t)}var u={plugin:t,key:null,seed:null,time:null,reseeds:0,generated:0},a=t.md,f=new Array(32);for(var l=0;l<32;++l)f[l]=a.create();return u.pools=f,u.pool=0,u.generate=function(t,r){function i(c){if(c)return r(c);if(l.length()>=t)return r(null,l.getBytes(t));u.generated>1048575&&(u.key=null);if(u.key===null)return e.util.nextTick(function(){n(i)});var h=s(u.key,u.seed);u.generated+=h.length,l.putBytes(h),u.key=a(s(u.key,o(u.seed))),u.seed=f(s(u.key,u.seed)),e.util.setImmediate(i)}if(!r)return u.generateSync(t);var s=u.plugin.cipher,o=u.plugin.increment,a=u.plugin.formatKey,f=u.plugin.formatSeed,l=e.util.createBuffer();u.key=null,i()},u.generateSync=function(t){var n=u.plugin.cipher,r=u.plugin.increment,s=u.plugin.formatKey,o=u.plugin.formatSeed;u.key=null;var a=e.util.createBuffer();while(a.length()<t){u.generated>1048575&&(u.key=null),u.key===null&&i();var f=n(u.key,u.seed);u.generated+=f.length,a.putBytes(f),u.key=s(n(u.key,r(u.seed))),u.seed=o(n(u.key,u.seed))}return a.getBytes(t)},r?(u.seedFile=function(e,t){r.randomBytes(e,function(e,n){if(e)return t(e);t(null,n.toString())})},u.seedFileSync=function(e){return r.randomBytes(e).toString()}):(u.seedFile=function(e,t){try{t(null,o(e))}catch(n){t(n)}},u.seedFileSync=o),u.collect=function(e){var t=e.length;for(var n=0;n<t;++n)u.pools[u.pool].update(e.substr(n,1)),u.pool=u.pool===31?0:u.pool+1},u.collectInt=function(e,t){var n="";for(var r=0;r<t;r+=8)n+=String.fromCharCode(e>>r&255);u.collect(n)},u.registerWorker=function(e){if(e===self)u.seedFile=function(e,t){function n(e){var r=e.data;r.forge&&r.forge.prng&&(self.removeEventListener("message",n),t(r.forge.prng.err,r.forge.prng.bytes))}self.addEventListener("message",n),self.postMessage({forge:{prng:{needed:e}}})};else{var t=function(t){var n=t.data;n.forge&&n.forge.prng&&u.seedFile(n.forge.prng.needed,function(t,n){e.postMessage({forge:{prng:{err:t,bytes:n}}})})};e.addEventListener("message",t)}},u}}var r="prng";if(typeof n!="function"){if(typeof module!="object"||!module.exports)return typeof forge=="undefined"&&(forge={}),e(forge);var i=!0;n=function(e,n){n(t,module)}}var s,o=function(t,n){n.exports=function(n){var i=s.map(function(e){return t(e)}).concat(e);n=n||{},n.defined=n.defined||{};if(n.defined[r])return n[r];n.defined[r]=!0;for(var o=0;o<i.length;++o)i[o](n);return n[r]}},u=n;n=function(e,t){return s=typeof e=="string"?t.slice(2):e.slice(2),i?(delete n,u.apply(null,Array.prototype.slice.call(arguments,0))):(n=u,n.apply(null,Array.prototype.slice.call(arguments,0)))},n("js/prng",["require","module","./md","./util"],function(){o.apply(null,Array.prototype.slice.call(arguments,0))})}(),function(){function e(e){if(e.random&&e.random.getBytes)return;(function(t){function n(){var t=e.prng.create(r);return t.getBytes=function(e,n){return t.generate(e,n)},t.getBytesSync=function(e){return t.generate(e)},t}var r={},i=new Array(4),s=e.util.createBuffer();r.formatKey=function(t){var n=e.util.createBuffer(t);return t=new Array(4),t[0]=n.getInt32(),t[1]=n.getInt32(),t[2]=n.getInt32(),t[3]=n.getInt32(),e.aes._expandKey(t,!1)},r.formatSeed=function(t){var n=e.util.createBuffer(t);return t=new Array(4),t[0]=n.getInt32(),t[1]=n.getInt32(),t[2]=n.getInt32(),t[3]=n.getInt32(),t},r.cipher=function(t,n){return e.aes._updateBlock(t,n,i,!1),s.putInt32(i[0]),s.putInt32(i[1]),s.putInt32(i[2]),s.putInt32(i[3]),s.getBytes()},r.increment=function(e){return++e[3],e},r.md=e.md.sha256;var o=n(),u=typeof process!="undefined"&&process.versions&&process.versions.node,a=null;if(typeof window!="undefined"){var f=window.crypto||window.msCrypto;f&&f.getRandomValues&&(a=function(e){return f.getRandomValues(e)})}if(e.disableNativeCode||!u&&!a){typeof window=="undefined"||window.document===undefined,o.collectInt(+(new Date),32);if(typeof navigator!="undefined"){var l="";for(var c in navigator)try{typeof navigator[c]=="string"&&(l+=navigator[c])}catch(h){}o.collect(l),l=null}t&&(t().mousemove(function(e){o.collectInt(e.clientX,16),o.collectInt(e.clientY,16)}),t().keypress(function(e){o.collectInt(e.charCode,8)}))}if(!e.random)e.random=o;else for(var c in o)e.random[c]=o[c];e.random.createInstance=n})(typeof jQuery!="undefined"?jQuery:null)}var r="random";if(typeof n!="function"){if(typeof module!="object"||!module.exports)return typeof forge=="undefined"&&(forge={}),e(forge);var i=!0;n=function(e,n){n(t,module)}}var s,o=function(t,n){n.exports=function(n){var i=s.map(function(e){return t(e)}).concat(e);n=n||{},n.defined=n.defined||{};if(n.defined[r])return n[r];n.defined[r]=!0;for(var o=0;o<i.length;++o)i[o](n);return n[r]}},u=n;n=function(e,t){return s=typeof e=="string"?t.slice(2):e.slice(2),i?(delete n,u.apply(null,Array.prototype.slice.call(arguments,0))):(n=u,n.apply(null,Array.prototype.slice.call(arguments,0)))},n("js/random",["require","module","./aes","./md","./prng","./util"],function(){o.apply(null,Array.prototype.slice.call(arguments,0))})}(),function(){function e(e){var t=[217,120,249,196,25,221,181,237,40,233,253,121,74,160,216,157,198,126,55,131,43,118,83,142,98,76,100,136,68,139,251,162,23,154,89,245,135,179,79,19,97,69,109,141,9,129,125,50,189,143,64,235,134,183,123,11,240,149,33,34,92,107,78,130,84,214,101,147,206,96,178,28,115,86,192,20,167,140,241,220,18,117,202,31,59,190,228,209,66,61,212,48,163,60,182,38,111,191,14,218,70,105,7,87,39,242,29,155,188,148,67,3,248,17,199,246,144,239,62,231,6,195,213,47,200,102,30,215,8,232,234,222,128,82,238,247,132,170,114,172,53,77,106,42,150,26,210,113,90,21,73,116,75,159,208,94,4,24,164,236,194,224,65,110,15,81,203,204,36,145,175,80,161,244,112,57,153,124,58,133,35,184,180,122,252,2,54,91,37,85,151,49,45,93,250,152,227,138,146,174,5,223,41,16,103,108,186,201,211,0,230,207,225,158,168,44,99,22,1,63,88,226,137,169,13,56,52,27,171,51,255,176,187,72,12,95,185,177,205,46,197,243,219,71,229,165,156,119,10,166,32,104,254,127,193,173],n=[1,2,3,5],r=function(e,t){return e<<t&65535|(e&65535)>>16-t},i=function(e,t){return(e&65535)>>t|e<<16-t&65535};e.rc2=e.rc2||{},e.rc2.expandKey=function(n,r){typeof n=="string"&&(n=e.util.createBuffer(n)),r=r||128;var i=n,s=n.length(),o=r,u=Math.ceil(o/8),a=255>>(o&7),f;for(f=s;f<128;f++)i.putByte(t[i.at(f-1)+i.at(f-s)&255]);i.setAt(128-u,t[i.at(128-u)&a]);for(f=127-u;f>=0;f--)i.setAt(f,t[i.at(f+1)^i.at(f+u)]);return i};var s=function(t,s,o){var u=!1,a=null,f=null,l=null,c,h,p,d,v=[];t=e.rc2.expandKey(t,s);for(p=0;p<64;p++)v.push(t.getInt16Le());o?(c=function(e){for(p=0;p<4;p++)e[p]+=v[d]+(e[(p+3)%4]&e[(p+2)%4])+(~e[(p+3)%4]&e[(p+1)%4]),e[p]=r(e[p],n[p]),d++},h=function(e){for(p=0;p<4;p++)e[p]+=v[e[(p+3)%4]&63]}):(c=function(e){for(p=3;p>=0;p--)e[p]=i(e[p],n[p]),e[p]-=v[d]+(e[(p+3)%4]&e[(p+2)%4])+(~e[(p+3)%4]&e[(p+1)%4]),d--},h=function(e){for(p=3;p>=0;p--)e[p]-=v[e[(p+3)%4]&63]});var m=function(e){var t=[];for(p=0;p<4;p++){var n=a.getInt16Le();l!==null&&(o?n^=l.getInt16Le():l.putInt16Le(n)),t.push(n&65535)}d=o?0:63;for(var r=0;r<e.length;r++)for(var i=0;i<e[r][0];i++)e[r][1](t);for(p=0;p<4;p++)l!==null&&(o?l.putInt16Le(t[p]):t[p]^=l.getInt16Le()),f.putInt16Le(t[p])},g=null;return g={start:function(t,n){t&&typeof t=="string"&&(t=e.util.createBuffer(t)),u=!1,a=e.util.createBuffer(),f=n||new e.util.createBuffer,l=t,g.output=f},update:function(e){u||a.putBuffer(e);while(a.length()>=8)m([[5,c],[1,h],[6,c],[1,h],[5,c]])},finish:function(e){var t=!0;if(o)if(e)t=e(8,a,!o);else{var n=a.length()===8?8:8-a.length();a.fillWithByte(n,n)}t&&(u=!0,g.update());if(!o){t=a.length()===0;if(t)if(e)t=e(8,f,!o);else{var r=f.length(),i=f.at(r-1);i>r?t=!1:f.truncate(i)}}return t}},g};e.rc2.startEncrypting=function(t,n,r){var i=e.rc2.createEncryptionCipher(t,128);return i.start(n,r),i},e.rc2.createEncryptionCipher=function(e,t){return s(e,t,!0)},e.rc2.startDecrypting=function(t,n,r){var i=e.rc2.createDecryptionCipher(t,128);return i.start(n,r),i},e.rc2.createDecryptionCipher=function(e,t){return s(e,t,!1)}}var r="rc2";if(typeof n!="function"){if(typeof module!="object"||!module.exports)return typeof forge=="undefined"&&(forge={}),e(forge);var i=!0;n=function(e,n){n(t,module)}}var s,o=function(t,n){n.exports=function(n){var i=s.map(function(e){return t(e)}).concat(e);n=n||{},n.defined=n.defined||{};if(n.defined[r])return n[r];n.defined[r]=!0;for(var o=0;o<i.length;++o)i[o](n);return n[r]}},u=n;n=function(e,t){return s=typeof e=="string"?t.slice(2):e.slice(2),i?(delete n,u.apply(null,Array.prototype.slice.call(arguments,0))):(n=u,n.apply(null,Array.prototype.slice.call(arguments,0)))},n("js/rc2",["require","module","./util"],function(){o.apply(null,Array.prototype.slice.call(arguments,0))})}(),function(){function e(e){function t(e,t,n){this.data=[],e!=null&&("number"==typeof e?this.fromNumber(e,t,n):t==null&&"string"!=typeof e?this.fromString(e,256):this.fromString(e,t))}function n(){return new t(null)}function r(e,t,n,r,i,s){while(--s>=0){var o=t*this.data[e++]+n.data[r]+i;i=Math.floor(o/67108864),n.data[r++]=o&67108863}return i}function i(e,t,n,r,i,s){var o=t&32767,u=t>>15;while(--s>=0){var a=this.data[e]&32767,f=this.data[e++]>>15,l=u*a+f*o;a=o*a+((l&32767)<<15)+n.data[r]+(i&1073741823),i=(a>>>30)+(l>>>15)+u*f+(i>>>30),n.data[r++]=a&1073741823}return i}function s(e,t,n,r,i,s){var o=t&16383,u=t>>14;while(--s>=0){var a=this.data[e]&16383,f=this.data[e++]>>14,l=u*a+f*o;a=o*a+((l&16383)<<14)+n.data[r]+i,i=(a>>28)+(l>>14)+u*f,n.data[r++]=a&268435455}return i}function o(e){return rn.charAt(e)}function u(e,t){var n=sn[e.charCodeAt(t)];return n==null?-1:n}function a(e){for(var t=this.t-1;t>=0;--t)e.data[t]=this.data[t];e.t=this.t,e.s=this.s}function f(e){this.t=1,this.s=e<0?-1:0,e>0?this.data[0]=e:e<-1?this.data[0]=e+this.DV:this.t=0}function l(e){var t=n();return t.fromInt(e),t}function c(e,n){var r;if(n==16)r=4;else if(n==8)r=3;else if(n==256)r=8;else if(n==2)r=1;else if(n==32)r=5;else{if(n!=4){this.fromRadix(e,n);return}r=2}this.t=0,this.s=0;var i=e.length,s=!1,o=0;while(--i>=0){var a=r==8?e[i]&255:u(e,i);if(a<0){e.charAt(i)=="-"&&(s=!0);continue}s=!1,o==0?this.data[this.t++]=a:o+r>this.DB?(this.data[this.t-1]|=(a&(1<<this.DB-o)-1)<<o,this.data[this.t++]=a>>this.DB-o):this.data[this.t-1]|=a<<o,o+=r,o>=this.DB&&(o-=this.DB)}r==8&&(e[0]&128)!=0&&(this.s=-1,o>0&&(this.data[this.t-1]|=(1<<this.DB-o)-1<<o)),this.clamp(),s&&t.ZERO.subTo(this,this)}function h(){var e=this.s&this.DM;while(this.t>0&&this.data[this.t-1]==e)--this.t}function p(e){if(this.s<0)return"-"+this.negate().toString(e);var t;if(e==16)t=4;else if(e==8)t=3;else if(e==2)t=1;else if(e==32)t=5;else{if(e!=4)return this.toRadix(e);t=2}var n=(1<<t)-1,r,i=!1,s="",u=this.t,a=this.DB-u*this.DB%t;if(u-->0){a<this.DB&&(r=this.data[u]>>a)>0&&(i=!0,s=o(r));while(u>=0)a<t?(r=(this.data[u]&(1<<a)-1)<<t-a,r|=this.data[--u]>>(a+=this.DB-t)):(r=this.data[u]>>(a-=t)&n,a<=0&&(a+=this.DB,--u)),r>0&&(i=!0),i&&(s+=o(r))}return i?s:"0"}function d(){var e=n();return t.ZERO.subTo(this,e),e}function v(){return this.s<0?this.negate():this}function m(e){var t=this.s-e.s;if(t!=0)return t;var n=this.t;t=n-e.t;if(t!=0)return this.s<0?-t:t;while(--n>=0)if((t=this.data[n]-e.data[n])!=0)return t;return 0}function g(e){var t=1,n;return(n=e>>>16)!=0&&(e=n,t+=16),(n=e>>8)!=0&&(e=n,t+=8),(n=e>>4)!=0&&(e=n,t+=4),(n=e>>2)!=0&&(e=n,t+=2),(n=e>>1)!=0&&(e=n,t+=1),t}function y(){return this.t<=0?0:this.DB*(this.t-1)+g(this.data[this.t-1]^this.s&this.DM)}function b(e,t){var n;for(n=this.t-1;n>=0;--n)t.data[n+e]=this.data[n];for(n=e-1;n>=0;--n)t.data[n]=0;t.t=this.t+e,t.s=this.s}function w(e,t){for(var n=e;n<this.t;++n)t.data[n-e]=this.data[n];t.t=Math.max(this.t-e,0),t.s=this.s}function E(e,t){var n=e%this.DB,r=this.DB-n,i=(1<<r)-1,s=Math.floor(e/this.DB),o=this.s<<n&this.DM,u;for(u=this.t-1;u>=0;--u)t.data[u+s+1]=this.data[u]>>r|o,o=(this.data[u]&i)<<n;for(u=s-1;u>=0;--u)t.data[u]=0;t.data[s]=o,t.t=this.t+s+1,t.s=this.s,t.clamp()}function S(e,t){t.s=this.s;var n=Math.floor(e/this.DB);if(n>=this.t){t.t=0;return}var r=e%this.DB,i=this.DB-r,s=(1<<r)-1;t.data[0]=this.data[n]>>r;for(var o=n+1;o<this.t;++o)t.data[o-n-1]|=(this.data[o]&s)<<i,t.data[o-n]=this.data[o]>>r;r>0&&(t.data[this.t-n-1]|=(this.s&s)<<i),t.t=this.t-n,t.clamp()}function x(e,t){var n=0,r=0,i=Math.min(e.t,this.t);while(n<i)r+=this.data[n]-e.data[n],t.data[n++]=r&this.DM,r>>=this.DB;if(e.t<this.t){r-=e.s;while(n<this.t)r+=this.data[n],t.data[n++]=r&this.DM,r>>=this.DB;r+=this.s}else{r+=this.s;while(n<e.t)r-=e.data[n],t.data[n++]=r&this.DM,r>>=this.DB;r-=e.s}t.s=r<0?-1:0,r<-1?t.data[n++]=this.DV+r:r>0&&(t.data[n++]=r),t.t=n,t.clamp()}function T(e,n){var r=this.abs(),i=e.abs(),s=r.t;n.t=s+i.t;while(--s>=0)n.data[s]=0;for(s=0;s<i.t;++s)n.data[s+r.t]=r.am(0,i.data[s],n,s,0,r.t);n.s=0,n.clamp(),this.s!=e.s&&t.ZERO.subTo(n,n)}function N(e){var t=this.abs(),n=e.t=2*t.t;while(--n>=0)e.data[n]=0;for(n=0;n<t.t-1;++n){var r=t.am(n,t.data[n],e,2*n,0,1);(e.data[n+t.t]+=t.am(n+1,2*t.data[n],e,2*n+1,r,t.t-n-1))>=t.DV&&(e.data[n+t.t]-=t.DV,e.data[n+t.t+1]=1)}e.t>0&&(e.data[e.t-1]+=t.am(n,t.data[n],e,2*n,0,1)),e.s=0,e.clamp()}function C(e,r,i){var s=e.abs();if(s.t<=0)return;var o=this.abs();if(o.t<s.t){r!=null&&r.fromInt(0),i!=null&&this.copyTo(i);return}i==null&&(i=n());var u=n(),a=this.s,f=e.s,l=this.DB-g(s.data[s.t-1]);l>0?(s.lShiftTo(l,u),o.lShiftTo(l,i)):(s.copyTo(u),o.copyTo(i));var c=u.t,h=u.data[c-1];if(h==0)return;var p=h*(1<<this.F1)+(c>1?u.data[c-2]>>this.F2:0),d=this.FV/p,v=(1<<this.F1)/p,m=1<<this.F2,y=i.t,b=y-c,w=r==null?n():r;u.dlShiftTo(b,w),i.compareTo(w)>=0&&(i.data[i.t++]=1,i.subTo(w,i)),t.ONE.dlShiftTo(c,w),w.subTo(u,u);while(u.t<c)u.data[u.t++]=0;while(--b>=0){var E=i.data[--y]==h?this.DM:Math.floor(i.data[y]*d+(i.data[y-1]+m)*v);if((i.data[y]+=u.am(0,E,i,b,0,c))<E){u.dlShiftTo(b,w),i.subTo(w,i);while(i.data[y]<--E)i.subTo(w,i)}}r!=null&&(i.drShiftTo(c,r),a!=f&&t.ZERO.subTo(r,r)),i.t=c,i.clamp(),l>0&&i.rShiftTo(l,i),a<0&&t.ZERO.subTo(i,i)}function k(e){var r=n();return this.abs().divRemTo(e,null,r),this.s<0&&r.compareTo(t.ZERO)>0&&e.subTo(r,r),r}function L(e){this.m=e}function A(e){return e.s<0||e.compareTo(this.m)>=0?e.mod(this.m):e}function O(e){return e}function M(e){e.divRemTo(this.m,null,e)}function _(e,t,n){e.multiplyTo(t,n),this.reduce(n)}function D(e,t){e.squareTo(t),this.reduce(t)}function P(){if(this.t<1)return 0;var e=this.data[0];if((e&1)==0)return 0;var t=e&3;return t=t*(2-(e&15)*t)&15,t=t*(2-(e&255)*t)&255,t=t*(2-((e&65535)*t&65535))&65535,t=t*(2-e*t%this.DV)%this.DV,t>0?this.DV-t:-t}function H(e){this.m=e,this.mp=e.invDigit(),this.mpl=this.mp&32767,this.mph=this.mp>>15,this.um=(1<<e.DB-15)-1,this.mt2=2*e.t}function B(e){var r=n();return e.abs().dlShiftTo(this.m.t,r),r.divRemTo(this.m,null,r),e.s<0&&r.compareTo(t.ZERO)>0&&this.m.subTo(r,r),r}function j(e){var t=n();return e.copyTo(t),this.reduce(t),t}function F(e){while(e.t<=this.mt2)e.data[e.t++]=0;for(var t=0;t<this.m.t;++t){var n=e.data[t]&32767,r=n*this.mpl+((n*this.mph+(e.data[t]>>15)*this.mpl&this.um)<<15)&e.DM;n=t+this.m.t,e.data[n]+=this.m.am(0,r,e,t,0,this.m.t);while(e.data[n]>=e.DV)e.data[n]-=e.DV,e.data[++n]++}e.clamp(),e.drShiftTo(this.m.t,e),e.compareTo(this.m)>=0&&e.subTo(this.m,e)}function I(e,t){e.squareTo(t),this.reduce(t)}function q(e,t,n){e.multiplyTo(t,n),this.reduce(n)}function R(){return(this.t>0?this.data[0]&1:this.s)==0}function U(e,r){if(e>4294967295||e<1)return t.ONE;var i=n(),s=n(),o=r.convert(this),u=g(e)-1;o.copyTo(i);while(--u>=0){r.sqrTo(i,s);if((e&1<<u)>0)r.mulTo(s,o,i);else{var a=i;i=s,s=a}}return r.revert(i)}function z(e,t){var n;return e<256||t.isEven()?n=new L(t):n=new H(t),this.exp(e,n)}function W(){var e=n();return this.copyTo(e),e}function X(){if(this.s<0){if(this.t==1)return this.data[0]-this.DV;if(this.t==0)return-1}else{if(this.t==1)return this.data[0];if(this.t==0)return 0}return(this.data[1]&(1<<32-this.DB)-1)<<this.DB|this.data[0]}function V(){return this.t==0?this.s:this.data[0]<<24>>24}function $(){return this.t==0?this.s:this.data[0]<<16>>16}function J(e){return Math.floor(Math.LN2*this.DB/Math.log(e))}function K(){return this.s<0?-1:this.t<=0||this.t==1&&this.data[0]<=0?0:1}function Q(e){e==null&&(e=10);if(this.signum()==0||e<2||e>36)return"0";var t=this.chunkSize(e),r=Math.pow(e,t),i=l(r),s=n(),o=n(),u="";this.divRemTo(i,s,o);while(s.signum()>0)u=(r+o.intValue()).toString(e).substr(1)+u,s.divRemTo(i,s,o);return o.intValue().toString(e)+u}function G(e,n){this.fromInt(0),n==null&&(n=10);var r=this.chunkSize(n),i=Math.pow(n,r),s=!1,o=0,a=0;for(var f=0;f<e.length;++f){var l=u(e,f);if(l<0){e.charAt(f)=="-"&&this.signum()==0&&(s=!0);continue}a=n*a+l,++o>=r&&(this.dMultiply(i),this.dAddOffset(a,0),o=0,a=0)}o>0&&(this.dMultiply(Math.pow(n,o)),this.dAddOffset(a,0)),s&&t.ZERO.subTo(this,this)}function Y(e,n,r){if("number"==typeof n)if(e<2)this.fromInt(1);else{this.fromNumber(e,r),this.testBit(e-1)||this.bitwiseTo(t.ONE.shiftLeft(e-1),ot,this),this.isEven()&&this.dAddOffset(1,0);while(!this.isProbablePrime(n))this.dAddOffset(2,0),this.bitLength()>e&&this.subTo(t.ONE.shiftLeft(e-1),this)}else{var i=new Array,s=e&7;i.length=(e>>3)+1,n.nextBytes(i),s>0?i[0]&=(1<<s)-1:i[0]=0,this.fromString(i,256)}}function Z(){var e=this.t,t=new Array;t[0]=this.s;var n=this.DB-e*this.DB%8,r,i=0;if(e-->0){n<this.DB&&(r=this.data[e]>>n)!=(this.s&this.DM)>>n&&(t[i++]=r|this.s<<this.DB-n);while(e>=0){n<8?(r=(this.data[e]&(1<<n)-1)<<8-n,r|=this.data[--e]>>(n+=this.DB-8)):(r=this.data[e]>>(n-=8)&255,n<=0&&(n+=this.DB,--e)),(r&128)!=0&&(r|=-256),i==0&&(this.s&128)!=(r&128)&&++i;if(i>0||r!=this.s)t[i++]=r}}return t}function et(e){return this.compareTo(e)==0}function tt(e){return this.compareTo(e)<0?this:e}function nt(e){return this.compareTo(e)>0?this:e}function rt(e,t,n){var r,i,s=Math.min(e.t,this.t);for(r=0;r<s;++r)n.data[r]=t(this.data[r],e.data[r]);if(e.t<this.t){i=e.s&this.DM;for(r=s;r<this.t;++r)n.data[r]=t(this.data[r],i);n.t=this.t}else{i=this.s&this.DM;for(r=s;r<e.t;++r)n.data[r]=t(i,e.data[r]);n.t=e.t}n.s=t(this.s,e.s),n.clamp()}function it(e,t){return e&t}function st(e){var t=n();return this.bitwiseTo(e,it,t),t}function ot(e,t){return e|t}function ut(e){var t=n();return this.bitwiseTo(e,ot,t),t}function at(e,t){return e^t}function ft(e){var t=n();return this.bitwiseTo(e,at,t),t}function lt(e,t){return e&~t}function ct(e){var t=n();return this.bitwiseTo(e,lt,t),t}function ht(){var e=n();for(var t=0;t<this.t;++t)e.data[t]=this.DM&~this.data[t];return e.t=this.t,e.s=~this.s,e}function pt(e){var t=n();return e<0?this.rShiftTo(-e,t):this.lShiftTo(e,t),t}function dt(e){var t=n();return e<0?this.lShiftTo(-e,t):this.rShiftTo(e,t),t}function vt(e){if(e==0)return-1;var t=0;return(e&65535)==0&&(e>>=16,t+=16),(e&255)==0&&(e>>=8,t+=8),(e&15)==0&&(e>>=4,t+=4),(e&3)==0&&(e>>=2,t+=2),(e&1)==0&&++t,t}function mt(){for(var e=0;e<this.t;++e)if(this.data[e]!=0)return e*this.DB+vt(this.data[e]);return this.s<0?this.t*this.DB:-1}function gt(e){var t=0;while(e!=0)e&=e-1,++t;return t}function yt(){var e=0,t=this.s&this.DM;for(var n=0;n<this.t;++n)e+=gt(this.data[n]^t);return e}function bt(e){var t=Math.floor(e/this.DB);return t>=this.t?this.s!=0:(this.data[t]&1<<e%this.DB)!=0}function wt(e,n){var r=t.ONE.shiftLeft(e);return this.bitwiseTo(r,n,r),r}function Et(e){return this.changeBit(e,ot)}function St(e){return this.changeBit(e,lt)}function xt(e){return this.changeBit(e,at)}function Tt(e,t){var n=0,r=0,i=Math.min(e.t,this.t);while(n<i)r+=this.data[n]+e.data[n],t.data[n++]=r&this.DM,r>>=this.DB;if(e.t<this.t){r+=e.s;while(n<this.t)r+=this.data[n],t.data[n++]=r&this.DM,r>>=this.DB;r+=this.s}else{r+=this.s;while(n<e.t)r+=e.data[n],t.data[n++]=r&this.DM,r>>=this.DB;r+=e.s}t.s=r<0?-1:0,r>0?t.data[n++]=r:r<-1&&(t.data[n++]=this.DV+r),t.t=n,t.clamp()}function Nt(e){var t=n();return this.addTo(e,t),t}function Ct(e){var t=n();return this.subTo(e,t),t}function kt(e){var t=n();return this.multiplyTo(e,t),t}function Lt(e){var t=n();return this.divRemTo(e,t,null),t}function At(e){var t=n();return this.divRemTo(e,null,t),t}function Ot(e){var t=n(),r=n();return this.divRemTo(e,t,r),new Array(t,r)}function Mt(e){this.data[this.t]=this.am(0,e-1,this,0,0,this.t),++this.t,this.clamp()}function _t(e,t){if(e==0)return;while(this.t<=t)this.data[this.t++]=0;this.data[t]+=e;while(this.data[t]>=this.DV)this.data[t]-=this.DV,++t>=this.t&&(this.data[this.t++]=0),++this.data[t]}function Dt(){}function Pt(e){return e}function Ht(e,t,n){e.multiplyTo(t,n)}function Bt(e,t){e.squareTo(t)}function jt(e){return this.exp(e,new Dt)}function Ft(e,t,n){var r=Math.min(this.t+e.t,t);n.s=0,n.t=r;while(r>0)n.data[--r]=0;var i;for(i=n.t-this.t;r<i;++r)n.data[r+this.t]=this.am(0,e.data[r],n,r,0,this.t);for(i=Math.min(e.t,t);r<i;++r)this.am(0,e.data[r],n,r,0,t-r);n.clamp()}function It(e,t,n){--t;var r=n.t=this.t+e.t-t;n.s=0;while(--r>=0)n.data[r]=0;for(r=Math.max(t-this.t,0);r<e.t;++r)n.data[this.t+r-t]=this.am(t-r,e.data[r],n,0,0,this.t+r-t);n.clamp(),n.drShiftTo(1,n)}function qt(e){this.r2=n(),this.q3=n(),t.ONE.dlShiftTo(2*e.t,this.r2),this.mu=this.r2.divide(e),this.m=e}function Rt(e){if(e.s<0||e.t>2*this.m.t)return e.mod(this.m);if(e.compareTo(this.m)<0)return e;var t=n();return e.copyTo(t),this.reduce(t),t}function Ut(e){return e}function zt(e){e.drShiftTo(this.m.t-1,this.r2),e.t>this.m.t+1&&(e.t=this.m.t+1,e.clamp()),this.mu.multiplyUpperTo(this.r2,this.m.t+1,this.q3),this.m.multiplyLowerTo(this.q3,this.m.t+1,this.r2);while(e.compareTo(this.r2)<0)e.dAddOffset(1,this.m.t+1);e.subTo(this.r2,e);while(e.compareTo(this.m)>=0)e.subTo(this.m,e)}function Wt(e,t){e.squareTo(t),this.reduce(t)}function Xt(e,t,n){e.multiplyTo(t,n),this.reduce(n)}function Vt(e,t){var r=e.bitLength(),i,s=l(1),o;if(r<=0)return s;r<18?i=1:r<48?i=3:r<144?i=4:r<768?i=5:i=6,r<8?o=new L(t):t.isEven()?o=new qt(t):o=new H(t);var u=new Array,a=3,f=i-1,c=(1<<i)-1;u[1]=o.convert(this);if(i>1){var h=n();o.sqrTo(u[1],h);while(a<=c)u[a]=n(),o.mulTo(h,u[a-2],u[a]),a+=2}var p=e.t-1,d,v=!0,m=n(),y;r=g(e.data[p])-1;while(p>=0){r>=f?d=e.data[p]>>r-f&c:(d=(e.data[p]&(1<<r+1)-1)<<f-r,p>0&&(d|=e.data[p-1]>>this.DB+r-f)),a=i;while((d&1)==0)d>>=1,--a;(r-=a)<0&&(r+=this.DB,--p);if(v)u[d].copyTo(s),v=!1;else{while(a>1)o.sqrTo(s,m),o.sqrTo(m,s),a-=2;a>0?o.sqrTo(s,m):(y=s,s=m,m=y),o.mulTo(m,u[d],s)}while(p>=0&&(e.data[p]&1<<r)==0)o.sqrTo(s,m),y=s,s=m,m=y,--r<0&&(r=this.DB-1,--p)}return o.revert(s)}function $t(e){var t=this.s<0?this.negate():this.clone(),n=e.s<0?e.negate():e.clone();if(t.compareTo(n)<0){var r=t;t=n,n=r}var i=t.getLowestSetBit(),s=n.getLowestSetBit();if(s<0)return t;i<s&&(s=i),s>0&&(t.rShiftTo(s,t),n.rShiftTo(s,n));while(t.signum()>0)(i=t.getLowestSetBit())>0&&t.rShiftTo(i,t),(i=n.getLowestSetBit())>0&&n.rShiftTo(i,n),t.compareTo(n)>=0?(t.subTo(n,t),t.rShiftTo(1,t)):(n.subTo(t,n),n.rShiftTo(1,n));return s>0&&n.lShiftTo(s,n),n}function Jt(e){if(e<=0)return 0;var t=this.DV%e,n=this.s<0?e-1:0;if(this.t>0)if(t==0)n=this.data[0]%e;else for(var r=this.t-1;r>=0;--r)n=(t*n+this.data[r])%e;return n}function Kt(e){var n=e.isEven();if(this.isEven()&&n||e.signum()==0)return t.ZERO;var r=e.clone(),i=this.clone(),s=l(1),o=l(0),u=l(0),a=l(1);while(r.signum()!=0){while(r.isEven()){r.rShiftTo(1,r);if(n){if(!s.isEven()||!o.isEven())s.addTo(this,s),o.subTo(e,o);s.rShiftTo(1,s)}else o.isEven()||o.subTo(e,o);o.rShiftTo(1,o)}while(i.isEven()){i.rShiftTo(1,i);if(n){if(!u.isEven()||!a.isEven())u.addTo(this,u),a.subTo(e,a);u.rShiftTo(1,u)}else a.isEven()||a.subTo(e,a);a.rShiftTo(1,a)}r.compareTo(i)>=0?(r.subTo(i,r),n&&s.subTo(u,s),o.subTo(a,o)):(i.subTo(r,i),n&&u.subTo(s,u),a.subTo(o,a))}return i.compareTo(t.ONE)!=0?t.ZERO:a.compareTo(e)>=0?a.subtract(e):a.signum()<0?(a.addTo(e,a),a.signum()<0?a.add(e):a):a}function Qt(e){var t,n=this.abs();if(n.t==1&&n.data[0]<=an[an.length-1]){for(t=0;t<an.length;++t)if(n.data[0]==an[t])return!0;return!1}if(n.isEven())return!1;t=1;while(t<an.length){var r=an[t],i=t+1;while(i<an.length&&r<fn)r*=an[i++];r=n.modInt(r);while(t<i)if(r%an[t++]==0)return!1}return n.millerRabin(e)}function Gt(e){var n=this.subtract(t.ONE),r=n.getLowestSetBit();if(r<=0)return!1;var i=n.shiftRight(r),s=Yt(),o;for(var u=0;u<e;++u){do o=new t(this.bitLength(),s);while(o.compareTo(t.ONE)<=0||o.compareTo(n)>=0);var a=o.modPow(i,this);if(a.compareTo(t.ONE)!=0&&a.compareTo(n)!=0){var f=1;while(f++<r&&a.compareTo(n)!=0){a=a.modPowInt(2,this);if(a.compareTo(t.ONE)==0)return!1}if(a.compareTo(n)!=0)return!1}}return!0}function Yt(){return{nextBytes:function(e){for(var t=0;t<e.length;++t)e[t]=Math.floor(Math.random()*256)}}}var Zt,en=0xdeadbeefcafe,tn=(en&16777215)==15715070;typeof navigator=="undefined"?(t.prototype.am=s,Zt=28):tn&&navigator.appName=="Microsoft Internet Explorer"?(t.prototype.am=i,Zt=30):tn&&navigator.appName!="Netscape"?(t.prototype.am=r,Zt=26):(t.prototype.am=s,Zt=28),t.prototype.DB=Zt,t.prototype.DM=(1<<Zt)-1,t.prototype.DV=1<<Zt;var nn=52;t.prototype.FV=Math.pow(2,nn),t.prototype.F1=nn-Zt,t.prototype.F2=2*Zt-nn;var rn="0123456789abcdefghijklmnopqrstuvwxyz",sn=new Array,on,un;on="0".charCodeAt(0);for(un=0;un<=9;++un)sn[on++]=un;on="a".charCodeAt(0);for(un=10;un<36;++un)sn[on++]=un;on="A".charCodeAt(0);for(un=10;un<36;++un)sn[on++]=un;L.prototype.convert=A,L.prototype.revert=O,L.prototype.reduce=M,L.prototype.mulTo=_,L.prototype.sqrTo=D,H.prototype.convert=B,H.prototype.revert=j,H.prototype.reduce=F,H.prototype.mulTo=q,H.prototype.sqrTo=I,t.prototype.copyTo=a,t.prototype.fromInt=f,t.prototype.fromString=c,t.prototype.clamp=h,t.prototype.dlShiftTo=b,t.prototype.drShiftTo=w,t.prototype.lShiftTo=E,t.prototype.rShiftTo=S,t.prototype.subTo=x,t.prototype.multiplyTo=T,t.prototype.squareTo=N,t.prototype.divRemTo=C,t.prototype.invDigit=P,t.prototype.isEven=R,t.prototype.exp=U,t.prototype.toString=p,t.prototype.negate=d,t.prototype.abs=v,t.prototype.compareTo=m,t.prototype.bitLength=y,t.prototype.mod=k,t.prototype.modPowInt=z,t.ZERO=l(0),t.ONE=l(1),Dt.prototype.convert=Pt,Dt.prototype.revert=Pt,Dt.prototype.mulTo=Ht,Dt.prototype.sqrTo=Bt,qt.prototype.convert=Rt,qt.prototype.revert=Ut,qt.prototype.reduce=zt,qt.prototype.mulTo=Xt,qt.prototype.sqrTo=Wt;var an=[2,3,5,7,11,13,17,19,23,29,31,37,41,43,47,53,59,61,67,71,73,79,83,89,97,101,103,107,109,113,127,131,137,139,149,151,157,163,167,173,179,181,191,193,197,199,211,223,227,229,233,239,241,251,257,263,269,271,277,281,283,293,307,311,313,317,331,337,347,349,353,359,367,373,379,383,389,397,401,409,419,421,431,433,439,443,449,457,461,463,467,479,487,491,499,503,509],fn=(1<<26)/an[an.length-1];t.prototype.chunkSize=J,t.prototype.toRadix=Q,t.prototype.fromRadix=G,t.prototype.fromNumber=Y,t.prototype.bitwiseTo=rt,t.prototype.changeBit=wt,t.prototype.addTo=Tt,t.prototype.dMultiply=Mt,t.prototype.dAddOffset=_t,t.prototype.multiplyLowerTo=Ft,t.prototype.multiplyUpperTo=It,t.prototype.modInt=Jt,t.prototype.millerRabin=Gt,t.prototype.clone=W,t.prototype.intValue=X,t.prototype.byteValue=V,t.prototype.shortValue=$,t.prototype.signum=K,t.prototype.toByteArray=Z,t.prototype.equals=et,t.prototype.min=tt,t.prototype.max=nt,t.prototype.and=st,t.prototype.or=ut,t.prototype.xor=ft,t.prototype.andNot=ct,t.prototype.not=ht,t.prototype.shiftLeft=pt,t.prototype.shiftRight=dt,t.prototype.getLowestSetBit=mt,t.prototype.bitCount=yt,t.prototype.testBit=bt,t.prototype.setBit=Et,t.prototype.clearBit=St,t.prototype.flipBit=xt,t.prototype.add=Nt,t.prototype.subtract=Ct,t.prototype.multiply=kt,t.prototype.divide=Lt,t.prototype.remainder=At,t.prototype.divideAndRemainder=Ot,t.prototype.modPow=Vt,t.prototype.modInverse=Kt,t.prototype.pow=jt,t.prototype.gcd=$t,t.prototype.isProbablePrime=Qt,e.jsbn=e.jsbn||{},e.jsbn.BigInteger=t}var r="jsbn";if(typeof n!="function"){if(typeof module!="object"||!module.exports)return typeof forge=="undefined"&&(forge={}),e(forge);var i=!0;n=function(e,n){n(t,module)}}var s,o=function(t,n){n.exports=function(n){var i=s.map(function(e){return t(e)}).concat(e);n=n||{},n.defined=n.defined||{};if(n.defined[r])return n[r];n.defined[r]=!0;for(var o=0;o<i.length;++o)i[o](n);return n[r]}},u=n;n=function(e,t){return s=typeof e=="string"?t.slice(2):e.slice(2),i?(delete n,u.apply(null,Array.prototype.slice.call(arguments,0))):(n=u,n.apply(null,Array.prototype.slice.call(arguments,0)))},n("js/jsbn",["require","module"],function(){o.apply(null,Array.prototype.slice.call(arguments,0))})}(),function(){function e(e){function t(t,n,r){r||(r=e.md.sha1.create());var i="",s=Math.ceil(n/r.digestLength);for(var o=0;o<s;++o){var u=String.fromCharCode(o>>24&255,o>>16&255,o>>8&255,o&255);r.start(),r.update(t+u),i+=r.digest().getBytes()}return i.substring(0,n)}var n=e.pkcs1=e.pkcs1||{};n.encode_rsa_oaep=function(n,r,i){var s,o,u,a;typeof i=="string"?(s=i,o=arguments[3]||undefined,u=arguments[4]||undefined):i&&(s=i.label||undefined,o=i.seed||undefined,u=i.md||undefined,i.mgf1&&i.mgf1.md&&(a=i.mgf1.md)),u?u.start():u=e.md.sha1.create(),a||(a=u);var f=Math.ceil(n.n.bitLength()/8),l=f-2*u.digestLength-2;if(r.length>l){var c=new Error("RSAES-OAEP input message length is too long.");throw c.length=r.length,c.maxLength=l,c}s||(s=""),u.update(s,"raw");var h=u.digest(),p="",d=l-r.length;for(var v=0;v<d;v++)p+="\0";var m=h.getBytes()+p+""+r;if(!o)o=e.random.getBytes(u.digestLength);else if(o.length!==u.digestLength){var c=new Error("Invalid RSAES-OAEP seed. The seed length must match the digest length.");throw c.seedLength=o.length,c.digestLength=u.digestLength,c}var g=t(o,f-u.digestLength-1,a),y=e.util.xorBytes(m,g,m.length),b=t(y,u.digestLength,a),w=e.util.xorBytes(o,b,o.length);return"\0"+w+y},n.decode_rsa_oaep=function(n,r,i){var s,o,u;typeof i=="string"?(s=i,o=arguments[3]||undefined):i&&(s=i.label||undefined,o=i.md||undefined,i.mgf1&&i.mgf1.md&&(u=i.mgf1.md));var a=Math.ceil(n.n.bitLength()/8);if(r.length!==a){var f=new Error("RSAES-OAEP encoded message length is invalid.");throw f.length=r.length,f.expectedLength=a,f}o===undefined?o=e.md.sha1.create():o.start(),u||(u=o);if(a<2*o.digestLength+2)throw new Error("RSAES-OAEP key is too short for the hash function.");s||(s=""),o.update(s,"raw");var l=o.digest().getBytes(),c=r.charAt(0),h=r.substring(1,o.digestLength+1),p=r.substring(1+o.digestLength),d=t(p,o.digestLength,u),v=e.util.xorBytes(h,d,h.length),m=t(v,a-o.digestLength-1,u),g=e.util.xorBytes(p,m,p.length),y=g.substring(0,o.digestLength),f=c!=="\0";for(var b=0;b<o.digestLength;++b)f|=l.charAt(b)!==y.charAt(b);var w=1,E=o.digestLength;for(var S=o.digestLength;S<g.length;S++){var x=g.charCodeAt(S),T=x&1^1,N=w?65534:0;f|=x&N,w&=T,E+=w}if(f||g.charCodeAt(E)!==1)throw new Error("Invalid RSAES-OAEP padding.");return g.substring(E+1)}}var r="pkcs1";if(typeof n!="function"){if(typeof module!="object"||!module.exports)return typeof forge=="undefined"&&(forge={}),e(forge);var i=!0;n=function(e,n){n(t,module)}}var s,o=function(t,n){n.exports=function(n){var i=s.map(function(e){return t(e)}).concat(e);n=n||{},n.defined=n.defined||{};if(n.defined[r])return n[r];n.defined[r]=!0;for(var o=0;o<i.length;++o)i[o](n);return n[r]}},u=n;n=function(e,t){return s=typeof e=="string"?t.slice(2):e.slice(2),i?(delete n,u.apply(null,Array.prototype.slice.call(arguments,0))):(n=u,n.apply(null,Array.prototype.slice.call(arguments,0)))},n("js/pkcs1",["require","module","./util","./random","./sha1"],function(){o.apply(null,Array.prototype.slice.call(arguments,0))})}(),function(){function e(e){function t(e,t,i,s){return"workers"in i?r(e,t,i,s):n(e,t,i,s)}function n(t,r,o,u){var f=i(t,r),l=0,c=s(f.bitLength());"millerRabinTests"in o&&(c=o.millerRabinTests);var h=10;"maxBlockTime"in o&&(h=o.maxBlockTime);var p=+(new Date);do{f.bitLength()>t&&(f=i(t,r));if(f.isProbablePrime(c))return u(null,f);f.dAddOffset(a[l++%8],0)}while(h<0||+(new Date)-p<h);e.util.setImmediate(function(){n(t,r,o,u)})}function r(t,r,s,o){function a(){function e(e){if(d)return;--a;var s=e.data;if(s.found){for(var l=0;l<n.length;++l)n[l].terminate();return d=!0,o(null,new u(s.prime,16))}f.bitLength()>t&&(f=i(t,r));var p=f.toString(16);e.target.postMessage({hex:p,workLoad:c}),f.dAddOffset(h,0)}l=Math.max(1,l);var n=[];for(var s=0;s<l;++s)n[s]=new Worker(p);var a=l;for(var s=0;s<l;++s)n[s].addEventListener("message",e);var d=!1}if(typeof Worker=="undefined")return n(t,r,s,o);var f=i(t,r),l=s.workers,c=s.workLoad||100,h=c*30/8,p=s.workerScript||"forge/prime.worker.js";if(l===-1)return e.util.estimateCores(function(e,t){e&&(t=2),l=t-1,a()});a()}function i(e,t){var n=new u(e,t),r=e-1;return n.testBit(r)||n.bitwiseTo(u.ONE.shiftLeft(r),l,n),n.dAddOffset(31-n.mod(f).byteValue(),0),n}function s(e){return e<=100?27:e<=150?18:e<=200?15:e<=250?12:e<=300?9:e<=350?8:e<=400?7:e<=500?6:e<=600?5:e<=800?4:e<=1250?3:2}if(e.prime)return;var o=e.prime=e.prime||{},u=e.jsbn.BigInteger,a=[6,4,2,4,2,4,6,2],f=new u(null);f.fromInt(30);var l=function(e,t){return e|t};o.generateProbablePrime=function(n,r,i){typeof r=="function"&&(i=r,r={}),r=r||{};var s=r.algorithm||"PRIMEINC";typeof s=="string"&&(s={name:s}),s.options=s.options||{};var o=r.prng||e.random,u={nextBytes:function(e){var t=o.getBytesSync(e.length);for(var n=0;n<e.length;++n)e[n]=t.charCodeAt(n)}};if(s.name==="PRIMEINC")return t(n,u,s.options,i);throw new Error("Invalid prime generation algorithm: "+s.name)}}var r="prime";if(typeof n!="function"){if(typeof module!="object"||!module.exports)return typeof forge=="undefined"&&(forge={}),e(forge);var i=!0;n=function(e,n){n(t,module)}}var s,o=function(t,n){n.exports=function(n){var i=s.map(function(e){return t(e)}).concat(e);n=n||{},n.defined=n.defined||{};if(n.defined[r])return n[r];n.defined[r]=!0;for(var o=0;o<i.length;++o)i[o](n);return n[r]}},u=n;n=function(e,t){return s=typeof e=="string"?t.slice(2):e.slice(2),i?(delete n,u.apply(null,Array.prototype.slice.call(arguments,0))):(n=u,n.apply(null,Array.prototype.slice.call(arguments,0)))},n("js/prime",["require","module","./util","./jsbn","./random"],function(){o.apply(null,Array.prototype.slice.call(arguments,0))})}(),function(){function e(e){function t(t,n,r){var i=e.util.createBuffer(),s=Math.ceil(n.n.bitLength()/8);if(t.length>s-11){var o=new Error("Message is too long for PKCS#1 v1.5 padding.");throw o.length=t.length,o.max=s-11,o}i.putByte(0),i.putByte(r);var u=s-3-t.length,a;if(r===0||r===1){a=r===0?0:255;for(var f=0;f<u;++f)i.putByte(a)}else while(u>0){var l=0,c=e.random.getBytes(u);for(var f=0;f<u;++f)a=c.charCodeAt(f),a===0?++l:i.putByte(a);u=l}return i.putByte(0),i.putBytes(t),i}function n(t,n,r,i){var s=Math.ceil(n.n.bitLength()/8),o=e.util.createBuffer(t),u=o.getByte(),a=o.getByte();if(u!==0||r&&a!==0&&a!==1||!r&&a!=2||r&&a===0&&typeof i=="undefined")throw new Error("Encryption block is invalid.");var f=0;if(a===0){f=s-3-i;for(var l=0;l<f;++l)if(o.getByte()!==0)throw new Error("Encryption block is invalid.")}else if(a===1){f=0;while(o.length()>1){if(o.getByte()!==255){--o.read;break}++f}}else if(a===2){f=0;while(o.length()>1){if(o.getByte()===0){--o.read;break}++f}}var c=o.getByte();if(c!==0||f!==s-3-o.length())throw new Error("Encryption block is invalid.");return o.getBytes()}function r(t,n,r){function i(){s(t.pBits,function(e,n){if(e)return r(e);t.p=n;if(t.q!==null)return u(e,t.q);s(t.qBits,u)})}function s(t,n){e.prime.generateProbablePrime(t,f,n)}function u(e,n){if(e)return r(e);t.q=n;if(t.p.compareTo(t.q)<0){var f=t.p;t.p=t.q,t.q=f}if(t.p.subtract(o.ONE).gcd(t.e).compareTo(o.ONE)!==0){t.p=null,i();return}if(t.q.subtract(o.ONE).gcd(t.e).compareTo(o.ONE)!==0){t.q=null,s(t.qBits,u);return}t.p1=t.p.subtract(o.ONE),t.q1=t.q.subtract(o.ONE),t.phi=t.p1.multiply(t.q1);if(t.phi.gcd(t.e).compareTo(o.ONE)!==0){t.p=t.q=null,i();return}t.n=t.p.multiply(t.q);if(t.n.bitLength()!==t.bits){t.q=null,s(t.qBits,u);return}var l=t.e.modInverse(t.phi);t.keys={privateKey:a.rsa.setPrivateKey(t.n,t.e,l,t.p,t.q,l.mod(t.p1),l.mod(t.q1),t.q.modInverse(t.p)),publicKey:a.rsa.setPublicKey(t.n,t.e)},r(null,t.keys)}typeof n=="function"&&(r=n,n={}),n=n||{};var f={algorithm:{name:n.algorithm||"PRIMEINC",options:{workers:n.workers||2,workLoad:n.workLoad||100,workerScript:n.workerScript}}};"prng"in n&&(f.prng=n.prng),i()}function i(t){var n=t.toString(16);return n[0]>="8"&&(n="00"+n),e.util.hexToBytes(n)}function s(e){return e<=100?27:e<=150?18:e<=200?15:e<=250?12:e<=300?9:e<=350?8:e<=400?7:e<=500?6:e<=600?5:e<=800?4:e<=1250?3:2}if(typeof o=="undefined")var o=e.jsbn.BigInteger;var u=e.asn1;e.pki=e.pki||{},e.pki.rsa=e.rsa=e.rsa||{};var a=e.pki,f=[6,4,2,4,2,4,6,2],l={name:"PrivateKeyInfo",tagClass:u.Class.UNIVERSAL,type:u.Type.SEQUENCE,constructed:!0,value:[{name:"PrivateKeyInfo.version",tagClass:u.Class.UNIVERSAL,type:u.Type.INTEGER,constructed:!1,capture:"privateKeyVersion"},{name:"PrivateKeyInfo.privateKeyAlgorithm",tagClass:u.Class.UNIVERSAL,type:u.Type.SEQUENCE,constructed:!0,value:[{name:"AlgorithmIdentifier.algorithm",tagClass:u.Class.UNIVERSAL,type:u.Type.OID,constructed:!1,capture:"privateKeyOid"}]},{name:"PrivateKeyInfo",tagClass:u.Class.UNIVERSAL,type:u.Type.OCTETSTRING,constructed:!1,capture:"privateKey"}]},c={name:"RSAPrivateKey",tagClass:u.Class.UNIVERSAL,type:u.Type.SEQUENCE,constructed:!0,value:[{name:"RSAPrivateKey.version",tagClass:u.Class.UNIVERSAL,type:u.Type.INTEGER,constructed:!1,capture:"privateKeyVersion"},{name:"RSAPrivateKey.modulus",tagClass:u.Class.UNIVERSAL,type:u.Type.INTEGER,constructed:!1,capture:"privateKeyModulus"},{name:"RSAPrivateKey.publicExponent",tagClass:u.Class.UNIVERSAL,type:u.Type.INTEGER,constructed:!1,capture:"privateKeyPublicExponent"},{name:"RSAPrivateKey.privateExponent",tagClass:u.Class.UNIVERSAL,type:u.Type.INTEGER,constructed:!1,capture:"privateKeyPrivateExponent"},{name:"RSAPrivateKey.prime1",tagClass:u.Class.UNIVERSAL,type:u.Type.INTEGER,constructed:!1,capture:"privateKeyPrime1"},{name:"RSAPrivateKey.prime2",tagClass:u.Class.UNIVERSAL,type:u.Type.INTEGER,constructed:!1,capture:"privateKeyPrime2"},{name:"RSAPrivateKey.exponent1",tagClass:u.Class.UNIVERSAL,type:u.Type.INTEGER,constructed:!1,capture:"privateKeyExponent1"},{name:"RSAPrivateKey.exponent2",tagClass:u.Class.UNIVERSAL,type:u.Type.INTEGER,constructed:!1,capture:"privateKeyExponent2"},{name:"RSAPrivateKey.coefficient",tagClass:u.Class.UNIVERSAL,type:u.Type.INTEGER,constructed:!1,capture:"privateKeyCoefficient"}]},h={name:"RSAPublicKey",tagClass:u.Class.UNIVERSAL,type:u.Type.SEQUENCE,constructed:!0,value:[{name:"RSAPublicKey.modulus",tagClass:u.Class.UNIVERSAL,type:u.Type.INTEGER,constructed:!1,capture:"publicKeyModulus"},{name:"RSAPublicKey.exponent",tagClass:u.Class.UNIVERSAL,type:u.Type.INTEGER,constructed:!1,capture:"publicKeyExponent"}]},p=e.pki.rsa.publicKeyValidator={name:"SubjectPublicKeyInfo",tagClass:u.Class.UNIVERSAL,type:u.Type.SEQUENCE,constructed:!0,captureAsn1:"subjectPublicKeyInfo",value:[{name:"SubjectPublicKeyInfo.AlgorithmIdentifier",tagClass:u.Class.UNIVERSAL,type:u.Type.SEQUENCE,constructed:!0,value:[{name:"AlgorithmIdentifier.algorithm",tagClass:u.Class.UNIVERSAL,type:u.Type.OID,constructed:!1,capture:"publicKeyOid"}]},{name:"SubjectPublicKeyInfo.subjectPublicKey",tagClass:u.Class.UNIVERSAL,type:u.Type.BITSTRING,constructed:!1,value:[{name:"SubjectPublicKeyInfo.subjectPublicKey.RSAPublicKey",tagClass:u.Class.UNIVERSAL,type:u.Type.SEQUENCE,constructed:!0,optional:!0,captureAsn1:"rsaPublicKey"}]}]},d=function(e){var t;if(e.algorithm in a.oids){t=a.oids[e.algorithm];var n=u.oidToDer(t).getBytes(),r=u.create(u.Class.UNIVERSAL,u.Type.SEQUENCE,!0,[]),i=u.create(u.Class.UNIVERSAL,u.Type.SEQUENCE,!0,[]);i.value.push(u.create(u.Class.UNIVERSAL,u.Type.OID,!1,n)),i.value.push(u.create(u.Class.UNIVERSAL,u.Type.NULL,!1,""));var s=u.create(u.Class.UNIVERSAL,u.Type.OCTETSTRING,!1,e.digest().getBytes());return r.value.push(i),r.value.push(s),u.toDer(r).getBytes()}var o=new Error("Unknown message digest algorithm.");throw o.algorithm=e.algorithm,o},v=function(t,n,r){if(r)return t.modPow(n.e,n.n);if(!n.p||!n.q)return t.modPow(n.d,n.n);n.dP||(n.dP=n.d.mod(n.p.subtract(o.ONE))),n.dQ||(n.dQ=n.d.mod(n.q.subtract(o.ONE))),n.qInv||(n.qInv=n.q.modInverse(n.p));var i;do i=(new o(e.util.bytesToHex(e.random.getBytes(n.n.bitLength()/8)),16)).mod(n.n);while(i.equals(o.ZERO));t=t.multiply(i.modPow(n.e,n.n)).mod(n.n);var s=t.mod(n.p).modPow(n.dP,n.p),u=t.mod(n.q).modPow(n.dQ,n.q);while(s.compareTo(u)<0)s=s.add(n.p);var a=s.subtract(u).multiply(n.qInv).mod(n.p).multiply(n.q).add(u);return a=a.multiply(i.modInverse(n.n)).mod(n.n),a};a.rsa.encrypt=function(n,r,i){var s=i,u,a=Math.ceil(r.n.bitLength()/8);i!==!1&&i!==!0?(s=i===2,u=t(n,r,i)):(u=e.util.createBuffer(),u.putBytes(n));var f=new o(u.toHex(),16),l=v(f,r,s),c=l.toString(16),h=e.util.createBuffer(),p=a-Math.ceil(c.length/2);while(p>0)h.putByte(0),--p;return h.putBytes(e.util.hexToBytes(c)),h.getBytes()},a.rsa.decrypt=function(t,r,i,s){var u=Math.ceil(r.n.bitLength()/8);if(t.length!==u){var a=new Error("Encrypted message length is invalid.");throw a.length=t.length,a.expected=u,a}var f=new o(e.util.createBuffer(t).toHex(),16);if(f.compareTo(r.n)>=0)throw new Error("Encrypted message is invalid.");var l=v(f,r,i),c=l.toString(16),h=e.util.createBuffer(),p=u-Math.ceil(c.length/2);while(p>0)h.putByte(0),--p;return h.putBytes(e.util.hexToBytes(c)),s!==!1?n(h.getBytes(),r,i):h.getBytes()},a.rsa.createKeyPairGenerationState=function(t,n,r){typeof t=="string"&&(t=parseInt(t,10)),t=t||2048,r=r||{};var i=r.prng||e.random,s={nextBytes:function(e){var t=i.getBytesSync(e.length);for(var n=0;n<e.length;++n)e[n]=t.charCodeAt(n)}},u=r.algorithm||"PRIMEINC",a;if(u!=="PRIMEINC")throw new Error("Invalid key generation algorithm: "+u);return a={algorithm:u,state:0,bits:t,rng:s,eInt:n||65537,e:new o(null),p:null,q:null,qBits:t>>1,pBits:t-(t>>1),pqState:0,num:null,keys:null},a.e.fromInt(a.eInt),a},a.rsa.stepKeyPairGenerationState=function(e,t){"algorithm"in e||(e.algorithm="PRIMEINC");var n=new o(null);n.fromInt(30);var r=0,i=function(e,t){return e|t},u=+(new Date),l,c=0;while(e.keys===null&&(t<=0||c<t)){if(e.state===0){var h=e.p===null?e.pBits:e.qBits,p=h-1;e.pqState===0?(e.num=new o(h,e.rng),e.num.testBit(p)||e.num.bitwiseTo(o.ONE.shiftLeft(p),i,e.num),e.num.dAddOffset(31-e.num.mod(n).byteValue(),0),r=0,++e.pqState):e.pqState===1?e.num.bitLength()>h?e.pqState=0:e.num.isProbablePrime(s(e.num.bitLength()))?++e.pqState:e.num.dAddOffset(f[r++%8],0):e.pqState===2?e.pqState=e.num.subtract(o.ONE).gcd(e.e).compareTo(o.ONE)===0?3:0:e.pqState===3&&(e.pqState=0,e.p===null?e.p=e.num:e.q=e.num,e.p!==null&&e.q!==null&&++e.state,e.num=null)}else if(e.state===1)e.p.compareTo(e.q)<0&&(e.num=e.p,e.p=e.q,e.q=e.num),++e.state;else if(e.state===2)e.p1=e.p.subtract(o.ONE),e.q1=e.q.subtract(o.ONE),e.phi=e.p1.multiply(e.q1),++e.state;else if(e.state===3)e.phi.gcd(e.e).compareTo(o.ONE)===0?++e.state:(e.p=null,e.q=null,e.state=0);else if(e.state===4)e.n=e.p.multiply(e.q),e.n.bitLength()===e.bits?++e.state:(e.q=null,e.state=0);else if(e.state===5){var d=e.e.modInverse(e.phi);e.keys={privateKey:a.rsa.setPrivateKey(e.n,e.e,d,e.p,e.q,d.mod(e.p1),d.mod(e.q1),e.q.modInverse(e.p)),publicKey:a.rsa.setPublicKey(e.n,e.e)}}l=+(new Date),c+=l-u,u=l}return e.keys!==null},a.rsa.generateKeyPair=function(e,t,n,i){arguments.length===1?typeof e=="object"?(n=e,e=undefined):typeof e=="function"&&(i=e,e=undefined):arguments.length===2?typeof e=="number"?typeof t=="function"?(i=t,t=undefined):typeof t!="number"&&(n=t,t=undefined):(n=e,i=t,e=undefined,t=undefined):arguments.length===3&&(typeof t=="number"?typeof n=="function"&&(i=n,n=undefined):(i=n,n=t,t=undefined)),n=n||{},e===undefined&&(e=n.bits||2048),t===undefined&&(t=n.e||65537);var s=a.rsa.createKeyPairGenerationState(e,t,n);if(!i)return a.rsa.stepKeyPairGenerationState(s,0),s.keys;r(s,n,i)},a.setRsaPublicKey=a.rsa.setPublicKey=function(r,i){var s={n:r,e:i};return s.encrypt=function(n,r,i){typeof r=="string"?r=r.toUpperCase():r===undefined&&(r="RSAES-PKCS1-V1_5");if(r==="RSAES-PKCS1-V1_5")r={encode:function(e,n,r){return t(e,n,2).getBytes()}};else if(r==="RSA-OAEP"||r==="RSAES-OAEP")r={encode:function(t,n){return e.pkcs1.encode_rsa_oaep(n,t,i)}};else if(["RAW","NONE","NULL",null].indexOf(r)!==-1)r={encode:function(e){return e}};else if(typeof r=="string")throw new Error('Unsupported encryption scheme: "'+r+'".');var o=r.encode(n,s,!0);return a.rsa.encrypt(o,s,!0)},s.verify=function(e,t,r){typeof r=="string"?r=r.toUpperCase():r===undefined&&(r="RSASSA-PKCS1-V1_5");if(r==="RSASSA-PKCS1-V1_5")r={verify:function(e,t){t=n(t,s,!0);var r=u.fromDer(t);return e===r.value[1].value}};else if(r==="NONE"||r==="NULL"||r===null)r={verify:function(e,t){return t=n(t,s,!0),e===t}};var i=a.rsa.decrypt(t,s,!0,!1);return r.verify(e,i,s.n.bitLength())},s},a.setRsaPrivateKey=a.rsa.setPrivateKey=function(t,r,i,s,o,u,f,l){var c={n:t,e:r,d:i,p:s,q:o,dP:u,dQ:f,qInv:l};return c.decrypt=function(t,r,i){typeof r=="string"?r=r.toUpperCase():r===undefined&&(r="RSAES-PKCS1-V1_5");var s=a.rsa.decrypt(t,c,!1,!1);if(r==="RSAES-PKCS1-V1_5")r={decode:n};else if(r==="RSA-OAEP"||r==="RSAES-OAEP")r={decode:function(t,n){return e.pkcs1.decode_rsa_oaep(n,t,i)}};else{if(["RAW","NONE","NULL",null].indexOf(r)===-1)throw new Error('Unsupported encryption scheme: "'+r+'".');r={decode:function(e){return e}}}return r.decode(s,c,!1)},c.sign=function(e,t){var n=!1;typeof t=="string"&&(t=t.toUpperCase());if(t===undefined||t==="RSASSA-PKCS1-V1_5")t={encode:d},n=1;else if(t==="NONE"||t==="NULL"||t===null)t={encode:function(){return e}},n=1;var r=t.encode(e,c.n.bitLength());return a.rsa.encrypt(r,c,n)},c},a.wrapRsaPrivateKey=function(e){return u.create(u.Class.UNIVERSAL,u.Type.SEQUENCE,!0,[u.create(u.Class.UNIVERSAL,u.Type.INTEGER,!1,u.integerToDer(0).getBytes()),u.create(u.Class.UNIVERSAL,u.Type.SEQUENCE,!0,[u.create(u.Class.UNIVERSAL,u.Type.OID,!1,u.oidToDer(a.oids.rsaEncryption).getBytes()),u.create(u.Class.UNIVERSAL,u.Type.NULL,!1,"")]),u.create(u.Class.UNIVERSAL,u.Type.OCTETSTRING,!1,u.toDer(e).getBytes())])},a.privateKeyFromAsn1=function(t){var n={},r=[];u.validate(t,l,n,r)&&(t=u.fromDer(e.util.createBuffer(n.privateKey))),n={},r=[];if(!u.validate(t,c,n,r)){var i=new Error("Cannot read private key. ASN.1 object does not contain an RSAPrivateKey.");throw i.errors=r,i}var s,f,h,p,d,v,m,g;return s=e.util.createBuffer(n.privateKeyModulus).toHex(),f=e.util.createBuffer(n.privateKeyPublicExponent).toHex(),h=e.util.createBuffer(n.privateKeyPrivateExponent).toHex(),p=e.util.createBuffer(n.privateKeyPrime1).toHex(),d=e.util.createBuffer(n.privateKeyPrime2).toHex(),v=e.util.createBuffer(n.privateKeyExponent1).toHex(),m=e.util.createBuffer(n.privateKeyExponent2).toHex(),g=e.util.createBuffer(n.privateKeyCoefficient).toHex(),a.setRsaPrivateKey(new o(s,16),new o(f,16),new o(h,16),new o(p,16),new o(d,16),new o(v,16),new o(m,16),new o(g,16))},a.privateKeyToAsn1=a.privateKeyToRSAPrivateKey=function(e){return u.create(u.Class.UNIVERSAL,u.Type.SEQUENCE,!0,[u.create(u.Class.UNIVERSAL,u.Type.INTEGER,!1,u.integerToDer(0).getBytes()),u.create(u.Class.UNIVERSAL,u.Type.INTEGER,!1,i(e.n)),u.create(u.Class.UNIVERSAL,u.Type.INTEGER,!1,i(e.e)),u.create(u.Class.UNIVERSAL,u.Type.INTEGER,!1,i(e.d)),u.create(u.Class.UNIVERSAL,u.Type.INTEGER,!1,i(e.p)),u.create(u.Class.UNIVERSAL,u.Type.INTEGER,!1,i(e.q)),u.create(u.Class.UNIVERSAL,u.Type.INTEGER,!1,i(e.dP)),u.create(u.Class.UNIVERSAL,u.Type.INTEGER,!1,i(e.dQ)),u.create(u.Class.UNIVERSAL,u.Type.INTEGER,!1,i(e.qInv))])},a.publicKeyFromAsn1=function(t){var n={},r=[];if(u.validate(t,p,n,r)){var i=u.derToOid(n.publicKeyOid);if(i!==a.oids.rsaEncryption){var s=new Error("Cannot read public key. Unknown OID.");throw s.oid=i,s}t=n.rsaPublicKey}r=[];if(!u.validate(t,h,n,r)){var s=new Error("Cannot read public key. ASN.1 object does not contain an RSAPublicKey.");throw s.errors=r,s}var f=e.util.createBuffer(n.publicKeyModulus).toHex(),l=e.util.createBuffer(n.publicKeyExponent).toHex();return a.setRsaPublicKey(new o(f,16),new o(l,16))},a.publicKeyToAsn1=a.publicKeyToSubjectPublicKeyInfo=function(e){return u.create(u.Class.UNIVERSAL,u.Type.SEQUENCE,!0,[u.create(u.Class.UNIVERSAL,u.Type.SEQUENCE,!0,[u.create(u.Class.UNIVERSAL,u.Type.OID,!1,u.oidToDer(a.oids.rsaEncryption).getBytes()),u.create(u.Class.UNIVERSAL,u.Type.NULL,!1,"")]),u.create(u.Class.UNIVERSAL,u.Type.BITSTRING,!1,[a.publicKeyToRSAPublicKey(e)])])},a.publicKeyToRSAPublicKey=function(e){return u.create(u.Class.UNIVERSAL,u.Type.SEQUENCE,!0,[u.create(u.Class.UNIVERSAL,u.Type.INTEGER,!1,i(e.n)),u.create(u.Class.UNIVERSAL,u.Type.INTEGER,!1,i(e.e))])}}var r="rsa";if(typeof n!="function"){if(typeof module!="object"||!module.exports)return typeof forge=="undefined"&&(forge={}),e(forge);var i=!0;n=function(e,n){n(t,module)}}var s,o=function(t,n){n.exports=function(n){var i=s.map(function(e){return t(e)}).concat(e);n=n||{},n.defined=n.defined||{};if(n.defined[r])return n[r];n.defined[r]=!0;for(var o=0;o<i.length;++o)i[o](n);return n[r]}},u=n;n=function(e,t){return s=typeof e=="string"?t.slice(2):e.slice(2),i?(delete n,u.apply(null,Array.prototype.slice.call(arguments,0))):(n=u,n.apply(null,Array.prototype.slice.call(arguments,0)))},n("js/rsa",["require","module","./asn1","./jsbn","./oids","./pkcs1","./prime","./random","./util"],function(){o.apply(null,Array.prototype.slice.call(arguments,0))})}(),function(){function e(e){function t(e,t){return e.start().update(t).digest().getBytes()}if(typeof n=="undefined")var n=e.jsbn.BigInteger;var r=e.asn1,i=e.pki=e.pki||{};i.pbe=e.pbe=e.pbe||{};var s=i.oids,o={name:"EncryptedPrivateKeyInfo",tagClass:r.Class.UNIVERSAL,type:r.Type.SEQUENCE,constructed:!0,value:[{name:"EncryptedPrivateKeyInfo.encryptionAlgorithm",tagClass:r.Class.UNIVERSAL,type:r.Type.SEQUENCE,constructed:!0,value:[{name:"AlgorithmIdentifier.algorithm",tagClass:r.Class.UNIVERSAL,type:r.Type.OID,constructed:!1,capture:"encryptionOid"},{name:"AlgorithmIdentifier.parameters",tagClass:r.Class.UNIVERSAL,type:r.Type.SEQUENCE,constructed:!0,captureAsn1:"encryptionParams"}]},{name:"EncryptedPrivateKeyInfo.encryptedData",tagClass:r.Class.UNIVERSAL,type:r.Type.OCTETSTRING,constructed:!1,capture:"encryptedData"}]},u={name:"PBES2Algorithms",tagClass:r.Class.UNIVERSAL,type:r.Type.SEQUENCE,constructed:!0,value:[{name:"PBES2Algorithms.keyDerivationFunc",tagClass:r.Class.UNIVERSAL,type:r.Type.SEQUENCE,constructed:!0,value:[{name:"PBES2Algorithms.keyDerivationFunc.oid",tagClass:r.Class.UNIVERSAL,type:r.Type.OID,constructed:!1,capture:"kdfOid"},{name:"PBES2Algorithms.params",tagClass:r.Class.UNIVERSAL,type:r.Type.SEQUENCE,constructed:!0,value:[{name:"PBES2Algorithms.params.salt",tagClass:r.Class.UNIVERSAL,type:r.Type.OCTETSTRING,constructed:!1,capture:"kdfSalt"},{name:"PBES2Algorithms.params.iterationCount",tagClass:r.Class.UNIVERSAL,type:r.Type.INTEGER,onstructed:!0,capture:"kdfIterationCount"}]}]},{name:"PBES2Algorithms.encryptionScheme",tagClass:r.Class.UNIVERSAL,type:r.Type.SEQUENCE,constructed:!0,value:[{name:"PBES2Algorithms.encryptionScheme.oid",tagClass:r.Class.UNIVERSAL,type:r.Type.OID,constructed:!1,capture:"encOid"},{name:"PBES2Algorithms.encryptionScheme.iv",tagClass:r.Class.UNIVERSAL,type:r.Type.OCTETSTRING,constructed:!1,capture:"encIv"}]}]},a={name:"pkcs-12PbeParams",tagClass:r.Class.UNIVERSAL,type:r.Type.SEQUENCE,constructed:!0,value:[{name:"pkcs-12PbeParams.salt",tagClass:r.Class.UNIVERSAL,type:r.Type.OCTETSTRING,constructed:!1,capture:"salt"},{name:"pkcs-12PbeParams.iterations",tagClass:r.Class.UNIVERSAL,type:r.Type.INTEGER,constructed:!1,capture:"iterations"}]};i.encryptPrivateKeyInfo=function(t,n,o){o=o||{},o.saltSize=o.saltSize||8,o.count=o.count||2048,o.algorithm=o.algorithm||"aes128";var u=e.random.getBytesSync(o.saltSize),a=o.count,f=r.integerToDer(a),l,c,h;if(o.algorithm.indexOf("aes")===0||o.algorithm==="des"){var p,d,v;switch(o.algorithm){case"aes128":l=16,p=16,d=s["aes128-CBC"],v=e.aes.createEncryptionCipher;break;case"aes192":l=24,p=16,d=s["aes192-CBC"],v=e.aes.createEncryptionCipher;break;case"aes256":l=32,p=16,d=s["aes256-CBC"],v=e.aes.createEncryptionCipher;break;case"des":l=8,p=8,d=s.desCBC,v=e.des.createEncryptionCipher;break;default:var m=new Error("Cannot encrypt private key. Unknown encryption algorithm.");throw m.algorithm=o.algorithm,m}var g=e.pkcs5.pbkdf2(n,u,a,l),y=e.random.getBytesSync(p),b=v(g);b.start(y),b.update(r.toDer(t)),b.finish(),h=b.output.getBytes(),c=r.create(r.Class.UNIVERSAL,r.Type.SEQUENCE,!0,[r.create(r.Class.UNIVERSAL,r.Type.OID,!1,r.oidToDer(s.pkcs5PBES2).getBytes()),r.create(r.Class.UNIVERSAL,r.Type.SEQUENCE,!0,[r.create(r.Class.UNIVERSAL,r.Type.SEQUENCE,!0,[r.create(r.Class.UNIVERSAL,r.Type.OID,!1,r.oidToDer(s.pkcs5PBKDF2).getBytes()),r.create(r.Class.UNIVERSAL,r.Type.SEQUENCE,!0,[r.create(r.Class.UNIVERSAL,r.Type.OCTETSTRING,!1,u),r.create(r.Class.UNIVERSAL,r.Type.INTEGER,!1,f.getBytes())])]),r.create(r.Class.UNIVERSAL,r.Type.SEQUENCE,!0,[r.create(r.Class.UNIVERSAL,r.Type.OID,!1,r.oidToDer(d).getBytes()),r.create(r.Class.UNIVERSAL,r.Type.OCTETSTRING,!1,y)])])])}else{if(o.algorithm!=="3des"){var m=new Error("Cannot encrypt private key. Unknown encryption algorithm.");throw m.algorithm=o.algorithm,m}l=24;var w=new e.util.ByteBuffer(u),g=i.pbe.generatePkcs12Key(n,w,1,a,l),y=i.pbe.generatePkcs12Key(n,w,2,a,l),b=e.des.createEncryptionCipher(g);b.start(y),b.update(r.toDer(t)),b.finish(),h=b.output.getBytes(),c=r.create(r.Class.UNIVERSAL,r.Type.SEQUENCE,!0,[r.create(r.Class.UNIVERSAL,r.Type.OID,!1,r.oidToDer(s["pbeWithSHAAnd3-KeyTripleDES-CBC"]).getBytes()),r.create(r.Class.UNIVERSAL,r.Type.SEQUENCE,!0,[r.create(r.Class.UNIVERSAL,r.Type.OCTETSTRING,!1,u),r.create(r.Class.UNIVERSAL,r.Type.INTEGER,!1,f.getBytes())])])}var E=r.create(r.Class.UNIVERSAL,r.Type.SEQUENCE,!0,[c,r.create(r.Class.UNIVERSAL,r.Type.OCTETSTRING,!1,h)]);return E},i.decryptPrivateKeyInfo=function(t,n){var s=null,u={},a=[];if(!r.validate(t,o,u,a)){var f=new Error("Cannot read encrypted private key. ASN.1 object is not a supported EncryptedPrivateKeyInfo.");throw f.errors=a,f}var l=r.derToOid(u.encryptionOid),c=i.pbe.getCipher(l,u.encryptionParams,n),h=e.util.createBuffer(u.encryptedData);return c.update(h),c.finish()&&(s=r.fromDer(c.output)),s},i.encryptedPrivateKeyToPem=function(t,n){var i={type:"ENCRYPTED PRIVATE KEY",body:r.toDer(t).getBytes()};return e.pem.encode(i,{maxline:n})},i.encryptedPrivateKeyFromPem=function(t){var n=e.pem.decode(t)[0];if(n.type!=="ENCRYPTED PRIVATE KEY"){var i=new Error('Could not convert encrypted private key from PEM; PEM header type is "ENCRYPTED PRIVATE KEY".');throw i.headerType=n.type,i}if(n.procType&&n.procType.type==="ENCRYPTED")throw new Error("Could not convert encrypted private key from PEM; PEM is encrypted.");return r.fromDer(n.body)},i.encryptRsaPrivateKey=function(t,n,s){s=s||{};if(!s.legacy){var o=i.wrapRsaPrivateKey(i.privateKeyToAsn1(t));return o=i.encryptPrivateKeyInfo(o,n,s),i.encryptedPrivateKeyToPem(o)}var u,a,f,l;switch(s.algorithm){case"aes128":u="AES-128-CBC",f=16,a=e.random.getBytesSync(16),l=e.aes.createEncryptionCipher;break;case"aes192":u="AES-192-CBC",f=24,a=e.random.getBytesSync(16),l=e.aes.createEncryptionCipher;break;case"aes256":u="AES-256-CBC",f=32,a=e.random.getBytesSync(16),l=e.aes.createEncryptionCipher;break;case"3des":u="DES-EDE3-CBC",f=24,a=e.random.getBytesSync(8),l=e.des.createEncryptionCipher;break;case"des":u="DES-CBC",f=8,a=e.random.getBytesSync(8),l=e.des.createEncryptionCipher;break;default:var c=new Error('Could not encrypt RSA private key; unsupported encryption algorithm "'+s.algorithm+'".');throw c.algorithm=s.algorithm,c}var h=e.pbe.opensslDeriveBytes(n,a.substr(0,8),f),p=l(h);p.start(a),p.update(r.toDer(i.privateKeyToAsn1(t))),p.finish();var d={type:"RSA PRIVATE KEY",procType:{version:"4",type:"ENCRYPTED"},dekInfo:{algorithm:u,parameters:e.util.bytesToHex(a).toUpperCase()},body:p.output.getBytes()};return e.pem.encode(d)},i.decryptRsaPrivateKey=function(t,n){var s=null,o=e.pem.decode(t)[0];if(o.type!=="ENCRYPTED PRIVATE KEY"&&o.type!=="PRIVATE KEY"&&o.type!=="RSA PRIVATE KEY"){var u=new Error('Could not convert private key from PEM; PEM header type is not "ENCRYPTED PRIVATE KEY", "PRIVATE KEY", or "RSA PRIVATE KEY".');throw u.headerType=u,u}if(o.procType&&o.procType.type==="ENCRYPTED"){var a,f;switch(o.dekInfo.algorithm){case"DES-CBC":a=8,f=e.des.createDecryptionCipher;break;case"DES-EDE3-CBC":a=24,f=e.des.createDecryptionCipher;break;case"AES-128-CBC":a=16,f=e.aes.createDecryptionCipher;break;case"AES-192-CBC":a=24,f=e.aes.createDecryptionCipher;break;case"AES-256-CBC":a=32,f=e.aes.createDecryptionCipher;break;case"RC2-40-CBC":a=5,f=function(t){return e.rc2.createDecryptionCipher(t,40)};break;case"RC2-64-CBC":a=8,f=function(t){return e.rc2.createDecryptionCipher(t,64)};break;case"RC2-128-CBC":a=16,f=function(t){return e.rc2.createDecryptionCipher(t,128)};break;default:var u=new Error('Could not decrypt private key; unsupported encryption algorithm "'+o.dekInfo.algorithm+'".');throw u.algorithm=o.dekInfo.algorithm,u}var l=e.util.hexToBytes(o.dekInfo.parameters),c=e.pbe.opensslDeriveBytes(n,l.substr(0,8),a),h=f(c);h.start(l),h.update(e.util.createBuffer(o.body));if(!h.finish())return s;s=h.output.getBytes()}else s=o.body;return o.type==="ENCRYPTED PRIVATE KEY"?s=i.decryptPrivateKeyInfo(r.fromDer(s),n):s=r.fromDer(s),s!==null&&(s=i.privateKeyFromAsn1(s)),s},i.pbe.generatePkcs12Key=function(t,n,r,i,s,o){var u,a;if(typeof o=="undefined"||o===null)o=e.md.sha1.create();var f=o.digestLength,l=o.blockLength,c=new e.util.ByteBuffer,h=new e.util.ByteBuffer;if(t!==null&&t!==undefined){for(a=0;a<t.length;a++)h.putInt16(t.charCodeAt(a));h.putInt16(0)}var p=h.length(),d=n.length(),v=new e.util.ByteBuffer;v.fillWithByte(r,l);var m=l*Math.ceil(d/l),g=new e.util.ByteBuffer;for(a=0;a<m;a++)g.putByte(n.at(a%d));var y=l*Math.ceil(p/l),b=new e.util.ByteBuffer;for(a=0;a<y;a++)b.putByte(h.at(a%p));var w=g;w.putBuffer(b);var E=Math.ceil(s/f);for(var S=1;S<=E;S++){var x=new e.util.ByteBuffer;x.putBytes(v.bytes()),x.putBytes(w.bytes());for(var T=0;T<i;T++)o.start(),o.update(x.getBytes()),x=o.digest();var N=new e.util.ByteBuffer;for(a=0;a<l;a++)N.putByte(x.at(a%f));var C=Math.ceil(d/l)+Math.ceil(p/l),k=new e.util.ByteBuffer;for(u=0;u<C;u++){var L=new e.util.ByteBuffer(w.getBytes(l)),A=511;for(a=N.length()-1;a>=0;a--)A>>=8,A+=N.at(a)+L.at(a),L.setAt(a,A&255);k.putBuffer(L)}w=k,c.putBuffer(x)}return c.truncate(c.length()-s),c},i.pbe.getCipher=function(e,t,n){switch(e){case i.oids.pkcs5PBES2:return i.pbe.getCipherForPBES2(e,t,n);case i.oids["pbeWithSHAAnd3-KeyTripleDES-CBC"]:case i.oids["pbewithSHAAnd40BitRC2-CBC"]:return i.pbe.getCipherForPKCS12PBE(e,t,n);default:var r=new Error("Cannot read encrypted PBE data block. Unsupported OID.");throw r.oid=e,r.supportedOids=["pkcs5PBES2","pbeWithSHAAnd3-KeyTripleDES-CBC","pbewithSHAAnd40BitRC2-CBC"],r}},i.pbe.getCipherForPBES2=function(t,n,s){var o={},a=[];if(!r.validate(n,u,o,a)){var f=new Error("Cannot read password-based-encryption algorithm parameters. ASN.1 object is not a supported EncryptedPrivateKeyInfo.");throw f.errors=a,f}t=r.derToOid(o.kdfOid);if(t!==i.oids.pkcs5PBKDF2){var f=new Error("Cannot read encrypted private key. Unsupported key derivation function OID.");throw f.oid=t,f.supportedOids=["pkcs5PBKDF2"],f}t=r.derToOid(o.encOid);if(t!==i.oids["aes128-CBC"]&&t!==i.oids["aes192-CBC"]&&t!==i.oids["aes256-CBC"]&&t!==i.oids["des-EDE3-CBC"]&&t!==i.oids.desCBC){var f=new Error("Cannot read encrypted private key. Unsupported encryption scheme OID.");throw f.oid=t,f.supportedOids=["aes128-CBC","aes192-CBC","aes256-CBC","des-EDE3-CBC","desCBC"],f}var l=o.kdfSalt,c=e.util.createBuffer(o.kdfIterationCount);c=c.getInt(c.length()<<3);var h,p;switch(i.oids[t]){case"aes128-CBC":h=16,p=e.aes.createDecryptionCipher;break;case"aes192-CBC":h=24,p=e.aes.createDecryptionCipher;break;case"aes256-CBC":h=32,p=e.aes.createDecryptionCipher;break;case"des-EDE3-CBC":h=24,p=e.des.createDecryptionCipher;break;case"desCBC":h=8,p=e.des.createDecryptionCipher}var d=e.pkcs5.pbkdf2(s,l,c,h),v=o.encIv,m=p(d);return m.start(v),m},i.pbe.getCipherForPKCS12PBE=function(t,n,s){var o={},u=[];if(!r.validate(n,a,o,u)){var f=new Error("Cannot read password-based-encryption algorithm parameters. ASN.1 object is not a supported EncryptedPrivateKeyInfo.");throw f.errors=u,f}var l=e.util.createBuffer(o.salt),c=e.util.createBuffer(o.iterations);c=c.getInt(c.length()<<3);var h,p,d;switch(t){case i.oids["pbeWithSHAAnd3-KeyTripleDES-CBC"]:h=24,p=8,d=e.des.startDecrypting;break;case i.oids["pbewithSHAAnd40BitRC2-CBC"]:h=5,p=8,d=function(t,n){var r=e.rc2.createDecryptionCipher(t,40);return r.start(n,null),r};break;default:var f=new Error("Cannot read PKCS #12 PBE data block. Unsupported OID.");throw f.oid=t,f}var v=i.pbe.generatePkcs12Key(s,l,1,c,h),m=i.pbe.generatePkcs12Key(s,l,2,c,p);return d(v,m)},i.pbe.opensslDeriveBytes=function(n,r,i,s){if(typeof s=="undefined"||s===null)s=e.md.md5.create();r===null&&(r="");var o=[t(s,n+r)];for(var u=16,a=1;u<i;++a,u+=16)o.push(t(s,o[a-1]+n+r));return o.join("").substr(0,i)}}var r="pbe";if(typeof n!="function"){if(typeof module!="object"||!module.exports)return typeof forge=="undefined"&&(forge={}),e(forge);var i=!0;n=function(e,n){n(t,module)}}var s,o=function(t,n){n.exports=function(n){var i=s.map(function(e){return t(e)}).concat(e);n=n||{},n.defined=n.defined||{};if(n.defined[r])return n[r];n.defined[r]=!0;for(var o=0;o<i.length;++o)i[o](n);return n[r]}},u=n;n=function(e,t){return s=typeof e=="string"?t.slice(2):e.slice(2),i?(delete n,u.apply(null,Array.prototype.slice.call(arguments,0))):(n=u,n.apply(null,Array.prototype.slice.call(arguments,0)))},n("js/pbe",["require","module","./aes","./asn1","./des","./md","./oids","./pem","./pbkdf2","./random","./rc2","./rsa","./util"],function(){o.apply(null,Array.prototype.slice.call(arguments,0))})}(),function(){function e(e){var t=e.asn1,n=e.pkcs7asn1=e.pkcs7asn1||{};e.pkcs7=e.pkcs7||{},e.pkcs7.asn1=n;var r={name:"ContentInfo",tagClass:t.Class.UNIVERSAL,type:t.Type.SEQUENCE,constructed:!0,value:[{name:"ContentInfo.ContentType",tagClass:t.Class.UNIVERSAL,type:t.Type.OID,constructed:!1,capture:"contentType"},{name:"ContentInfo.content",tagClass:t.Class.CONTEXT_SPECIFIC,type:0,constructed:!0,optional:!0,captureAsn1:"content"}]};n.contentInfoValidator=r;var i={name:"EncryptedContentInfo",tagClass:t.Class.UNIVERSAL,type:t.Type.SEQUENCE,constructed:!0,value:[{name:"EncryptedContentInfo.contentType",tagClass:t.Class.UNIVERSAL,type:t.Type.OID,constructed:!1,capture:"contentType"},{name:"EncryptedContentInfo.contentEncryptionAlgorithm",tagClass:t.Class.UNIVERSAL,type:t.Type.SEQUENCE,constructed:!0,value:[{name:"EncryptedContentInfo.contentEncryptionAlgorithm.algorithm",tagClass:t.Class.UNIVERSAL,type:t.Type.OID,constructed:!1,capture:"encAlgorithm"},{name:"EncryptedContentInfo.contentEncryptionAlgorithm.parameter",tagClass:t.Class.UNIVERSAL,captureAsn1:"encParameter"}]},{name:"EncryptedContentInfo.encryptedContent",tagClass:t.Class.CONTEXT_SPECIFIC,type:0,capture:"encryptedContent",captureAsn1:"encryptedContentAsn1"}]};n.envelopedDataValidator={name:"EnvelopedData",tagClass:t.Class.UNIVERSAL,type:t.Type.SEQUENCE,constructed:!0,value:[{name:"EnvelopedData.Version",tagClass:t.Class.UNIVERSAL,type:t.Type.INTEGER,constructed:!1,capture:"version"},{name:"EnvelopedData.RecipientInfos",tagClass:t.Class.UNIVERSAL,type:t.Type.SET,constructed:!0,captureAsn1:"recipientInfos"}].concat(i)},n.encryptedDataValidator={name:"EncryptedData",tagClass:t.Class.UNIVERSAL,type:t.Type.SEQUENCE,constructed:!0,value:[{name:"EncryptedData.Version",tagClass:t.Class.UNIVERSAL,type:t.Type.INTEGER,constructed:!1,capture:"version"}].concat(i)};var s={name:"SignerInfo",tagClass:t.Class.UNIVERSAL,type:t.Type.SEQUENCE,constructed:!0,value:[{name:"SignerInfo.Version",tagClass:t.Class.UNIVERSAL,type:t.Type.INTEGER,constructed:!1},{name:"SignerInfo.IssuerAndSerialNumber",tagClass:t.Class.UNIVERSAL,type:t.Type.SEQUENCE,constructed:!0},{name:"SignerInfo.DigestAlgorithm",tagClass:t.Class.UNIVERSAL,type:t.Type.SEQUENCE,constructed:!0},{name:"SignerInfo.AuthenticatedAttributes",tagClass:t.Class.CONTEXT_SPECIFIC,type:0,constructed:!0,optional:!0,capture:"authenticatedAttributes"},{name:"SignerInfo.DigestEncryptionAlgorithm",tagClass:t.Class.UNIVERSAL,type:t.Type.SEQUENCE,constructed:!0},{name:"SignerInfo.EncryptedDigest",tagClass:t.Class.UNIVERSAL,type:t.Type.OCTETSTRING,constructed:!1,capture:"signature"},{name:"SignerInfo.UnauthenticatedAttributes",tagClass:t.Class.CONTEXT_SPECIFIC,type:1,constructed:!0,optional:!0}]};n.signedDataValidator={name:"SignedData",tagClass:t.Class.UNIVERSAL,type:t.Type.SEQUENCE,constructed:!0,value:[{name:"SignedData.Version",tagClass:t.Class.UNIVERSAL,type:t.Type.INTEGER,constructed:!1,capture:"version"},{name:"SignedData.DigestAlgorithms",tagClass:t.Class.UNIVERSAL,type:t.Type.SET,constructed:!0,captureAsn1:"digestAlgorithms"},r,{name:"SignedData.Certificates",tagClass:t.Class.CONTEXT_SPECIFIC,type:0,optional:!0,captureAsn1:"certificates"},{name:"SignedData.CertificateRevocationLists",tagClass:t.Class.CONTEXT_SPECIFIC,type:1,optional:!0,captureAsn1:"crls"},{name:"SignedData.SignerInfos",tagClass:t.Class.UNIVERSAL,type:t.Type.SET,capture:"signerInfos",optional:!0,value:[s]}]},n.recipientInfoValidator={name:"RecipientInfo",tagClass:t.Class.UNIVERSAL,type:t.Type.SEQUENCE,constructed:!0,value:[{name:"RecipientInfo.version",tagClass:t.Class.UNIVERSAL,type:t.Type.INTEGER,constructed:!1,capture:"version"},{name:"RecipientInfo.issuerAndSerial",tagClass:t.Class.UNIVERSAL,type:t.Type.SEQUENCE,constructed:!0,value:[{name:"RecipientInfo.issuerAndSerial.issuer",tagClass:t.Class.UNIVERSAL,type:t.Type.SEQUENCE,constructed:!0,captureAsn1:"issuer"},{name:"RecipientInfo.issuerAndSerial.serialNumber",tagClass:t.Class.UNIVERSAL,type:t.Type.INTEGER,constructed:!1,capture:"serial"}]},{name:"RecipientInfo.keyEncryptionAlgorithm",tagClass:t.Class.UNIVERSAL,type:t.Type.SEQUENCE,constructed:!0,value:[{name:"RecipientInfo.keyEncryptionAlgorithm.algorithm",tagClass:t.Class.UNIVERSAL,type:t.Type.OID,constructed:!1,capture:"encAlgorithm"},{name:"RecipientInfo.keyEncryptionAlgorithm.parameter",tagClass:t.Class.UNIVERSAL,constructed:!1,captureAsn1:"encParameter"}]},{name:"RecipientInfo.encryptedKey",tagClass:t.Class.UNIVERSAL,type:t.Type.OCTETSTRING,constructed:!1,capture:"encKey"}]}}var r="pkcs7asn1";if(typeof n!="function"){if(typeof module!="object"||!module.exports)return typeof forge=="undefined"&&(forge={}),e(forge);var i=!0;n=function(e,n){n(t,module)}}var s,o=function(t,n){n.exports=function(n){var i=s.map(function(e){return t(e)}).concat(e);n=n||{},n.defined=n.defined||{};if(n.defined[r])return n[r];n.defined[r]=!0;for(var o=0;o<i.length;++o)i[o](n);return n[r]}},u=n;n=function(e,t){return s=typeof e=="string"?t.slice(2):e.slice(2),i?(delete n,u.apply(null,Array.prototype.slice.call(arguments,0))):(n=u,n.apply(null,Array.prototype.slice.call(arguments,0)))},n("js/pkcs7asn1",["require","module","./asn1","./util"],function(){o.apply(null,Array.prototype.slice.call(arguments,0))})}(),function(){function e(e){e.mgf=e.mgf||{};var t=e.mgf.mgf1=e.mgf1=e.mgf1||{};t.create=function(t){var n={generate:function(n,r){var i=new e.util.ByteBuffer,s=Math.ceil(r/t.digestLength);for(var o=0;o<s;o++){var u=new e.util.ByteBuffer;u.putInt32(o),t.start(),t.update(n+u.getBytes()),i.putBuffer(t.digest())}return i.truncate(i.length()-r),i.getBytes()}};return n}}var r="mgf1";if(typeof n!="function"){if(typeof module!="object"||!module.exports)return typeof forge=="undefined"&&(forge={}),e(forge);var i=!0;n=function(e,n){n(t,module)}}var s,o=function(t,n){n.exports=function(n){var i=s.map(function(e){return t(e)}).concat(e);n=n||{},n.defined=n.defined||{};if(n.defined[r])return n[r];n.defined[r]=!0;for(var o=0;o<i.length;++o)i[o](n);return n[r]}},u=n;n=function(e,t){return s=typeof e=="string"?t.slice(2):e.slice(2),i?(delete n,u.apply(null,Array.prototype.slice.call(arguments,0))):(n=u,n.apply(null,Array.prototype.slice.call(arguments,0)))},n("js/mgf1",["require","module","./util"],function(){o.apply(null,Array.prototype.slice.call(arguments,0))})}(),function(){function e(e){e.mgf=e.mgf||{},e.mgf.mgf1=e.mgf1}var r="mgf";if(typeof n!="function"){if(typeof module!="object"||!module.exports)return typeof forge=="undefined"&&(forge={}),e(forge);var i=!0;n=function(e,n){n(t,module)}}var s,o=function(t,n){n.exports=function(n){var i=s.map(function(e){return t(e)}).concat(e);n=n||{},n.defined=n.defined||{};if(n.defined[r])return n[r];n.defined[r]=!0;for(var o=0;o<i.length;++o)i[o](n);return n[r]}},u=n;n=function(e,t){return s=typeof e=="string"?t.slice(2):e.slice(2),i?(delete n,u.apply(null,Array.prototype.slice.call(arguments,0))):(n=u,n.apply(null,Array.prototype.slice.call(arguments,0)))},n("js/mgf",["require","module","./mgf1"],function(){o.apply(null,Array.prototype.slice.call(arguments,0))})}(),function(){function e(e){var t=e.pss=e.pss||{};t.create=function(t){arguments.length===3&&(t={md:arguments[0],mgf:arguments[1],saltLength:arguments[2]});var n=t.md,r=t.mgf,i=n.digestLength,s=t.salt||null;typeof s=="string"&&(s=e.util.createBuffer(s));var o;if("saltLength"in t)o=t.saltLength;else{if(s===null)throw new Error("Salt length not specified or specific salt not given.");o=s.length()}if(s!==null&&s.length()!==o)throw new Error("Given salt length does not match length of given salt.");var u=t.prng||e.random,a={};return a.encode=function(t,a){var f,l=a-1,c=Math.ceil(l/8),h=t.digest().getBytes();if(c<i+o+2)throw new Error("Message is too long to encrypt.");var p;s===null?p=u.getBytesSync(o):p=s.bytes();var d=new e.util.ByteBuffer;d.fillWithByte(0,8),d.putBytes(h),d.putBytes(p),n.start(),n.update(d.getBytes());var v=n.digest().getBytes(),m=new e.util.ByteBuffer;m.fillWithByte(0,c-o-i-2),m.putByte(1),m.putBytes(p);var g=m.getBytes(),y=c-i-1,b=r.generate(v,y),w="";for(f=0;f<y;f++)w+=String.fromCharCode(g.charCodeAt(f)^b.charCodeAt(f));var E=65280>>8*c-l&255;return w=String.fromCharCode(w.charCodeAt(0)&~E)+w.substr(1),w+v+String.fromCharCode(188)},a.verify=function(t,s,u){var a,f=u-1,l=Math.ceil(f/8);s=s.substr(-l);if(l<i+o+2)throw new Error("Inconsistent parameters to PSS signature verification.");if(s.charCodeAt(l-1)!==188)throw new Error("Encoded message does not end in 0xBC.");var c=l-i-1,h=s.substr(0,c),p=s.substr(c,i),d=65280>>8*l-f&255;if((h.charCodeAt(0)&d)!==0)throw new Error("Bits beyond keysize not zero as expected.");var v=r.generate(p,c),m="";for(a=0;a<c;a++)m+=String.fromCharCode(h.charCodeAt(a)^v.charCodeAt(a));m=String.fromCharCode(m.charCodeAt(0)&~d)+m.substr(1);var g=l-i-o-2;for(a=0;a<g;a++)if(m.charCodeAt(a)!==0)throw new Error("Leftmost octets not zero as expected");if(m.charCodeAt(g)!==1)throw new Error("Inconsistent PSS signature, 0x01 marker not found");var y=m.substr(-o),b=new e.util.ByteBuffer;b.fillWithByte(0,8),b.putBytes(t),b.putBytes(y),n.start(),n.update(b.getBytes());var w=n.digest().getBytes();return p===w},a}}var r="pss";if(typeof n!="function"){if(typeof module!="object"||!module.exports)return typeof forge=="undefined"&&(forge={}),e(forge);var i=!0;n=function(e,n){n(t,module)}}var s,o=function(t,n){n.exports=function(n){var i=s.map(function(e){return t(e)}).concat(e);n=n||{},n.defined=n.defined||{};if(n.defined[r])return n[r];n.defined[r]=!0;for(var o=0;o<i.length;++o)i[o](n);return n[r]}},u=n;n=function(e,t){return s=typeof e=="string"?t.slice(2):e.slice(2),i?(delete n,u.apply(null,Array.prototype.slice.call(arguments,0))):(n=u,n.apply(null,Array.prototype.slice.call(arguments,0)))},n("js/pss",["require","module","./random","./util"],function(){o.apply(null,Array.prototype.slice.call(arguments,0))})}(),function(){function e(e){function t(e,t){typeof t=="string"&&(t={shortName:t});var n=null,r;for(var i=0;n===null&&i<e.attributes.length;++i)r=e.attributes[i],t.type&&t.type===r.type?n=r:t.name&&t.name===r.name?n=r:t.shortName&&t.shortName===r.shortName&&(n=r);return n}function n(t){var n=a.create(a.Class.UNIVERSAL,a.Type.SEQUENCE,!0,[]),r,i,s=t.attributes;for(var o=0;o<s.length;++o){r=s[o];var u=r.value,f=a.Type.PRINTABLESTRING;"valueTagClass"in r&&(f=r.valueTagClass,f===a.Type.UTF8&&(u=e.util.encodeUtf8(u))),i=a.create(a.Class.UNIVERSAL,a.Type.SET,!0,[a.create(a.Class.UNIVERSAL,a.Type.SEQUENCE,!0,[a.create(a.Class.UNIVERSAL,a.Type.OID,!1,a.oidToDer(r.type).getBytes()),a.create(a.Class.UNIVERSAL,f,!1,u)])]),n.value.push(i)}return n}function r(t){var n={};for(var r=0;r<t.length;++r){var i=t[r];if(i.shortName&&(i.valueTagClass===a.Type.UTF8||i.valueTagClass===a.Type.PRINTABLESTRING||i.valueTagClass===a.Type.IA5STRING)){var s=i.value;i.valueTagClass===a.Type.UTF8&&(s=e.util.encodeUtf8(i.value)),i.shortName in n?e.util.isArray(n[i.shortName])?n[i.shortName].push(s):n[i.shortName]=[n[i.shortName],s]:n[i.shortName]=s}}return n}function i(e){var t;for(var n=0;n<e.length;++n){t=e[n],typeof t.name=="undefined"&&(t.type&&t.type in f.oids?t.name=f.oids[t.type]:t.shortName&&t.shortName in c&&(t.name=f.oids[c[t.shortName]]));if(typeof t.type=="undefined"){if(!(t.name&&t.name in f.oids)){var r=new Error("Attribute type not specified.");throw r.attribute=t,r}t.type=f.oids[t.name]}typeof t.shortName=="undefined"&&t.name&&t.name in c&&(t.shortName=c[t.name]);if(t.type===l.extensionRequest){t.valueConstructed=!0,t.valueTagClass=a.Type.SEQUENCE;if(!t.value&&t.extensions){t.value=[];for(var i=0;i<t.extensions.length;++i)t.value.push(f.certificateExtensionToAsn1(s(t.extensions[i])))}}if(typeof t.value=="undefined"){var r=new Error("Attribute value not specified.");throw r.attribute=t,r}}}function s(t,n){n=n||{},typeof t.name=="undefined"&&t.id&&t.id in f.oids&&(t.name=f.oids[t.id]);if(typeof t.id=="undefined"){if(!(t.name&&t.name in f.oids)){var r=new Error("Extension ID not specified.");throw r.extension=t,r}t.id=f.oids[t.name]}if(typeof t.value!="undefined")return;if(t.name==="keyUsage"){var i=0,s=0,o=0;t.digitalSignature&&(s|=128,i=7),t.nonRepudiation&&(s|=64,i=6),t.keyEncipherment&&(s|=32,i=5),t.dataEncipherment&&(s|=16,i=4),t.keyAgreement&&(s|=8,i=3),t.keyCertSign&&(s|=4,i=2),t.cRLSign&&(s|=2,i=1),t.encipherOnly&&(s|=1,i=0),t.decipherOnly&&(o|=128,i=7);var u=String.fromCharCode(i);o!==0?u+=String.fromCharCode(s)+String.fromCharCode(o):s!==0&&(u+=String.fromCharCode(s)),t.value=a.create(a.Class.UNIVERSAL,a.Type.BITSTRING,!1,u)}else if(t.name==="basicConstraints")t.value=a.create(a.Class.UNIVERSAL,a.Type.SEQUENCE,!0,[]),t.cA&&t.value.value.push(a.create(a.Class.UNIVERSAL,a.Type.BOOLEAN,!1,String.fromCharCode(255))),"pathLenConstraint"in t&&t.value.value.push(a.create(a.Class.UNIVERSAL,a.Type.INTEGER,!1,a.integerToDer(t.pathLenConstraint).getBytes()));else if(t.name==="extKeyUsage"){t.value=a.create(a.Class.UNIVERSAL,a.Type.SEQUENCE,!0,[]);var c=t.value.value;for(var h in t){if(t[h]!==!0)continue;h in l?c.push(a.create(a.Class.UNIVERSAL,a.Type.OID,!1,a.oidToDer(l[h]).getBytes())):h.indexOf(".")!==-1&&c.push(a.create(a.Class.UNIVERSAL,a.Type.OID,!1,a.oidToDer(h).getBytes()))}}else if(t.name==="nsCertType"){var i=0,s=0;t.client&&(s|=128,i=7),t.server&&(s|=64,i=6),t.email&&(s|=32,i=5),t.objsign&&(s|=16,i=4),t.reserved&&(s|=8,i=3),t.sslCA&&(s|=4,i=2),t.emailCA&&(s|=2,i=1),t.objCA&&(s|=1,i=0);var u=String.fromCharCode(i);s!==0&&(u+=String.fromCharCode(s)),t.value=a.create(a.Class.UNIVERSAL,a.Type.BITSTRING,!1,u)}else if(t.name==="subjectAltName"||t.name==="issuerAltName"){t.value=a.create(a.Class.UNIVERSAL,a.Type.SEQUENCE,!0,[]);var p;for(var d=0;d<t.altNames.length;++d){p=t.altNames[d];var u=p.value;if(p.type===7&&p.ip){u=e.util.bytesFromIP(p.ip);if(u===null){var r=new Error('Extension "ip" value is not a valid IPv4 or IPv6 address.');throw r.extension=t,r}}else p.type===8&&(p.oid?u=a.oidToDer(a.oidToDer(p.oid)):u=a.oidToDer(u));t.value.value.push(a.create(a.Class.CONTEXT_SPECIFIC,p.type,!1,u))}}else if(t.name==="subjectKeyIdentifier"&&n.cert){var v=n.cert.generateSubjectKeyIdentifier();t.subjectKeyIdentifier=v.toHex(),t.value=a.create(a.Class.UNIVERSAL,a.Type.OCTETSTRING,!1,v.getBytes())}if(typeof t.value=="undefined"){var r=new Error("Extension value not specified.");throw r.extension=t,r}return t}function o(e,t){switch(e){case l["RSASSA-PSS"]:var n=[];return t.hash.algorithmOid!==undefined&&n.push(a.create(a.Class.CONTEXT_SPECIFIC,0,!0,[a.create(a.Class.UNIVERSAL,a.Type.SEQUENCE,!0,[a.create(a.Class.UNIVERSAL,a.Type.OID,!1,a.oidToDer(t.hash.algorithmOid).getBytes()),a.create(a.Class.UNIVERSAL,a.Type.NULL,!1,"")])])),t.mgf.algorithmOid!==undefined&&n.push(a.create(a.Class.CONTEXT_SPECIFIC,1,!0,[a.create(a.Class.UNIVERSAL,a.Type.SEQUENCE,!0,[a.create(a.Class.UNIVERSAL,a.Type.OID,!1,a.oidToDer(t.mgf.algorithmOid).getBytes()),a.create(a.Class.UNIVERSAL,a.Type.SEQUENCE,!0,[a.create(a.Class.UNIVERSAL,a.Type.OID,!1,a.oidToDer(t.mgf.hash.algorithmOid).getBytes()),a.create(a.Class.UNIVERSAL,a.Type.NULL,!1,"")])])])),t.saltLength!==undefined&&n.push(a.create(a.Class.CONTEXT_SPECIFIC,2,!0,[a.create(a.Class.UNIVERSAL,a.Type.INTEGER,!1,a.integerToDer(t.saltLength).getBytes())])),a.create(a.Class.UNIVERSAL,a.Type.SEQUENCE,!0,n);default:return a.create(a.Class.UNIVERSAL,a.Type.NULL,!1,"")}}function u(t){var n=a.create(a.Class.CONTEXT_SPECIFIC,0,!0,[]);if(t.attributes.length===0)return n;var r=t.attributes;for(var i=0;i<r.length;++i){var s=r[i],o=s.value,u=a.Type.UTF8;"valueTagClass"in s&&(u=s.valueTagClass),u===a.Type.UTF8&&(o=e.util.encodeUtf8(o));var f=!1;"valueConstructed"in s&&(f=s.valueConstructed);var l=a.create(a.Class.UNIVERSAL,a.Type.SEQUENCE,!0,[a.create(a.Class.UNIVERSAL,a.Type.OID,!1,a.oidToDer(s.type).getBytes()),a.create(a.Class.UNIVERSAL,a.Type.SET,!0,[a.create(a.Class.UNIVERSAL,u,f,o)])]);n.value.push(l)}return n}var a=e.asn1,f=e.pki=e.pki||{},l=f.oids,c={};c.CN=l.commonName,c.commonName="CN",c.C=l.countryName,c.countryName="C",c.L=l.localityName,c.localityName="L",c.ST=l.stateOrProvinceName,c.stateOrProvinceName="ST",c.O=l.organizationName,c.organizationName="O",c.OU=l.organizationalUnitName,c.organizationalUnitName="OU",c.E=l.emailAddress,c.emailAddress="E";var h=e.pki.rsa.publicKeyValidator,p={name:"Certificate",tagClass:a.Class.UNIVERSAL,type:a.Type.SEQUENCE,constructed:!0,value:[{name:"Certificate.TBSCertificate",tagClass:a.Class.UNIVERSAL,type:a.Type.SEQUENCE,constructed:!0,captureAsn1:"tbsCertificate",value:[{name:"Certificate.TBSCertificate.version",tagClass:a.Class.CONTEXT_SPECIFIC,type:0,constructed:!0,optional:!0,value:[{name:"Certificate.TBSCertificate.version.integer",tagClass:a.Class.UNIVERSAL,type:a.Type.INTEGER,constructed:!1,capture:"certVersion"}]},{name:"Certificate.TBSCertificate.serialNumber",tagClass:a.Class.UNIVERSAL,type:a.Type.INTEGER,constructed:!1,capture:"certSerialNumber"},{name:"Certificate.TBSCertificate.signature",tagClass:a.Class.UNIVERSAL,type:a.Type.SEQUENCE,constructed:!0,value:[{name:"Certificate.TBSCertificate.signature.algorithm",tagClass:a.Class.UNIVERSAL,type:a.Type.OID,constructed:!1,capture:"certinfoSignatureOid"},{name:"Certificate.TBSCertificate.signature.parameters",tagClass:a.Class.UNIVERSAL,optional:!0,captureAsn1:"certinfoSignatureParams"}]},{name:"Certificate.TBSCertificate.issuer",tagClass:a.Class.UNIVERSAL,type:a.Type.SEQUENCE,constructed:!0,captureAsn1:"certIssuer"},{name:"Certificate.TBSCertificate.validity",tagClass:a.Class.UNIVERSAL,type:a.Type.SEQUENCE,constructed:!0,value:[{name:"Certificate.TBSCertificate.validity.notBefore (utc)",tagClass:a.Class.UNIVERSAL,type:a.Type.UTCTIME,constructed:!1,optional:!0,capture:"certValidity1UTCTime"},{name:"Certificate.TBSCertificate.validity.notBefore (generalized)",tagClass:a.Class.UNIVERSAL,type:a.Type.GENERALIZEDTIME,constructed:!1,optional:!0,capture:"certValidity2GeneralizedTime"},{name:"Certificate.TBSCertificate.validity.notAfter (utc)",tagClass:a.Class.UNIVERSAL,type:a.Type.UTCTIME,constructed:!1,optional:!0,capture:"certValidity3UTCTime"},{name:"Certificate.TBSCertificate.validity.notAfter (generalized)",tagClass:a.Class.UNIVERSAL,type:a.Type.GENERALIZEDTIME,constructed:!1,optional:!0,capture:"certValidity4GeneralizedTime"}]},{name:"Certificate.TBSCertificate.subject",tagClass:a.Class.UNIVERSAL,type:a.Type.SEQUENCE,constructed:!0,captureAsn1:"certSubject"},h,{name:"Certificate.TBSCertificate.issuerUniqueID",tagClass:a.Class.CONTEXT_SPECIFIC,type:1,constructed:!0,optional:!0,value:[{name:"Certificate.TBSCertificate.issuerUniqueID.id",tagClass:a.Class.UNIVERSAL,type:a.Type.BITSTRING,constructed:!1,capture:"certIssuerUniqueId"}]},{name:"Certificate.TBSCertificate.subjectUniqueID",tagClass:a.Class.CONTEXT_SPECIFIC,type:2,constructed:!0,optional:!0,value:[{name:"Certificate.TBSCertificate.subjectUniqueID.id",tagClass:a.Class.UNIVERSAL,type:a.Type.BITSTRING,constructed:!1,capture:"certSubjectUniqueId"}]},{name:"Certificate.TBSCertificate.extensions",tagClass:a.Class.CONTEXT_SPECIFIC,type:3,constructed:!0,captureAsn1:"certExtensions",optional:!0}]},{name:"Certificate.signatureAlgorithm",tagClass:a.Class.UNIVERSAL,type:a.Type.SEQUENCE,constructed:!0,value:[{name:"Certificate.signatureAlgorithm.algorithm",tagClass:a.Class.UNIVERSAL,type:a.Type.OID,constructed:!1,capture:"certSignatureOid"},{name:"Certificate.TBSCertificate.signature.parameters",tagClass:a.Class.UNIVERSAL,optional:!0,captureAsn1:"certSignatureParams"}]},{name:"Certificate.signatureValue",tagClass:a.Class.UNIVERSAL,type:a.Type.BITSTRING,constructed:!1,capture:"certSignature"}]},d={name:"rsapss",tagClass:a.Class.UNIVERSAL,type:a.Type.SEQUENCE,constructed:!0,value:[{name:"rsapss.hashAlgorithm",tagClass:a.Class.CONTEXT_SPECIFIC,type:0,constructed:!0,value:[{name:"rsapss.hashAlgorithm.AlgorithmIdentifier",tagClass:a.Class.UNIVERSAL,type:a.Class.SEQUENCE,constructed:!0,optional:!0,value:[{name:"rsapss.hashAlgorithm.AlgorithmIdentifier.algorithm",tagClass:a.Class.UNIVERSAL,type:a.Type.OID,constructed:!1,capture:"hashOid"}]}]},{name:"rsapss.maskGenAlgorithm",tagClass:a.Class.CONTEXT_SPECIFIC,type:1,constructed:!0,value:[{name:"rsapss.maskGenAlgorithm.AlgorithmIdentifier",tagClass:a.Class.UNIVERSAL,type:a.Class.SEQUENCE,constructed:!0,optional:!0,value:[{name:"rsapss.maskGenAlgorithm.AlgorithmIdentifier.algorithm",tagClass:a.Class.UNIVERSAL,type:a.Type.OID,constructed:!1,capture:"maskGenOid"},{name:"rsapss.maskGenAlgorithm.AlgorithmIdentifier.params",tagClass:a.Class.UNIVERSAL,type:a.Type.SEQUENCE,constructed:!0,value:[{name:"rsapss.maskGenAlgorithm.AlgorithmIdentifier.params.algorithm",tagClass:a.Class.UNIVERSAL,type:a.Type.OID,constructed:!1,capture:"maskGenHashOid"}]}]}]},{name:"rsapss.saltLength",tagClass:a.Class.CONTEXT_SPECIFIC,type:2,optional:!0,value:[{name:"rsapss.saltLength.saltLength",tagClass:a.Class.UNIVERSAL,type:a.Class.INTEGER,constructed:!1,capture:"saltLength"}]},{name:"rsapss.trailerField",tagClass:a.Class.CONTEXT_SPECIFIC,type:3,optional:!0,value:[{name:"rsapss.trailer.trailer",tagClass:a.Class.UNIVERSAL,type:a.Class.INTEGER,constructed:!1,capture:"trailer"}]}]},v={name:"CertificationRequestInfo",tagClass:a.Class.UNIVERSAL,type:a.Type.SEQUENCE,constructed:!0,captureAsn1:"certificationRequestInfo",value:[{name:"CertificationRequestInfo.integer",tagClass:a.Class.UNIVERSAL,type:a.Type.INTEGER,constructed:!1,capture:"certificationRequestInfoVersion"},{name:"CertificationRequestInfo.subject",tagClass:a.Class.UNIVERSAL,type:a.Type.SEQUENCE,constructed:!0,captureAsn1:"certificationRequestInfoSubject"},h,{name:"CertificationRequestInfo.attributes",tagClass:a.Class.CONTEXT_SPECIFIC,type:0,constructed:!0,optional:!0,capture:"certificationRequestInfoAttributes",value:[{name:"CertificationRequestInfo.attributes",tagClass:a.Class.UNIVERSAL,type:a.Type.SEQUENCE,constructed:!0,value:[{name:"CertificationRequestInfo.attributes.type",tagClass:a.Class.UNIVERSAL,type:a.Type.OID,constructed:!1},{name:"CertificationRequestInfo.attributes.value",tagClass:a.Class.UNIVERSAL,type:a.Type.SET,constructed:!0}]}]}]},m={name:"CertificationRequest",tagClass:a.Class.UNIVERSAL,type:a.Type.SEQUENCE,constructed:!0,captureAsn1:"csr",value:[v,{name:"CertificationRequest.signatureAlgorithm",tagClass:a.Class.UNIVERSAL,type:a.Type.SEQUENCE,constructed:!0,value:[{name:"CertificationRequest.signatureAlgorithm.algorithm",tagClass:a.Class.UNIVERSAL,type:a.Type.OID,constructed:!1,capture:"csrSignatureOid"},{name:"CertificationRequest.signatureAlgorithm.parameters",tagClass:a.Class.UNIVERSAL,optional:!0,captureAsn1:"csrSignatureParams"}]},{name:"CertificationRequest.signature",tagClass:a.Class.UNIVERSAL,type:a.Type.BITSTRING,constructed:!1,capture:"csrSignature"}]};f.RDNAttributesAsArray=function(e,t){var n=[],r,i,s;for(var o=0;o<e.value.length;++o){r=e.value[o];for(var u=0;u<r.value.length;++u)s={},i=r.value[u],s.type=a.derToOid(i.value[0].value),s.value=i.value[1].value,s.valueTagClass=i.value[1].type,s.type in l&&(s.name=l[s.type],s.name in c&&(s.shortName=c[s.name])),t&&(t.update(s.type),t.update(s.value)),n.push(s)}return n},f.CRIAttributesAsArray=function(e){var t=[];for(var n=0;n<e.length;++n){var r=e[n],i=a.derToOid(r.value[0].value),s=r.value[1].value;for(var o=0;o<s.length;++o){var u={};u.type=i,u.value=s[o].value,u.valueTagClass=s[o].type,u.type in l&&(u.name=l[u.type],u.name in c&&(u.shortName=c[u.name]));if(u.type===l.extensionRequest){u.extensions=[];for(var h=0;h<u.value.length;++h)u.extensions.push(f.certificateExtensionFromAsn1(u.value[h]))}t.push(u)}}return t};var g=function(e,t,n){var r={};if(e!==l["RSASSA-PSS"])return r;n&&(r={hash:{algorithmOid:l.sha1},mgf:{algorithmOid:l.mgf1,hash:{algorithmOid:l.sha1}},saltLength:20});var i={},s=[];if(!a.validate(t,d,i,s)){var o=new Error("Cannot read RSASSA-PSS parameter block.");throw o.errors=s,o}return i.hashOid!==undefined&&(r.hash=r.hash||{},r.hash.algorithmOid=a.derToOid(i.hashOid)),i.maskGenOid!==undefined&&(r.mgf=r.mgf||{},r.mgf.algorithmOid=a.derToOid(i.maskGenOid),r.mgf.hash=r.mgf.hash||{},r.mgf.hash.algorithmOid=a.derToOid(i.maskGenHashOid)),i.saltLength!==undefined&&(r.saltLength=i.saltLength.charCodeAt(0)),r};f.certificateFromPem=function(t,n,r){var i=e.pem.decode(t)[0];if(i.type!=="CERTIFICATE"&&i.type!=="X509 CERTIFICATE"&&i.type!=="TRUSTED CERTIFICATE"){var s=new Error('Could not convert certificate from PEM; PEM header type is not "CERTIFICATE", "X509 CERTIFICATE", or "TRUSTED CERTIFICATE".');throw s.headerType=i.type,s}if(i.procType&&i.procType.type==="ENCRYPTED")throw new Error("Could not convert certificate from PEM; PEM is encrypted.");var o=a.fromDer(i.body,r);return f.certificateFromAsn1(o,n)},f.certificateToPem=function(t,n){var r={type:"CERTIFICATE",body:a.toDer(f.certificateToAsn1(t)).getBytes()};return e.pem.encode(r,{maxline:n})},f.publicKeyFromPem=function(t){var n=e.pem.decode(t)[0];if(n.type!=="PUBLIC KEY"&&n.type!=="RSA PUBLIC KEY"){var r=new Error('Could not convert public key from PEM; PEM header type is not "PUBLIC KEY" or "RSA PUBLIC KEY".');throw r.headerType=n.type,r}if(n.procType&&n.procType.type==="ENCRYPTED")throw new Error("Could not convert public key from PEM; PEM is encrypted.");var i=a.fromDer(n.body);return f.publicKeyFromAsn1(i)},f.publicKeyToPem=function(t,n){var r={type:"PUBLIC KEY",body:a.toDer(f.publicKeyToAsn1(t)).getBytes()};return e.pem.encode(r,{maxline:n})},f.publicKeyToRSAPublicKeyPem=function(t,n){var r={type:"RSA PUBLIC KEY",body:a.toDer(f.publicKeyToRSAPublicKey(t)).getBytes()};return e.pem.encode(r,{maxline:n})},f.getPublicKeyFingerprint=function(t,n){n=n||{};var r=n.md||e.md.sha1.create(),i=n.type||"RSAPublicKey",s;switch(i){case"RSAPublicKey":s=a.toDer(f.publicKeyToRSAPublicKey(t)).getBytes();break;case"SubjectPublicKeyInfo":s=a.toDer(f.publicKeyToAsn1(t)).getBytes();break;default:throw new Error('Unknown fingerprint type "'+n.type+'".')}r.start(),r.update(s);var o=r.digest();if(n.encoding==="hex"){var u=o.toHex();return n.delimiter?u.match(/.{2}/g).join(n.delimiter):u}if(n.encoding==="binary")return o.getBytes();if(n.encoding)throw new Error('Unknown encoding "'+n.encoding+'".');return o},f.certificationRequestFromPem=function(t,n,r){var i=e.pem.decode(t)[0];if(i.type!=="CERTIFICATE REQUEST"){var s=new Error('Could not convert certification request from PEM; PEM header type is not "CERTIFICATE REQUEST".');throw s.headerType=i.type,s}if(i.procType&&i.procType.type==="ENCRYPTED")throw new Error("Could not convert certification request from PEM; PEM is encrypted.");var o=a.fromDer(i.body,r);return f.certificationRequestFromAsn1(o,n)},f.certificationRequestToPem=function(t,n){var r={type:"CERTIFICATE REQUEST",body:a.toDer(f.certificationRequestToAsn1(t)).getBytes()};return e.pem.encode(r,{maxline:n})},f.createCertificate=function(){var n={};return n.version=2,n.serialNumber="00",n.signatureOid=null,n.signature=null,n.siginfo={},n.siginfo.algorithmOid=null,n.validity={},n.validity.notBefore=new Date,n.validity.notAfter=new Date,n.issuer={},n.issuer.getField=function(e){return t(n.issuer,e)},n.issuer.addField=function(e){i([e]),n.issuer.attributes.push(e)},n.issuer.attributes=[],n.issuer.hash=null,n.subject={},n.subject.getField=function(e){return t(n.subject,e)},n.subject.addField=function(e){i([e]),n.subject.attributes.push(e)},n.subject.attributes=[],n.subject.hash=null,n.extensions=[],n.publicKey=null,n.md=null,n.setSubject=function(e,t){i(e),n.subject.attributes=e,delete n.subject.uniqueId,t&&(n.subject.uniqueId=t),n.subject.hash=null},n.setIssuer=function(e,t){i(e),n.issuer.attributes=e,delete n.issuer.uniqueId,t&&(n.issuer.uniqueId=t),n.issuer.hash=null},n.setExtensions=function(e){for(var t=0;t<e.length;++t)s(e[t],{cert:n});n.extensions=e},n.getExtension=function(e){typeof e=="string"&&(e={name:e});var t=null,r;for(var i=0;t===null&&i<n.extensions.length;++i)r=n.extensions[i],e.id&&r.id===e.id?t=r:e.name&&r.name===e.name&&(t=r);return t},n.sign=function(t,r){n.md=r||e.md.sha1.create();var i=l[n.md.algorithm+"WithRSAEncryption"];if(!i){var s=new Error("Could not compute certificate digest. Unknown message digest algorithm OID.");throw s.algorithm=n.md.algorithm,s}n.signatureOid=n.siginfo.algorithmOid=i,n.tbsCertificate=f.getTBSCertificate(n);var o=a.toDer(n.tbsCertificate);n.md.update(o.getBytes()),n.signature=t.sign(n.md)},n.verify=function(t){var r=!1;if(!n.issued(t)){var i=t.issuer,s=n.subject,o=new Error("The parent certificate did not issue the given child certificate; the child certificate's issuer does not match the parent's subject.");throw o.expectedIssuer=i.attributes,o.actualIssuer=s.attributes,o}var u=t.md;if(u===null){if(t.signatureOid in l){var c=l[t.signatureOid];switch(c){case"sha1WithRSAEncryption":u=e.md.sha1.create();break;case"md5WithRSAEncryption":u=e.md.md5.create();break;case"sha256WithRSAEncryption":u=e.md.sha256.create();break;case"RSASSA-PSS":u=e.md.sha256.create()}}if(u===null){var o=new Error("Could not compute certificate digest. Unknown signature OID.");throw o.signatureOid=t.signatureOid,o}var h=t.tbsCertificate||f.getTBSCertificate(t),p=a.toDer(h);u.update(p.getBytes())}if(u!==null){var d;switch(t.signatureOid){case l.sha1WithRSAEncryption:d=undefined;break;case l["RSASSA-PSS"]:var v,m;v=l[t.signatureParameters.mgf.hash.algorithmOid];if(v===undefined||e.md[v]===undefined){var o=new Error("Unsupported MGF hash function.");throw o.oid=t.signatureParameters.mgf.hash.algorithmOid,o.name=v,o}m=l[t.signatureParameters.mgf.algorithmOid];if(m===undefined||e.mgf[m]===undefined){var o=new Error("Unsupported MGF function.");throw o.oid=t.signatureParameters.mgf.algorithmOid,o.name=m,o}m=e.mgf[m].create(e.md[v].create()),v=l[t.signatureParameters.hash.algorithmOid];if(v===undefined||e.md[v]===undefined)throw{message:"Unsupported RSASSA-PSS hash function.",oid:t.signatureParameters.hash.algorithmOid,name:v};d=e.pss.create(e.md[v].create(),m,t.signatureParameters.saltLength)}r=n.publicKey.verify(u.digest().getBytes(),t.signature,d)}return r},n.isIssuer=function(e){var t=!1,r=n.issuer,i=e.subject;if(r.hash&&i.hash)t=r.hash===i.hash;else if(r.attributes.length===i.attributes.length){t=!0;var s,o;for(var u=0;t&&u<r.attributes.length;++u){s=r.attributes[u],o=i.attributes[u];if(s.type!==o.type||s.value!==o.value)t=!1}}return t},n.issued=function(e){return e.isIssuer(n)},n.generateSubjectKeyIdentifier=function(){return f.getPublicKeyFingerprint(n.publicKey,{type:"RSAPublicKey"})},n.verifySubjectKeyIdentifier=function(){var t=l.subjectKeyIdentifier;for(var r=0;r<n.extensions.length;++r){var i=n.extensions[r];if(i.id===t){var s=n.generateSubjectKeyIdentifier().getBytes();return e.util.hexToBytes(i.subjectKeyIdentifier)===s}}return!1},n},f.certificateFromAsn1=function(n,r){var s={},o=[];if(!a.validate(n,p,s,o)){var u=new Error("Cannot read X.509 certificate. ASN.1 object is not an X509v3 Certificate.");throw u.errors=o,u}if(typeof s.certSignature!="string"){var c="\0";for(var h=0;h<s.certSignature.length;++h)c+=a.toDer(s.certSignature[h]).getBytes();s.certSignature=c}var d=a.derToOid(s.publicKeyOid);if(d!==f.oids.rsaEncryption)throw new Error("Cannot read public key. OID is not RSA.");var v=f.createCertificate();v.version=s.certVersion?s.certVersion.charCodeAt(0):0;var m=e.util.createBuffer(s.certSerialNumber);v.serialNumber=m.toHex(),v.signatureOid=e.asn1.derToOid(s.certSignatureOid),v.signatureParameters=g(v.signatureOid,s.certSignatureParams,!0),v.siginfo.algorithmOid=e.asn1.derToOid(s.certinfoSignatureOid),v.siginfo.parameters=g(v.siginfo.algorithmOid,s.certinfoSignatureParams,!1);var y=e.util.createBuffer(s.certSignature);++y.read,v.signature=y.getBytes();var b=[];s.certValidity1UTCTime!==undefined&&b.push(a.utcTimeToDate(s.certValidity1UTCTime)),s.certValidity2GeneralizedTime!==undefined&&b.push(a.generalizedTimeToDate(s.certValidity2GeneralizedTime)),s.certValidity3UTCTime!==undefined&&b.push(a.utcTimeToDate(s.certValidity3UTCTime)),s.certValidity4GeneralizedTime!==undefined&&b.push(a.generalizedTimeToDate(s.certValidity4GeneralizedTime));if(b.length>2)throw new Error("Cannot read notBefore/notAfter validity times; more than two times were provided in the certificate.");if(b.length<2)throw new Error("Cannot read notBefore/notAfter validity times; they were not provided as either UTCTime or GeneralizedTime.");v.validity.notBefore=b[0],v.validity.notAfter=b[1],v.tbsCertificate=s.tbsCertificate;if(r){v.md=null;if(v.signatureOid in l){var d=l[v.signatureOid];switch(d){case"sha1WithRSAEncryption":v.md=e.md.sha1.create();break;case"md5WithRSAEncryption":v.md=e.md.md5.create();break;case"sha256WithRSAEncryption":v.md=e.md.sha256.create();break;case"RSASSA-PSS":v.md=e.md.sha256.create()}}if(v.md===null){var u=new Error("Could not compute certificate digest. Unknown signature OID.");throw u.signatureOid=v.signatureOid,u}var w=a.toDer(v.tbsCertificate);v.md.update(w.getBytes())}var E=e.md.sha1.create();v.issuer.getField=function(e){return t(v.issuer,e)},v.issuer.addField=function(e){i([e]),v.issuer.attributes.push(e)},v.issuer.attributes=f.RDNAttributesAsArray(s.certIssuer,E),s.certIssuerUniqueId&&(v.issuer.uniqueId=s.certIssuerUniqueId),v.issuer.hash=E.digest().toHex();var S=e.md.sha1.create();return v.subject.getField=function(e){return t(v.subject,e)},v.subject.addField=function(e){i([e]),v.subject.attributes.push(e)},v.subject.attributes=f.RDNAttributesAsArray(s.certSubject,S),s.certSubjectUniqueId&&(v.subject.uniqueId=s.certSubjectUniqueId),v.subject.hash=S.digest().toHex(),s.certExtensions?v.extensions=f.certificateExtensionsFromAsn1(s.certExtensions):v.extensions=[],v.publicKey=f.publicKeyFromAsn1(s.subjectPublicKeyInfo),v},f.certificateExtensionsFromAsn1=function(e){var t=[];for(var n=0;n<e.value.length;++n){var r=e.value[n];for(var i=0;i<r.value.length;++i)t.push(f.certificateExtensionFromAsn1(r.value[i]))}return t},f.certificateExtensionFromAsn1=function(t){var n={};n.id=a.derToOid(t.value[0].value),n.critical=!1,t.value[1].type===a.Type.BOOLEAN?(n.critical=t.value[1].value.charCodeAt(0)!==0,n.value=t.value[2].value):n.value=t.value[1].value;if(n.id in l){n.name=l[n.id];if(n.name==="keyUsage"){var r=a.fromDer(n.value),i=0,s=0;r.value.length>1&&(i=r.value.charCodeAt(1),s=r.value.length>2?r.value.charCodeAt(2):0),n.digitalSignature=(i&128)===128,n.nonRepudiation=(i&64)===64,n.keyEncipherment=(i&32)===32,n.dataEncipherment=(i&16)===16,n.keyAgreement=(i&8)===8,n.keyCertSign=(i&4)===4,n.cRLSign=(i&2)===2,n.encipherOnly=(i&1)===1,n.decipherOnly=(s&128)===128}else if(n.name==="basicConstraints"){var r=a.fromDer(n.value);r.value.length>0&&r.value[0].type===a.Type.BOOLEAN?n.cA=r.value[0].value.charCodeAt(0)!==0:n.cA=!1;var o=null;r.value.length>0&&r.value[0].type===a.Type.INTEGER?o=r.value[0].value:r.value.length>1&&(o=r.value[1].value),o!==null&&(n.pathLenConstraint=a.derToInteger(o))}else if(n.name==="extKeyUsage"){var r=a.fromDer(n.value);for(var u=0;u<r.value.length;++u){var f=a.derToOid(r.value[u].value);f in l?n[l[f]]=!0:n[f]=!0}}else if(n.name==="nsCertType"){var r=a.fromDer(n.value),i=0;r.value.length>1&&(i=r.value.charCodeAt(1)),n.client=(i&128)===128,n.server=(i&64)===64,n.email=(i&32)===32,n.objsign=(i&16)===16,n.reserved=(i&8)===8,n.sslCA=(i&4)===4,n.emailCA=(i&2)===2,n.objCA=(i&1)===1}else if(n.name==="subjectAltName"||n.name==="issuerAltName"){n.altNames=[];var c,r=a.fromDer(n.value);for(var h=0;h<r.value.length;++h){c=r.value[h];var p={type:c.type,value:c.value};n.altNames.push(p);switch(c.type){case 1:case 2:case 6:break;case 7:p.ip=e.util.bytesToIP(c.value);break;case 8:p.oid=a.derToOid(c.value);break;default:}}}else if(n.name==="subjectKeyIdentifier"){var r=a.fromDer(n.value);n.subjectKeyIdentifier=e.util.bytesToHex(r.value)}}return n},f.certificationRequestFromAsn1=function(n,r){var s={},o=[];if(!a.validate(n,m,s,o)){var u=new Error("Cannot read PKCS#10 certificate request. ASN.1 object is not a PKCS#10 CertificationRequest.");throw u.errors=o,u}if(typeof s.csrSignature!="string"){var c="\0";for(var h=0;h<s.csrSignature.length;++h)c+=a.toDer(s.csrSignature[h]).getBytes();s.csrSignature=c}var p=a.derToOid(s.publicKeyOid);if(p!==f.oids.rsaEncryption)throw new Error("Cannot read public key. OID is not RSA.");var d=f.createCertificationRequest();d.version=s.csrVersion?s.csrVersion.charCodeAt(0):0,d.signatureOid=e.asn1.derToOid(s.csrSignatureOid),d.signatureParameters=g(d.signatureOid,s.csrSignatureParams,!0),d.siginfo.algorithmOid=e.asn1.derToOid(s.csrSignatureOid),d.siginfo.parameters=g(d.siginfo.algorithmOid,s.csrSignatureParams,!1);var v=e.util.createBuffer(s.csrSignature);++v.read,d.signature=v.getBytes(),d.certificationRequestInfo=s.certificationRequestInfo;if(r){d.md=null;if(d.signatureOid in l){var p=l[d.signatureOid];switch(p){case"sha1WithRSAEncryption":d.md=e.md.sha1.create();break;case"md5WithRSAEncryption":d.md=e.md.md5.create();break;case"sha256WithRSAEncryption":d.md=e.md.sha256.create();break;case"RSASSA-PSS":d.md=e.md.sha256.create()}}if(d.md===null){var u=new Error("Could not compute certification request digest. Unknown signature OID.");throw u.signatureOid=d.signatureOid,u}var y=a.toDer(d.certificationRequestInfo);d.md.update(y.getBytes())}var b=e.md.sha1.create();return d.subject.getField=function(e){return t(d.subject,e)},d.subject.addField=function(e){i([e]),d.subject.attributes.push(e)},d.subject.attributes=f.RDNAttributesAsArray(s.certificationRequestInfoSubject,b),d.subject.hash=b.digest().toHex(),d.publicKey=f.publicKeyFromAsn1(s.subjectPublicKeyInfo),d.getAttribute=function(e){return t(d,e)},d.addAttribute=function(e){i([e]),d.attributes.push(e)},d.attributes=f.CRIAttributesAsArray(s.certificationRequestInfoAttributes||[]),d},f.createCertificationRequest=function(){var n={};return n.version=0,n.signatureOid=null,n.signature=null,n.siginfo={},n.siginfo.algorithmOid=null,n.subject={},n.subject.getField=function(e){return t(n.subject,e)},n.subject.addField=function(e){i([e]),n.subject.attributes.push(e)},n.subject.attributes=[],n.subject.hash=null,n.publicKey=null,n.attributes=[],n.getAttribute=function(e){return t(n,e)},n.addAttribute=function(e){i([e]),n.attributes.push(e)},n.md=null,n.setSubject=function(e){i(e),n.subject.attributes=e,n.subject.hash=null},n.setAttributes=function(e){i(e),n.attributes=e},n.sign=function(t,r){n.md=r||e.md.sha1.create();var i=l[n.md.algorithm+"WithRSAEncryption"];if(!i){var s=new Error("Could not compute certification request digest. Unknown message digest algorithm OID.");throw s.algorithm=n.md.algorithm,s}n.signatureOid=n.siginfo.algorithmOid=i,n.certificationRequestInfo=f.getCertificationRequestInfo(n);var o=a.toDer(n.certificationRequestInfo);n.md.update(o.getBytes()),n.signature=t.sign(n.md)},n.verify=function(){var t=!1,r=n.md;if(r===null){if(n.signatureOid in l){var i=l[n.signatureOid];switch(i){case"sha1WithRSAEncryption":r=e.md.sha1.create();break;case"md5WithRSAEncryption":r=e.md.md5.create();break;case"sha256WithRSAEncryption":r=e.md.sha256.create();break;case"RSASSA-PSS":r=e.md.sha256.create()}}if(r===null){var s=new Error("Could not compute certification request digest. Unknown signature OID.");throw s.signatureOid=n.signatureOid,s}var o=n.certificationRequestInfo||f.getCertificationRequestInfo(n),u=a.toDer(o);r.update(u.getBytes())}if(r!==null){var c;switch(n.signatureOid){case l.sha1WithRSAEncryption:break;case l["RSASSA-PSS"]:var h,p;h=l[n.signatureParameters.mgf.hash.algorithmOid];if(h===undefined||e.md[h]===undefined){var s=new Error("Unsupported MGF hash function.");throw s.oid=n.signatureParameters.mgf.hash.algorithmOid,s.name=h,s}p=l[n.signatureParameters.mgf.algorithmOid];if(p===undefined||e.mgf[p]===undefined){var s=new Error("Unsupported MGF function.");throw s.oid=n.signatureParameters.mgf.algorithmOid,s.name=p,s}p=e.mgf[p].create(e.md[h].create()),h=l[n.signatureParameters.hash.algorithmOid];if(h===undefined||e.md[h]===undefined){var s=new Error("Unsupported RSASSA-PSS hash function.");throw s.oid=n.signatureParameters.hash.algorithmOid,s.name=h,s}c=e.pss.create(e.md[h].create(),p,n.signatureParameters.saltLength)}t=n.publicKey.verify(r.digest().getBytes(),n.signature,c)}return t},n},f.getTBSCertificate=function(t){var r=a.create(a.Class.UNIVERSAL,a.Type.SEQUENCE,!0,[a.create(a.Class.CONTEXT_SPECIFIC,0,!0,[a.create(a.Class.UNIVERSAL,a.Type.INTEGER,!1,a.integerToDer(t.version).getBytes())]),a.create(a.Class.UNIVERSAL,a.Type.INTEGER,!1,e.util.hexToBytes(t.serialNumber)),a.create(a.Class.UNIVERSAL,a.Type.SEQUENCE,!0,[a.create(a.Class.UNIVERSAL,a.Type.OID,!1,a.oidToDer(t.siginfo.algorithmOid).getBytes()),o(t.siginfo.algorithmOid,t.siginfo.parameters)]),n(t.issuer),a.create(a.Class.UNIVERSAL,a.Type.SEQUENCE,!0,[a.create(a.Class.UNIVERSAL,a.Type.UTCTIME,!1,a.dateToUtcTime(t.validity.notBefore)),a.create(a.Class.UNIVERSAL,a.Type.UTCTIME,!1,a.dateToUtcTime(t.validity.notAfter))]),n(t.subject),f.publicKeyToAsn1(t.publicKey)]);return t.issuer.uniqueId&&r.value.push(a.create(a.Class.CONTEXT_SPECIFIC,1,!0,[a.create(a.Class.UNIVERSAL,a.Type.BITSTRING,!1,String.fromCharCode(0)+t.issuer.uniqueId)])),t.subject.uniqueId&&r.value.push(a.create(a.Class.CONTEXT_SPECIFIC,2,!0,[a.create(a.Class.UNIVERSAL,a.Type.BITSTRING,!1,String.fromCharCode(0)+t.subject.uniqueId)])),t.extensions.length>0&&r.value.push(f.certificateExtensionsToAsn1(t.extensions)),r},f.getCertificationRequestInfo=function(e){var t=a.create(a.Class.UNIVERSAL,a.Type.SEQUENCE,!0,[a.create(a.Class.UNIVERSAL,a.Type.INTEGER,!1,a.integerToDer(e.version).getBytes()),n(e.subject),f.publicKeyToAsn1(e.publicKey),u(e)]);return t},f.distinguishedNameToAsn1=function(e){return n(e)},f.certificateToAsn1=function(e){var t=e.tbsCertificate||f.getTBSCertificate(e);return a.create(a.Class.UNIVERSAL,a.Type.SEQUENCE,!0,[t,a.create(a.Class.UNIVERSAL,a.Type.SEQUENCE,!0,[a.create(a.Class.UNIVERSAL,a.Type.OID,!1,a.oidToDer(e.signatureOid).getBytes()),o(e.signatureOid,e.signatureParameters)]),a.create(a.Class.UNIVERSAL,a.Type.BITSTRING,!1,String.fromCharCode(0)+e.signature)])},f.certificateExtensionsToAsn1=function(e){var t=a.create(a.Class.CONTEXT_SPECIFIC,3,!0,[]),n=a.create(a.Class.UNIVERSAL,a.Type.SEQUENCE,!0,[]);t.value.push(n);for(var r=0;r<e.length;++r)n.value.push(f.certificateExtensionToAsn1(e[r]));return t},f.certificateExtensionToAsn1=function(e){var t=a.create(a.Class.UNIVERSAL,a.Type.SEQUENCE,!0,[]);t.value.push(a.create(a.Class.UNIVERSAL,a.Type.OID,!1,a.oidToDer(e.id).getBytes())),e.critical&&t.value.push(a.create(a.Class.UNIVERSAL,a.Type.BOOLEAN,!1,String.fromCharCode(255)));var n=e.value;return typeof e.value!="string"&&(n=a.toDer(n).getBytes()),t.value.push(a.create(a.Class.UNIVERSAL,a.Type.OCTETSTRING,!1,n)),t},f.certificationRequestToAsn1=function(e){var t=e.certificationRequestInfo||f.getCertificationRequestInfo(e);return a.create(a.Class.UNIVERSAL,a.Type.SEQUENCE,!0,[t,a.create(a.Class.UNIVERSAL,a.Type.SEQUENCE,!0,[a.create(a.Class.UNIVERSAL,a.Type.OID,!1,a.oidToDer(e.signatureOid).getBytes()),o(e.signatureOid,e.signatureParameters)]),a.create(a.Class.UNIVERSAL,a.Type.BITSTRING,!1,String.fromCharCode(0)+e.signature)])},f.createCaStore=function(t){function r(t){if(!t.hash){var r=e.md.sha1.create();t.attributes=f.RDNAttributesAsArray(n(t),r),t.hash=r.digest().toHex()}return i.certs[t.hash]||null}var i={certs:{}};i.getIssuer=function(e){var t=r(e.issuer);return t},i.addCertificate=function(t){typeof t=="string"&&(t=e.pki.certificateFromPem(t));if(!t.subject.hash){var r=e.md.sha1.create();t.subject.attributes=f.RDNAttributesAsArray(n(t.subject),r),t.subject.hash=r.digest().toHex()}if(t.subject.hash in i.certs){var s=i.certs[t.subject.hash];e.util.isArray(s)||(s=[s]),s.push(t)}else i.certs[t.subject.hash]=t},i.hasCertificate=function(t){var n=r(t.subject);if(!n)return!1;e.util.isArray(n)||(n=[n]);var i=a.toDer(f.certificateToAsn1(t)).getBytes();for(var s=0;s<n.length;++s){var o=a.toDer(f.certificateToAsn1(n[s])).getBytes();if(i===o)return!0}return!1};if(t)for(var s=0;s<t.length;++s){var o=t[s];i.addCertificate(o)}return i},f.certificateError={bad_certificate:"forge.pki.BadCertificate",unsupported_certificate:"forge.pki.UnsupportedCertificate",certificate_revoked:"forge.pki.CertificateRevoked",certificate_expired:"forge.pki.CertificateExpired",certificate_unknown:"forge.pki.CertificateUnknown",unknown_ca:"forge.pki.UnknownCertificateAuthority"},f.verifyCertificateChain=function(t,n,r){n=n.slice(0);var i=n.slice(0),s=new Date,o=!0,u=null,a=0;do{var l=n.shift(),c=null,h=!1;if(s<l.validity.notBefore||s>l.validity.notAfter)u={message:"Certificate is not valid yet or has expired.",error:f.certificateError.certificate_expired,notBefore:l.validity.notBefore,notAfter:l.validity.notAfter,now:s};if(u===null){c=n[0]||t.getIssuer(l),c===null&&l.isIssuer(l)&&(h=!0,c=l);if(c){var p=c;e.util.isArray(p)||(p=[p]);var d=!1;while(!d&&p.length>0){c=p.shift();try{d=c.verify(l)}catch(v){}}d||(u={message:"Certificate signature is invalid.",error:f.certificateError.bad_certificate})}u===null&&(!c||h)&&!t.hasCertificate(l)&&(u={message:"Certificate is not trusted.",error:f.certificateError.unknown_ca})}u===null&&c&&!l.isIssuer(c)&&(u={message:"Certificate issuer is invalid.",error:f.certificateError.bad_certificate});if(u===null){var m={keyUsage:!0,basicConstraints:!0};for(var g=0;u===null&&g<l.extensions.length;++g){var y=l.extensions[g];y.critical&&!(y.name in m)&&(u={message:"Certificate has an unsupported critical extension.",error:f.certificateError.unsupported_certificate})}}if(u===null&&(!o||n.length===0&&(!c||h))){var b=l.getExtension("basicConstraints"),w=l.getExtension("keyUsage");w!==null&&(!w.keyCertSign||b===null)&&(u={message:"Certificate keyUsage or basicConstraints conflict or indicate that the certificate is not a CA. If the certificate is the only one in the chain or isn't the first then the certificate must be a valid CA.",error:f.certificateError.bad_certificate}),u===null&&b!==null&&!b.cA&&(u={message:"Certificate basicConstraints indicates the certificate is not a CA.",error:f.certificateError.bad_certificate});if(u===null&&w!==null&&"pathLenConstraint"in b){var E=a-1;E>b.pathLenConstraint&&(u={message:"Certificate basicConstraints pathLenConstraint violated.",error:f.certificateError.bad_certificate})}}var S=u===null?!0:u.error,x=r?r(S,a,i):S;if(x!==!0){S===!0&&(u={message:"The application rejected the certificate.",error:f.certificateError.bad_certificate});if(x||x===0)typeof x=="object"&&!e.util.isArray(x)?(x.message&&(u.message=x.message),x.error&&(u.error=x.error)):typeof x=="string"&&(u.error=x);throw u}u=null,o=!1,++a}while(n.length>0);return!0}}var r="x509";if(typeof n!="function"){if(typeof module!="object"||!module.exports)return typeof forge=="undefined"&&(forge={}),e(forge);var i=!0;n=function(e,n){n(t,module)}}var s,o=function(t,n){n.exports=function(n){var i=s.map(function(e){return t(e)}).concat(e);n=n||{},n.defined=n.defined||{};if(n.defined[r])return n[r];n.defined[r]=!0;for(var o=0;o<i.length;++o)i[o](n);return n.pki}},u=n;n=function(e,t){return s=typeof e=="string"?t.slice(2):e.slice(2),i?(delete n,u.apply(null,Array.prototype.slice.call(arguments,0))):(n=u,n.apply(null,Array.prototype.slice.call(arguments,0)))},n("js/x509",["require","module","./aes","./asn1","./des","./md","./mgf","./oids","./pem","./pss","./rsa","./util"],function(){o.apply(null,Array.prototype.slice.call(arguments,0))})}(),function(){function e(e){function t(e,t,n,r){var i=[];for(var s=0;s<e.length;s++)for(var o=0;o<e[s].safeBags.length;o++){var u=e[s].safeBags[o];if(r!==undefined&&u.type!==r)continue;if(t===null){i.push(u);continue}u.attributes[t]!==undefined&&u.attributes[t].indexOf(n)>=0&&i.push(u)}return i}function n(t){if(t.composed||t.constructed){var n=e.util.createBuffer();for(var r=0;r<t.value.length;++r)n.putBytes(t.value[r].value);t.composed=t.constructed=!1,t.value=n.getBytes()}return t}function r(e,t,r,o){t=u.fromDer(t,r);if(t.tagClass!==u.Class.UNIVERSAL||t.type!==u.Type.SEQUENCE||t.constructed!==!0)throw new Error("PKCS#12 AuthenticatedSafe expected to be a SEQUENCE OF ContentInfo");for(var f=0;f<t.value.length;f++){var c=t.value[f],h={},p=[];if(!u.validate(c,l,h,p)){var d=new Error("Cannot read ContentInfo.");throw d.errors=p,d}var v={encrypted:!1},m=null,g=h.content.value[0];switch(u.derToOid(h.contentType)){case a.oids.data:if(g.tagClass!==u.Class.UNIVERSAL||g.type!==u.Type.OCTETSTRING)throw new Error("PKCS#12 SafeContents Data is not an OCTET STRING.");m=n(g).value;break;case a.oids.encryptedData:m=i(g,o),v.encrypted=!0;break;default:var d=new Error("Unsupported PKCS#12 contentType.");throw d.contentType=u.derToOid(h.contentType),d}v.safeBags=s(m,r,o),e.safeContents.push(v)}}function i(t,r){var i={},s=[];if(!u.validate(t,e.pkcs7.asn1.encryptedDataValidator,i,s)){var o=new Error("Cannot read EncryptedContentInfo.");throw o.errors=s,o}var f=u.derToOid(i.contentType);if(f!==a.oids.data){var o=new Error("PKCS#12 EncryptedContentInfo ContentType is not Data.");throw o.oid=f,o}f=u.derToOid(i.encAlgorithm);var l=a.pbe.getCipher(f,i.encParameter,r),c=n(i.encryptedContentAsn1),h=e.util.createBuffer(c.value);l.update(h);if(!l.finish())throw new Error("Failed to decrypt PKCS#12 SafeContents.");return l.output.getBytes()}function s(e,t,n){if(!t&&e.length===0)return[];e=u.fromDer(e,t);if(e.tagClass!==u.Class.UNIVERSAL||e.type!==u.Type.SEQUENCE||e.constructed!==!0)throw new Error("PKCS#12 SafeContents expected to be a SEQUENCE OF SafeBag.");var r=[];for(var i=0;i<e.value.length;i++){var s=e.value[i],f={},l=[];if(!u.validate(s,h,f,l)){var c=new Error("Cannot read SafeBag.");throw c.errors=l,c}var p={type:u.derToOid(f.bagId),attributes:o(f.bagAttributes)};r.push(p);var v,m,g=f.bagValue.value[0];switch(p.type){case a.oids.pkcs8ShroudedKeyBag:g=a.decryptPrivateKeyInfo(g,n);if(g===null)throw new Error("Unable to decrypt PKCS#8 ShroudedKeyBag, wrong password?");case a.oids.keyBag:try{p.key=a.privateKeyFromAsn1(g)}catch(y){p.key=null,p.asn1=g}continue;case a.oids.certBag:v=d,m=function(){if(u.derToOid(f.certId)!==a.oids.x509Certificate){var e=new Error("Unsupported certificate type, only X.509 supported.");throw e.oid=u.derToOid(f.certId),e}var n=u.fromDer(f.cert,t);try{p.cert=a.certificateFromAsn1(n,!0)}catch(r){p.cert=null,p.asn1=n}};break;default:var c=new Error("Unsupported PKCS#12 SafeBag type.");throw c.oid=p.type,c}if(v!==undefined&&!u.validate(g,v,f,l)){var c=new Error("Cannot read PKCS#12 "+v.name);throw c.errors=l,c}m()}return r}function o(e){var t={};if(e!==undefined)for(var n=0;n<e.length;++n){var r={},i=[];if(!u.validate(e[n],p,r,i)){var s=new Error("Cannot read PKCS#12 BagAttribute.");throw s.errors=i,s}var o=u.derToOid(r.oid);if(a.oids[o]===undefined)continue;t[a.oids[o]]=[];for(var f=0;f<r.values.length;++f)t[a.oids[o]].push(r.values[f].value)}return t}var u=e.asn1,a=e.pki,f=e.pkcs12=e.pkcs12||{},l={name:"ContentInfo",tagClass:u.Class.UNIVERSAL,type:u.Type.SEQUENCE,constructed:!0,value:[{name:"ContentInfo.contentType",tagClass:u.Class.UNIVERSAL,type:u.Type.OID,constructed:!1,capture:"contentType"},{name:"ContentInfo.content",tagClass:u.Class.CONTEXT_SPECIFIC,constructed:!0,captureAsn1:"content"}]},c={name:"PFX",tagClass:u.Class.UNIVERSAL,type:u.Type.SEQUENCE,constructed:!0,value:[{name:"PFX.version",tagClass:u.Class.UNIVERSAL,type:u.Type.INTEGER,constructed:!1,capture:"version"},l,{name:"PFX.macData",tagClass:u.Class.UNIVERSAL,type:u.Type.SEQUENCE,constructed:!0,optional:!0,captureAsn1:"mac",value:[{name:"PFX.macData.mac",tagClass:u.Class.UNIVERSAL,type:u.Type.SEQUENCE,constructed:!0,value:[{name:"PFX.macData.mac.digestAlgorithm",tagClass:u.Class.UNIVERSAL,type:u.Type.SEQUENCE,constructed:!0,value:[{name:"PFX.macData.mac.digestAlgorithm.algorithm",tagClass:u.Class.UNIVERSAL,type:u.Type.OID,constructed:!1,capture:"macAlgorithm"},{name:"PFX.macData.mac.digestAlgorithm.parameters",tagClass:u.Class.UNIVERSAL,captureAsn1:"macAlgorithmParameters"}]},{name:"PFX.macData.mac.digest",tagClass:u.Class.UNIVERSAL,type:u.Type.OCTETSTRING,constructed:!1,capture:"macDigest"}]},{name:"PFX.macData.macSalt",tagClass:u.Class.UNIVERSAL,type:u.Type.OCTETSTRING,constructed:!1,capture:"macSalt"},{name:"PFX.macData.iterations",tagClass:u.Class.UNIVERSAL,type:u.Type.INTEGER,constructed:!1,optional:!0,capture:"macIterations"}]}]},h={name:"SafeBag",tagClass:u.Class.UNIVERSAL,type:u.Type.SEQUENCE,constructed:!0,value:[{name:"SafeBag.bagId",tagClass:u.Class.UNIVERSAL,type:u.Type.OID,constructed:!1,capture:"bagId"},{name:"SafeBag.bagValue",tagClass:u.Class.CONTEXT_SPECIFIC,constructed:!0,captureAsn1:"bagValue"},{name:"SafeBag.bagAttributes",tagClass:u.Class.UNIVERSAL,type:u.Type.SET,constructed:!0,optional:!0,capture:"bagAttributes"}]},p={name:"Attribute",tagClass:u.Class.UNIVERSAL,type:u.Type.SEQUENCE,constructed:!0,value:[{name:"Attribute.attrId",tagClass:u.Class.UNIVERSAL,type:u.Type.OID,constructed:!1,capture:"oid"},{name:"Attribute.attrValues",tagClass:u.Class.UNIVERSAL,type:u.Type.SET,constructed:!0,capture:"values"}]},d={name:"CertBag",tagClass:u.Class.UNIVERSAL,type:u.Type.SEQUENCE,constructed:!0,value:[{name:"CertBag.certId",tagClass:u.Class.UNIVERSAL,type:u.Type.OID,constructed:!1,capture:"certId"},{name:"CertBag.certValue",tagClass:u.Class.CONTEXT_SPECIFIC,constructed:!0,value:[{name:"CertBag.certValue[0]",tagClass:u.Class.UNIVERSAL,type:u.Class.OCTETSTRING,constructed:!1,capture:"cert"}]}]};f.pkcs12FromAsn1=function(i,s,o){typeof s=="string"?(o=s,s=!0):s===undefined&&(s=!0);var l={},h=[];if(!u.validate(i,c,l,h)){var p=new Error("Cannot read PKCS#12 PFX. ASN.1 object is not an PKCS#12 PFX.");throw p.errors=p,p}var d={version:l.version.charCodeAt(0),safeContents:[],getBags:function(n){var r={},i;return"localKeyId"in n?i=n.localKeyId:"localKeyIdHex"in n&&(i=e.util.hexToBytes(n.localKeyIdHex)),i===undefined&&!("friendlyName"in n)&&"bagType"in n&&(r[n.bagType]=t(d.safeContents,null,null,n.bagType)),i!==undefined&&(r.localKeyId=t(d.safeContents,"localKeyId",i,n.bagType)),"friendlyName"in n&&(r.friendlyName=t(d.safeContents,"friendlyName",n.friendlyName,n.bagType)),r},getBagsByFriendlyName:function(e,n){return t(d.safeContents,"friendlyName",e,n)},getBagsByLocalKeyId:function(e,n){return t(d.safeContents,"localKeyId",e,n)}};if(l.version.charCodeAt(0)!==3){var p=new Error("PKCS#12 PFX of version other than 3 not supported.");throw p.version=l.version.charCodeAt(0),p}if(u.derToOid(l.contentType)!==a.oids.data){var p=new Error("Only PKCS#12 PFX in password integrity mode supported.");throw p.oid=u.derToOid(l.contentType),p}var v=l.content.value[0];if(v.tagClass!==u.Class.UNIVERSAL||v.type!==u.Type.OCTETSTRING)throw new Error("PKCS#12 authSafe content data is not an OCTET STRING.");v=n(v);if(l.mac){var m=null,g=0,y=u.derToOid(l.macAlgorithm);switch(y){case a.oids.sha1:m=e.md.sha1.create(),g=20;break;case a.oids.sha256:m=e.md.sha256.create(),g=32;break;case a.oids.sha384:m=e.md.sha384.create(),g=48;break;case a.oids.sha512:m=e.md.sha512.create(),g=64;break;case a.oids.md5:m=e.md.md5.create(),g=16}if(m===null)throw new Error("PKCS#12 uses unsupported MAC algorithm: "+y);var b=new e.util.ByteBuffer(l.macSalt),w="macIterations"in l?parseInt(e.util.bytesToHex(l.macIterations),16):1,E=f.generateKey(o,b,3,w,g,m),S=e.hmac.create();S.start(m,E),S.update(v.value);var x=S.getMac();if(x.getBytes()!==l.macDigest)throw new Error("PKCS#12 MAC could not be verified. Invalid password?")}return r(d,v.value,s,o),d},f.toPkcs12Asn1=function(t,n,r,i){i=i||{},i.saltSize=i.saltSize||8,i.count=i.count||2048,i.algorithm=i.algorithm||i.encAlgorithm||"aes128","useMac"in i||(i.useMac=!0),"localKeyId"in i||(i.localKeyId=null),"generateLocalKeyId"in i||(i.generateLocalKeyId=!0);var s=i.localKeyId,o;if(s!==null)s=e.util.hexToBytes(s);else if(i.generateLocalKeyId)if(n){var l=e.util.isArray(n)?n[0]:n;typeof l=="string"&&(l=a.certificateFromPem(l));var c=e.md.sha1.create();c.update(u.toDer(a.certificateToAsn1(l)).getBytes()),s=c.digest().getBytes()}else s=e.random.getBytes(20);var h=[];s!==null&&h.push(u.create(u.Class.UNIVERSAL,u.Type.SEQUENCE,!0,[u.create(u.Class.UNIVERSAL,u.Type.OID,!1,u.oidToDer(a.oids.localKeyId).getBytes()),u.create(u.Class.UNIVERSAL,u.Type.SET,!0,[u.create(u.Class.UNIVERSAL,u.Type.OCTETSTRING,!1,s)])])),"friendlyName"in i&&h.push(u.create(u.Class.UNIVERSAL,u.Type.SEQUENCE,!0,[u.create(u.Class.UNIVERSAL,u.Type.OID,!1,u.oidToDer(a.oids.friendlyName).getBytes()),u.create(u.Class.UNIVERSAL,u.Type.SET,!0,[u.create(u.Class.UNIVERSAL,u.Type.BMPSTRING,!1,i.friendlyName)])])),h.length>0&&(o=u.create(u.Class.UNIVERSAL,u.Type.SET,!0,h));var p=[],d=[];n!==null&&(e.util.isArray(n)?d=n:d=[n]);var v=[];for(var m=0;m<d.length;++m){n=d[m],typeof n=="string"&&(n=a.certificateFromPem(n));var g=m===0?o:undefined,y=a.certificateToAsn1(n),b=u.create(u.Class.UNIVERSAL,u.Type.SEQUENCE,!0,[u.create(u.Class.UNIVERSAL,u.Type.OID,!1,u.oidToDer(a.oids.certBag).getBytes()),u.create(u.Class.CONTEXT_SPECIFIC,0,!0,[u.create(u.Class.UNIVERSAL,u.Type.SEQUENCE,!0,[u.create(u.Class.UNIVERSAL,u.Type.OID,!1,u.oidToDer(a.oids.x509Certificate).getBytes()),u.create(u.Class.CONTEXT_SPECIFIC,0,!0,[u.create(u.Class.UNIVERSAL,u.Type.OCTETSTRING,!1,u.toDer(y).getBytes())])])]),g]);v.push(b)}if(v.length>0){var w=u.create(u.Class.UNIVERSAL,u.Type.SEQUENCE,!0,v),E=u.create(u.Class.UNIVERSAL,u.Type.SEQUENCE,!0,[u.create(u.Class.UNIVERSAL,u.Type.OID,!1,u.oidToDer(a.oids.data).getBytes()),u.create(u.Class.CONTEXT_SPECIFIC,0,!0,[u.create(u.Class.UNIVERSAL,u.Type.OCTETSTRING,!1,u.toDer(w).getBytes())])]);p.push(E)}var S=null;if(t!==null){var x=a.wrapRsaPrivateKey(a.privateKeyToAsn1(t));r===null?S=u.create(u.Class.UNIVERSAL,u.Type.SEQUENCE,!0,[u.create(u.Class.UNIVERSAL,u.Type.OID,!1,u.oidToDer(a.oids.keyBag).getBytes()),u.create(u.Class.CONTEXT_SPECIFIC,0,!0,[x]),o]):S=u.create(u.Class.UNIVERSAL,u.Type.SEQUENCE,!0,[u.create(u.Class.UNIVERSAL,u.Type.OID,!1,u.oidToDer(a.oids.pkcs8ShroudedKeyBag).getBytes()),u.create(u.Class.CONTEXT_SPECIFIC,0,!0,[a.encryptPrivateKeyInfo(x,r,i)]),o]);var T=u.create(u.Class.UNIVERSAL,u.Type.SEQUENCE,!0,[S]),N=u.create(u.Class.UNIVERSAL,u.Type.SEQUENCE,!0,[u.create(u.Class.UNIVERSAL,u.Type.OID,!1,u.oidToDer(a.oids.data).getBytes()),u.create(u.Class.CONTEXT_SPECIFIC,0,!0,[u.create(u.Class.UNIVERSAL,u.Type.OCTETSTRING,!1,u.toDer(T).getBytes())])]);p.push(N)}var C=u.create(u.Class.UNIVERSAL,u.Type.SEQUENCE,!0,p),k;if(i.useMac){var c=e.md.sha1.create(),L=new e.util.ByteBuffer(e.random.getBytes(i.saltSize)),A=i.count,t=f.generateKey(r,L,3,A,20),O=e.hmac.create();O.start(c,t),O.update(u.toDer(C).getBytes());var M=O.getMac();k=u.create(u.Class.UNIVERSAL,u.Type.SEQUENCE,!0,[u.create(u.Class.UNIVERSAL,u.Type.SEQUENCE,!0,[u.create(u.Class.UNIVERSAL,u.Type.SEQUENCE,!0,[u.create(u.Class.UNIVERSAL,u.Type.OID,!1,u.oidToDer(a.oids.sha1).getBytes()),u.create(u.Class.UNIVERSAL,u.Type.NULL,!1,"")]),u.create(u.Class.UNIVERSAL,u.Type.OCTETSTRING,!1,M.getBytes())]),u.create(u.Class.UNIVERSAL,u.Type.OCTETSTRING,!1,L.getBytes()),u.create(u.Class.UNIVERSAL,u.Type.INTEGER,!1,u.integerToDer(A).getBytes())])}return u.create(u.Class.UNIVERSAL,u.Type.SEQUENCE,!0,[u.create(u.Class.UNIVERSAL,u.Type.INTEGER,!1,u.integerToDer(3).getBytes()),u.create(u.Class.UNIVERSAL,u.Type.SEQUENCE,!0,[u.create(u.Class.UNIVERSAL,u.Type.OID,!1,u.oidToDer(a.oids.data).getBytes()),u.create(u.Class.CONTEXT_SPECIFIC,0,!0,[u.create(u.Class.UNIVERSAL,u.Type.OCTETSTRING,!1,u.toDer(C).getBytes())])]),k])},f.generateKey=e.pbe.generatePkcs12Key}var r="pkcs12";if(typeof n!="function"){if(typeof module!="object"||!module.exports)return typeof forge=="undefined"&&(forge={}),e(forge);var i=!0;n=function(e,n){n(t,module)}}var s,o=function(t,n){n.exports=function(n){var i=s.map(function(e){return t(e)}).concat(e);n=n||{},n.defined=n.defined||{};if(n.defined[r])return n[r];n.defined[r]=!0;for(var o=0;o<i.length;++o)i[o](n);return n[r]}},u=n;n=function(e,t){return s=typeof e=="string"?t.slice(2):e.slice(2),i?(delete n,u.apply(null,Array.prototype.slice.call(arguments,0))):(n=u,n.apply(null,Array.prototype.slice.call(arguments,0)))},n("js/pkcs12",["require","module","./asn1","./hmac","./oids","./pkcs7asn1","./pbe","./random","./rsa","./sha1","./util","./x509"],function(){o.apply(null,Array.prototype.slice.call(arguments,0))})}(),function(){function e(e){var t=e.asn1,n=e.pki=e.pki||{};n.pemToDer=function(t){var n=e.pem.decode(t)[0];if(n.procType&&n.procType.type==="ENCRYPTED")throw new Error("Could not convert PEM to DER; PEM is encrypted.");return e.util.createBuffer(n.body)},n.privateKeyFromPem=function(r){var i=e.pem.decode(r)[0];if(i.type!=="PRIVATE KEY"&&i.type!=="RSA PRIVATE KEY"){var s=new Error('Could not convert private key from PEM; PEM header type is not "PRIVATE KEY" or "RSA PRIVATE KEY".');throw s.headerType=i.type,s}if(i.procType&&i.procType.type==="ENCRYPTED")throw new Error("Could not convert private key from PEM; PEM is encrypted.");var o=t.fromDer(i.body);return n.privateKeyFromAsn1(o)},n.privateKeyToPem=function(r,i){var s={type:"RSA PRIVATE KEY",body:t.toDer(n.privateKeyToAsn1(r)).getBytes()};return e.pem.encode(s,{maxline:i})},n.privateKeyInfoToPem=function(n,r){var i={type:"PRIVATE KEY",body:t.toDer(n).getBytes()};return e.pem.encode(i,{maxline:r})}}var r="pki";if(typeof n!="function"){if(typeof module!="object"||!module.exports)return typeof forge=="undefined"&&(forge={}),e(forge);var i=!0;n=function(e,n){n(t,module)}}var s,o=function(t,n){n.exports=function(n){var i=s.map(function(e){return t(e)}).concat(e);n=n||{},n.defined=n.defined||{};if(n.defined[r])return n[r];n.defined[r]=!0;for(var o=0;o<i.length;++o)i[o](n);return n[r]}},u=n;n=function(e,t){return s=typeof e=="string"?t.slice(2):e.slice(2),i?(delete n,u.apply(null,Array.prototype.slice.call(arguments,0))):(n=u,n.apply(null,Array.prototype.slice.call(arguments,0)))},n("js/pki",["require","module","./asn1","./oids","./pbe","./pem","./pbkdf2","./pkcs12","./pss","./rsa","./util","./x509"],function(){o.apply(null,Array.prototype.slice.call(arguments,0))})}(),function(){function e(e){var t=function(t,n,r,i){var s=e.util.createBuffer(),o=t.length>>1,u=o+(t.length&1),a=t.substr(0,u),f=t.substr(o,u),l=e.util.createBuffer(),c=e.hmac.create();r=n+r;var h=Math.ceil(i/16),p=Math.ceil(i/20);c.start("MD5",a);var d=e.util.createBuffer();l.putBytes(r);for(var v=0;v<h;++v)c.start(null,null),c.update(l.getBytes()),l.putBuffer(c.digest()),c.start(null,null),c.update(l.bytes()+r),d.putBuffer(c.digest());c.start("SHA1",f);var m=e.util.createBuffer();l.clear(),l.putBytes(r);for(var v=0;v<p;++v)c.start(null,null),c.update(l.getBytes()),l.putBuffer(c.digest()),c.start(null,null),c.update(l.bytes()+r),m.putBuffer(c.digest());return s.putBytes(e.util.xorBytes(d.getBytes(),m.getBytes(),i)),s},n=function(e,t,n,r){},r=function(t,n,r){var i=e.hmac.create();i.start("SHA1",t);var s=e.util.createBuffer();return s.putInt32(n[0]),s.putInt32(n[1]),s.putByte(r.type),s.putByte(r.version.major),s.putByte(r.version.minor),s.putInt16(r.length),s.putBytes(r.fragment.bytes()),i.update(s.getBytes()),i.digest().getBytes()},i=function(t,n,r){var i=!1;try{var s=t.deflate(n.fragment.getBytes());n.fragment=e.util.createBuffer(s),n.length=s.length,i=!0}catch(o){}return i},s=function(t,n,r){var i=!1;try{var s=t.inflate(n.fragment.getBytes());n.fragment=e.util.createBuffer(s),n.length=s.length,i=!0}catch(o){}return i},o=function(t,n){var r=0;switch(n){case 1:r=t.getByte();break;case 2:r=t.getInt16();break;case 3:r=t.getInt24();break;case 4:r=t.getInt32()}return e.util.createBuffer(t.getBytes(r))},u=function(e,t,n){e.putInt(n.length(),t<<3),e.putBuffer(n)},a={};a.Versions={TLS_1_0:{major:3,minor:1},TLS_1_1:{major:3,minor:2},TLS_1_2:{major:3,minor:3}},a.SupportedVersions=[a.Versions.TLS_1_1,a.Versions.TLS_1_0],a.Version=a.SupportedVersions[0],a.MaxFragment=15360,a.ConnectionEnd={server:0,client:1},a.PRFAlgorithm={tls_prf_sha256:0},a.BulkCipherAlgorithm={none:null,rc4:0,des3:1,aes:2},a.CipherType={stream:0,block:1,aead:2},a.MACAlgorithm={none:null,hmac_md5:0,hmac_sha1:1,hmac_sha256:2,hmac_sha384:3,hmac_sha512:4},a.CompressionMethod={none:0,deflate:1},a.ContentType={change_cipher_spec:20,alert:21,handshake:22,application_data:23,heartbeat:24},a.HandshakeType={hello_request:0,client_hello:1,server_hello:2,certificate:11,server_key_exchange:12,certificate_request:13,server_hello_done:14,certificate_verify:15,client_key_exchange:16,finished:20},a.Alert={},a.Alert.Level={warning:1,fatal:2},a.Alert.Description={close_notify:0,unexpected_message:10,bad_record_mac:20,decryption_failed:21,record_overflow:22,decompression_failure:30,handshake_failure:40,bad_certificate:42,unsupported_certificate:43,certificate_revoked:44,certificate_expired:45,certificate_unknown:46,illegal_parameter:47,unknown_ca:48,access_denied:49,decode_error:50,decrypt_error:51,export_restriction:60,protocol_version:70,insufficient_security:71,internal_error:80,user_canceled:90,no_renegotiation:100},a.HeartbeatMessageType={heartbeat_request:1,heartbeat_response:2},a.CipherSuites={},a.getCipherSuite=function(e){var t=null;for(var n in a.CipherSuites){var r=a.CipherSuites[n];if(r.id[0]===e.charCodeAt(0)&&r.id[1]===e.charCodeAt(1)){t=r;break}}return t},a.handleUnexpected=function(e,t){var n=!e.open&&e.entity===a.ConnectionEnd.client;n||e.error(e,{message:"Unexpected message. Received TLS record out of order.",send:!0,alert:{level:a.Alert.Level.fatal,description:a.Alert.Description.unexpected_message}})},a.handleHelloRequest=function(e,t,n){!e.handshaking&&e.handshakes>0&&(a.queue(e,a.createAlert(e,{level:a.Alert.Level.warning,description:a.Alert.Description.no_renegotiation})),a.flush(e)),e.process()},a.parseHelloMessage=function(t,n,r){var i=null,s=t.entity===a.ConnectionEnd.client;if(r<38)t.error(t,{message:s?"Invalid ServerHello message. Message too short.":"Invalid ClientHello message. Message too short.",send:!0,alert:{level:a.Alert.Level.fatal,description:a.Alert.Description.illegal_parameter}});else{var u=n.fragment,f=u.length();i={version:{major:u.getByte(),minor:u.getByte()},random:e.util.createBuffer(u.getBytes(32)),session_id:o(u,1),extensions:[]},s?(i.cipher_suite=u.getBytes(2),i.compression_method=u.getByte()):(i.cipher_suites=o(u,2),i.compression_methods=o(u,1)),f=r-(f-u.length());if(f>0){var l=o(u,2);while(l.length()>0)i.extensions.push({type:[l.getByte(),l.getByte()],data:o(l,2)});if(!s)for(var c=0;c<i.extensions.length;++c){var h=i.extensions[c];if(h.type[0]===0&&h.type[1]===0){var p=o(h.data,2);while(p.length()>0){var d=p.getByte();if(d!==0)break;t.session.extensions.server_name.serverNameList.push(o(p,2).getBytes())}}}}if(t.session.version)if(i.version.major!==t.session.version.major||i.version.minor!==t.session.version.minor)return t.error(t,{message:"TLS version change is disallowed during renegotiation.",send:!0,alert:{level:a.Alert.Level.fatal,description:a.Alert.Description.protocol_version}});if(s)t.session.cipherSuite=a.getCipherSuite(i.cipher_suite);else{var v=e.util.createBuffer(i.cipher_suites.bytes());while(v.length()>0){t.session.cipherSuite=a.getCipherSuite(v.getBytes(2));if(t.session.cipherSuite!==null)break}}if(t.session.cipherSuite===null)return t.error(t,{message:"No cipher suites in common.",send:!0,alert:{level:a.Alert.Level.fatal,description:a.Alert.Description.handshake_failure},cipherSuite:e.util.bytesToHex(i.cipher_suite)});s?t.session.compressionMethod=i.compression_method:t.session.compressionMethod=a.CompressionMethod.none}return i},a.createSecurityParameters=function(e,t){var n=e.entity===a.ConnectionEnd.client,r=t.random.bytes(),i=n?e.session.sp.client_random:r,s=n?r:a.createRandom().getBytes();e.session.sp={entity:e.entity,prf_algorithm:a.PRFAlgorithm.tls_prf_sha256,bulk_cipher_algorithm:null,cipher_type:null,enc_key_length:null,block_length:null,fixed_iv_length:null,record_iv_length:null,mac_algorithm:null,mac_length:null,mac_key_length:null,compression_algorithm:e.session.compressionMethod,pre_master_secret:null,master_secret:null,client_random:i,server_random:s}},a.handleServerHello=function(e,t,n){var r=a.parseHelloMessage(e,t,n);if(e.fail)return;if(!(r.version.minor<=e.version.minor))return e.error(e,{message:"Incompatible TLS version.",send:!0,alert:{level:a.Alert.Level.fatal,description:a.Alert.Description.protocol_version}});e.version.minor=r.version.minor,e.session.version=e.version;var i=r.session_id.bytes();i.length>0&&i===e.session.id?(e.expect=d,e.session.resuming=!0,e.session.sp.server_random=r.random.bytes()):(e.expect=l,e.session.resuming=!1,a.createSecurityParameters(e,r)),e.session.id=i,e.process()},a.handleClientHello=function(t,n,r){var i=a.parseHelloMessage(t,n,r);if(t.fail)return;var s=i.session_id.bytes(),o=null;if(t.sessionCache){o=t.sessionCache.getSession(s);if(o===null)s="";else if(o.version.major!==i.version.major||o.version.minor>i.version.minor)o=null,s=""}s.length===0&&(s=e.random.getBytes(32)),t.session.id=s,t.session.clientHelloVersion=i.version,t.session.sp={};if(o)t.version=t.session.version=o.version,t.session.sp=o.sp;else{var u;for(var f=1;f<a.SupportedVersions.length;++f){u=a.SupportedVersions[f];if(u.minor<=i.version.minor)break}t.version={major:u.major,minor:u.minor},t.session.version=t.version}o!==null?(t.expect=S,t.session.resuming=!0,t.session.sp.client_random=i.random.bytes()):(t.expect=t.verifyClient!==!1?b:w,t.session.resuming=!1,a.createSecurityParameters(t,i)),t.open=!0,a.queue(t,a.createRecord(t,{type:a.ContentType.handshake,data:a.createServerHello(t)})),t.session.resuming?(a.queue(t,a.createRecord(t,{type:a.ContentType.change_cipher_spec,data:a.createChangeCipherSpec()})),t.state.pending=a.createConnectionState(t),t.state.current.write=t.state.pending.write,a.queue(t,a.createRecord(t,{type:a.ContentType.handshake,data:a.createFinished(t)}))):(a.queue(t,a.createRecord(t,{type:a.ContentType.handshake,data:a.createCertificate(t)})),t.fail||(a.queue(t,a.createRecord(t,{type:a.ContentType.handshake,data:a.createServerKeyExchange(t)})),t.verifyClient!==!1&&a.queue(t,a.createRecord(t,{type:a.ContentType.handshake,data:a.createCertificateRequest(t)})),a.queue(t,a.createRecord(t,{type:a.ContentType.handshake,data:a.createServerHelloDone(t)})))),a.flush(t),t.process()},a.handleCertificate=function(t,n,r){if(r<3)return t.error(t,{message:"Invalid Certificate message. Message too short.",send:!0,alert:{level:a.Alert.Level.fatal,description:a.Alert.Description.illegal_parameter}});var i=n.fragment,s={certificate_list:o(i,3)},u,f,l=[];try{while(s.certificate_list.length()>0)u=o(s.certificate_list,3),f=e.asn1.fromDer(u),u=e.pki.certificateFromAsn1(f,!0),l.push(u)}catch(h){return t.error(t,{message:"Could not parse certificate list.",cause:h,send:!0,alert:{level:a.Alert.Level.fatal,description:a.Alert.Description.bad_certificate}})}var p=t.entity===a.ConnectionEnd.client;!p&&t.verifyClient!==!0||l.length!==0?l.length===0?t.expect=p?c:w:(p?t.session.serverCertificate=l[0]:t.session.clientCertificate=l[0],a.verifyCertificateChain(t,l)&&(t.expect=p?c:w)):t.error(t,{message:p?"No server certificate provided.":"No client certificate provided.",send:!0,alert:{level:a.Alert.Level.fatal,description:a.Alert.Description.illegal_parameter}}),t.process()},a.handleServerKeyExchange=function(e,t,n){if(n>0)return e.error(e,{message:"Invalid key parameters. Only RSA is supported.",send:!0,alert:{level:a.Alert.Level.fatal,description:a.Alert.Description.unsupported_certificate}});e.expect=h,e.process()},a.handleClientKeyExchange=function(t,n,r){if(r<48)return t.error(t,{message:"Invalid key parameters. Only RSA is supported.",send:!0,alert:{level:a.Alert.Level.fatal,description:a.Alert.Description.unsupported_certificate}});var i=n.fragment,s={enc_pre_master_secret:o(i,2).getBytes()},u=null;if(t.getPrivateKey)try{u=t.getPrivateKey(t,t.session.serverCertificate),u=e.pki.privateKeyFromPem(u)}catch(f){t.error(t,{message:"Could not get private key.",cause:f,send:!0,alert:{level:a.Alert.Level.fatal,description:a.Alert.Description.internal_error}})}if(u===null)return t.error(t,{message:"No private key set.",send:!0,alert:{level:a.Alert.Level.fatal,description:a.Alert.Description.internal_error}});try{var l=t.session.sp;l.pre_master_secret=u.decrypt(s.enc_pre_master_secret);var c=t.session.clientHelloVersion;if(c.major!==l.pre_master_secret.charCodeAt(0)||c.minor!==l.pre_master_secret.charCodeAt(1))throw new Error("TLS version rollback attack detected.")}catch(f){l.pre_master_secret=e.random.getBytes(48)}t.expect=S,t.session.clientCertificate!==null&&(t.expect=E),t.process()},a.handleCertificateRequest=function(e,t,n){if(n<3)return e.error(e,{message:"Invalid CertificateRequest. Message too short.",send:!0,alert:{level:a.Alert.Level.fatal,description:a.Alert.Description.illegal_parameter}});var r=t.fragment,i={certificate_types:o(r,1),certificate_authorities:o(r,2)};e.session.certificateRequest=i,e.expect=p,e.process()},a.handleCertificateVerify=function(t,n,r){if(r<2)return t.error(t,{message:"Invalid CertificateVerify. Message too short.",send:!0,alert:{level:a.Alert.Level.fatal,description:a.Alert.Description.illegal_parameter}});var i=n.fragment;i.read-=4;var s=i.bytes();i.read+=4;var u={signature:o(i,2).getBytes()},f=e.util.createBuffer();f.putBuffer(t.session.md5.digest()),f.putBuffer(t.session.sha1.digest()),f=f.getBytes();try{var l=t.session.clientCertificate;if(!l.publicKey.verify(f,u.signature,"NONE"))throw new Error("CertificateVerify signature does not match.");t.session.md5.update(s),t.session.sha1.update(s)}catch(c){return t.error(t,{message:"Bad signature in CertificateVerify.",send:!0,alert:{level:a.Alert.Level.fatal,description:a.Alert.Description.handshake_failure}})}t.expect=S,t.process()},a.handleServerHelloDone=function(t,n,r){if(r>0)return t.error(t,{message:"Invalid ServerHelloDone message. Invalid length.",send:!0,alert:{level:a.Alert.Level.fatal,description:a.Alert.Description.record_overflow}});if(t.serverCertificate===null){var i={message:"No server certificate provided. Not enough security.",send:!0,alert:{level:a.Alert.Level.fatal,description:a.Alert.Description.insufficient_security}},s=0,o=t.verify(t,i.alert.description,s,[]);if(o!==!0){if(o||o===0)typeof o=="object"&&!e.util.isArray(o)?(o.message&&(i.message=o.message),o.alert&&(i.alert.description=o.alert)):typeof o=="number"&&(i.alert.description=o);return t.error(t,i)}}t.session.certificateRequest!==null&&(n=a.createRecord(t,{type:a.ContentType.handshake,data:a.createCertificate(t)}),a.queue(t,n)),n=a.createRecord(t,{type:a.ContentType.handshake,data:a.createClientKeyExchange(t)}),a.queue(t,n),t.expect=g;var u=function(e,t){e.session.certificateRequest!==null&&e.session.clientCertificate!==null&&a.queue(e,a.createRecord(e,{type:a.ContentType.handshake,data:a.createCertificateVerify(e,t)})),a.queue(e,a.createRecord(e,{type:a.ContentType.change_cipher_spec,data:a.createChangeCipherSpec()})),e.state.pending=a.createConnectionState(e),e.state.current.write=e.state.pending.write,a.queue(e,a.createRecord(e,{type:a.ContentType.handshake,data:a.createFinished(e)})),e.expect=d,a.flush(e),e.process()};if(t.session.certificateRequest===null||t.session.clientCertificate===null)return u(t,null);a.getClientSignature(t,u)},a.handleChangeCipherSpec=function(e,t){if(t.fragment.getByte()!==1)return e.error(e,{message:"Invalid ChangeCipherSpec message received.",send:!0,alert:{level:a.Alert.Level.fatal,description:a.Alert.Description.illegal_parameter}});var n=e.entity===a.ConnectionEnd.client;if(e.session.resuming&&n||!e.session.resuming&&!n)e.state.pending=a.createConnectionState(e);e.state.current.read=e.state.pending.read;if(!e.session.resuming&&n||e.session.resuming&&!n)e.state.pending=null;e.expect=n?v:x,e.process()},a.handleFinished=function(n,r,i){var s=r.fragment;s.read-=4;var o=s.bytes();s.read+=4;var u=r.fragment.getBytes();s=e.util.createBuffer(),s.putBuffer(n.session.md5.digest()),s.putBuffer(n.session.sha1.digest());var f=n.entity===a.ConnectionEnd.client,l=f?"server finished":"client finished",c=n.session.sp,h=12,p=t;s=p(c.master_secret,l,s.getBytes(),h);if(s.getBytes()!==u)return n.error(n,{message:"Invalid verify_data in Finished message.",send:!0,alert:{level:a.Alert.Level.fatal,description:a.Alert.Description.decrypt_error}});n.session.md5.update(o),n.session.sha1.update(o);if(n.session.resuming&&f||!n.session.resuming&&!f)a.queue(n,a.createRecord(n,{type:a.ContentType.change_cipher_spec,data:a.createChangeCipherSpec()})),n.state.current.write=n.state.pending.write,n.state.pending=null,a.queue(n,a.createRecord(n,{type:a.ContentType.handshake,data:a.createFinished(n)}));n.expect=f?m:T,n.handshaking=!1,++n.handshakes,n.peerCertificate=f?n.session.serverCertificate:n.session.clientCertificate,a.flush(n),n.isConnected=!0,n.connected(n),n.process()},a.handleAlert=function(e,t){var n=t.fragment,r={level:n.getByte(),description:n.getByte()},i;switch(r.description){case a.Alert.Description.close_notify:i="Connection closed.";break;case a.Alert.Description.unexpected_message:i="Unexpected message.";break;case a.Alert.Description.bad_record_mac:i="Bad record MAC.";break;case a.Alert.Description.decryption_failed:i="Decryption failed.";break;case a.Alert.Description.record_overflow:i="Record overflow.";break;case a.Alert.Description.decompression_failure:i="Decompression failed.";break;case a.Alert.Description.handshake_failure:i="Handshake failure.";break;case a.Alert.Description.bad_certificate:i="Bad certificate.";break;case a.Alert.Description.unsupported_certificate:i="Unsupported certificate.";break;case a.Alert.Description.certificate_revoked:i="Certificate revoked.";break;case a.Alert.Description.certificate_expired:i="Certificate expired.";break;case a.Alert.Description.certificate_unknown:i="Certificate unknown.";break;case a.Alert.Description.illegal_parameter:i="Illegal parameter.";break;case a.Alert.Description.unknown_ca:i="Unknown certificate authority.";break;case a.Alert.Description.access_denied:i="Access denied.";break;case a.Alert.Description.decode_error:i="Decode error.";break;case a.Alert.Description.decrypt_error:i="Decrypt error.";break;case a.Alert.Description.export_restriction:i="Export restriction.";break;case a.Alert.Description.protocol_version:i="Unsupported protocol version.";break;case a.Alert.Description.insufficient_security:i="Insufficient security.";break;case a.Alert.Description.internal_error:i="Internal error.";break;case a.Alert.Description.user_canceled:i="User canceled.";break;case a.Alert.Description.no_renegotiation:i="Renegotiation not supported.";break;default:i="Unknown error."}if(r.description===a.Alert.Description.close_notify)return e.close();e.error(e,{message:i,send:!1,origin:e.entity===a.ConnectionEnd.client?"server":"client",alert:r}),e.process()},a.handleHandshake=function(t,n){var r=n.fragment,i=r.getByte(),s=r.getInt24();if(s>r.length())return t.fragmented=n,n.fragment=e.util.createBuffer(),r.read-=4,t.process();t.fragmented=null,r.read-=4;var o=r.bytes(s+4);r.read+=4,i in q[t.entity][t.expect]?(t.entity===a.ConnectionEnd.server&&!t.open&&!t.fail&&(t.handshaking=!0,t.session={version:null,extensions:{server_name:{serverNameList:[]}},cipherSuite:null,compressionMethod:null,serverCertificate:null,clientCertificate:null,md5:e.md.md5.create(),sha1:e.md.sha1.create()}),i!==a.HandshakeType.hello_request&&i!==a.HandshakeType.certificate_verify&&i!==a.HandshakeType.finished&&(t.session.md5.update(o),t.session.sha1.update(o)),q[t.entity][t.expect][i](t,n,s)):a.handleUnexpected(t,n)},a.handleApplicationData=function(e,t){e.data.putBuffer(t.fragment),e.dataReady(e),e.process()},a.handleHeartbeat=function(t,n){var r=n.fragment,i=r.getByte(),s=r.getInt16(),o=r.getBytes(s);if(i===a.HeartbeatMessageType.heartbeat_request){if(t.handshaking||s>o.length)return t.process();a.queue(t,a.createRecord(t,{type:a.ContentType.heartbeat,data:a.createHeartbeat(a.HeartbeatMessageType.heartbeat_response,o)})),a.flush(t)}else if(i===a.HeartbeatMessageType.heartbeat_response){if(o!==t.expectedHeartbeatPayload)return t.process();t.heartbeatReceived&&t.heartbeatReceived(t,e.util.createBuffer(o))}t.process()};var f=0,l=1,c=2,h=3,p=4,d=5,v=6,m=7,g=8,y=0,b=1,w=2,E=3,S=4,x=5,T=6,N=7,C=a.handleUnexpected,k=a.handleChangeCipherSpec,L=a.handleAlert,A=a.handleHandshake,O=a.handleApplicationData,M=a.handleHeartbeat,_=[];_[a.ConnectionEnd.client]=[[C,L,A,C,M],[C,L,A,C,M],[C,L,A,C,M],[C,L,A,C,M],[C,L,A,C,M],[k,L,C,C,M],[C,L,A,C,M],[C,L,A,O,M],[C,L,A,C,M]],_[a.ConnectionEnd.server]=[[C,L,A,C,M],[C,L,A,C,M],[C,L,A,C,M],[C,L,A,C,M],[k,L,C,C,M],[C,L,A,C,M],[C,L,A,O,M],[C,L,A,C,M]];var D=a.handleHelloRequest,P=a.handleServerHello,H=a.handleCertificate,B=a.handleServerKeyExchange,j=a.handleCertificateRequest,F=a.handleServerHelloDone,I=a.handleFinished,q=[];q[a.ConnectionEnd.client]=[[C,C,P,C,C,C,C,C,C,C,C,C,C,C,C,C,C,C,C,C,C],[D,C,C,C,C,C,C,C,C,C,C,H,B,j,F,C,C,C,C,C,C],[D,C,C,C,C,C,C,C,C,C,C,C,B,j,F,C,C,C,C,C,C],[D,C,C,C,C,C,C,C,C,C,C,C,C,j,F,C,C,C,C,C,C],[D,C,C,C,C,C,C,C,C,C,C,C,C,C,F,C,C,C,C,C,C],[D,C,C,C,C,C,C,C,C,C,C,C,C,C,C,C,C,C,C,C,C],[D,C,C,C,C,C,C,C,C,C,C,C,C,C,C,C,C,C,C,C,I],[D,C,C,C,C,C,C,C,C,C,C,C,C,C,C,C,C,C,C,C,C],[D,C,C,C,C,C,C,C,C,C,C,C,C,C,C,C,C,C,C,C,C]];var R=a.handleClientHello,U=a.handleClientKeyExchange,z=a.handleCertificateVerify;q[a.ConnectionEnd.server]=[[C,R,C,C,C,C,C,C,C,C,C,C,C,C,C,C,C,C,C,C,C],[C,C,C,C,C,C,C,C,C,C,C,H,C,C,C,C,C,C,C,C,C],[C,C,C,C,C,C,C,C,C,C,C,C,C,C,C,C,U,C,C,C,C],[C,C,C,C,C,C,C,C,C,C,C,C,C,C,C,z,C,C,C,C,C],[C,C,C,C,C,C,C,C,C,C,C,C,C,C,C,C,C,C,C,C,C],[C,C,C,C,C,C,C,C,C,C,C,C,C,C,C,C,C,C,C,C,I],[C,C,C,C,C,C,C,C,C,C,C,C,C,C,C,C,C,C,C,C,C],[C,C,C,C,C,C,C,C,C,C,C,C,C,C,C,C,C,C,C,C,C]],a.generateKeys=function(e,n){var r=t,i=n.client_random+n.server_random;e.session.resuming||(n.master_secret=r(n.pre_master_secret,"master secret",i,48).bytes(),n.pre_master_secret=null),i=n.server_random+n.client_random;var s=2*n.mac_key_length+2*n.enc_key_length,o=e.version.major===a.Versions.TLS_1_0.major&&e.version.minor===a.Versions.TLS_1_0.minor;o&&(s+=2*n.fixed_iv_length);var u=r(n.master_secret,"key expansion",i,s),f={client_write_MAC_key:u.getBytes(n.mac_key_length),server_write_MAC_key:u.getBytes(n.mac_key_length),client_write_key:u.getBytes(n.enc_key_length),server_write_key:u.getBytes(n.enc_key_length)};return o&&(f.client_write_IV=u.getBytes(n.fixed_iv_length),f.server_write_IV=u.getBytes(n.fixed_iv_length)),f},a.createConnectionState=function(e){var t=e.entity===a.ConnectionEnd.client,n=function(){var e={sequenceNumber:[0,0],macKey:null,macLength:0,macFunction:null,cipherState:null,cipherFunction:function(e){return!0},compressionState:null,compressFunction:function(e){return!0},updateSequenceNumber:function(){e.sequenceNumber[1]===4294967295?(e.sequenceNumber[1]=0,++e.sequenceNumber[0]):++e.sequenceNumber[1]}};return e},r={read:n(),write:n()};r.read.update=function(e,t){return r.read.cipherFunction(t,r.read)?r.read.compressFunction(e,t,r.read)||e.error(e,{message:"Could not decompress record.",send:!0,alert:{level:a.Alert.Level.fatal,description:a.Alert.Description.decompression_failure}}):e.error(e,{message:"Could not decrypt record or bad MAC.",send:!0,alert:{level:a.Alert.Level.fatal,description:a.Alert.Description.bad_record_mac}}),!e.fail},r.write.update=function(e,t){return r.write.compressFunction(e,t,r.write)?r.write.cipherFunction(t,r.write)||e.error(e,{message:"Could not encrypt record.",send:!1,alert:{level:a.Alert.Level.fatal,description:a.Alert.Description.internal_error}}):e.error(e,{message:"Could not compress record.",send:!1,alert:{level:a.Alert.Level.fatal,description:a.Alert.Description.internal_error}}),!e.fail};if(e.session){var o=e.session.sp;e.session.cipherSuite.initSecurityParameters(o),o.keys=a.generateKeys(e,o),r.read.macKey=t?o.keys.server_write_MAC_key:o.keys.client_write_MAC_key,r.write.macKey=t?o.keys.client_write_MAC_key:o.keys.server_write_MAC_key,e.session.cipherSuite.initConnectionState(r,e,o);switch(o.compression_algorithm){case a.CompressionMethod.none:break;case a.CompressionMethod.deflate:r.read.compressFunction=s,r.write.compressFunction=i;break;default:throw new Error("Unsupported compression algorithm.")}}return r},a.createRandom=function(){var t=new Date,n=+t+t.getTimezoneOffset()*6e4,r=e.util.createBuffer();return r.putInt32(n),r.putBytes(e.random.getBytes(28)),r},a.createRecord=function(e,t){if(!t.data)return null;var n={type:t.type,version:{major:e.version.major,minor:e.version.minor},length:t.data.length(),fragment:t.data};return n},a.createAlert=function(t,n){var r=e.util.createBuffer();return r.putByte(n.level),r.putByte(n.description),a.createRecord(t,{type:a.ContentType.alert,data:r})},a.createClientHello=function(t){t.session.clientHelloVersion={major:t.version.major,minor:t.version.minor};var n=e.util.createBuffer();for(var r=0;r<t.cipherSuites.length;++r){var i=t.cipherSuites[r];n.putByte(i.id[0]),n.putByte(i.id[1])}var s=n.length(),o=e.util.createBuffer();o.putByte(a.CompressionMethod.none);var f=o.length(),l=e.util.createBuffer();if(t.virtualHost){var c=e.util.createBuffer();c.putByte(0),c.putByte(0);var h=e.util.createBuffer();h.putByte(0),u(h,2,e.util.createBuffer(t.virtualHost));var p=e.util.createBuffer();u(p,2,h),u(c,2,p),l.putBuffer(c)}var d=l.length();d>0&&(d+=2);var v=t.session.id,m=v.length+1+2+4+28+2+s+1+f+d,g=e.util.createBuffer();return g.putByte(a.HandshakeType.client_hello),g.putInt24(m),g.putByte(t.version.major),g.putByte(t.version.minor),g.putBytes(t.session.sp.client_random),u(g,1,e.util.createBuffer(v)),u(g,2,n),u(g,1,o),d>0&&u(g,2,l),g},a.createServerHello=function(t){var n=t.session.id,r=n.length+1+2+4+28+2+1,i=e.util.createBuffer();return i.putByte(a.HandshakeType.server_hello),i.putInt24(r),i.putByte(t.version.major),i.putByte(t.version.minor),i.putBytes(t.session.sp.server_random),u(i,1,e.util.createBuffer(n)),i.putByte(t.session.cipherSuite.id[0]),i.putByte(t.session.cipherSuite.id[1]),i.putByte(t.session.compressionMethod),i},a.createCertificate=function(t){var n=t.entity===a.ConnectionEnd.client,r=null;if(t.getCertificate){var i;n?i=t.session.certificateRequest:i=t.session.extensions.server_name.serverNameList,r=t.getCertificate(t,i)}var s=e.util.createBuffer();if(r!==null)try{e.util.isArray(r)||(r=[r]);var o=null;for(var f=0;f<r.length;++f){var l=e.pem.decode(r[f])[0];if(l.type!=="CERTIFICATE"&&l.type!=="X509 CERTIFICATE"&&l.type!=="TRUSTED CERTIFICATE"){var c=new Error('Could not convert certificate from PEM; PEM header type is not "CERTIFICATE", "X509 CERTIFICATE", or "TRUSTED CERTIFICATE".');throw c.headerType=l.type,c}if(l.procType&&l.procType.type==="ENCRYPTED")throw new Error("Could not convert certificate from PEM; PEM is encrypted.");var h=e.util.createBuffer(l.body);o===null&&(o=e.asn1.fromDer(h.bytes(),!1));var p=e.util.createBuffer();u(p,3,h),s.putBuffer(p)}r=e.pki.certificateFromAsn1(o),n?t.session.clientCertificate=r:t.session.serverCertificate=r}catch(d){return t.error(t,{message:"Could not send certificate list.",cause:d,send:!0,alert:{level:a.Alert.Level.fatal,description:a.Alert.Description.bad_certificate}})}var v=3+s.length(),m=e.util.createBuffer();return m.putByte(a.HandshakeType.certificate),m.putInt24(v),u(m,3,s),m},a.createClientKeyExchange=function(t){var n=e.util.createBuffer();n.putByte(t.session.clientHelloVersion.major),n.putByte(t.session.clientHelloVersion.minor),n.putBytes(e.random.getBytes(46));var r=t.session.sp;r.pre_master_secret=n.getBytes();var i=t.session.serverCertificate.publicKey;n=i.encrypt(r.pre_master_secret);var s=n.length+2,o=e.util.createBuffer();return o.putByte(a.HandshakeType.client_key_exchange),o.putInt24(s),o.putInt16(n.length),o.putBytes(n),o},a.createServerKeyExchange=function(t){var n=0,r=e.util.createBuffer();return n>0&&(r.putByte(a.HandshakeType.server_key_exchange),r.putInt24(n)),r},a.getClientSignature=function(t,n){var r=e.util.createBuffer();r.putBuffer(t.session.md5.digest()),r.putBuffer(t.session.sha1.digest()),r=r.getBytes(),t.getSignature=t.getSignature||function(t,n,r){var i=null;if(t.getPrivateKey)try{i=t.getPrivateKey(t,t.session.clientCertificate),i=e.pki.privateKeyFromPem(i)}catch(s){t.error(t,{message:"Could not get private key.",cause:s,send:!0,alert:{level:a.Alert.Level.fatal,description:a.Alert.Description.internal_error}})}i===null?t.error(t,{message:"No private key set.",send:!0,alert:{level:a.Alert.Level.fatal,description:a.Alert.Description.internal_error}}):n=i.sign(n,null),r(t,n)},t.getSignature(t,r,n)},a.createCertificateVerify=function(t,n){var r=n.length+2,i=e.util.createBuffer();return i.putByte(a.HandshakeType.certificate_verify),i.putInt24(r),i.putInt16(n.length),i.putBytes(n),i},a.createCertificateRequest=function(t){var n=e.util.createBuffer();n.putByte(1);var r=e.util.createBuffer();for(var i in t.caStore.certs){var s=t.caStore.certs[i],o=e.pki.distinguishedNameToAsn1(s.subject);r.putBuffer(e.asn1.toDer(o))}var f=1+n.length()+2+r.length(),l=e.util.createBuffer();return l.putByte(a.HandshakeType.certificate_request),l.putInt24(f),u(l,1,n),u(l,2,r),l},a.createServerHelloDone=function(t){var n=e.util.createBuffer();return n.putByte(a.HandshakeType.server_hello_done),n.putInt24(0),n},a.createChangeCipherSpec=function(){var t=e.util.createBuffer();return t.putByte(1),t},a.createFinished=function(n){var r=e.util.createBuffer();r.putBuffer(n.session.md5.digest()),r.putBuffer(n.session.sha1.digest());var i=n.entity===a.ConnectionEnd.client,s=n.session.sp,o=12,u=t,f=i?"client finished":"server finished";r=u(s.master_secret,f,r.getBytes(),o);var l=e.util.createBuffer();return l.putByte(a.HandshakeType.finished),l.putInt24(r.length()),l.putBuffer(r),l},a.createHeartbeat=function(t,n,r){typeof r=="undefined"&&(r=n.length);var i=e.util.createBuffer();i.putByte(t),i.putInt16(r),i.putBytes(n);var s=i.length(),o=Math.max(16,s-r-3);return i.putBytes(e.random.getBytes(o)),i},a.queue=function(t,n){if(!n)return;if(n.type===a.ContentType.handshake){var r=n.fragment.bytes();t.session.md5.update(r),t.session.sha1.update(r),r=null}var i;if(n.fragment.length()<=a.MaxFragment)i=[n];else{i=[];var s=n.fragment.bytes();while(s.length>a.MaxFragment)i.push(a.createRecord(t,{type:n.type,data:e.util.createBuffer(s.slice(0,a.MaxFragment))})),s=s.slice(a.MaxFragment);s.length>0&&i.push(a.createRecord(t,{type:n.type,data:e.util.createBuffer(s)}))}for(var o=0;o<i.length&&!t.fail;++o){var u=i[o],f=t.state.current.write;f.update(t,u)&&t.records.push(u)}},a.flush=function(e){for(var t=0;t<e.records.length;++t){var n=e.records[t];e.tlsData.putByte(n.type),e.tlsData.putByte(n.version.major),e.tlsData.putByte(n.version.minor),e.tlsData.putInt16(n.fragment.length()),e.tlsData.putBuffer(e.records[t].fragment)}return e.records=[],e.tlsDataReady(e)};var W=function(t){switch(t){case!0:return!0;case e.pki.certificateError.bad_certificate:return a.Alert.Description.bad_certificate;case e.pki.certificateError.unsupported_certificate:return a.Alert.Description.unsupported_certificate;case e.pki.certificateError.certificate_revoked:return a.Alert.Description.certificate_revoked;case e.pki.certificateError.certificate_expired:return a.Alert.Description.certificate_expired;case e.pki.certificateError.certificate_unknown:return a.Alert.Description.certificate_unknown;case e.pki.certificateError.unknown_ca:return a.Alert.Description.unknown_ca;default:return a.Alert.Description.bad_certificate}},X=function(t){switch(t){case!0:return!0;case a.Alert.Description.bad_certificate:return e.pki.certificateError.bad_certificate;case a.Alert.Description.unsupported_certificate:return e.pki.certificateError.unsupported_certificate;case a.Alert.Description.certificate_revoked:return e.pki.certificateError.certificate_revoked;case a.Alert.Description.certificate_expired:return e.pki.certificateError.certificate_expired;case a.Alert.Description.certificate_unknown:return e.pki.certificateError.certificate_unknown;case a.Alert.Description.unknown_ca:return e.pki.certificateError.unknown_ca;default:return e.pki.certificateError.bad_certificate}};a.verifyCertificateChain=function(t,n){try{e.pki.verifyCertificateChain(t.caStore,n,function(n,r,i){var s=W(n),o=t.verify(t,n,r,i);if(o!==!0){if(typeof o=="object"&&!e.util.isArray(o)){var u=new Error("The application rejected the certificate.");throw u.send=!0,u.alert={level:a.Alert.Level.fatal,description:a.Alert.Description.bad_certificate},o.message&&(u.message=o.message),o.alert&&(u.alert.description=o.alert),u}o!==n&&(o=X(o))}return o})}catch(r){var i=r;if(typeof i!="object"||e.util.isArray(i))i={send:!0,alert:{level:a.Alert.Level.fatal,description:W(r)}};"send"in i||(i.send=!0),"alert"in i||(i.alert={level:a.Alert.Level.fatal,description:W(i.error)}),t.error(t,i)}return!t.fail},a.createSessionCache=function(t,n){var r=null;if(t&&t.getSession&&t.setSession&&t.order)r=t;else{r={},r.cache=t||{},r.capacity=Math.max(n||100,1),r.order=[];for(var i in t)r.order.length<=n?r.order.push(i):delete t[i];r.getSession=function(t){var n=null,i=null;t?i=e.util.bytesToHex(t):r.order.length>0&&(i=r.order[0]);if(i!==null&&i in r.cache){n=r.cache[i],delete r.cache[i];for(var s in r.order)if(r.order[s]===i){r.order.splice(s,1);break}}return n},r.setSession=function(t,n){if(r.order.length===r.capacity){var i=r.order.shift();delete r.cache[i]}var i=e.util.bytesToHex(t);r.order.push(i),r.cache[i]=n}}return r},a.createConnection=function(t){var n=null;t.caStore?e.util.isArray(t.caStore)?n=e.pki.createCaStore(t.caStore):n=t.caStore:n=e.pki.createCaStore();var r=t.cipherSuites||null;if(r===null){r=[];for(var i in a.CipherSuites)r.push(a.CipherSuites[i])}var s=t.server||!1?a.ConnectionEnd.server:a.ConnectionEnd.client,o=t.sessionCache?a.createSessionCache(t.sessionCache):null,u={version:{major:a.Version.major,minor:a.Version.minor},entity:s,sessionId:t.sessionId,caStore:n,sessionCache:o,cipherSuites:r,connected:t.connected,virtualHost:t.virtualHost||null,verifyClient:t.verifyClient||!1,verify:t.verify||function(e,t,n,r){return t},getCertificate:t.getCertificate||null,getPrivateKey:t.getPrivateKey||null,getSignature:t.getSignature||null,input:e.util.createBuffer(),tlsData:e.util.createBuffer(),data:e.util.createBuffer(),tlsDataReady:t.tlsDataReady,dataReady:t.dataReady,heartbeatReceived:t.heartbeatReceived,closed:t.closed,error:function(e,n){n.origin=n.origin||(e.entity===a.ConnectionEnd.client?"client":"server"),n.send&&(a.queue(e,a.createAlert(e,n.alert)),a.flush(e));var r=n.fatal!==!1;r&&(e.fail=!0),t.error(e,n),r&&e.close(!1)},deflate:t.deflate||null,inflate:t.inflate||null};u.reset=function(e){u.version={major:a.Version.major,minor:a.Version.minor},u.record=null,u.session=null,u.peerCertificate=null,u.state={pending:null,current:null},u.expect=u.entity===a.ConnectionEnd.client?f:y,u.fragmented=null,u.records=[],u.open=!1,u.handshakes=0,u.handshaking=!1,u.isConnected=!1,u.fail=!e&&typeof e!="undefined",u.input.clear(),u.tlsData.clear(),u.data.clear(),u.state.current=a.createConnectionState(u)},u.reset();var l=function(e,t){var n=t.type-a.ContentType.change_cipher_spec,r=_[e.entity][e.expect];n in r?r[n](e,t):a.handleUnexpected(e,t)},c=function(t){var n=0,r=t.input,i=r.length();if(i<5)n=5-i;else{t.record={type:r.getByte(),version:{major:r.getByte(),minor:r.getByte()},length:r.getInt16(),fragment:e.util.createBuffer(),ready:!1};var s=t.record.version.major===t.version.major;s&&t.session&&t.session.version&&(s=t.record.version.minor===t.version.minor),s||t.error(t,{message:"Incompatible TLS version.",send:!0,alert:{level:a.Alert.Level.fatal,description:a.Alert.Description.protocol_version}})}return n},h=function(e){var t=0,n=e.input,r=n.length();if(r<e.record.length)t=e.record.length-r;else{e.record.fragment.putBytes(n.getBytes(e.record.length)),n.compact();var i=e.state.current.read;i.update(e,e.record)&&(e.fragmented!==null&&(e.fragmented.type===e.record.type?(e.fragmented.fragment.putBuffer(e.record.fragment),e.record=e.fragmented):e.error(e,{message:"Invalid fragmented record.",send:!0,alert:{level:a.Alert.Level.fatal,description:a.Alert.Description.unexpected_message}})),e.record.ready=!0)}return t};return u.handshake=function(t){if(u.entity!==a.ConnectionEnd.client)u.error(u,{message:"Cannot initiate handshake as a server.",fatal:!1});else if(u.handshaking)u.error(u,{message:"Handshake already in progress.",fatal:!1});else{u.fail&&!u.open&&u.handshakes===0&&(u.fail=!1),u.handshaking=!0,t=t||"";var n=null;t.length>0&&(u.sessionCache&&(n=u.sessionCache.getSession(t)),n===null&&(t="")),t.length===0&&u.sessionCache&&(n=u.sessionCache.getSession(),n!==null&&(t=n.id)),u.session={id:t,version:null,cipherSuite:null,compressionMethod:null,serverCertificate:null,certificateRequest:null,clientCertificate:null,sp:{},md5:e.md.md5.create(),sha1:e.md.sha1.create()},n&&(u.version=n.version,u.session.sp=n.sp),u.session.sp.client_random=a.createRandom().getBytes(),u.open=!0,a.queue(u,a.createRecord(u,{type:a.ContentType.handshake,data:a.createClientHello(u)})),a.flush(u)}},u.process=function(e){var t=0;return e&&u.input.putBytes(e),u.fail||(u.record!==null&&u.record.ready&&u.record.fragment.isEmpty()&&(u.record=null),u.record===null&&(t=c(u)),!u.fail&&u.record!==null&&!u.record.ready&&(t=h(u)),!u.fail&&u.record!==null&&u.record.ready&&l(u,u.record)),t},u.prepare=function(t){return a.queue(u,a.createRecord(u,{type:a.ContentType.application_data,data:e.util.createBuffer(t)})),a.flush(u)},u.prepareHeartbeatRequest=function(t,n){return t instanceof e.util.ByteBuffer&&(t=t.bytes()),typeof n=="undefined"&&(n=t.length),u.expectedHeartbeatPayload=t,a.queue(u,a.createRecord(u,{type:a.ContentType.heartbeat,data:a.createHeartbeat(a.HeartbeatMessageType.heartbeat_request,t,n)})),a.flush(u)},u.close=function(e){if(!u.fail&&u.sessionCache&&u.session){var t={id:u.session.id,version:u.session.version,sp:u.session.sp};t.sp.keys=null,u.sessionCache.setSession(t.id,t)}if(u.open){u.open=!1,u.input.clear();if(u.isConnected||u.handshaking)u.isConnected=u.handshaking=!1,a.queue(u,a.createAlert(u,{level:a.Alert.Level.warning,description:a.Alert.Description.close_notify})),a.flush(u);u.closed(u)}u.reset(e)},u},e.tls=e.tls||{};for(var V in a)typeof a[V]!="function"&&(e.tls[V]=a[V]);e.tls.prf_tls1=t,e.tls.hmac_sha1=r,e.tls.createSessionCache=a.createSessionCache,e.tls.createConnection=a.createConnection}var r="tls";if(typeof n!="function"){if(typeof module!="object"||!module.exports)return typeof forge=="undefined"&&(forge={}),e(forge);var i=!0;n=function(e,n){n(t,module)}}var s,o=function(t,n){n.exports=function(n){var i=s.map(function(e){return t(e)}).concat(e);n=n||{},n.defined=n.defined||{};if(n.defined[r])return n[r];n.defined[r]=!0;for(var o=0;o<i.length;++o)i[o](n);return n[r]}},u=n;n=function(e,t){return s=typeof e=="string"?t.slice(2):e.slice(2),i?(delete n,u.apply(null,Array.prototype.slice.call(arguments,0))):(n=u,n.apply(null,Array.prototype.slice.call(arguments,0)))},n("js/tls",["require","module","./asn1","./hmac","./md","./pem","./pki","./random","./util"],function(){o.apply(null,Array.prototype.slice.call(arguments,0))})}(),function(){function e(e){function t(t,r,i){var u=r.entity===e.tls.ConnectionEnd.client;t.read.cipherState={init:!1,cipher:e.cipher.createDecipher("AES-CBC",u?i.keys.server_write_key:i.keys.client_write_key),iv:u?i.keys.server_write_IV:i.keys.client_write_IV},t.write.cipherState={init:!1,cipher:e.cipher.createCipher("AES-CBC",u?i.keys.client_write_key:i.keys.server_write_key),iv:u?i.keys.client_write_IV:i.keys.server_write_IV},t.read.cipherFunction=s,t.write.cipherFunction=n,t.read.macLength=t.write.macLength=i.mac_length,t.read.macFunction=t.write.macFunction=o.hmac_sha1}function n(t,n){var i=!1,s=n.macFunction(n.macKey,n.sequenceNumber,t);t.fragment.putBytes(s),n.updateSequenceNumber();var u;t.version.minor===o.Versions.TLS_1_0.minor?u=n.cipherState.init?null:n.cipherState.iv:u=e.random.getBytesSync(16),n.cipherState.init=!0;var a=n.cipherState.cipher;return a.start({iv:u}),t.version.minor>=o.Versions.TLS_1_1.minor&&a.output.putBytes(u),a.update(t.fragment),a.finish(r)&&(t.fragment=a.output,t.length=t.fragment.length(),i=!0),i}function r(e,t,n){if(!n){var r=e-t.length()%e;t.fillWithByte(r-1,r)}return!0}function i(e,t,n){var r=!0;if(n){var i=t.length(),s=t.last();for(var o=i-1-s;o<i-1;++o)r=r&&t.at(o)==s;r&&t.truncate(s+1)}return r}function s(t,n){var r=!1;++u;var s;t.version.minor===o.Versions.TLS_1_0.minor?s=n.cipherState.init?null:n.cipherState.iv:s=t.fragment.getBytes(16),n.cipherState.init=!0;var a=n.cipherState.cipher;a.start({iv:s}),a.update(t.fragment),r=a.finish(i);var f=n.macLength,l="";for(var c=0;c<f;++c)l+=String.fromCharCode(0);var h=a.output.length();h>=f?(t.fragment=a.output.getBytes(h-f),l=a.output.getBytes(f)):t.fragment=a.output.getBytes(),t.fragment=e.util.createBuffer(t.fragment),t.length=t.fragment.length();var p=n.macFunction(n.macKey,n.sequenceNumber,t);return n.updateSequenceNumber(),r=p===l&&r,r}var o=e.tls;o.CipherSuites.TLS_RSA_WITH_AES_128_CBC_SHA={id:[0,47],name:"TLS_RSA_WITH_AES_128_CBC_SHA",initSecurityParameters:function(e){e.bulk_cipher_algorithm=o.BulkCipherAlgorithm.aes,e.cipher_type=o.CipherType.block,e.enc_key_length=16,e.block_length=16,e.fixed_iv_length=16,e.record_iv_length=16,e.mac_algorithm=o.MACAlgorithm.hmac_sha1,e.mac_length=20,e.mac_key_length=20},initConnectionState:t},o.CipherSuites.TLS_RSA_WITH_AES_256_CBC_SHA={id:[0,53],name:"TLS_RSA_WITH_AES_256_CBC_SHA",initSecurityParameters:function(e){e.bulk_cipher_algorithm=o.BulkCipherAlgorithm.aes,e.cipher_type=o.CipherType.block,e.enc_key_length=32,e.block_length=16,e.fixed_iv_length=16,e.record_iv_length=16,e.mac_algorithm=o.MACAlgorithm.hmac_sha1,e.mac_length=20,e.mac_key_length=20},initConnectionState:t};var u=0}var r="aesCipherSuites";if(typeof n!="function"){if(typeof module!="object"||!module.exports)return typeof forge=="undefined"&&(forge={}),e(forge);var i=!0;n=function(e,n){n(t,module)}}var s,o=function(t,n){n.exports=function(n){var i=s.map(function(e){return t(e)}).concat(e);n=n||{},n.defined=n.defined||{};if(n.defined[r])return n[r];n.defined[r]=!0;for(var o=0;o<i.length;++o)i[o](n);return n[r]}},u=n;n=function(e,t){return s=typeof e=="string"?t.slice(2):e.slice(2),i?(delete n,u.apply(null,Array.prototype.slice.call(arguments,0))):(n=u,n.apply(null,Array.prototype.slice.call(arguments,0)))},n("js/aesCipherSuites",["require","module","./aes","./tls"],function(){o.apply(null,Array.prototype.slice.call(arguments,0))})}(),function(){function e(e){e.debug=e.debug||{},e.debug.storage={},e.debug.get=function(t,n){var r;return typeof t=="undefined"?r=e.debug.storage:t in e.debug.storage&&(typeof n=="undefined"?r=e.debug.storage[t]:r=e.debug.storage[t][n]),r},e.debug.set=function(t,n,r){t in e.debug.storage||(e.debug.storage[t]={}),e.debug.storage[t][n]=r},e.debug.clear=function(t,n){typeof t=="undefined"?e.debug.storage={}:t in e.debug.storage&&(typeof n=="undefined"?delete e.debug.storage[t]:delete e.debug.storage[t][n])}}var r="debug";if(typeof n!="function"){if(typeof module!="object"||!module.exports)return typeof forge=="undefined"&&(forge={}),e(forge);var i=!0;n=function(e,n){n(t,module)}}var s,o=function(t,n){n.exports=function(n){var i=s.map(function(e){return t(e)}).concat(e);n=n||{},n.defined=n.defined||{};if(n.defined[r])return n[r];n.defined[r]=!0;for(var o=0;o<i.length;++o)i[o](n);return n[r]}},u=n;n=function(e,t){return s=typeof e=="string"?t.slice(2):e.slice(2),i?(delete n,u.apply(null,Array.prototype.slice.call(arguments,0))):(n=u,n.apply(null,Array.prototype.slice.call(arguments,0)))},n("js/debug",["require","module"],function(){o.apply(null,Array.prototype.slice.call(arguments,0))})}(),function(){function e(e){function t(t,n,r,i){t.generate=function(t,s){var o=new e.util.ByteBuffer,u=Math.ceil(s/i)+r,a=new e.util.ByteBuffer;for(var f=r;f<u;++f){a.putInt32(f),n.start(),n.update(t+a.getBytes());var l=n.digest();o.putBytes(l.getBytes(i))}return o.truncate(o.length()-s),o.getBytes()}}e.kem=e.kem||{};var n=e.jsbn.BigInteger;e.kem.rsa={},e.kem.rsa.create=function(t,r){r=r||{};var i=r.prng||e.random,s={};return s.encrypt=function(r,s){var o=Math.ceil(r.n.bitLength()/8),u;do u=(new n(e.util.bytesToHex(i.getBytesSync(o)),16)).mod(r.n);while(u.equals(n.ZERO));u=e.util.hexToBytes(u.toString(16));var a=o-u.length;a>0&&(u=e.util.fillString(String.fromCharCode(0),a)+u);var f=r.encrypt(u,"NONE"),l=t.generate(u,s);return{encapsulation:f,key:l}},s.decrypt=function(e,n,r){var i=e.decrypt(n,"NONE");return t.generate(i,r)},s},e.kem.kdf1=function(e,n){t(this,e,0,n||e.digestLength)},e.kem.kdf2=function(e,n){t(this,e,1,n||e.digestLength)}}var r="kem";if(typeof n!="function"){if(typeof module!="object"||!module.exports)return typeof forge=="undefined"&&(forge={}),e(forge);var i=!0;n=function(e,n){n(t,module)}}var s,o=function(t,n){n.exports=function(n){var i=s.map(function(e){return t(e)}).concat(e);n=n||{},n.defined=n.defined||{};if(n.defined[r])return n[r];n.defined[r]=!0;for(var o=0;o<i.length;++o)i[o](n);return n[r]}},u=n;n=function(e,t){return s=typeof e=="string"?t.slice(2):e.slice(2),i?(delete n,u.apply(null,Array.prototype.slice.call(arguments,0))):(n=u,n.apply(null,Array.prototype.slice.call(arguments,0)))},n("js/kem",["require","module","./util","./random","./jsbn"],function(){o.apply(null,Array.prototype.slice.call(arguments,0))})}(),function(){function e(e){e.log=e.log||{},e.log.levels=["none","error","warning","info","debug","verbose","max"];var t={},n=[],r=null;e.log.LEVEL_LOCKED=2,e.log.NO_LEVEL_CHECK=4,e.log.INTERPOLATE=8;for(var i=0;i<e.log.levels.length;++i){var s=e.log.levels[i];t[s]={index:i,name:s.toUpperCase()}}e.log.logMessage=function(r){var i=t[r.level].index;for(var s=0;s<n.length;++s){var o=n[s];if(o.flags&e.log.NO_LEVEL_CHECK)o.f(r);else{var u=t[o.level].index;i<=u&&o.f(o,r)}}},e.log.prepareStandard=function(e){"standard"in e||(e.standard=t[e.level].name+" ["+e.category+"] "+e.message)},e.log.prepareFull=function(t){if(!("full"in t)){var n=[t.message];n=n.concat([]||t.arguments),t.full=e.util.format.apply(this,n)}},e.log.prepareStandardFull=function(t){"standardFull"in t||(e.log.prepareStandard(t),t.standardFull=t.standard)};var o=["error","warning","info","debug","verbose"];for(var i=0;i<o.length;++i)(function(t){e.log[t]=function(n,r){var i=Array.prototype.slice.call(arguments).slice(2),s={timestamp:new Date,level:t,category:n,message:r,arguments:i};e.log.logMessage(s)}})(o[i]);e.log.makeLogger=function(t){var n={flags:0,f:t};return e.log.setLevel(n,"none"),n},e.log.setLevel=function(t,n){var r=!1;if(t&&!(t.flags&e.log.LEVEL_LOCKED))for(var i=0;i<e.log.levels.length;++i){var s=e.log.levels[i];if(n==s){t.level=n,r=!0;break}}return r},e.log.lock=function(t,n){typeof n=="undefined"||n?t.flags|=e.log.LEVEL_LOCKED:t.flags&=~e.log.LEVEL_LOCKED},e.log.addLogger=function(e){n.push(e)};if(typeof console!="undefined"&&"log"in console){var u;if(console.error&&console.warn&&console.info&&console.debug){var a={error:console.error,warning:console.warn,info:console.info,debug:console.debug,verbose:console.debug},f=function(t,n){e.log.prepareStandard(n);var r=a[n.level],i=[n.standard];i=i.concat(n.arguments.slice()),r.apply(console,i)};u=e.log.makeLogger(f)}else{var f=function(t,n){e.log.prepareStandardFull(n),console.log(n.standardFull)};u=e.log.makeLogger(f)}e.log.setLevel(u,"debug"),e.log.addLogger(u),r=u}else console={log:function(){}};if(r!==null){var l=e.util.getQueryVariables();"console.level"in l&&e.log.setLevel(r,l["console.level"].slice(-1)[0]);if("console.lock"in l){var c=l["console.lock"].slice(-1)[0];c=="true"&&e.log.lock(r)}}e.log.consoleLogger=r}var r="log";if(typeof n!="function"){if(typeof module!="object"||!module.exports)return typeof forge=="undefined"&&(forge={}),e(forge);var i=!0;n=function(e,n){n(t,module)}}var s,o=function(t,n){n.exports=function(n){var i=s.map(function(e){return t(e)}).concat(e);n=n||{},n.defined=n.defined||{};if(n.defined[r])return n[r];n.defined[r]=!0;for(var o=0;o<i.length;++o)i[o](n);return n[r]}},u=n;n=function(e,t){return s=typeof e=="string"?t.slice(2):e.slice(2),i?(delete n,u.apply(null,Array.prototype.slice.call(arguments,0))):(n=u,n.apply(null,Array.prototype.slice.call(arguments,0)))},n("js/log",["require","module","./util"],function(){o.apply(null,Array.prototype.slice.call(arguments,0))})}(),function(){function e(e){var t=e.asn1,n=e.pkcs7=e.pkcs7||{};n.messageFromPem=function(r){var i=e.pem.decode(r)[0];if(i.type!=="PKCS7"){var s=new Error('Could not convert PKCS#7 message from PEM; PEM header type is not "PKCS#7".');throw s.headerType=i.type,s}if(i.procType&&i.procType.type==="ENCRYPTED")throw new Error("Could not convert PKCS#7 message from PEM; PEM is encrypted.");var o=t.fromDer(i.body);return n.messageFromAsn1(o)},n.messageToPem=function(n,r){var i={type:"PKCS7",body:t.toDer(n.toAsn1()).getBytes()};return e.pem.encode(i,{maxline:r})},n.messageFromAsn1=function(r){var i={},s=[];if(!t.validate(r,n.asn1.contentInfoValidator,i,s)){var o=new Error("Cannot read PKCS#7 message. ASN.1 object is not an PKCS#7 ContentInfo.");throw o.errors=s,o}var u=t.derToOid(i.contentType),a;switch(u){case e.pki.oids.envelopedData:a=n.createEnvelopedData();break;case e.pki.oids.encryptedData:a=n.createEncryptedData();break;case e.pki.oids.signedData:a=n.createSignedData();break;default:throw new Error("Cannot read PKCS#7 message. ContentType with OID "+u+" is not (yet) supported.")}return a.fromAsn1(i.content.value[0]),a};var r=function(r){var i={},s=[];if(!t.validate(r,n.asn1.recipientInfoValidator,i,s)){var o=new Error("Cannot read PKCS#7 message. ASN.1 object is not an PKCS#7 EnvelopedData.");throw o.errors=s,o}return{version:i.version.charCodeAt(0),issuer:e.pki.RDNAttributesAsArray(i.issuer),serialNumber:e.util.createBuffer(i.serial).toHex(),encryptedContent:{algorithm:t.derToOid(i.encAlgorithm),parameter:i.encParameter.value,content:i.encKey}}},i=function(n){return t.create(t.Class.UNIVERSAL,t.Type.SEQUENCE,!0,[t.create(t.Class.UNIVERSAL,t.Type.INTEGER,!1,t.integerToDer(n.version).getBytes()),t.create(t.Class.UNIVERSAL,t.Type.SEQUENCE,!0,[e.pki.distinguishedNameToAsn1({attributes:n.issuer}),t.create(t.Class.UNIVERSAL,t.Type.INTEGER,!1,e.util.hexToBytes(n.serialNumber))]),t.create(t.Class.UNIVERSAL,t.Type.SEQUENCE,!0,[t.create(t.Class.UNIVERSAL,t.Type.OID,!1,t.oidToDer(n.encryptedContent.algorithm).getBytes()),t.create(t.Class.UNIVERSAL,t.Type.NULL,!1,"")]),t.create(t.Class.UNIVERSAL,t.Type.OCTETSTRING,!1,n.encryptedContent.content)])},s=function(e){var t=[];for(var n=0;n<e.length;n++)t.push(r(e[n]));return t},o=function(e){var t=[];for(var n=0;n<e.length;n++)t.push(i(e[n]));return t},u=function(n){return[t.create(t.Class.UNIVERSAL,t.Type.OID,!1,t.oidToDer(e.pki.oids.data).getBytes()),t.create(t.Class.UNIVERSAL,t.Type.SEQUENCE,!0,[t.create(t.Class.UNIVERSAL,t.Type.OID,!1,t.oidToDer(n.algorithm).getBytes()),t.create(t.Class.UNIVERSAL,t.Type.OCTETSTRING,!1,n.parameter.getBytes())]),t.create(t.Class.CONTEXT_SPECIFIC,0,!0,[t.create(t.Class.UNIVERSAL,t.Type.OCTETSTRING,!1,n.content.getBytes())])]},a=function(n,r,i){var s={},o=[];if(!t.validate(r,i,s,o)){var u=new Error("Cannot read PKCS#7 message. ASN.1 object is not a supported PKCS#7 message.");throw u.errors=u,u}var a=t.derToOid(s.contentType);if(a!==e.pki.oids.data)throw new Error("Unsupported PKCS#7 message. Only wrapped ContentType Data supported.");if(s.encryptedContent){var f="";if(e.util.isArray(s.encryptedContent))for(var l=0;l<s.encryptedContent.length;++l){if(s.encryptedContent[l].type!==t.Type.OCTETSTRING)throw new Error("Malformed PKCS#7 message, expecting encrypted content constructed of only OCTET STRING objects.");f+=s.encryptedContent[l].value}else f=s.encryptedContent;n.encryptedContent={algorithm:t.derToOid(s.encAlgorithm),parameter:e.util.createBuffer(s.encParameter.value),content:e.util.createBuffer(f)}}if(s.content){var f="";if(e.util.isArray(s.content))for(var l=0;l<s.content.length;++l){if(s.content[l].type!==t.Type.OCTETSTRING)throw new Error("Malformed PKCS#7 message, expecting content constructed of only OCTET STRING objects.");f+=s.content[l].value}else f=s.content;n.content=e.util.createBuffer(f)}return n.version=s.version.charCodeAt(0),n.rawCapture=s,s},f=function(t){if(t.encryptedContent.key===undefined)throw new Error("Symmetric key not available.");if(t.content===undefined){var n;switch(t.encryptedContent.algorithm){case e.pki.oids["aes128-CBC"]:case e.pki.oids["aes192-CBC"]:case e.pki.oids["aes256-CBC"]:n=e.aes.createDecryptionCipher(t.encryptedContent.key);break;case e.pki.oids.desCBC:case e.pki.oids["des-EDE3-CBC"]:n=e.des.createDecryptionCipher(t.encryptedContent.key);break;default:throw new Error("Unsupported symmetric cipher, OID "+t.encryptedContent.algorithm)}n.start(t.encryptedContent.parameter),n.update(t.encryptedContent.content);if(!n.finish())throw new Error("Symmetric decryption failed.");t.content=n.output}};n.createSignedData=function(){var r=null;return r={type:e.pki.oids.signedData,version:1,certificates:[],crls:[],digestAlgorithmIdentifiers:[],contentInfo:null,signerInfos:[],fromAsn1:function(t){a(r,t,n.asn1.signedDataValidator),r.certificates=[],r.crls=[],r.digestAlgorithmIdentifiers=[],r.contentInfo=null,r.signerInfos=[];var i=r.rawCapture.certificates.value;for(var s=0;s<i.length;++s)r.certificates.push(e.pki.certificateFromAsn1(i[s]))},toAsn1:function(){if("content"in r)throw new Error("Signing PKCS#7 content not yet implemented.");r.contentInfo||r.sign();var n=[];for(var i=0;i<r.certificates.length;++i)n.push(e.pki.certificateToAsn1(r.certificates[0]));var s=[];return t.create(t.Class.UNIVERSAL,t.Type.SEQUENCE,!0,[t.create(t.Class.UNIVERSAL,t.Type.OID,!1,t.oidToDer(r.type).getBytes()),t.create(t.Class.CONTEXT_SPECIFIC,0,!0,[t.create(t.Class.UNIVERSAL,t.Type.SEQUENCE,!0,[t.create(t.Class.UNIVERSAL,t.Type.INTEGER,!1,t.integerToDer(r.version).getBytes()),t.create(t.Class.UNIVERSAL,t.Type.SET,!0,r.digestAlgorithmIdentifiers),r.contentInfo,t.create(t.Class.CONTEXT_SPECIFIC,0,!0,n),t.create(t.Class.CONTEXT_SPECIFIC,1,!0,s),t.create(t.Class.UNIVERSAL,t.Type.SET,!0,r.signerInfos)])])])},sign:function(n){if("content"in r)throw new Error("PKCS#7 signing not yet implemented.");typeof r.content!="object"&&(r.contentInfo=t.create(t.Class.UNIVERSAL,t.Type.SEQUENCE,!0,[t.create(t.Class.UNIVERSAL,t.Type.OID,!1,t.oidToDer(e.pki.oids.data).getBytes())]),"content"in r&&r.contentInfo.value.push(t.create(t.Class.CONTEXT_SPECIFIC,0,!0,[t.create(t.Class.UNIVERSAL,t.Type.OCTETSTRING,!1,r.content)])))},verify:function(){throw new Error("PKCS#7 signature verification not yet implemented.")},addCertificate:function(t){typeof t=="string"&&(t=e.pki.certificateFromPem(t)),r.certificates.push(t)},addCertificateRevokationList:function(e){throw new Error("PKCS#7 CRL support not yet implemented.")}},r},n.createEncryptedData=function(){var t=null;return t={type:e.pki.oids.encryptedData,version:0,encryptedContent:{algorithm:e.pki.oids["aes256-CBC"]},fromAsn1:function(e){a(t,e,n.asn1.encryptedDataValidator)},decrypt:function(e){e!==undefined&&(t.encryptedContent.key=e),f(t)}},t},n.createEnvelopedData=function(){var r=null;return r={type:e.pki.oids.envelopedData,version:0,recipients:[],encryptedContent:{algorithm:e.pki.oids["aes256-CBC"]},fromAsn1:function(e){var t=a(r,e,n.asn1.envelopedDataValidator);r.recipients=s(t.recipientInfos.value)},toAsn1:function(){return t.create(t.Class.UNIVERSAL,t.Type.SEQUENCE,!0,[t.create(t.Class.UNIVERSAL,t.Type.OID,!1,t.oidToDer(r.type).getBytes()),t.create(t.Class.CONTEXT_SPECIFIC,0,!0,[t.create(t.Class.UNIVERSAL,t.Type.SEQUENCE,!0,[t.create(t.Class.UNIVERSAL,t.Type.INTEGER,!1,t.integerToDer(r.version).getBytes()),t.create(t.Class.UNIVERSAL,t.Type.SET,!0,o(r.recipients)),t.create(t.Class.UNIVERSAL,t.Type.SEQUENCE,!0,u(r.encryptedContent))])])])},findRecipient:function(e){var t=e.issuer.attributes;for(var n=0;n<r.recipients.length;++n){var i=r.recipients[n],s=i.issuer;if(i.serialNumber!==e.serialNumber)continue;if(s.length!==t.length)continue;var o=!0;for(var u=0;u<t.length;++u)if(s[u].type!==t[u].type||s[u].value!==t[u].value){o=!1;break}if(o)return i}return null},decrypt:function(t,n){if(r.encryptedContent.key===undefined&&t!==undefined&&n!==undefined)switch(t.encryptedContent.algorithm){case e.pki.oids.rsaEncryption:case e.pki.oids.desCBC:var i=n.decrypt(t.encryptedContent.content);r.encryptedContent.key=e.util.createBuffer(i);break;default:throw new Error("Unsupported asymmetric cipher, OID "+t.encryptedContent.algorithm)}f(r)},addRecipient:function(t){r.recipients.push({version:0,issuer:t.issuer.attributes,serialNumber:t.serialNumber,encryptedContent:{algorithm:e.pki.oids.rsaEncryption,key:t.publicKey}})},encrypt:function(t,n){if(r.encryptedContent.content===undefined){n=n||r.encryptedContent.algorithm,t=t||r.encryptedContent.key;var i,s,o;switch(n){case e.pki.oids["aes128-CBC"]:i=16,s=16,o=e.aes.createEncryptionCipher;break;case e.pki.oids["aes192-CBC"]:i=24,s=16,o=e.aes.createEncryptionCipher;break;case e.pki.oids["aes256-CBC"]:i=32,s=16,o=e.aes.createEncryptionCipher;break;case e.pki.oids["des-EDE3-CBC"]:i=24,s=8,o=e.des.createEncryptionCipher;break;default:throw new Error("Unsupported symmetric cipher, OID "+n)}if(t===undefined)t=e.util.createBuffer(e.random.getBytes(i));else if(t.length()!=i)throw new Error("Symmetric key has wrong length; got "+t.length()+" bytes, expected "+i+".");r.encryptedContent.algorithm=n,r.encryptedContent.key=t,r.encryptedContent.parameter=e.util.createBuffer(e.random.getBytes(s));var u=o(t);u.start(r.encryptedContent.parameter.copy()),u.update(r.content);if(!u.finish())throw new Error("Symmetric encryption failed.");r.encryptedContent.content=u.output}for(var a=0;a<r.recipients.length;a++){var f=r.recipients[a];if(f.encryptedContent.content!==undefined)continue;switch(f.encryptedContent.algorithm){case e.pki.oids.rsaEncryption:f.encryptedContent.content=f.encryptedContent.key.encrypt(r.encryptedContent.key.data);break;default:throw new Error("Unsupported asymmetric cipher, OID "+f.encryptedContent.algorithm)}}}},r}}var r="pkcs7";if(typeof n!="function"){if(typeof module!="object"||!module.exports)return typeof forge=="undefined"&&(forge={}),e(forge);var i=!0;n=function(e,n){n(t,module)}}var s,o=function(t,n){n.exports=function(n){var i=s.map(function(e){return t(e)}).concat(e);n=n||{},n.defined=n.defined||{};if(n.defined[r])return n[r];n.defined[r]=!0;for(var o=0;o<i.length;++o)i[o](n);return n[r]}},u=n;n=function(e,t){return s=typeof e=="string"?t.slice(2):e.slice(2),i?(delete n,u.apply(null,Array.prototype.slice.call(arguments,0))):(n=u,n.apply(null,Array.prototype.slice.call(arguments,0)))},n("js/pkcs7",["require","module","./aes","./asn1","./des","./oids","./pem","./pkcs7asn1","./random","./util","./x509"],function(){o.apply(null,Array.prototype.slice.call(arguments,0))})}(),function(){function e(e){function t(t,n){var r=n.toString(16);r[0]>="8"&&(r="00"+r);var i=e.util.hexToBytes(r);t.putInt32(i.length),t.putBytes(i)}function n(e,t){e.putInt32(t.length),e.putString(t)}function r(){var t=e.md.sha1.create(),n=arguments.length;for(var r=0;r<n;++r)t.update(arguments[r]);return t.digest()}var i=e.ssh=e.ssh||{};i.privateKeyToPutty=function(i,s,o){o=o||"",s=s||"";var u="ssh-rsa",a=s===""?"none":"aes256-cbc",f="PuTTY-User-Key-File-2: "+u+"\r\n";f+="Encryption: "+a+"\r\n",f+="Comment: "+o+"\r\n";var l=e.util.createBuffer();n(l,u),t(l,i.e),t(l,i.n);var c=e.util.encode64(l.bytes(),64),h=Math.floor(c.length/66)+1;f+="Public-Lines: "+h+"\r\n",f+=c;var p=e.util.createBuffer();t(p,i.d),t(p,i.p),t(p,i.q),t(p,i.qInv);var d;if(!s)d=e.util.encode64(p.bytes(),64);else{var v=p.length()+16-1;v-=v%16;var m=r(p.bytes());m.truncate(m.length()-v+p.length()),p.putBuffer(m);var g=e.util.createBuffer();g.putBuffer(r("\0\0\0\0",s)),g.putBuffer(r("\0\0\0",s));var y=e.aes.createEncryptionCipher(g.truncate(8),"CBC");y.start(e.util.createBuffer().fillWithByte(0,16)),y.update(p.copy()),y.finish();var b=y.output;b.truncate(16),d=e.util.encode64(b.bytes(),64)}h=Math.floor(d.length/66)+1,f+="\r\nPrivate-Lines: "+h+"\r\n",f+=d;var w=r("putty-private-key-file-mac-key",s),E=e.util.createBuffer();n(E,u),n(E,a),n(E,o),E.putInt32(l.length()),E.putBuffer(l),E.putInt32(p.length()),E.putBuffer(p);var S=e.hmac.create();return S.start("sha1",w),S.update(E.bytes()),f+="\r\nPrivate-MAC: "+S.digest().toHex()+"\r\n",f},i.publicKeyToOpenSSH=function(r,i){var s="ssh-rsa";i=i||"";var o=e.util.createBuffer();return n(o,s),t(o,r.e),t(o,r.n),s+" "+e.util.encode64(o.bytes())+" "+i},i.privateKeyToOpenSSH=function(t,n){return n?e.pki.encryptRsaPrivateKey(t,n,{legacy:!0,algorithm:"aes128"}):e.pki.privateKeyToPem(t)},i.getPublicKeyFingerprint=function(r,i){i=i||{};var s=i.md||e.md.md5.create(),o="ssh-rsa",u=e.util.createBuffer();n(u,o),t(u,r.e),t(u,r.n),s.start(),s.update(u.getBytes());var a=s.digest();if(i.encoding==="hex"){var f=a.toHex();return i.delimiter?f.match(/.{2}/g).join(i.delimiter):f}if(i.encoding==="binary")return a.getBytes();if(i.encoding)throw new Error('Unknown encoding "'+i.encoding+'".');return a}}var r="ssh";if(typeof n!="function"){if(typeof module!="object"||!module.exports)return typeof forge=="undefined"&&(forge={}),e(forge);var i=!0;n=function(e,n){n(t,module)}}var s,o=function(t,n){n.exports=function(n){var i=s.map(function(e){return t(e)}).concat(e);n=n||{},n.defined=n.defined||{};if(n.defined[r])return n[r];n.defined[r]=!0;for(var o=0;o<i.length;++o)i[o](n);return n[r]}},u=n;n=function(e,t){return s=typeof e=="string"?t.slice(2):e.slice(2),i?(delete n,u.apply(null,Array.prototype.slice.call(arguments,0))):(n=u,n.apply(null,Array.prototype.slice.call(arguments,0)))},n("js/ssh",["require","module","./aes","./hmac","./md5","./sha1","./util"],function(){o.apply(null,Array.prototype.slice.call(arguments,0))})}(),function(){function e(e){var t="forge.task",n=0,r={},i=0;e.debug.set(t,"tasks",r);var s={};e.debug.set(t,"queues",s);var o="?",u=30,a=20,f="ready",l="running",c="blocked",h="sleeping",p="done",d="error",v="stop",m="start",g="block",y="unblock",b="sleep",w="wakeup",E="cancel",S="fail",x={};x[f]={},x[f][v]=f,x[f][m]=l,x[f][E]=p,x[f][S]=d,x[l]={},x[l][v]=f,x[l][m]=l,x[l][g]=c,x[l][y]=l,x[l][b]=h,x[l][w]=l,x[l][E]=p,x[l][S]=d,x[c]={},x[c][v]=c,x[c][m]=c,x[c][g]=c,x[c][y]=c,x[c][b]=c,x[c][w]=c,x[c][E]=p,x[c][S]=d,x[h]={},x[h][v]=h,x[h][m]=h,x[h][g]=h,x[h][y]=h,x[h][b]=h,x[h][w]=h,x[h][E]=p,x[h][S]=d,x[p]={},x[p][v]=p,x[p][m]=p,x[p][g]=p,x[p][y]=p,x[p][b]=p,x[p][w]=p,x[p][E]=p,x[p][S]=d,x[d]={},x[d][v]=d,x[d][m]=d,x[d][g]=d,x[d][y]=d,x[d][b]=d,x[d][w]=d,x[d][E]=d,x[d][S]=d;var T=function(s){this.id=-1,this.name=s.name||o,this.parent=s.parent||null,this.run=s.run,this.subtasks=[],this.error=!1,this.state=f,this.blocks=0,this.timeoutId=null,this.swapTime=null,this.userData=null,this.id=i++,r[this.id]=this,n>=1&&e.log.verbose(t,"[%s][%s] init",this.id,this.name,this)};T.prototype.debug=function(n){n=n||"",e.log.debug(t,n,"[%s][%s] task:",this.id,this.name,this,"subtasks:",this.subtasks.length,"queue:",s)},T.prototype.next=function(e,t){typeof e=="function"&&(t=e,e=this.name);var n=new T({run:t,name:e,parent:this});return n.state=l,n.type=this.type,n.successCallback=this.successCallback||null,n.failureCallback=this.failureCallback||null,this.subtasks.push(n),this},T.prototype.parallel=function(t,n){return e.util.isArray(t)&&(n=t,t=this.name),this.next(t,function(r){var i=r;i.block(n.length);var s=function(t,r){e.task.start({type:t,run:function(e){n[r](e)},success:function(e){i.unblock()},failure:function(e){i.unblock()}})};for(var o=0;o<n.length;o++){var u=t+"__parallel-"+r.id+"-"+o,a=o;s(u,a)}})},T.prototype.stop=function(){this.state=x[this.state][v]},T.prototype.start=function(){this.error=!1,this.state=x[this.state][m],this.state===l&&(this.start=new Date,this.run(this),C(this,0))},T.prototype.block=function(e){e=typeof e=="undefined"?1:e,this.blocks+=e,this.blocks>0&&(this.state=x[this.state][g])},T.prototype.unblock=function(e){return e=typeof e=="undefined"?1:e,this.blocks-=e,this.blocks===0&&this.state!==p&&(this.state=l,C(this,0)),this.blocks},T.prototype.sleep=function(e){e=typeof e=="undefined"?0:e,this.state=x[this.state][b];var t=this;this.timeoutId=setTimeout(function(){t.timeoutId=null,t.state=l,C(t,0)},e)},T.prototype.wait=function(e){e.wait(this)},T.prototype.wakeup=function(){this.state===h&&(cancelTimeout(this.timeoutId),this.timeoutId=null,this.state=l,C(this,0))},T.prototype.cancel=function(){this.state=x[this.state][E],this.permitsNeeded=0,this.timeoutId!==null&&(cancelTimeout(this.timeoutId),this.timeoutId=null),this.subtasks=[]},T.prototype.fail=function(e){this.error=!0,k(this,!0);if(e)e.error=this.error,e.swapTime=this.swapTime,e.userData=this.userData,C(e,0);else{if(this.parent!==null){var t=this.parent;while(t.parent!==null)t.error=this.error,t.swapTime=this.swapTime,t.userData=this.userData,t=t.parent;k(t,!0)}this.failureCallback&&this.failureCallback(this)}};var N=function(e){e.error=!1,e.state=x[e.state][m],setTimeout(function(){e.state===l&&(e.swapTime=+(new Date),e.run(e),C(e,0))},0)},C=function(e,t){var n=t>u||+(new Date)-e.swapTime>a,r=function(t){t++;if(e.state===l){n&&(e.swapTime=+(new Date));if(e.subtasks.length>0){var r=e.subtasks.shift();r.error=e.error,r.swapTime=e.swapTime,r.userData=e.userData,r.run(r),r.error||C(r,t)}else k(e),e.error||e.parent!==null&&(e.parent.error=e.error,e.parent.swapTime=e.swapTime,e.parent.userData=e.userData,C(e.parent,t))}};n?setTimeout(r,0):r(t)},k=function(i,o){i.state=p,delete r[i.id],n>=1&&e.log.verbose(t,"[%s][%s] finish",i.id,i.name,i),i.parent===null&&(i.type in s?s[i.type].length===0?e.log.error(t,"[%s][%s] task queue empty [%s]",i.id,i.name,i.type):s[i.type][0]!==i?e.log.error(t,"[%s][%s] task not first in queue [%s]",i.id,i.name,i.type):(s[i.type].shift(),s[i.type].length===0?(n>=1&&e.log.verbose(t,"[%s][%s] delete queue [%s]",i.id,i.name,i.type),delete s[i.type]):(n>=1&&e.log.verbose(t,"[%s][%s] queue start next [%s] remain:%s",i.id,i.name,i.type,s[i.type].length),s[i.type][0].start())):e.log.error(t,"[%s][%s] task queue missing [%s]",i.id,i.name,i.type),o||(i.error&&i.failureCallback?i.failureCallback(i):!i.error&&i.successCallback&&i.successCallback(i)))};e.task=e.task||{},e.task.start=function(r){var i=new T({run:r.run,name:r.name||o});i.type=r.type,i.successCallback=r.success||null,i.failureCallback=r.failure||null,i.type in s?s[r.type].push(i):(n>=1&&e.log.verbose(t,"[%s][%s] create queue [%s]",i.id,i.name,i.type),s[i.type]=[i],N(i))},e.task.cancel=function(e){e in s&&(s[e]=[s[e][0]])},e.task.createCondition=function(){var e={tasks:{}};return e.wait=function(t){t.id in e.tasks||(t.block(),e.tasks[t.id]=t)},e.notify=function(){var t=e.tasks;e.tasks={};for(var n in t)t[n].unblock()},e}}var r="task";if(typeof n!="function"){if(typeof module!="object"||!module.exports)return typeof forge=="undefined"&&(forge={}),e(forge);var i=!0;n=function(e,n){n(t,module)}}var s,o=function(t,n){n.exports=function(n){var i=s.map(function(e){return t(e)}).concat(e);n=n||{},n.defined=n.defined||{};if(n.defined[r])return n[r];n.defined[r]=!0;for(var o=0;o<i.length;++o)i[o](n);return n[r]}},u=n;n=function(e,t){return s=typeof e=="string"?t.slice(2):e.slice(2),i?(delete n,u.apply(null,Array.prototype.slice.call(arguments,0))):(n=u,n.apply(null,Array.prototype.slice.call(arguments,0)))},n("js/task",["require","module","./debug","./log","./util"],function(){o.apply(null,Array.prototype.slice.call(arguments,0))})}(),function(){var e="forge";if(typeof n!="function"){if(typeof module!="object"||!module.exports){typeof forge=="undefined"&&(forge={disableNativeCode:!1});return}var r=!0;n=function(e,n){n(t,module)}}var i,s=function(t,n){n.exports=function(n){var r=i.map(function(e){return t(e)});n=n||{},n.defined=n.defined||{};if(n.defined[e])return n[e];n.defined[e]=!0;for(var s=0;s<r.length;++s)r[s](n);return n},n.exports.disableNativeCode=!1,n.exports(n.exports)},o=n;n=function(e,t){return i=typeof e=="string"?t.slice(2):e.slice(2),r?(delete n,o.apply(null,Array.prototype.slice.call(arguments,0))):(n=o,n.apply(null,Array.prototype.slice.call(arguments,0)))},n("js/forge",["require","module","./aes","./aesCipherSuites","./asn1","./cipher","./cipherModes","./debug","./des","./hmac","./kem","./log","./md","./mgf1","./pbkdf2","./pem","./pkcs7","./pkcs1","./pkcs12","./pki","./prime","./prng","./pss","./random","./rc2","./ssh","./task","./tls","./util"],function(){s.apply(null,Array.prototype.slice.call(arguments,0))})}(),t("js/forge")}),function(){function e(t,n,r){this.maxSize_=t||-1,this.debug_=n||!1,this.storage_=r||new e.BasicCacheStorage,this.fillFactor_=.75,this.stats_={},this.stats_.hits=0,this.stats_.misses=0,this.log_("Initialized cache with size "+t)}e.Priority={LOW:1,NORMAL:2,HIGH:4},e.BasicCacheStorage=function(){this.items_={},this.count_=0},e.BasicCacheStorage.prototype.get=function(e){return this.items_[e]},e.BasicCacheStorage.prototype.set=function(e,t){typeof this.get(e)=="undefined"&&this.count_++,this.items_[e]=t},e.BasicCacheStorage.prototype.size=function(e,t){return this.count_},e.BasicCacheStorage.prototype.remove=function(e){var t=this.get(e);return typeof t!="undefined"&&this.count_--,delete this.items_[e],t},e.BasicCacheStorage.prototype.keys=function(){var e=[],t;for(t in this.items_)e.push(t);return e},e.LocalStorageCacheStorage=function(e){this.prefix_="cache-storage."+(e||"default")+".";var t=this.prefix_.replace(/[-[\]{}()*+?.,\\^$|#\s]/g,"\\$&");this.regexp_=new RegExp("^"+t)},e.LocalStorageCacheStorage.prototype.get=function(e){var t=window.localStorage[this.prefix_+e];return t?JSON.parse(t):null},e.LocalStorageCacheStorage.prototype.set=function(e,t){window.localStorage[this.prefix_+e]=JSON.stringify(t)},e.LocalStorageCacheStorage.prototype.size=function(e,t){return this.keys().length},e.LocalStorageCacheStorage.prototype.remove=function(e){var t=this.get(e);return delete window.localStorage[this.prefix_+e],t},e.LocalStorageCacheStorage.prototype.keys=function(){var e=[],t;for(t in window.localStorage)t.match(this.regexp_)&&e.push(t.replace(this.prefix_,""));return e},e.prototype.getItem=function(e){var t=this.storage_.get(e);t!=null&&(this.isExpired_(t)?(this.removeItem(e),t=null):t.lastAccessed=(new Date).getTime());var n=t?t.value:null;return n?(this.stats_.hits++,this.log_("Cache HIT for key "+e)):(this.stats_.misses++,this.log_("Cache MISS for key "+e)),n},e._CacheItem=function(t,n,r){if(!t)throw new Error("key cannot be null or empty");this.key=t,this.value=n,r=r||{},r.expirationAbsolute&&(r.expirationAbsolute=r.expirationAbsolute.getTime()),r.priority||(r.priority=e.Priority.NORMAL),this.options=r,this.lastAccessed=(new Date).getTime()},e.prototype.setItem=function(t,n,r){this.storage_.get(t)!=null&&this.removeItem(t),this.addItem_(new e._CacheItem(t,n,r)),this.log_("Setting key "+t);if(this.maxSize_>0&&this.size()>this.maxSize_){var i=this;setTimeout(function(){i.purge_.call(i)},0)}},e.prototype.clear=function(){var e=this.storage_.keys();for(var t=0;t<e.length;t++)this.removeItem(e[t]);this.log_("Cache cleared")},e.prototype.getStats=function(){return this.stats_},e.prototype.toHtmlString=function(){var e=this.size()+" item(s) in cache<br /><ul>",t=this.storage_.keys();for(var n=0;n<t.length;n++){var r=this.storage_.get(t[n]);e=e+"<li>"+r.key.toString()+" = "+r.value.toString()+"</li>"}return e+="</ul>",e},e.prototype.resize=function(e){this.log_("Resizing Cache from "+this.maxSize_+" to "+e);var t=this.maxSize_;this.maxSize_=e,e>0&&(t<0||e<t)&&this.size()>e&&this.purge_(),this.log_("Resizing done")},e.prototype.purge_=function(){var e=new Array,t=Math.round(this.maxSize_*this.fillFactor_);this.maxSize_<0&&(t=this.size()*this.fillFactor_);var n=this.storage_.keys();for(var r=0;r<n.length;r++){var i=n[r],s=this.storage_.get(i);this.isExpired_(s)?this.removeItem(i):e.push(s)}if(e.length>t){e=e.sort(function(e,t){return e.options.priority!=t.options.priority?t.options.priority-e.options.priority:t.lastAccessed-e.lastAccessed});while(e.length>t){var o=e.pop();this.removeItem(o.key)}}this.log_("Purged cached")},e.prototype.addItem_=function(e,t){var n=this;try{this.storage_.set(e.key,e)}catch(r){if(t)throw this.log_("Failed setting again, giving up: "+r.toString()),r;this.log_("Error adding item, purging and trying again: "+r.toString()),this.purge_(),this.addItem_(e,!0)}},e.prototype.removeItem=function(e){var t=this.storage_.remove(e);return this.log_("removed key "+e),t&&t.options&&t.options.callback&&setTimeout(function(){t.options.callback.call(null,t.key,t.value)},0),t?t.value:null},e.prototype.removeWhere=function(e){var t=this.storage_.keys();for(var n=0;n<t.length;n++){var r=t[n],i=this.storage_.get(r);e(r,i.value)===!0&&this.removeItem(r)}},e.prototype.size=function(){return this.storage_.size()},e.prototype.isExpired_=function(e){var t=(new Date).getTime(),n=!1;e.options.expirationAbsolute&&e.options.expirationAbsolute<t&&(n=!0);if(!n&&e.options.expirationSliding){var r=e.lastAccessed+e.options.expirationSliding*1e3;r<t&&(n=!0)}return n},e.prototype.log_=function(e){this.debug_&&console.log(e)};var t=this;typeof module!="undefined"&&module.exports?module.exports=e:typeof define=="function"&&define.amd?define("jscache",[],function(){return e}):t.Cache=e}(),function(){function _t(t,n){if(t!==n){var r=t===null,i=t===e,s=t===t,o=n===null,u=n===e,a=n===n;if(t>n&&!o||!s||r&&!u&&a||i&&a)return 1;if(t<n&&!r||!a||o&&!i&&s||u&&s)return-1}return 0}function Dt(e,t,n){var r=e.length,i=n?r:-1;while(n?i--:++i<r)if(t(e[i],i,e))return i;return-1}function Pt(e,t,n){if(t!==t)return Xt(e,n);var r=n-1,i=e.length;while(++r<i)if(e[r]===t)return r;return-1}function Ht(e){return typeof e=="function"||!1}function Bt(e){return e==null?"":e+""}function jt(e,t){var n=-1,r=e.length;while(++n<r&&t.indexOf(e.charAt(n))>-1);return n}function Ft(e,t){var n=e.length;while(n--&&t.indexOf(e.charAt(n))>-1);return n}function It(e,t){return _t(e.criteria,t.criteria)||e.index-t.index}function qt(e,t,n){var r=-1,i=e.criteria,s=t.criteria,o=i.length,u=n.length;while(++r<o){var a=_t(i[r],s[r]);if(a){if(r>=u)return a;var f=n[r];return a*(f==="asc"||f===!0?1:-1)}}return e.index-t.index}function Rt(e){return bt[e]}function Ut(e){return wt[e]}function zt(e,t,n){return t?e=xt[e]:n&&(e=Tt[e]),"\\"+e}function Wt(e){return"\\"+Tt[e]}function Xt(e,t,n){var r=e.length,i=t+(n?0:-1);while(n?i--:++i<r){var s=e[i];if(s!==s)return i}return-1}function Vt(e){return!!e&&typeof e=="object"}function $t(e){return e<=160&&e>=9&&e<=13||e==32||e==160||e==5760||e==6158||e>=8192&&(e<=8202||e==8232||e==8233||e==8239||e==8287||e==12288||e==65279)}function Jt(e,t){var n=-1,r=e.length,i=-1,s=[];while(++n<r)e[n]===t&&(e[n]=b,s[++i]=n);return s}function Kt(e,t){var n,r=-1,i=e.length,s=-1,o=[];while(++r<i){var u=e[r],a=t?t(u,r,e):u;if(!r||n!==a)n=a,o[++s]=u}return o}function Qt(e){var t=-1,n=e.length;while(++t<n&&$t(e.charCodeAt(t)));return t}function Gt(e){var t=e.length;while(t--&&$t(e.charCodeAt(t)));return t}function Yt(e){return Et[e]}function Zt(C){function Hn(e){if(Vt(e)&&!mu(e)&&!(e instanceof In)){if(e instanceof jn)return e;if($t.call(e,"__chain__")&&$t.call(e,"__wrapped__"))return gs(e)}return new jn(e)}function Bn(){}function jn(e,t,n){this.__wrapped__=e,this.__actions__=n||[],this.__chain__=!!t}function In(e){this.__wrapped__=e,this.__actions__=[],this.__dir__=1,this.__filtered__=!1,this.__iteratees__=[],this.__takeCount__=Ln,this.__views__=[]}function qn(){var e=new In(this.__wrapped__);return e.__actions__=Yn(this.__actions__),e.__dir__=this.__dir__,e.__filtered__=this.__filtered__,e.__iteratees__=Yn(this.__iteratees__),e.__takeCount__=this.__takeCount__,e.__views__=Yn(this.__views__),e}function Rn(){if(this.__filtered__){var e=new In(this);e.__dir__=-1,e.__filtered__=!0}else e=this.clone(),e.__dir__*=-1;return e}function Un(){var e=this.__wrapped__.value(),t=this.__dir__,n=mu(e),r=t<0,i=n?e.length:0,s=Ki(0,i,this.__views__),o=s.start,u=s.end,a=u-o,f=r?u:o-1,l=this.__iteratees__,c=l.length,h=0,p=xn(a,this.__takeCount__);if(!n||i<v||i==a&&p==a)return ii(r&&n?e.reverse():e,this.__actions__);var d=[];e:while(a--&&h<p){f+=t;var y=-1,b=e[f];while(++y<c){var w=l[y],E=w.iteratee,S=w.type,x=E(b);if(S==g)b=x;else if(!x){if(S==m)continue e;break e}}d[h++]=b}return d}function zn(){this.__data__={}}function Wn(e){return this.has(e)&&delete this.__data__[e]}function Xn(t){return t=="__proto__"?e:this.__data__[t]}function Vn(e){return e!="__proto__"&&$t.call(this.__data__,e)}function $n(e,t){return e!="__proto__"&&(this.__data__[e]=t),this}function Jn(e){var t=e?e.length:0;this.data={hash:gn(null),set:new cn};while(t--)this.push(e[t])}function Kn(e,t){var n=e.data,r=typeof t=="string"||Nu(t)?n.set.has(t):n.hash[t];return r?0:-1}function Qn(e){var t=this.data;typeof e=="string"||Nu(e)?t.set.add(e):t.hash[e]=!0}function Gn(e,t){var n=-1,r=e.length,i=-1,s=t.length,o=O(r+s);while(++n<r)o[n]=e[n];while(++i<s)o[n++]=t[i];return o}function Yn(e,t){var n=-1,r=e.length;t||(t=O(r));while(++n<r)t[n]=e[n];return t}function Zn(e,t){var n=-1,r=e.length;while(++n<r)if(t(e[n],n,e)===!1)break;return e}function er(e,t){var n=e.length;while(n--)if(t(e[n],n,e)===!1)break;return e}function tr(e,t){var n=-1,r=e.length;while(++n<r)if(!t(e[n],n,e))return!1;return!0}function nr(e,t,n,r){var i=-1,s=e.length,o=r,u=o;while(++i<s){var a=e[i],f=+t(a);n(f,o)&&(o=f,u=a)}return u}function rr(e,t){var n=-1,r=e.length,i=-1,s=[];while(++n<r){var o=e[n];t(o,n,e)&&(s[++i]=o)}return s}function ir(e,t){var n=-1,r=e.length,i=O(r);while(++n<r)i[n]=t(e[n],n,e);return i}function sr(e,t){var n=-1,r=t.length,i=e.length;while(++n<r)e[i+n]=t[n];return e}function or(e,t,n,r){var i=-1,s=e.length;r&&s&&(n=e[++i]);while(++i<s)n=t(n,e[i],i,e);return n}function ur(e,t,n,r){var i=e.length;r&&i&&(n=e[--i]);while(i--)n=t(n,e[i],i,e);return n}function ar(e,t){var n=-1,r=e.length;while(++n<r)if(t(e[n],n,e))return!0;return!1}function fr(e,t){var n=e.length,r=0;while(n--)r+=+t(e[n])||0;return r}function lr(t,n){return t===e?n:t}function cr(t,n,r,i){return t===e||!$t.call(i,r)?n:t}function hr(t,n,r){var i=-1,s=ta(n),o=s.length;while(++i<o){var u=s[i],a=t[u],f=r(a,n[u],u,t,n);if((f===f?f!==a:a===a)||a===e&&!(u in t))t[u]=f}return t}function pr(e,t){return t==null?e:vr(t,ta(t),e)}function dr(t,n){var r=-1,i=t==null,s=!i&&es(t),o=s?t.length:0,u=n.length,a=O(u);while(++r<u){var f=n[r];s?a[r]=ts(f,o)?t[f]:e:a[r]=i?e:t[f]}return a}function vr(e,t,n){n||(n={});var r=-1,i=t.length;while(++r<i){var s=t[r];n[s]=e[s]}return n}function mr(t,n,r){var i=typeof t;return i=="function"?n===e?t:ui(t,n,r):t==null?qa:i=="object"?qr(t):n===e?Ja(t):Rr(t,n)}function gr(t,n,r,i,s,o,u){var a;r&&(a=s?r(t,i,s):r(t));if(a!==e)return a;if(!Nu(t))return t;var f=mu(t);if(f){a=Qi(t);if(!n)return Yn(t,a)}else{var l=nn.call(t),c=l==N;if(!(l==L||l==w||c&&!s))return yt[l]?Yi(t,l,n):s?t:{};a=Gi(c?{}:t);if(!n)return pr(a,t)}o||(o=[]),u||(u=[]);var h=o.length;while(h--)if(o[h]==t)return u[h];return o.push(t),u.push(a),(f?Zn:_r)(t,function(e,i){a[i]=gr(e,n,r,i,t,o,u)}),a}function br(t,n,r){if(typeof t!="function")throw new Ct(y);return hn(function(){t.apply(e,r)},n)}function wr(e,t){var n=e?e.length:0,r=[];if(!n)return r;var i=-1,s=Xi(),o=s==Pt,u=o&&t.length>=v?mi(t):null,a=t.length;u&&(s=Kn,o=!1,t=u);e:while(++i<n){var f=e[i];if(o&&f===f){var l=a;while(l--)if(t[l]===f)continue e;r.push(f)}else s(t,f,0)<0&&r.push(f)}return r}function xr(e,t){var n=!0;return Er(e,function(e,r,i){return n=!!t(e,r,i),n}),n}function Tr(e,t,n,r){var i=r,s=i;return Er(e,function(e,o,u){var a=+t(e,o,u);if(n(a,i)||a===r&&a===s)i=a,s=e}),s}function Nr(t,n,r,i){var s=t.length;r=r==null?0:+r||0,r<0&&(r=-r>s?0:s+r),i=i===e||i>s?s:+i||0,i<0&&(i+=s),s=r>i?0:i>>>0,r>>>=0;while(r<s)t[r++]=n;return t}function Cr(e,t){var n=[];return Er(e,function(e,r,i){t(e,r,i)&&n.push(e)}),n}function kr(e,t,n,r){var i;return n(e,function(e,n,s){if(t(e,n,s))return i=r?n:e,!1}),i}function Lr(e,t,n,r){r||(r=[]);var i=-1,s=e.length;while(++i<s){var o=e[i];Vt(o)&&es(o)&&(n||mu(o)||vu(o))?t?Lr(o,t,n,r):sr(r,o):n||(r[r.length]=o)}return r}function Mr(e,t){return Ar(e,t,na)}function _r(e,t){return Ar(e,t,ta)}function Dr(e,t){return Or(e,t,ta)}function Pr(e,t){var n=-1,r=t.length,i=-1,s=[];while(++n<r){var o=t[n];Tu(e[o])&&(s[++i]=o)}return s}function Hr(t,n,r){if(t==null)return;r!==e&&r in vs(t)&&(n=[r]);var i=0,s=n.length;while(t!=null&&i<s)t=t[n[i++]];return i&&i==s?t:e}function Br(e,t,n,r,i,s){return e===t?!0:e==null||t==null||!Nu(e)&&!Vt(t)?e!==e&&t!==t:jr(e,t,Br,n,r,i,s)}function jr(e,t,n,r,i,s,o){var u=mu(e),a=mu(t),f=E,l=E;u||(f=nn.call(e),f==w?f=L:f!=L&&(u=Pu(e))),a||(l=nn.call(t),l==w?l=L:l!=L&&(a=Pu(t)));var c=f==L,h=l==L,p=f==l;if(p&&!u&&!c)return qi(e,t,f);if(!i){var d=c&&$t.call(e,"__wrapped__"),v=h&&$t.call(t,"__wrapped__");if(d||v)return n(d?e.value():e,v?t.value():t,r,i,s,o)}if(!p)return!1;s||(s=[]),o||(o=[]);var m=s.length;while(m--)if(s[m]==e)return o[m]==t;s.push(e),o.push(t);var g=(u?Ii:Ri)(e,t,n,r,i,s,o);return s.pop(),o.pop(),g}function Fr(t,n,r){var i=n.length,s=i,o=!r;if(t==null)return!s;t=vs(t);while(i--){var u=n[i];if(o&&u[2]?u[1]!==t[u[0]]:!(u[0]in t))return!1}while(++i<s){u=n[i];var a=u[0],f=t[a],l=u[1];if(o&&u[2]){if(f===e&&!(a in t))return!1}else{var c=r?r(f,l,a):e;if(c===e?!Br(l,f,r,!0):!c)return!1}}return!0}function Ir(e,t){var n=-1,r=es(e)?O(e.length):[];return Er(e,function(e,i,s){r[++n]=t(e,i,s)}),r}function qr(t){var n=$i(t);if(n.length==1&&n[0][2]){var r=n[0][0],i=n[0][1];return function(t){return t==null?!1:t[r]===i&&(i!==e||r in vs(t))}}return function(e){return Fr(e,n)}}function Rr(t,n){var r=mu(t),i=rs(t)&&os(n),s=t+"";return t=ms(t),function(o){if(o==null)return!1;var u=s;o=vs(o);if((r||!i)&&!(u in o)){o=t.length==1?o:Hr(o,Qr(t,0,-1));if(o==null)return!1;u=Ps(t),o=vs(o)}return o[u]===n?n!==e||u in o:Br(n,o[u],e,!0)}}function Ur(t,n,r,i,s){if(!Nu(t))return t;var o=es(n)&&(mu(n)||Pu(n)),u=o?e:ta(n);return Zn(u||n,function(a,f){u&&(f=a,a=n[f]);if(Vt(a))i||(i=[]),s||(s=[]),zr(t,n,f,Ur,r,i,s);else{var l=t[f],c=r?r(l,a,f,t,n):e,h=c===e;h&&(c=a),(c!==e||o&&!(f in t))&&(h||(c===c?c!==l:l===l))&&(t[f]=c)}}),t}function zr(t,n,r,i,s,o,u){var a=o.length,f=n[r];while(a--)if(o[a]==f){t[r]=u[a];return}var l=t[r],c=s?s(l,f,r,t,n):e,h=c===e;h&&(c=f,es(f)&&(mu(f)||Pu(f))?c=mu(l)?l:es(l)?Yn(l):[]:Mu(f)||vu(f)?c=vu(l)?Iu(l):Mu(l)?l:{}:h=!1),o.push(f),u.push(c);if(h)t[r]=i(c,f,s,o,u);else if(c===c?c!==l:l===l)t[r]=c}function Wr(t){return function(n){return n==null?e:n[t]}}function Xr(e){var t=e+"";return e=ms(e),function(n){return Hr(n,e,t)}}function Vr(e,t){var n=e?t.length:0;while(n--){var r=t[n];if(r!=i&&ts(r)){var i=r;pn.call(e,r,1)}}return e}function $r(e,t){return e+yn(Cn()*(t-e+1))}function Jr(e,t,n,r,i){return i(e,function(e,i,s){n=r?(r=!1,e):t(n,e,i,s)}),n}function Qr(t,n,r){var i=-1,s=t.length;n=n==null?0:+n||0,n<0&&(n=-n>s?0:s+n),r=r===e||r>s?s:+r||0,r<0&&(r+=s),s=n>r?0:r-n>>>0,n>>>=0;var o=O(s);while(++i<s)o[i]=t[i+n];return o}function Gr(e,t){var n;return Er(e,function(e,r,i){return n=t(e,r,i),!n}),!!n}function Yr(e,t){var n=e.length;e.sort(t);while(n--)e[n]=e[n].value;return e}function Zr(e,t,n){var r=Ui(),i=-1;t=ir(t,function(e){return r(e)});var s=Ir(e,function(e){var n=ir(t,function(t){return t(e)});return{criteria:n,index:++i,value:e}});return Yr(s,function(e,t){return qt(e,t,n)})}function ei(e,t){var n=0;return Er(e,function(e,r,i){n+=+t(e,r,i)||0}),n}function ti(e,t){var n=-1,r=Xi(),i=e.length,s=r==Pt,o=s&&i>=v,u=o?mi():null,a=[];u?(r=Kn,s=!1):(o=!1,u=t?[]:a);e:while(++n<i){var f=e[n],l=t?t(f,n,e):f;if(s&&f===f){var c=u.length;while(c--)if(u[c]===l)continue e;t&&u.push(l),a.push(f)}else r(u,l,0)<0&&((t||o)&&u.push(l),a.push(f))}return a}function ni(e,t){var n=-1,r=t.length,i=O(r);while(++n<r)i[n]=e[t[n]];return i}function ri(e,t,n,r){var i=e.length,s=r?i:-1;while((r?s--:++s<i)&&t(e[s],s,e));return n?Qr(e,r?0:s,r?s+1:i):Qr(e,r?s+1:0,r?i:s)}function ii(e,t){var n=e;n instanceof In&&(n=n.value());var r=-1,i=t.length;while(++r<i){var s=t[r];n=s.func.apply(s.thisArg,sr([n],s.args))}return n}function si(e,t,n){var r=0,i=e?e.length:r;if(typeof t=="number"&&t===t&&i<=Mn){while(r<i){var s=r+i>>>1,o=e[s];(n?o<=t:o<t)&&o!==null?r=s+1:i=s}return i}return oi(e,t,qa,n)}function oi(t,n,r,i){n=r(n);var s=0,o=t?t.length:0,u=n!==n,a=n===null,f=n===e;while(s<o){var l=yn((s+o)/2),c=r(t[l]),h=c!==e,p=c===c;if(u)var d=p||i;else a?d=p&&h&&(i||c!=null):f?d=p&&(i||h):c==null?d=!1:d=i?c<=n:c<n;d?s=l+1:o=l}return xn(o,On)}function ui(t,n,r){if(typeof t!="function")return qa;if(n===e)return t;switch(r){case 1:return function(e){return t.call(n,e)};case 3:return function(e,r,i){return t.call(n,e,r,i)};case 4:return function(e,r,i,s){return t.call(n,e,r,i,s)};case 5:return function(e,r,i,s,o){return t.call(n,e,r,i,s,o)}}return function(){return t.apply(n,arguments)}}function ai(e){var t=new on(e.byteLength),n=new dn(t);return n.set(new dn(e)),t}function fi(e,t,n){var r=n.length,i=-1,s=Sn(e.length-r,0),o=-1,u=t.length,a=O(u+s);while(++o<u)a[o]=t[o];while(++i<r)a[n[i]]=e[i];while(s--)a[o++]=e[i++];return a}function li(e,t,n){var r=-1,i=n.length,s=-1,o=Sn(e.length-i,0),u=-1,a=t.length,f=O(o+a);while(++s<o)f[s]=e[s];var l=s;while(++u<a)f[l+u]=t[u];while(++r<i)f[l+n[r]]=e[s++];return f}function ci(e,t){return function(n,r,i){var s=t?t():{};r=Ui(r,i,3);if(mu(n)){var o=-1,u=n.length;while(++o<u){var a=n[o];e(s,a,r(a,o,n),n)}}else Er(n,function(t,n,i){e(s,t,r(t,n,i),i)});return s}}function hi(t){return uu(function(n,r){var i=-1,s=n==null?0:r.length,o=s>2?r[s-2]:e,u=s>2?r[2]:e,a=s>1?r[s-1]:e;typeof o=="function"?(o=ui(o,a,5),s-=2):(o=typeof a=="function"?a:e,s-=o?1:0),u&&ns(r[0],r[1],u)&&(o=s<3?e:o,s=1);while(++i<s){var f=r[i];f&&t(n,f,o)}return n})}function pi(e,t){return function(n,r){var i=n?Vi(n):0;if(!ss(i))return e(n,r);var s=t?i:-1,o=vs(n);while(t?s--:++s<i)if(r(o[s],s,o)===!1)break;return n}}function di(e){return function(t,n,r){var i=vs(t),s=r(t),o=s.length,u=e?o:-1;while(e?u--:++u<o){var a=s[u];if(n(i[a],a,i)===!1)break}return t}}function vi(e,t){function r(){var i=this&&this!==Mt&&this instanceof r?n:e;return i.apply(t,arguments)}var n=yi(e);return r}function mi(e){return gn&&cn?new Jn(e):null}function gi(e){return function(t){var n=-1,r=Ba(ga(t)),i=r.length,s="";while(++n<i)s=e(s,r[n],n);return s}}function yi(e){return function(){var t=arguments;switch(t.length){case 0:return new e;case 1:return new e(t[0]);case 2:return new e(t[0],t[1]);case 3:return new e(t[0],t[1],t[2]);case 4:return new e(t[0],t[1],t[2],t[3]);case 5:return new e(t[0],t[1],t[2],t[3],t[4]);case 6:return new e(t[0],t[1],t[2],t[3],t[4],t[5]);case 7:return new e(t[0],t[1],t[2],t[3],t[4],t[5],t[6])}var n=yr(e.prototype),r=e.apply(n,t);return Nu(r)?r:n}}function bi(t){function n(r,i,s){s&&ns(r,i,s)&&(i=e);var o=Fi(r,t,e,e,e,e,e,i);return o.placeholder=n.placeholder,o}return n}function wi(t,n){return uu(function(r){var i=r[0];return i==null?i:(r.push(n),t.apply(e,r))})}function Ei(t,n){return function(r,i,s){s&&ns(r,i,s)&&(i=e),i=Ui(i,s,3);if(i.length==1){r=mu(r)?r:ds(r);var o=nr(r,i,t,n);if(!r.length||o!==n)return o}return Tr(r,i,t,n)}}function Si(t,n){return function(r,i,s){i=Ui(i,s,3);if(mu(r)){var o=Dt(r,i,n);return o>-1?r[o]:e}return kr(r,i,t)}}function xi(e){return function(t,n,r){return!t||!t.length?-1:(n=Ui(n,r,3),Dt(t,n,e))}}function Ti(e){return function(t,n,r){return n=Ui(n,r,3),kr(t,n,e,!0)}}function Ni(t){return function(){var n,r=arguments.length,i=t?r:-1,o=0,a=O(r);while(t?i--:++i<r){var c=a[o++]=arguments[i];if(typeof c!="function")throw new Ct(y);!n&&jn.prototype.thru&&Wi(c)=="wrapper"&&(n=new jn([],!0))}i=n?-1:r;while(++i<r){c=a[i];var h=Wi(c),p=h=="wrapper"?zi(c):e;p&&is(p[0])&&p[1]==(f|s|u|l)&&!p[4].length&&p[9]==1?n=n[Wi(p[0])].apply(n,p[3]):n=c.length==1&&is(c)?n[h]():n.thru(c)}return function(){var e=arguments,t=e[0];if(n&&e.length==1&&mu(t)&&t.length>=v)return n.plant(t).value();var i=0,s=r?a[i].apply(this,e):t;while(++i<r)s=a[i].call(this,s);return s}}}function Ci(t,n){return function(r,i,s){return typeof i=="function"&&s===e&&mu(r)?t(r,i):n(r,ui(i,s,3))}}function ki(t){return function(n,r,i){if(typeof r!="function"||i!==e)r=ui(r,i,3);return t(n,r,na)}}function Li(t){return function(n,r,i){if(typeof r!="function"||i!==e)r=ui(r,i,3);return t(n,r)}}function Ai(e){return function(t,n,r){var i={};return n=Ui(n,r,3),_r(t,function(t,r,s){var o=n(t,r,s);r=e?o:r,t=e?t:o,i[r]=t}),i}}function Oi(e){return function(t,n,r){return t=Bt(t),(e?t:"")+Pi(t,n,r)+(e?"":t)}}function Mi(t){var n=uu(function(r,i){var s=Jt(i,n.placeholder);return Fi(r,t,e,i,s)});return n}function _i(t,n){return function(r,i,s,o){var u=arguments.length<3;return typeof i=="function"&&o===e&&mu(r)?t(r,i,s,u):Jr(r,Ui(i,o,4),s,u,n)}}function Di(t,l,c,h,p,d,v,m,g,y){function C(){var i=arguments.length,s=i,o=O(i);while(s--)o[s]=arguments[s];h&&(o=fi(o,h,p)),d&&(o=li(o,d,v));if(S||T){var f=C.placeholder,k=Jt(o,f);i-=k.length;if(i<y){var L=m?Yn(m):e,A=Sn(y-i,0),M=S?k:e,_=S?e:k,D=S?o:e,P=S?e:o;l|=S?u:a,l&=~(S?a:u),x||(l&=~(n|r));var H=[t,l,c,D,M,P,_,L,g,A],B=Di.apply(e,H);return is(t)&&hs(B,H),B.placeholder=f,B}}var j=w?c:this,F=E?j[t]:t;return m&&(o=cs(o,m)),b&&g<o.length&&(o.length=g),this&&this!==Mt&&this instanceof C&&(F=N||yi(t)),F.apply(j,o)}var b=l&f,w=l&n,E=l&r,S=l&s,x=l&i,T=l&o,N=E?e:yi(t);return C}function Pi(e,t,n){var r=e.length;t=+t;if(r>=t||!wn(t))return"";var i=t-r;return n=n==null?" ":n+"",Ca(n,mn(i/n.length)).slice(0,i)}function Hi(e,t,r,i){function u(){var t=-1,n=arguments.length,a=-1,f=i.length,l=O(f+n);while(++a<f)l[a]=i[a];while(n--)l[a++]=arguments[++t];var c=this&&this!==Mt&&this instanceof u?o:e;return c.apply(s?r:this,l)}var s=t&n,o=yi(e);return u}function Bi(t){var n=Et[t];return function(t,r){return r=r===e?0:+r||0,r?(r=fn(10,r),n(t*r)/r):n(t)}}function ji(e){return function(t,n,r,i){var s=Ui(r);return r==null&&s===mr?si(t,n,e):oi(t,n,s(r,i,1),e)}}function Fi(t,i,s,o,f,l,c,h){var p=i&r;if(!p&&typeof t!="function")throw new Ct(y);var d=o?o.length:0;d||(i&=~(u|a),o=f=e),d-=f?f.length:0;if(i&a){var v=o,m=f;o=f=e}var g=p?e:zi(t),b=[t,i,s,o,f,v,m,l,c,h];g&&(us(b,g),i=b[1],h=b[9]),b[9]=h==null?p?0:t.length:Sn(h-d,0)||0;if(i==n)var w=vi(b[0],b[2]);else i!=u&&i!=(n|u)||!!b[4].length?w=Di.apply(e,b):w=Hi.apply(e,b);var E=g?Kr:hs;return E(w,b)}function Ii(t,n,r,i,s,o,u){var a=-1,f=t.length,l=n.length;if(f!=l&&!(s&&l>f))return!1;while(++a<f){var c=t[a],h=n[a],p=i?i(s?h:c,s?c:h,a):e;if(p!==e){if(p)continue;return!1}if(s){if(!ar(n,function(e){return c===e||r(c,e,i,s,o,u)}))return!1}else if(c!==h&&!r(c,h,i,s,o,u))return!1}return!0}function qi(e,t,n){switch(n){case S:case x:return+e==+t;case T:return e.name==t.name&&e.message==t.message;case k:return e!=+e?t!=+t:e==+t;case A:case M:return e==t+""}return!1}function Ri(t,n,r,i,s,o,u){var a=ta(t),f=a.length,l=ta(n),c=l.length;if(f!=c&&!s)return!1;var h=f;while(h--){var p=a[h];if(!(s?p in n:$t.call(n,p)))return!1}var d=s;while(++h<f){p=a[h];var v=t[p],m=n[p],g=i?i(s?m:v,s?v:m,p):e;if(g===e?!r(v,m,i,s,o,u):!g)return!1;d||(d=p=="constructor")}if(!d){var y=t.constructor,b=n.constructor;if(y!=b&&"constructor"in t&&"constructor"in n&&!(typeof y=="function"&&y instanceof y&&typeof b=="function"&&b instanceof b))return!1}return!0}function Ui(e,t,n){var r=Hn.callback||Fa;return r=r===Fa?mr:r,n?r(e,t,n):r}function Wi(e){var t=e.name,n=Pn[t],r=n?n.length:0;while(r--){var i=n[r],s=i.func;if(s==null||s==e)return i.name}return t}function Xi(e,t,n){var r=Hn.indexOf||Ms;return r=r===Ms?Pt:r,e?r(e,t,n):r}function $i(e){var t=oa(e),n=t.length;while(n--)t[n][2]=os(t[n][1]);return t}function Ji(t,n){var r=t==null?e:t[n];return Lu(r)?r:e}function Ki(e,t,n){var r=-1,i=n.length;while(++r<i){var s=n[r],o=s.size;switch(s.type){case"drop":e+=o;break;case"dropRight":t-=o;break;case"take":t=xn(t,e+o);break;case"takeRight":e=Sn(e,t-o)}}return{start:e,end:t}}function Qi(e){var t=e.length,n=new e.constructor(t);return t&&typeof e[0]=="string"&&$t.call(e,"index")&&(n.index=e.index,n.input=e.input),n}function Gi(e){var t=e.constructor;return typeof t=="function"&&t instanceof t||(t=xt),new t}function Yi(e,t,n){var r=e.constructor;switch(t){case D:return ai(e);case S:case x:return new r(+e);case P:case H:case B:case j:case F:case I:case q:case R:case U:var i=e.buffer;return new r(n?ai(i):i,e.byteOffset,e.length);case k:case M:return new r(e);case A:var s=new r(e.source,ut.exec(e));s.lastIndex=e.lastIndex}return s}function Zi(t,n,r){t!=null&&!rs(n,t)&&(n=ms(n),t=n.length==1?t:Hr(t,Qr(n,0,-1)),n=Ps(n));var i=t==null?t:t[n];return i==null?e:i.apply(t,r)}function es(e){return e!=null&&ss(Vi(e))}function ts(e,t){return e=typeof e=="number"||lt.test(e)?+e:-1,t=t==null?_n:t,e>-1&&e%1==0&&e<t}function ns(e,t,n){if(!Nu(n))return!1;var r=typeof t;if(r=="number"?es(n)&&ts(t,n.length):r=="string"&&t in n){var i=n[t];return e===e?e===i:i!==i}return!1}function rs(e,t){var n=typeof e;if(n=="string"&&et.test(e)||n=="number")return!0;if(mu(e))return!1;var r=!Z.test(e);return r||t!=null&&e in vs(t)}function is(e){var t=Wi(e);if(t in In.prototype){var n=Hn[t];if(e===n)return!0;var r=zi(n);return!!r&&e===r[0]}return!1}function ss(e){return typeof e=="number"&&e>-1&&e%1==0&&e<=_n}function os(e){return e===e&&!Nu(e)}function us(e,t){var r=e[1],o=t[1],u=r|o,a=u<f,c=o==f&&r==s||o==f&&r==l&&e[7].length<=t[8]||o==(f|l)&&r==s;if(!a&&!c)return e;o&n&&(e[2]=t[2],u|=r&n?0:i);var h=t[3];if(h){var p=e[3];e[3]=p?fi(p,h,t[4]):Yn(h),e[4]=p?Jt(e[3],b):Yn(t[4])}return h=t[5],h&&(p=e[5],e[5]=p?li(p,h,t[6]):Yn(h),e[6]=p?Jt(e[5],b):Yn(t[6])),h=t[7],h&&(e[7]=Yn(h)),o&f&&(e[8]=e[8]==null?t[8]:xn(e[8],t[8])),e[9]==null&&(e[9]=t[9]),e[0]=t[0],e[1]=u,e}function as(t,n){return t===e?n:qu(t,n,as)}function fs(e,t){e=vs(e);var n=-1,r=t.length,i={};while(++n<r){var s=t[n];s in e&&(i[s]=e[s])}return i}function ls(e,t){var n={};return Mr(e,function(e,r,i){t(e,r,i)&&(n[r]=e)}),n}function cs(t,n){var r=t.length,i=xn(n.length,r),s=Yn(t);while(i--){var o=n[i];t[i]=ts(o,r)?s[o]:e}return t}function ps(e){var t=na(e),n=t.length,r=n&&e.length,i=!!r&&ss(r)&&(mu(e)||vu(e)),s=-1,o=[];while(++s<n){var u=t[s];(i&&ts(u,r)||$t.call(e,u))&&o.push(u)}return o}function ds(e){return e==null?[]:es(e)?Nu(e)?e:xt(e):ca(e)}function vs(e){return Nu(e)?e:xt(e)}function ms(e){if(mu(e))return e;var t=[];return Bt(e).replace(tt,function(e,n,r,i){t.push(r?i.replace(st,"$1"):n||e)}),t}function gs(e){return e instanceof In?e.clone():new jn(e.__wrapped__,e.__chain__,Yn(e.__actions__))}function ys(e,t,n){(n?ns(e,t,n):t==null)?t=1:t=Sn(yn(t)||1,1);var r=0,i=e?e.length:0,s=-1,o=O(mn(i/t));while(r<i)o[++s]=Qr(e,r,r+=t);return o}function bs(e){var t=-1,n=e?e.length:0,r=-1,i=[];while(++t<n){var s=e[t];s&&(i[++r]=s)}return i}function Es(e,t,n){var r=e?e.length:0;if(!r)return[];if(n?ns(e,t,n):t==null)t=1;return Qr(e,t<0?0:t)}function Ss(e,t,n){var r=e?e.length:0;if(!r)return[];if(n?ns(e,t,n):t==null)t=1;return t=r-(+t||0),Qr(e,0,t<0?0:t)}function xs(e,t,n){return e&&e.length?ri(e,Ui(t,n,3),!0,!0):[]}function Ts(e,t,n){return e&&e.length?ri(e,Ui(t,n,3),!0):[]}function Ns(e,t,n,r){var i=e?e.length:0;return i?(n&&typeof n!="number"&&ns(e,t,n)&&(n=0,r=i),Nr(e,t,n,r)):[]}function Ls(t){return t?t[0]:e}function As(e,t,n){var r=e?e.length:0;return n&&ns(e,t,n)&&(t=!1),r?Lr(e,t):[]}function Os(e){var t=e?e.length:0;return t?Lr(e,!0):[]}function Ms(e,t,n){var r=e?e.length:0;if(!r)return-1;if(typeof n=="number")n=n<0?Sn(r+n,0):n;else if(n){var i=si(e,t);return i<r&&(t===t?t===e[i]:e[i]!==e[i])?i:-1}return Pt(e,t,n||0)}function _s(e){return Ss(e,1)}function Ps(t){var n=t?t.length:0;return n?t[n-1]:e}function Hs(e,t,n){var r=e?e.length:0;if(!r)return-1;var i=r;if(typeof n=="number")i=(n<0?Sn(r+n,0):xn(n||0,r-1))+1;else if(n){i=si(e,t,!0)-1;var s=e[i];return(t===t?t===s:s!==s)?i:-1}if(t!==t)return Xt(e,i,!0);while(i--)if(e[i]===t)return i;return-1}function Bs(){var e=arguments,t=e[0];if(!t||!t.length)return t;var n=0,r=Xi(),i=e.length;while(++n<i){var s=0,o=e[n];while((s=r(t,o,s))>-1)pn.call(t,s,1)}return t}function Fs(e,t,n){var r=[];if(!e||!e.length)return r;var i=-1,s=[],o=e.length;t=Ui(t,n,3);while(++i<o){var u=e[i];t(u,i,e)&&(r.push(u),s.push(i))}return Vr(e,s),r}function Is(e){return Es(e,1)}function qs(e,t,n){var r=e?e.length:0;return r?(n&&typeof n!="number"&&ns(e,t,n)&&(t=0,n=r),Qr(e,t,n)):[]}function zs(e,t,n){var r=e?e.length:0;if(!r)return[];if(n?ns(e,t,n):t==null)t=1;return Qr(e,0,t<0?0:t)}function Ws(e,t,n){var r=e?e.length:0;if(!r)return[];if(n?ns(e,t,n):t==null)t=1;return t=r-(+t||0),Qr(e,t<0?0:t)}function Xs(e,t,n){return e&&e.length?ri(e,Ui(t,n,3),!1,!0):[]}function Vs(e,t,n){return e&&e.length?ri(e,Ui(t,n,3)):[]}function Js(t,n,r,i){var s=t?t.length:0;if(!s)return[];n!=null&&typeof n!="boolean"&&(i=r,r=ns(t,n,i)?e:n,n=!1);var o=Ui();if(r!=null||o!==mr)r=o(r,i,3);return n&&Xi()==Pt?Kt(t,r):ti(t,r)}function Ks(e){if(!e||!e.length)return[];var t=-1,n=0;e=rr(e,function(e){if(es(e))return n=Sn(e.length,n),!0});var r=O(n);while(++t<n)r[t]=ir(e,Wr(t));return r}function Qs(t,n,r){var i=t?t.length:0;if(!i)return[];var s=Ks(t);return n==null?s:(n=ui(n,r,4),ir(s,function(t){return or(t,n,e,!0)}))}function Ys(){var e=-1,t=arguments.length;while(++e<t){var n=arguments[e];if(es(n))var r=r?sr(wr(r,n),wr(n,r)):n}return r?ti(r):[]}function eo(e,t){var n=-1,r=e?e.length:0,i={};r&&!t&&!mu(e[0])&&(t=[]);while(++n<r){var s=e[n];t?i[s]=t[n]:s&&(i[s[0]]=s[1])}return i}function no(e){var t=Hn(e);return t.__chain__=!0,t}function ro(e,t,n){return t.call(n,e),e}function io(e,t,n){return t.call(n,e)}function so(){return no(this)}function oo(){return new jn(this.value(),this.__chain__)}function ao(e){var t,n=this;while(n instanceof Bn){var r=gs(n);t?i.__wrapped__=r:t=r;var i=r;n=n.__wrapped__}return i.__wrapped__=e,t}function fo(){var t=this.__wrapped__,n=function(e){return r&&r.__dir__<0?e:e.reverse()};if(t instanceof In){var r=t;return this.__actions__.length&&(r=new In(this)),r=r.reverse(),r.__actions__.push({func:io,args:[n],thisArg:e}),new jn(r,this.__chain__)}return this.thru(n)}function lo(){return this.value()+""}function co(){return ii(this.__wrapped__,this.__actions__)}function vo(t,n,r){var i=mu(t)?tr:xr;r&&ns(t,n,r)&&(n=e);if(typeof n!="function"||r!==e)n=Ui(n,r,3);return i(t,n)}function mo(e,t,n){var r=mu(e)?rr:Cr;return t=Ui(t,n,3),r(e,t)}function bo(e,t){return go(e,qr(t))}function xo(e,t,n,r){var i=e?Vi(e):0;return ss(i)||(e=ca(e),i=e.length),typeof n!="number"||r&&ns(t,n,r)?n=0:n=n<0?Sn(i+n,0):n||0,typeof e=="string"||!mu(e)&&Du(e)?n<=i&&e.indexOf(t,n)>-1:!!i&&Xi(e,t,n)>-1}function Co(e,t,n){var r=mu(e)?ir:Ir;return t=Ui(t,n,3),r(e,t)}function Lo(e,t){return Co(e,Ja(t))}function Mo(e,t,n){var r=mu(e)?rr:Cr;return t=Ui(t,n,3),r(e,function(e,n,r){return!t(e,n,r)})}function _o(t,n,r){if(r?ns(t,n,r):n==null){t=ds(t);var i=t.length;return i>0?t[$r(0,i-1)]:e}var s=-1,o=Fu(t),i=o.length,u=i-1;n=xn(n<0?0:+n||0,i);while(++s<n){var a=$r(s,u),f=o[a];o[a]=o[s],o[s]=f}return o.length=n,o}function Do(e){return _o(e,Ln)}function Po(e){var t=e?Vi(e):0;return ss(t)?t:ta(e).length}function Ho(t,n,r){var i=mu(t)?ar:Gr;r&&ns(t,n,r)&&(n=e);if(typeof n!="function"||r!==e)n=Ui(n,r,3);return i(t,n)}function Bo(t,n,r){if(t==null)return[];r&&ns(t,n,r)&&(n=e);var i=-1;n=Ui(n,r,3);var s=Ir(t,function(e,t,r){return{criteria:n(e,t,r),index:++i,value:e}});return Yr(s,It)}function Fo(t,n,r,i){return t==null?[]:(i&&ns(n,r,i)&&(r=e),mu(n)||(n=n==null?[]:[n]),mu(r)||(r=r==null?[]:[r]),Zr(t,n,r))}function Io(e,t){return mo(e,qr(t))}function Ro(e,t){if(typeof t!="function"){if(typeof e!="function")throw new Ct(y);var n=e;e=t,t=n}return e=wn(e=+e)?e:0,function(){if(--e<1)return t.apply(this,arguments)}}function Uo(t,n,r){return r&&ns(t,n,r)&&(n=e),n=t&&n==null?t.length:Sn(+n||0,0),Fi(t,f,e,e,e,e,n)}function zo(t,n){var r;if(typeof n!="function"){if(typeof t!="function")throw new Ct(y);var i=t;t=n,n=i}return function(){return--t>0&&(r=n.apply(this,arguments)),t<=1&&(n=e),r}}function Ko(t,n,r){function v(){f&&un(f),s&&un(s),c=0,s=f=l=e}function m(n,r){r&&un(r),s=f=l=e,n&&(c=qo(),o=t.apply(a,i),!f&&!s&&(i=a=e))}function g(){var e=n-(qo()-u);e<=0||e>n?m(l,s):f=hn(g,e)}function b(){m(p,f)}function w(){i=arguments,u=qo(),a=this,l=p&&(f||!d);if(h===!1)var r=d&&!f;else{!s&&!d&&(c=u);var v=h-(u-c),m=v<=0||v>h;m?(s&&(s=un(s)),c=u,o=t.apply(a,i)):s||(s=hn(b,v))}return m&&f?f=un(f):!f&&n!==h&&(f=hn(g,n)),r&&(m=!0,o=t.apply(a,i)),m&&!f&&!s&&(i=a=e),o}var i,s,o,u,a,f,l,c=0,h=!1,p=!0;if(typeof t!="function")throw new Ct(y);n=n<0?0:+n||0;if(r===!0){var d=!0;p=!1}else Nu(r)&&(d=!!r.leading,h="maxWait"in r&&Sn(+r.maxWait||0,n),p="trailing"in r?!!r.trailing:p);return w.cancel=v,w}function eu(e,t){if(typeof e!="function"||t&&typeof t!="function")throw new Ct(y);var n=function(){var r=arguments,i=t?t.apply(this,r):r[0],s=n.cache;if(s.has(i))return s.get(i);var o=e.apply(this,r);return n.cache=s.set(i,o),o};return n.cache=new eu.Cache,n}function nu(e){if(typeof e!="function")throw new Ct(y);return function(){return!e.apply(this,arguments)}}function ru(e){return zo(2,e)}function uu(t,n){if(typeof t!="function")throw new Ct(y);return n=Sn(n===e?t.length-1:+n||0,0),function(){var e=arguments,r=-1,i=Sn(e.length-n,0),s=O(i);while(++r<i)s[r]=e[n+r];switch(n){case 0:return t.call(this,s);case 1:return t.call(this,e[0],s);case 2:return t.call(this,e[0],e[1],s)}var o=O(n+1);r=-1;while(++r<n)o[r]=e[r];return o[n]=s,t.apply(this,o)}}function au(e){if(typeof e!="function")throw new Ct(y);return function(t){return e.apply(this,t)}}function fu(e,t,n){var r=!0,i=!0;if(typeof e!="function")throw new Ct(y);return n===!1?r=!1:Nu(n)&&(r="leading"in n?!!n.leading:r,i="trailing"in n?!!n.trailing:i),Ko(e,t,{leading:r,maxWait:+t,trailing:i})}function lu(t,n){return n=n==null?qa:n,Fi(n,u,e,[t],[])}function cu(e,t,n,r){return t&&typeof t!="boolean"&&ns(e,t,n)?t=!1:typeof t=="function"&&(r=n,n=t,t=!1),typeof n=="function"?gr(e,t,ui(n,r,1)):gr(e,t)}function hu(e,t,n){return typeof t=="function"?gr(e,!0,ui(t,n,1)):gr(e,!0)}function pu(e,t){return e>t}function du(e,t){return e>=t}function vu(e){return Vt(e)&&es(e)&&$t.call(e,"callee")&&!ln.call(e,"callee")}function gu(e){return e===!0||e===!1||Vt(e)&&nn.call(e)==S}function yu(e){return Vt(e)&&nn.call(e)==x}function bu(e){return!!e&&e.nodeType===1&&Vt(e)&&!Mu(e)}function wu(e){return e==null?!0:es(e)&&(mu(e)||Du(e)||vu(e)||Vt(e)&&Tu(e.splice))?!e.length:!ta(e).length}function Eu(t,n,r,i){r=typeof r=="function"?ui(r,i,3):e;var s=r?r(t,n):e;return s===e?Br(t,n,r):!!s}function Su(e){return Vt(e)&&typeof e.message=="string"&&nn.call(e)==T}function xu(e){return typeof e=="number"&&wn(e)}function Tu(e){return Nu(e)&&nn.call(e)==N}function Nu(e){var t=typeof e;return!!e&&(t=="object"||t=="function")}function Cu(t,n,r,i){return r=typeof r=="function"?ui(r,i,3):e,Fr(t,$i(n),r)}function ku(e){return Ou(e)&&e!=+e}function Lu(e){return e==null?!1:Tu(e)?sn.test(Ot.call(e)):Vt(e)&&ft.test(e)}function Au(e){return e===null}function Ou(e){return typeof e=="number"||Vt(e)&&nn.call(e)==k}function Mu(t){var n;if(!Vt(t)||nn.call(t)!=L||!!vu(t)||!$t.call(t,"constructor")&&(n=t.constructor,typeof n=="function"&&!(n instanceof n)))return!1;var r;return Mr(t,function(e,t){r=t}),r===e||$t.call(t,r)}function _u(e){return Nu(e)&&nn.call(e)==A}function Du(e){return typeof e=="string"||Vt(e)&&nn.call(e)==M}function Pu(e){return Vt(e)&&ss(e.length)&&!!gt[nn.call(e)]}function Hu(t){return t===e}function Bu(e,t){return e<t}function ju(e,t){return e<=t}function Fu(e){var t=e?Vi(e):0;return ss(t)?t?Yn(e):[]:ca(e)}function Iu(e){return vr(e,na(e))}function Uu(t,n,r){var i=yr(t);return r&&ns(t,n,r)&&(n=e),n?pr(i,n):i}function Gu(e){return Pr(e,na(e))}function Yu(t,n,r){var i=t==null?e:Hr(t,ms(n),n+"");return i===e?r:i}function Zu(e,t){if(e==null)return!1;var n=$t.call(e,t);if(!n&&!rs(t)){t=ms(t),e=t.length==1?e:Hr(e,Qr(t,0,-1));if(e==null)return!1;t=Ps(t),n=$t.call(e,t)}return n||ss(e.length)&&ts(t,e.length)&&(mu(e)||vu(e))}function ea(t,n,r){r&&ns(t,n,r)&&(n=e);var i=-1,s=ta(t),o=s.length,u={};while(++i<o){var a=s[i],f=t[a];n?$t.call(u,f)?u[f].push(a):u[f]=[a]:u[f]=a}return u}function na(e){if(e==null)return[];Nu(e)||(e=xt(e));var t=e.length;t=t&&ss(t)&&(mu(e)||vu(e))&&t||0;var n=e.constructor,r=-1,i=typeof n=="function"&&n.prototype===e,s=O(t),o=t>0;while(++r<t)s[r]=r+"";for(var u in e)(!o||!ts(u,t))&&(u!="constructor"||!i&&!!$t.call(e,u))&&s.push(u);return s}function oa(e){e=vs(e);var t=-1,n=ta(e),r=n.length,i=O(r);while(++t<r){var s=n[t];i[t]=[s,e[s]]}return i}function aa(t,n,r){var i=t==null?e:t[n];return i===e&&(t!=null&&!rs(n,t)&&(n=ms(n),t=n.length==1?t:Hr(t,Qr(n,0,-1)),i=t==null?e:t[Ps(n)]),i=i===e?r:i),Tu(i)?i.call(t):i}function fa(e,t,n){if(e==null)return e;var r=t+"";t=e[r]!=null||rs(t,e)?[r]:ms(t);var i=-1,s=t.length,o=s-1,u=e;while(u!=null&&++i<s){var a=t[i];Nu(u)&&(i==o?u[a]=n:u[a]==null&&(u[a]=ts(t[i+1])?[]:{})),u=u[a]}return e}function la(t,n,r,i){var s=mu(t)||Pu(t);n=Ui(n,i,4);if(r==null)if(s||Nu(t)){var o=t.constructor;s?r=mu(t)?new o:[]:r=yr(Tu(o)?o.prototype:e)}else r={};return(s?Zn:_r)(t,function(e,t,i){return n(r,e,t,i)}),r}function ca(e){return ni(e,ta(e))}function ha(e){return ni(e,na(e))}function pa(t,n,r){return n=+n||0,r===e?(r=n,n=0):r=+r||0,t>=xn(n,r)&&t<Sn(n,r)}function da(t,n,r){r&&ns(t,n,r)&&(n=r=e);var i=t==null,s=n==null;r==null&&(s&&typeof t=="boolean"?(r=t,t=1):typeof n=="boolean"&&(r=n,s=!0)),i&&s&&(n=1,s=!1),t=+t||0,s?(n=t,t=0):n=+n||0;if(r||t%1||n%1){var o=Cn();return xn(t+o*(n-t+an("1e-"+((o+"").length-1))),n)}return $r(t,n)}function ma(e){return e=Bt(e),e&&e.charAt(0).toUpperCase()+e.slice(1)}function ga(e){return e=Bt(e),e&&e.replace(ct,Rt).replace(it,"")}function ya(t,n,r){t=Bt(t),n+="";var i=t.length;return r=r===e?i:xn(r<0?0:+r||0,i),r-=n.length,r>=0&&t.indexOf(n,r)==r}function ba(e){return e=Bt(e),e&&K.test(e)?e.replace($,Ut):e}function wa(e){return e=Bt(e),e&&rt.test(e)?e.replace(nt,zt):e||"(?:)"}function Sa(e,t,n){e=Bt(e),t=+t;var r=e.length;if(r>=t||!wn(t))return e;var i=(t-r)/2,s=yn(i),o=mn(i);return n=Pi("",o,n),n.slice(0,s)+e+n}function Na(e,t,n){return(n?ns(e,t,n):t==null)?t=0:t&&(t=+t),e=Ma(e),Nn(e,t||(at.test(e)?16:10))}function Ca(e,t){var n="";e=Bt(e),t=+t;if(t<1||!e||!wn(t))return n;do t%2&&(n+=e),t=yn(t/2),e+=e;while(t);return n}function Aa(e,t,n){return e=Bt(e),n=n==null?0:xn(n<0?0:+n||0,e.length),e.lastIndexOf(t,n)==n}function Oa(t,n,r){var i=Hn.templateSettings;r&&ns(t,n,r)&&(n=r=e),t=Bt(t),n=hr(pr({},r||n),i,cr);var s=hr(pr({},n.imports),i.imports,cr),o=ta(s),u=ni(s,o),a,f,l=0,c=n.interpolate||ht,h="__p += '",p=Tt((n.escape||ht).source+"|"+c.source+"|"+(c===Y?ot:ht).source+"|"+(n.evaluate||ht).source+"|$","g"),d="//# sourceURL="+("sourceURL"in n?n.sourceURL:"lodash.templateSources["+ ++mt+"]")+"\n";t.replace(p,function(e,n,r,i,s,o){return r||(r=i),h+=t.slice(l,o).replace(pt,Wt),n&&(a=!0,h+="' +\n__e("+n+") +\n'"),s&&(f=!0,h+="';\n"+s+";\n__p += '"),r&&(h+="' +\n((__t = ("+r+")) == null ? '' : __t) +\n'"),l=o+e.length,e}),h+="';\n";var v=n.variable;v||(h="with (obj) {\n"+h+"\n}\n"),h=(f?h.replace(z,""):h).replace(W,"$1").replace(X,"$1;"),h="function("+(v||"obj")+") {\n"+(v?"":"obj || (obj = {});\n")+"var __t, __p = ''"+(a?", __e = _.escape":"")+(f?", __j = Array.prototype.join;\nfunction print() { __p += __j.call(arguments, '') }\n":";\n")+h+"return __p\n}";var m=ja(function(){return wt(o,d+"return "+h).apply(e,u)});m.source=h;if(Su(m))throw m;return m}function Ma(e,t,n){var r=e;return e=Bt(e),e?(n?ns(r,t,n):t==null)?e.slice(Qt(e),Gt(e)+1):(t+="",e.slice(jt(e,t),Ft(e,t)+1)):e}function _a(e,t,n){var r=e;return e=Bt(e),e?(n?ns(r,t,n):t==null)?e.slice(Qt(e)):e.slice(jt(e,t+"")):e}function Da(e,t,n){var r=e;return e=Bt(e),e?(n?ns(r,t,n):t==null)?e.slice(0,Gt(e)+1):e.slice(0,Ft(e,t+"")+1):e}function Pa(t,n,r){r&&ns(t,n,r)&&(n=e);var i=c,s=h;if(n!=null)if(Nu(n)){var o="separator"in n?n.separator:o;i="length"in n?+n.length||0:i,s="omission"in n?Bt(n.omission):s}else i=+n||0;t=Bt(t);if(i>=t.length)return t;var u=i-s.length;if(u<1)return s;var a=t.slice(0,u);if(o==null)return a+s;if(_u(o)){if(t.slice(u).search(o)){var f,l,p=t.slice(0,u);o.global||(o=Tt(o.source,(ut.exec(o)||"")+"g")),o.lastIndex=0;while(f=o.exec(p))l=f.index;a=a.slice(0,l==null?u:l)}}else if(t.indexOf(o,u)!=u){var d=a.lastIndexOf(o);d>-1&&(a=a.slice(0,d))}return a+s}function Ha(e){return e=Bt(e),e&&J.test(e)?e.replace(V,Yt):e}function Ba(t,n,r){return r&&ns(t,n,r)&&(n=e),t=Bt(t),t.match(n||dt)||[]}function Fa(t,n,r){return r&&ns(t,n,r)&&(n=e),Vt(t)?Ra(t):mr(t,n)}function Ia(e){return function(){return e}}function qa(e){return e}function Ra(e){return qr(gr(e,!0))}function Ua(e,t){return Rr(e,gr(t,!0))}function Xa(t,n,r){if(r==null){var i=Nu(n),s=i?ta(n):e,o=s&&s.length?Pr(n,s):e;if(o?!o.length:!i)o=!1,r=n,n=t,t=this}o||(o=Pr(n,ta(n)));var u=!0,a=-1,f=Tu(t),l=o.length;r===!1?u=!1:Nu(r)&&"chain"in r&&(u=r.chain);while(++a<l){var c=o[a],h=n[c];t[c]=h,f&&(t.prototype[c]=function(e){return function(){var n=this.__chain__;if(u||n){var r=t(this.__wrapped__),i=r.__actions__=Yn(this.__actions__);return i.push({func:e,args:arguments,thisArg:t}),r.__chain__=n,r}return e.apply(t,sr([this.value()],arguments))}}(h))}return t}function Va(){return Mt._=rn,this}function $a(){}function Ja(e){return rs(e)?Wr(e):Xr(e)}function Ka(e){return function(t){return Hr(e,ms(t),t+"")}}function Qa(t,n,r){r&&ns(t,n,r)&&(n=r=e),t=+t||0,r=r==null?1:+r||0,n==null?(n=t,t=0):n=+n||0;var i=-1,s=Sn(mn((n-t)/(r||1)),0),o=O(s);while(++i<s)o[i]=t,t+=r;return o}function Ga(e,t,n){e=yn(e);if(e<1||!wn(e))return[];var r=-1,i=O(xn(e,An));t=ui(t,n,1);while(++r<e)r<An?i[r]=t(r):t(r);return i}function Ya(e){var t=++tn;return Bt(e)+t}function Za(e,t){return(+e||0)+(+t||0)}function of(t,n,r){return r&&ns(t,n,r)&&(n=e),n=Ui(n,r,3),n.length==1?fr(mu(t)?t:ds(t),n):ei(t,n)}C=C?en.defaults(Mt.Object(),C,en.pick(Mt,vt)):Mt;var O=C.Array,_=C.Date,bt=C.Error,wt=C.Function,Et=C.Math,St=C.Number,xt=C.Object,Tt=C.RegExp,Nt=C.String,Ct=C.TypeError,kt=O.prototype,Lt=xt.prototype,At=Nt.prototype,Ot=wt.prototype.toString,$t=Lt.hasOwnProperty,tn=0,nn=Lt.toString,rn=Mt._,sn=Tt("^"+Ot.call($t).replace(/[\\^$.*+?()[\]{}|]/g,"\\$&").replace(/hasOwnProperty|(function).*?(?=\\\()| for .+?(?=\\\])/g,"$1.*?")+"$"),on=C.ArrayBuffer,un=C.clearTimeout,an=C.parseFloat,fn=Et.pow,ln=Lt.propertyIsEnumerable,cn=Ji(C,"Set"),hn=C.setTimeout,pn=kt.splice,dn=C.Uint8Array,vn=Ji(C,"WeakMap"),mn=Et.ceil,gn=Ji(xt,"create"),yn=Et.floor,bn=Ji(O,"isArray"),wn=C.isFinite,En=Ji(xt,"keys"),Sn=Et.max,xn=Et.min,Tn=Ji(_,"now"),Nn=C.parseInt,Cn=Et.random,kn=St.NEGATIVE_INFINITY,Ln=St.POSITIVE_INFINITY,An=4294967295,On=An-1,Mn=An>>>1,_n=9007199254740991,Dn=vn&&new vn,Pn={},Fn=Hn.support={};Hn.templateSettings={escape:Q,evaluate:G,interpolate:Y,variable:"",imports:{_:Hn}};var yr=function(){function t(){}return function(n){if(Nu(n)){t.prototype=n;var r=new t;t.prototype=e}return r||{}}}(),Er=pi(_r),Sr=pi(Dr,!0),Ar=di(),Or=di(!0),Kr=Dn?function(e,t){return Dn.set(e,t),e}:qa,zi=Dn?function(e){return Dn.get(e)}:$a,Vi=Wr("length"),hs=function(){var e=0,t=0;return function(n,r){var i=qo(),s=d-(i-t);t=i;if(s>0){if(++e>=p)return n}else e=0;return Kr(n,r)}}(),ws=uu(function(e,t){return Vt(e)&&es(e)?wr(e,Lr(t,!1,!0)):[]}),Cs=xi(),ks=xi(!0),Ds=uu(function(e){var t=e.length,n=t,r=O(l),i=Xi(),s=i==Pt,o=[];while(n--){var u=e[n]=es(u=e[n])?u:[];r[n]=s&&u.length>=120?mi(n&&u):null}var a=e[0],f=-1,l=a?a.length:0,c=r[0];e:while(++f<l){u=a[f];if((c?Kn(c,u):i(o,u,0))<0){var n=t;while(--n){var h=r[n];if((h?Kn(h,u):i(e[n],u,0))<0)continue e}c&&c.push(u),o.push(u)}}return o}),js=uu(function(e,t){t=Lr(t);var n=dr(e,t);return Vr(e,t.sort(_t)),n}),Rs=ji(),Us=ji(!0),$s=uu(function(e){return ti(Lr(e,!1,!0))}),Gs=uu(function(e,t){return es(e)?wr(e,t):[]}),Zs=uu(Ks),to=uu(function(t){var n=t.length,r=n>2?t[n-2]:e,i=n>1?t[n-1]:e;return n>2&&typeof r=="function"?n-=2:(r=n>1&&typeof i=="function"?(--n,i):e,i=e),t.length=n,Qs(t,r,i)}),uo=uu(function(e){return e=Lr(e),this.thru(function(t){return Gn(mu(t)?t:[vs(t)],e)})}),ho=uu(function(e,t){return dr(e,Lr(t))}),po=ci(function(e,t,n){$t.call(e,n)?++e[n]:e[n]=1}),go=Si(Er),yo=Si(Sr,!0),wo=Ci(Zn,Er),Eo=Ci(er,Sr),So=ci(function(e,t,n){$t.call(e,n)?e[n].push(t):e[n]=[t]}),To=ci(function(e,t,n){e[n]=t}),No=uu(function(t,n,r){var i=-1,s=typeof n=="function",o=rs(n),u=es(t)?O(t.length):[];return Er(t,function(t){var a=s?n:o&&t!=null?t[n]:e;u[++i]=a?a.apply(t,r):Zi(t,n,r)}),u}),ko=ci(function(e,t,n){e[n?0:1].push(t)},function(){return[[],[]]}),Ao=_i(or,Er),Oo=_i(ur,Sr),jo=uu(function(e,t){if(e==null)return[];var n=t[2];return n&&ns(t[0],t[1],n)&&(t.length=1),Zr(e,Lr(t),[])}),qo=Tn||function(){return(new _).getTime()},Wo=uu(function(e,t,r){var i=n;if(r.length){var s=Jt(r,Wo.placeholder);i|=u}return Fi(e,i,t,r,s)}),Xo=uu(function(e,t){t=t.length?Lr(t):Gu(e);var r=-1,i=t.length;while(++r<i){var s=t[r];e[s]=Fi(e[s],n,e)}return e}),Vo=uu(function(e,t,i){var s=n|r;if(i.length){var o=Jt(i,Vo.placeholder);s|=u}return Fi(t,s,e,i,o)}),$o=bi(s),Jo=bi(o),Qo=uu(function(e,t){return br(e,1,t)}),Go=uu(function(e,t,n){return br(e,t,n)}),Yo=Ni(),Zo=Ni(!0),tu=uu(function(e,t){t=Lr(t);if(typeof e!="function"||!tr(t,Ht))throw new Ct(y);var n=t.length;return uu(function(r){var i=xn(r.length,n);while(i--)r[i]=t[i](r[i]);return e.apply(this,r)})}),iu=Mi(u),su=Mi(a),ou=uu(function(t,n){return Fi(t,l,e,e,e,Lr(n))}),mu=bn||function(e){return Vt(e)&&ss(e.length)&&nn.call(e)==E},qu=hi(Ur),Ru=hi(function(e,t,n){return n?hr(e,t,n):pr(e,t)}),zu=wi(Ru,lr),Wu=wi(qu,as),Xu=Ti(_r),Vu=Ti(Dr),$u=ki(Ar),Ju=ki(Or),Ku=Li(_r),Qu=Li(Dr),ta=En?function(t){var n=t==null?e:t.constructor;return typeof n=="function"&&n.prototype===t||typeof t!="function"&&es(t)?ps(t):Nu(t)?En(t):[]}:ps,ra=Ai(!0),ia=Ai(),sa=uu(function(e,t){if(e==null)return{};if(typeof t[0]!="function"){var t=ir(Lr(t),Nt);return fs(e,wr(na(e),t))}var n=ui(t[0],t[1],3);return ls(e,function(e,t,r){return!n(e,t,r)})}),ua=uu(function(e,t){return e==null?{}:typeof t[0]=="function"?ls(e,ui(t[0],t[1],3)):fs(e,Lr(t))}),va=gi(function(e,t,n){return t=t.toLowerCase(),e+(n?t.charAt(0).toUpperCase()+t.slice(1):t)}),Ea=gi(function(e,t,n){return e+(n?"-":"")+t.toLowerCase()}),xa=Oi(),Ta=Oi(!0),ka=gi(function(e,t,n){return e+(n?"_":"")+t.toLowerCase()}),La=gi(function(e,t,n){return e+(n?" ":"")+(t.charAt(0).toUpperCase()+t.slice(1))}),ja=uu(function(t,n){try{return t.apply(e,n)}catch(r){return Su(r)?r:new bt(r)}}),za=uu(function(e,t){return function(n){return Zi(n,e,t)}}),Wa=uu(function(e,t){return function(n){return Zi(e,n,t)}}),ef=Bi("ceil"),tf=Bi("floor"),nf=Ei(pu,kn),rf=Ei(Bu,Ln),sf=Bi("round");return Hn.prototype=Bn.prototype,jn.prototype=yr(Bn.prototype),jn.prototype.constructor=jn,In.prototype=yr(Bn.prototype),In.prototype.constructor=In,zn.prototype["delete"]=Wn,zn.prototype.get=Xn,zn.prototype.has=Vn,zn.prototype.set=$n,Jn.prototype.push=Qn,eu.Cache=zn,Hn.after=Ro,Hn.ary=Uo,Hn.assign=Ru,Hn.at=ho,Hn.before=zo,Hn.bind=Wo,Hn.bindAll=Xo,Hn.bindKey=Vo,Hn.callback=Fa,Hn.chain=no,Hn.chunk=ys,Hn.compact=bs,Hn.constant=Ia,Hn.countBy=po,Hn.create=Uu,Hn.curry=$o,Hn.curryRight=Jo,Hn.debounce=Ko,Hn.defaults=zu,Hn.defaultsDeep=Wu,Hn.defer=Qo,Hn.delay=Go,Hn.difference=ws,Hn.drop=Es,Hn.dropRight=Ss,Hn.dropRightWhile=xs,Hn.dropWhile=Ts,Hn.fill=Ns,Hn.filter=mo,Hn.flatten=As,Hn.flattenDeep=Os,Hn.flow=Yo,Hn.flowRight=Zo,Hn.forEach=wo,Hn.forEachRight=Eo,Hn.forIn=$u,Hn.forInRight=Ju,Hn.forOwn=Ku,Hn.forOwnRight=Qu,Hn.functions=Gu,Hn.groupBy=So,Hn.indexBy=To,Hn.initial=_s,Hn.intersection=Ds,Hn.invert=ea,Hn.invoke=No,Hn.keys=ta,Hn.keysIn=na,Hn.map=Co,Hn.mapKeys=ra,Hn.mapValues=ia,Hn.matches=Ra,Hn.matchesProperty=Ua,Hn.memoize=eu,Hn.merge=qu,Hn.method=za,Hn.methodOf=Wa,Hn.mixin=Xa,Hn.modArgs=tu,Hn.negate=nu,Hn.omit=sa,Hn.once=ru,Hn.pairs=oa,Hn.partial=iu,Hn.partialRight=su,Hn.partition=ko,Hn.pick=ua,Hn.pluck=Lo,Hn.property=Ja,Hn.propertyOf=Ka,Hn.pull=Bs,Hn.pullAt=js,Hn.range=Qa,Hn.rearg=ou,Hn.reject=Mo,Hn.remove=Fs,Hn.rest=Is,Hn.restParam=uu,Hn.set=fa,Hn.shuffle=Do,Hn.slice=qs,Hn.sortBy=Bo,Hn.sortByAll=jo,Hn.sortByOrder=Fo,Hn.spread=au,Hn.take=zs,Hn.takeRight=Ws,Hn.takeRightWhile=Xs,Hn.takeWhile=Vs,Hn.tap=ro,Hn.throttle=fu,Hn.thru=io,Hn.times=Ga,Hn.toArray=Fu,Hn.toPlainObject=Iu,Hn.transform=la,Hn.union=$s,Hn.uniq=Js,Hn.unzip=Ks,Hn.unzipWith=Qs,Hn.values=ca,Hn.valuesIn=ha,Hn.where=Io,Hn.without=Gs,Hn.wrap=lu,Hn.xor=Ys,Hn.zip=Zs,Hn.zipObject=eo,Hn.zipWith=to,Hn.backflow=Zo,Hn.collect=Co,Hn.compose=Zo,Hn.each=wo,Hn.eachRight=Eo,Hn.extend=Ru,Hn.iteratee=Fa,Hn.methods=Gu,Hn.object=eo,Hn.select=mo,Hn.tail=Is,Hn.unique=Js,Xa(Hn,Hn),Hn.add=Za,Hn.attempt=ja,Hn.camelCase=va,Hn.capitalize=ma,Hn.ceil=ef,Hn.clone=cu,Hn.cloneDeep=hu,Hn.deburr=ga,Hn.endsWith=ya,Hn.escape=ba,Hn.escapeRegExp=wa,Hn.every=vo,Hn.find=go,Hn.findIndex=Cs,Hn.findKey=Xu,Hn.findLast=yo,Hn.findLastIndex=ks,Hn.findLastKey=Vu,Hn.findWhere=bo,Hn.first=Ls,Hn.floor=tf,Hn.get=Yu,Hn.gt=pu,Hn.gte=du,Hn.has=Zu,Hn.identity=qa,Hn.includes=xo,Hn.indexOf=Ms,Hn.inRange=pa,Hn.isArguments=vu,Hn.isArray=mu,Hn.isBoolean=gu,Hn.isDate=yu,Hn.isElement=bu,Hn.isEmpty=wu,Hn.isEqual=Eu,Hn.isError=Su,Hn.isFinite=xu,Hn.isFunction=Tu,Hn.isMatch=Cu,Hn.isNaN=ku,Hn.isNative=Lu,Hn.isNull=Au,Hn.isNumber=Ou,Hn.isObject=Nu,Hn.isPlainObject=Mu,Hn.isRegExp=_u,Hn.isString=Du,Hn.isTypedArray=Pu,Hn.isUndefined=Hu,Hn.kebabCase=Ea,Hn.last=Ps,Hn.lastIndexOf=Hs,Hn.lt=Bu,Hn.lte=ju,Hn.max=nf,Hn.min=rf,Hn.noConflict=Va,Hn.noop=$a,Hn.now=qo,Hn.pad=Sa,Hn.padLeft=xa,Hn.padRight=Ta,Hn.parseInt=Na,Hn.random=da,Hn.reduce=Ao,Hn.reduceRight=Oo,Hn.repeat=Ca,Hn.result=aa,Hn.round=sf,Hn.runInContext=Zt,Hn.size=Po,Hn.snakeCase=ka,Hn.some=Ho,Hn.sortedIndex=Rs,Hn.sortedLastIndex=Us,Hn.startCase=La,Hn.startsWith=Aa,Hn.sum=of,Hn.template=Oa,Hn.trim=Ma,Hn.trimLeft=_a,Hn.trimRight=Da,Hn.trunc=Pa,Hn.unescape=Ha,Hn.uniqueId=Ya,Hn.words=Ba,Hn.all=vo,Hn.any=Ho,Hn.contains=xo,Hn.eq=Eu,Hn.detect=go,Hn.foldl=Ao,Hn.foldr=Oo,Hn.head=Ls,Hn.include=xo,Hn.inject=Ao,Xa(Hn,function(){var e={};return _r(Hn,function(t,n){Hn.prototype[n]||(e[n]=t)}),e}(),!1),Hn.sample=_o,Hn.prototype.sample=function(e){return!this.__chain__&&e==null?_o(this.value()):this.thru(function(t){return _o(t,e)})},Hn.VERSION=t,Zn(["bind","bindKey","curry","curryRight","partial","partialRight"],function(e){Hn[e].placeholder=Hn}),Zn(["drop","take"],function(e,t){In.prototype[e]=function(n){var r=this.__filtered__;if(r&&!t)return new In(this);n=n==null?1:Sn(yn(n)||0,0);var i=this.clone();return r?i.__takeCount__=xn(i.__takeCount__,n):i.__views__.push({size:n,type:e+(i.__dir__<0?"Right":"")}),i},In.prototype[e+"Right"]=function(t){return this.reverse()[e](t).reverse()}}),Zn(["filter","map","takeWhile"],function(e,t){var n=t+1,r=n!=g;In.prototype[e]=function(e,t){var i=this.clone();return i.__iteratees__.push({iteratee:Ui(e,t,1),type:n}),i.__filtered__=i.__filtered__||r,i}}),Zn(["first","last"],function(e,t){var n="take"+(t?"Right":"");In.prototype[e]=function(){return this[n](1).value()[0]}}),Zn(["initial","rest"],function(e,t){var n="drop"+(t?"":"Right");In.prototype[e]=function(){return this.__filtered__?new In(this):this[n](1)}}),Zn(["pluck","where"],function(e,t){var n=t?"filter":"map",r=t?qr:Ja;In.prototype[e]=function(e){return this[n](r(e))}}),In.prototype.compact=function(){return this.filter(qa)},In.prototype.reject=function(e,t){return e=Ui(e,t,1),this.filter(function(t){return!e(t)})},In.prototype.slice=function(t,n){t=t==null?0:+t||0;var r=this;return r.__filtered__&&(t>0||n<0)?new In(r):(t<0?r=r.takeRight(-t):t&&(r=r.drop(t)),n!==e&&(n=+n||0,r=n<0?r.dropRight(-n):r.take(n-t)),r)},In.prototype.takeRightWhile=function(e,t){return this.reverse().takeWhile(e,t).reverse()},In.prototype.toArray=function(){return this.take(Ln)},_r(In.prototype,function(t,n){var r=/^(?:filter|map|reject)|While$/.test(n),i=/^(?:first|last)$/.test(n),s=Hn[i?"take"+(n=="last"?"Right":""):n];if(!s)return;Hn.prototype[n]=function(){var n=i?[1]:arguments,o=this.__chain__,u=this.__wrapped__,a=!!this.__actions__.length,f=u instanceof In,l=n[0],c=f||mu(u);c&&r&&typeof l=="function"&&l.length!=1&&(f=c=!1);var h=function(t){return i&&o?s(t,1)[0]:s.apply(e,sr([t],n))},p={func:io,args:[h],thisArg:e},d=f&&!a;if(i&&!o)return d?(u=u.clone(),u.__actions__.push(p),t.call(u)):s.call(e,this.value())[0];if(!i&&c){u=d?u:new In(this);var v=t.apply(u,n);return v.__actions__.push(p),new jn(v,o)}return this.thru(h)}}),Zn(["join","pop","push","replace","shift","sort","splice","split","unshift"],function(e){var t=(/^(?:replace|split)$/.test(e)?At:kt)[e],n=/^(?:push|sort|unshift)$/.test(e)?"tap":"thru",r=/^(?:join|pop|replace|shift)$/.test(e);Hn.prototype[e]=function(){var e=arguments;return r&&!this.__chain__?t.apply(this.value(),e):this[n](function(n){return t.apply(n,e)})}}),_r(In.prototype,function(e,t){var n=Hn[t];if(n){var r=n.name,i=Pn[r]||(Pn[r]=[]);i.push({name:t,func:n})}}),Pn[Di(e,r).name]=[{name:"wrapper",func:e}],In.prototype.clone=qn,In.prototype.reverse=Rn,In.prototype.value=Un,Hn.prototype.chain=so,Hn.prototype.commit=oo,Hn.prototype.concat=uo,Hn.prototype.plant=ao,Hn.prototype.reverse=fo,Hn.prototype.toString=lo,Hn.prototype.run=Hn.prototype.toJSON=Hn.prototype.valueOf=Hn.prototype.value=co,Hn.prototype.collect=Hn.prototype.map,Hn.prototype.head=Hn.prototype.first,Hn.prototype.select=Hn.prototype.filter,Hn.prototype.tail=Hn.prototype.rest,Hn}var e,t="3.10.0",n=1,r=2,i=4,s=8,o=16,u=32,a=64,f=128,l=256,c=30,h="...",p=150,d=16,v=200,m=1,g=2,y="Expected a function",b="__lodash_placeholder__",w="[object Arguments]",E="[object Array]",S="[object Boolean]",x="[object Date]",T="[object Error]",N="[object Function]",C="[object Map]",k="[object Number]",L="[object Object]",A="[object RegExp]",O="[object Set]",M="[object String]",_="[object WeakMap]",D="[object ArrayBuffer]",P="[object Float32Array]",H="[object Float64Array]",B="[object Int8Array]",j="[object Int16Array]",F="[object Int32Array]",I="[object Uint8Array]",q="[object Uint8ClampedArray]",R="[object Uint16Array]",U="[object Uint32Array]",z=/\b__p \+= '';/g,W=/\b(__p \+=) '' \+/g,X=/(__e\(.*?\)|\b__t\)) \+\n'';/g,V=/&(?:amp|lt|gt|quot|#39|#96);/g,$=/[&<>"'`]/g,J=RegExp(V.source),K=RegExp($.source),Q=/<%-([\s\S]+?)%>/g,G=/<%([\s\S]+?)%>/g,Y=/<%=([\s\S]+?)%>/g,Z=/\.|\[(?:[^[\]]*|(["'])(?:(?!\1)[^\n\\]|\\.)*?\1)\]/,et=/^\w*$/,tt=/[^.[\]]+|\[(?:(-?\d+(?:\.\d+)?)|(["'])((?:(?!\2)[^\n\\]|\\.)*?)\2)\]/g,nt=/^[:!,]|[\\^$.*+?()[\]{}|\/]|(^[0-9a-fA-Fnrtuvx])|([\n\r\u2028\u2029])/g,rt=RegExp(nt.source),it=/[\u0300-\u036f\ufe20-\ufe23]/g,st=/\\(\\)?/g,ot=/\$\{([^\\}]*(?:\\.[^\\}]*)*)\}/g,ut=/\w*$/,at=/^0[xX]/,ft=/^\[object .+?Constructor\]$/,lt=/^\d+$/,ct=/[\xc0-\xd6\xd8-\xde\xdf-\xf6\xf8-\xff]/g,ht=/($^)/,pt=/['\n\r\u2028\u2029\\]/g,dt=function(){var e="[A-Z\\xc0-\\xd6\\xd8-\\xde]",t="[a-z\\xdf-\\xf6\\xf8-\\xff]+";return RegExp(e+"+(?="+e+t+")|"+e+"?"+t+"|"+e+"+|[0-9]+","g")}(),vt=["Array","ArrayBuffer","Date","Error","Float32Array","Float64Array","Function","Int8Array","Int16Array","Int32Array","Math","Number","Object","RegExp","Set","String","_","clearTimeout","isFinite","parseFloat","parseInt","setTimeout","TypeError","Uint8Array","Uint8ClampedArray","Uint16Array","Uint32Array","WeakMap"],mt=-1,gt={};gt[P]=gt[H]=gt[B]=gt[j]=gt[F]=gt[I]=gt[q]=gt[R]=gt[U]=!0,gt[w]=gt[E]=gt[D]=gt[S]=gt[x]=gt[T]=gt[N]=gt[C]=gt[k]=gt[L]=gt[A]=gt[O]=gt[M]=gt[_]=!1;var yt={};yt[w]=yt[E]=yt[D]=yt[S]=yt[x]=yt[P]=yt[H]=yt[B]=yt[j]=yt[F]=yt[k]=yt[L]=yt[A]=yt[M]=yt[I]=yt[q]=yt[R]=yt[U]=!0,yt[T]=yt[N]=yt[C]=yt[O]=yt[_]=!1;var bt={"À":"A","Á":"A","Â":"A","Ã":"A","Ä":"A","Å":"A","à":"a","á":"a","â":"a","ã":"a","ä":"a","å":"a","Ç":"C","ç":"c","Ð":"D","ð":"d","È":"E","É":"E","Ê":"E","Ë":"E","è":"e","é":"e","ê":"e","ë":"e","Ì":"I","Í":"I","Î":"I","Ï":"I","ì":"i","í":"i","î":"i","ï":"i","Ñ":"N","ñ":"n","Ò":"O","Ó":"O","Ô":"O","Õ":"O","Ö":"O","Ø":"O","ò":"o","ó":"o","ô":"o","õ":"o","ö":"o","ø":"o","Ù":"U","Ú":"U","Û":"U","Ü":"U","ù":"u","ú":"u","û":"u","ü":"u","Ý":"Y","ý":"y","ÿ":"y","Æ":"Ae","æ":"ae","Þ":"Th","þ":"th","ß":"ss"},wt={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;","`":"&#96;"},Et={"&amp;":"&","&lt;":"<","&gt;":">","&quot;":'"',"&#39;":"'","&#96;":"`"},St={"function":!0,object:!0},xt={0:"x30",1:"x31",2:"x32",3:"x33",4:"x34",5:"x35",6:"x36",7:"x37",8:"x38",9:"x39",A:"x41",B:"x42",C:"x43",D:"x44",E:"x45",F:"x46",a:"x61",b:"x62",c:"x63",d:"x64",e:"x65",f:"x66",n:"x6e",r:"x72",t:"x74",u:"x75",v:"x76",x:"x78"},Tt={"\\":"\\","'":"'","\n":"n","\r":"r","\u2028":"u2028","\u2029":"u2029"},Nt=St[typeof exports]&&exports&&!exports.nodeType&&exports,Ct=St[typeof module]&&module&&!module.nodeType&&module,kt=Nt&&Ct&&typeof global=="object"&&global&&global.Object&&global,Lt=St[typeof self]&&self&&self.Object&&self,At=St[typeof window]&&window&&window.Object&&window,Ot=Ct&&Ct.exports===Nt&&Nt,Mt=kt||At!==(this&&this.window)&&At||Lt||this,en=Zt();typeof define=="function"&&typeof define.amd=="object"&&define.amd?(Mt._=en,define("lodash",[],function(){return en})):Nt&&Ct?Ot?(Ct.exports=en)._=en:Nt._=en:Mt._=en}.call(this),function(e,t){typeof module=="object"&&module.exports&&typeof require=="function"?module.exports=t():typeof define=="function"&&typeof define.amd=="object"?define("loglevel",t):e.log=t()}(this,function(){function r(e){return typeof console===n?!1:console[e]!==undefined?i(console,e):console.log!==undefined?i(console,"log"):t}function i(e,t){var n=e[t];if(typeof n.bind=="function")return n.bind(e);try{return Function.prototype.bind.call(n,e)}catch(r){return function(){return Function.prototype.apply.apply(n,[e,arguments])}}}function s(t,r){return function(){typeof console!==n&&(u(r),e[t].apply(e,arguments))}}function u(n){for(var r=0;r<o.length;r++){var i=o[r];e[i]=r<n?t:e.methodFactory(i,n)}}function a(e){var t=(o[e]||"silent").toUpperCase();try{window.localStorage.loglevel=t;return}catch(n){}try{window.document.cookie="loglevel="+t+";"}catch(n){}}function f(){var t;try{t=window.localStorage.loglevel}catch(r){}if(typeof t===n)try{t=/loglevel=([^;]+)/.exec(window.document.cookie)[1]}catch(r){}e.levels[t]===undefined&&(t="WARN"),e.setLevel(e.levels[t],!1)}var e={},t=function(){},n="undefined",o=["trace","debug","info","warn","error"];e.levels={TRACE:0,DEBUG:1,INFO:2,WARN:3,ERROR:4,SILENT:5},e.methodFactory=function(e,t){return r(e)||s(e,t)},e.setLevel=function(t,r){typeof t=="string"&&e.levels[t.toUpperCase()]!==undefined&&(t=e.levels[t.toUpperCase()]);if(!(typeof t=="number"&&t>=0&&t<=e.levels.SILENT))throw"log.setLevel() called with invalid level: "+t;r!==!1&&a(t),u(t);if(typeof console===n&&t<e.levels.SILENT)return"No console available for logging"},e.enableAll=function(t){e.setLevel(e.levels.TRACE,t)},e.disableAll=function(t){e.setLevel(e.levels.SILENT,t)};var l=typeof window!==n?window.log:undefined;return e.noConflict=function(){return typeof window!==n&&window.log===e&&(window.log=l),e},f(),e}),function(e,t){"use strict";function r(e,t){return(e&65535)*t+(((e>>>16)*t&65535)<<16)}function i(e,t){return e<<t|e>>>32-t}function s(e){return e^=e>>>16,e=r(e,2246822507),e^=e>>>13,e=r(e,3266489909),e^=e>>>16,e}function o(e,t){e=[e[0]>>>16,e[0]&65535,e[1]>>>16,e[1]&65535],t=[t[0]>>>16,t[0]&65535,t[1]>>>16,t[1]&65535];var n=[0,0,0,0];return n[3]+=e[3]+t[3],n[2]+=n[3]>>>16,n[3]&=65535,n[2]+=e[2]+t[2],n[1]+=n[2]>>>16,n[2]&=65535,n[1]+=e[1]+t[1],n[0]+=n[1]>>>16,n[1]&=65535,n[0]+=e[0]+t[0],n[0]&=65535,[n[0]<<16|n[1],n[2]<<16|n[3]]}function u(e,t){e=[e[0]>>>16,e[0]&65535,e[1]>>>16,e[1]&65535],t=[t[0]>>>16,t[0]&65535,t[1]>>>16,t[1]&65535];var n=[0,0,0,0];return n[3]+=e[3]*t[3],n[2]+=n[3]>>>16,n[3]&=65535,n[2]+=e[2]*t[3],n[1]+=n[2]>>>16,n[2]&=65535,n[2]+=e[3]*t[2],n[1]+=n[2]>>>16,n[2]&=65535,n[1]+=e[1]*t[3],n[0]+=n[1]>>>16,n[1]&=65535,n[1]+=e[2]*t[2],n[0]+=n[1]>>>16,n[1]&=65535,n[1]+=e[3]*t[1],n[0]+=n[1]>>>16,n[1]&=65535,n[0]+=e[0]*t[3]+e[1]*t[2]+e[2]*t[1]+e[3]*t[0],n[0]&=65535,[n[0]<<16|n[1],n[2]<<16|n[3]]}function a(e,t){return t%=64,t===32?[e[1],e[0]]:t<32?[e[0]<<t|e[1]>>>32-t,e[1]<<t|e[0]>>>32-t]:(t-=32,[e[1]<<t|e[0]>>>32-t,e[0]<<t|e[1]>>>32-t])}function f(e,t){return t%=64,t===0?e:t<32?[e[0]<<t|e[1]>>>32-t,e[1]<<t]:[e[1]<<t-32,0]}function l(e,t){return[e[0]^t[0],e[1]^t[1]]}function c(e){return e=l(e,[0,e[0]>>>1]),e=u(e,[4283543511,3981806797]),e=l(e,[0,e[0]>>>1]),e=u(e,[3301882366,444984403]),e=l(e,[0,e[0]>>>1]),e}var n={version:"2.1.2",x86:{},x64:{}};n.x86.hash32=function(e,t){e=e||"",t=t||0;var n=e.length%4,o=e.length-n,u=t,a=0,f=3432918353,l=461845907;for(var c=0;c<o;c+=4)a=e.charCodeAt(c)&255|(e.charCodeAt(c+1)&255)<<8|(e.charCodeAt(c+2)&255)<<16|(e.charCodeAt(c+3)&255)<<24,a=r(a,f),a=i(a,15),a=r(a,l),u^=a,u=i(u,13),u=r(u,5)+3864292196;a=0;switch(n){case 3:a^=(e.charCodeAt(c+2)&255)<<16;case 2:a^=(e.charCodeAt(c+1)&255)<<8;case 1:a^=e.charCodeAt(c)&255,a=r(a,f),a=i(a,15),a=r(a,l),u^=a}return u^=e.length,u=s(u),u>>>0},n.x86.hash128=function(e,t){e=e||"",t=t||0;var n=e.length%16,o=e.length-n,u=t,a=t,f=t,l=t,c=0,h=0,p=0,d=0,v=597399067,m=2869860233,g=951274213,y=2716044179;for(var b=0;b<o;b+=16)c=e.charCodeAt(b)&255|(e.charCodeAt(b+1)&255)<<8|(e.charCodeAt(b+2)&255)<<16|(e.charCodeAt(b+3)&255)<<24,h=e.charCodeAt(b+4)&255|(e.charCodeAt(b+5)&255)<<8|(e.charCodeAt(b+6)&255)<<16|(e.charCodeAt(b+7)&255)<<24,p=e.charCodeAt(b+8)&255|(e.charCodeAt(b+9)&255)<<8|(e.charCodeAt(b+10)&255)<<16|(e.charCodeAt(b+11)&255)<<24,d=e.charCodeAt(b+12)&255|(e.charCodeAt(b+13)&255)<<8|(e.charCodeAt(b+14)&255)<<16|(e.charCodeAt(b+15)&255)<<24,c=r(c,v),c=i(c,15),c=r(c,m),u^=c,u=i(u,19),u+=a,u=r(u,5)+1444728091,h=r(h,m),h=i(h,16),h=r(h,g),a^=h,a=i(a,17),a+=f,a=r(a,5)+197830471,p=r(p,g),p=i(p,17),p=r(p,y),f^=p,f=i(f,15),f+=l,f=r(f,5)+2530024501,d=r(d,y),d=i(d,18),d=r(d,v),l^=d,l=i(l,13),l+=u,l=r(l,5)+850148119;c=0,h=0,p=0,d=0;switch(n){case 15:d^=e.charCodeAt(b+14)<<16;case 14:d^=e.charCodeAt(b+13)<<8;case 13:d^=e.charCodeAt(b+12),d=r(d,y),d=i(d,18),d=r(d,v),l^=d;case 12:p^=e.charCodeAt(b+11)<<24;case 11:p^=e.charCodeAt(b+10)<<16;case 10:p^=e.charCodeAt(b+9)<<8;case 9:p^=e.charCodeAt(b+8),p=r(p,g),p=i(p,17),p=r(p,y),f^=p;case 8:h^=e.charCodeAt(b+7)<<24;case 7:h^=e.charCodeAt(b+6)<<16;case 6:h^=e.charCodeAt(b+5)<<8;case 5:h^=e.charCodeAt(b+4),h=r(h,m),h=i(h,16),h=r(h,g),a^=h;case 4:c^=e.charCodeAt(b+3)<<24;case 3:c^=e.charCodeAt(b+2)<<16;case 2:c^=e.charCodeAt(b+1)<<8;case 1:c^=e.charCodeAt(b),c=r(c,v),c=i(c,15),c=r(c,m),u^=c}return u^=e.length,a^=e.length,f^=e.length,l^=e.length,u+=a,u+=f,u+=l,a+=u,f+=u,l+=u,u=s(u),a=s(a),f=s(f),l=s(l),u+=a,u+=f,u+=l,a+=u,f+=u,l+=u,("00000000"+(u>>>0).toString(16)).slice(-8)+("00000000"+(a>>>0).toString(16)).slice(-8)+("00000000"+(f>>>0).toString(16)).slice(-8)+("00000000"+(l>>>0).toString(16)).slice(-8)},n.x64.hash128=function(e,t){e=e||"",t=t||0;var n=e.length%16,r=e.length-n,i=[0,t],s=[0,t],h=[0,0],p=[0,0],d=[2277735313,289559509],v=[1291169091,658871167];for(var m=0;m<r;m+=16)h=[e.charCodeAt(m+4)&255|(e.charCodeAt(m+5)&255)<<8|(e.charCodeAt(m+6)&255)<<16|(e.charCodeAt(m+7)&255)<<24,e.charCodeAt(m)&255|(e.charCodeAt(m+1)&255)<<8|(e.charCodeAt(m+2)&255)<<16|(e.charCodeAt(m+3)&255)<<24],p=[e.charCodeAt(m+12)&255|(e.charCodeAt(m+13)&255)<<8|(e.charCodeAt(m+14)&255)<<16|(e.charCodeAt(m+15)&255)<<24,e.charCodeAt(m+8)&255|(e.charCodeAt(m+9)&255)<<8|(e.charCodeAt(m+10)&255)<<16|(e.charCodeAt(m+11)&255)<<24],h=u(h,d),h=a(h,31),h=u(h,v),i=l(i,h),i=a(i,27),i=o(i,s),i=o(u(i,[0,5]),[0,1390208809]),p=u(p,v),p=a(p,33),p=u(p,d),s=l(s,p),s=a(s,31),s=o(s,i),s=o(u(s,[0,5]),[0,944331445]);h=[0,0],p=[0,0];switch(n){case 15:p=l(p,f([0,e.charCodeAt(m+14)],48));case 14:p=l(p,f([0,e.charCodeAt(m+13)],40));case 13:p=l(p,f([0,e.charCodeAt(m+12)],32));case 12:p=l(p,f([0,e.charCodeAt(m+11)],24));case 11:p=l(p,f([0,e.charCodeAt(m+10)],16));case 10:p=l(p,f([0,e.charCodeAt(m+9)],8));case 9:p=l(p,[0,e.charCodeAt(m+8)]),p=u(p,v),p=a(p,33),p=u(p,d),s=l(s,p);case 8:h=l(h,f([0,e.charCodeAt(m+7)],56));case 7:h=l(h,f([0,e.charCodeAt(m+6)],48));case 6:h=l(h,f([0,e.charCodeAt(m+5)],40));case 5:h=l(h,f([0,e.charCodeAt(m+4)],32));case 4:h=l(h,f([0,e.charCodeAt(m+3)],24));case 3:h=l(h,f([0,e.charCodeAt(m+2)],16));case 2:h=l(h,f([0,e.charCodeAt(m+1)],8));case 1:h=l(h,[0,e.charCodeAt(m)]),h=u(h,d),h=a(h,31),h=u(h,v),i=l(i,h)}return i=l(i,[0,e.length]),s=l(s,[0,e.length]),i=o(i,s),s=o(s,i),i=c(i),s=c(s),i=o(i,s),s=o(s,i),("00000000"+(i[0]>>>0).toString(16)).slice(-8)+("00000000"+(i[1]>>>0).toString(16)).slice(-8)+("00000000"+(s[0]>>>0).toString(16)).slice(-8)+("00000000"+(s[1]>>>0).toString(16)).slice(-8)},typeof exports!="undefined"?(typeof module!="undefined"&&module.exports&&(exports=module.exports=n),exports.murmurHash3=n):typeof define=="function"&&define.amd?define("murmurhash3",[],function(){return n}):(n._murmurHash3=e.murmurHash3,n.noConflict=function(){return e.murmurHash3=n._murmurHash3,n._murmurHash3=t,n.noConflict=t,n},e.murmurHash3=n)}(this),function(e){if(typeof exports=="object"&&typeof module!="undefined")module.exports=e();else if(typeof define=="function"&&define.amd)define("pako",[],e);else{var t;typeof window!="undefined"?t=window:typeof global!="undefined"?t=global:typeof self!="undefined"?t=self:t=this,t.pako=e()}}(function(){var e,t,n;return function r(e,t,n){function i(o,u){if(!t[o]){if(!e[o]){var a=typeof require=="function"&&require;if(!u&&a)return a(o,!0);if(s)return s(o,!0);var f=new Error("Cannot find module '"+o+"'");throw f.code="MODULE_NOT_FOUND",f}var l=t[o]={exports:{}};e[o][0].call(l.exports,function(t){var n=e[o][1][t];return i(n?n:t)},l,l.exports,r,e,t,n)}return t[o].exports}var s=typeof require=="function"&&require;for(var o=0;o<n.length;o++)i(n[o]);return i}({1:[function(e,t,n){"use strict";function g(e,t){var n=new m(t);n.push(e,!0);if(n.err)throw n.msg;return n.result}function y(e,t){return t=t||{},t.raw=!0,g(e,t)}function b(e,t){return t=t||{},t.gzip=!0,g(e,t)}var r=e("./zlib/deflate.js"),i=e("./utils/common"),s=e("./utils/strings"),o=e("./zlib/messages"),u=e("./zlib/zstream"),a=Object.prototype.toString,f=0,l=4,c=0,h=1,p=-1,d=0,v=8,m=function(e){this.options=i.assign({level:p,method:v,chunkSize:16384,windowBits:15,memLevel:8,strategy:d,to:""},e||{});var t=this.options;t.raw&&t.windowBits>0?t.windowBits=-t.windowBits:t.gzip&&t.windowBits>0&&t.windowBits<16&&(t.windowBits+=16),this.err=0,this.msg="",this.ended=!1,this.chunks=[],this.strm=new u,this.strm.avail_out=0;var n=r.deflateInit2(this.strm,t.level,t.method,t.windowBits,t.memLevel,t.strategy);if(n!==c)throw new Error(o[n]);t.header&&r.deflateSetHeader(this.strm,t.header)};m.prototype.push=function(e,t){var n=this.strm,o=this.options.chunkSize,u,p;if(this.ended)return!1;p=t===~~t?t:t===!0?l:f,typeof e=="string"?n.input=s.string2buf(e):a.call(e)==="[object ArrayBuffer]"?n.input=new Uint8Array(e):n.input=e,n.next_in=0,n.avail_in=n.input.length;do{n.avail_out===0&&(n.output=new i.Buf8(o),n.next_out=0,n.avail_out=o),u=r.deflate(n,p);if(u!==h&&u!==c)return this.onEnd(u),this.ended=!0,!1;if(n.avail_out===0||n.avail_in===0&&p===l)this.options.to==="string"?this.onData(s.buf2binstring(i.shrinkBuf(n.output,n.next_out))):this.onData(i.shrinkBuf(n.output,n.next_out))}while((n.avail_in>0||n.avail_out===0)&&u!==h);return p===l?(u=r.deflateEnd(this.strm),this.onEnd(u),this.ended=!0,u===c):!0},m.prototype.onData=function(e){this.chunks.push(e)},m.prototype.onEnd=function(e){e===c&&(this.options.to==="string"?this.result=this.chunks.join(""):this.result=i.flattenChunks(this.chunks)),this.chunks=[],this.err=e,this.msg=this.strm.msg},n.Deflate=m,n.deflate=g,n.deflateRaw=y,n.gzip=b},{"./utils/common":3,"./utils/strings":4,"./zlib/deflate.js":8,"./zlib/messages":13,"./zlib/zstream":15}],2:[function(e,t,n){"use strict";function h(e,t){var n=new c(t);n.push(e,!0);if(n.err)throw n.msg;return n.result}function p(e,t){return t=t||{},t.raw=!0,h(e,t)}var r=e("./zlib/inflate.js"),i=e("./utils/common"),s=e("./utils/strings"),o=e("./zlib/constants"),u=e("./zlib/messages"),a=e("./zlib/zstream"),f=e("./zlib/gzheader"),l=Object.prototype.toString,c=function(e){this.options=i.assign({chunkSize:16384,windowBits:0,to:""},e||{});var t=this.options;t.raw&&t.windowBits>=0&&t.windowBits<16&&(t.windowBits=-t.windowBits,t.windowBits===0&&(t.windowBits=-15)),t.windowBits>=0&&t.windowBits<16&&(!e||!e.windowBits)&&(t.windowBits+=32),t.windowBits>15&&t.windowBits<48&&(t.windowBits&15)===0&&(t.windowBits|=15),this.err=0,this.msg="",this.ended=!1,this.chunks=[],this.strm=new a,this.strm.avail_out=0;var n=r.inflateInit2(this.strm,t.windowBits);if(n!==o.Z_OK)throw new Error(u[n]);this.header=new f,r.inflateGetHeader(this.strm,this.header)};c.prototype.push=function(e,t){var n=this.strm,u=this.options.chunkSize,a,f,c,h,p;if(this.ended)return!1;f=t===~~t?t:t===!0?o.Z_FINISH:o.Z_NO_FLUSH,typeof e=="string"?n.input=s.binstring2buf(e):l.call(e)==="[object ArrayBuffer]"?n.input=new Uint8Array(e):n.input=e,n.next_in=0,n.avail_in=n.input.length;do{n.avail_out===0&&(n.output=new i.Buf8(u),n.next_out=0,n.avail_out=u),a=r.inflate(n,o.Z_NO_FLUSH);if(a!==o.Z_STREAM_END&&a!==o.Z_OK)return this.onEnd(a),this.ended=!0,!1;n.next_out&&(n.avail_out===0||a===o.Z_STREAM_END||n.avail_in===0&&f===o.Z_FINISH)&&(this.options.to==="string"?(c=s.utf8border(n.output,n.next_out),h=n.next_out-c,p=s.buf2string(n.output,c),n.next_out=h,n.avail_out=u-h,h&&i.arraySet(n.output,n.output,c,h,0),this.onData(p)):this.onData(i.shrinkBuf(n.output,n.next_out)))}while(n.avail_in>0&&a!==o.Z_STREAM_END);return a===o.Z_STREAM_END&&(f=o.Z_FINISH),f===o.Z_FINISH?(a=r.inflateEnd(this.strm),this.onEnd(a),this.ended=!0,a===o.Z_OK):!0},c.prototype.onData=function(e){this.chunks.push(e)},c.prototype.onEnd=function(e){e===o.Z_OK&&(this.options.to==="string"?this.result=this.chunks.join(""):this.result=i.flattenChunks(this.chunks)),this.chunks=[],this.err=e,this.msg=this.strm.msg},n.Inflate=c,n.inflate=h,n.inflateRaw=p,n.ungzip=h},{"./utils/common":3,"./utils/strings":4,"./zlib/constants":6,"./zlib/gzheader":9,"./zlib/inflate.js":11,"./zlib/messages":13,"./zlib/zstream":15}],3:[function(e,t,n){"use strict";var r=typeof Uint8Array!="undefined"&&typeof Uint16Array!="undefined"&&typeof Int32Array!="undefined";n.assign=function(e){var t=Array.prototype.slice.call(arguments,1);while(t.length){var n=t.shift();if(!n)continue;if(typeof n!="object")throw new TypeError(n+"must be non-object");for(var r in n)n.hasOwnProperty(r)&&(e[r]=n[r])}return e},n.shrinkBuf=function(e,t){return e.length===t?e:e.subarray?e.subarray(0,t):(e.length=t,e)};var i={arraySet:function(e,t,n,r,i){if(t.subarray&&e.subarray){e.set(t.subarray(n,n+r),i);return}for(var s=0;s<r;s++)e[i+s]=t[n+s]},flattenChunks:function(e){var t,n,r,i,s,o;r=0;for(t=0,n=e.length;t<n;t++)r+=e[t].length;o=new Uint8Array(r),i=0;for(t=0,n=e.length;t<n;t++)s=e[t],o.set(s,i),i+=s.length;return o}},s={arraySet:function(e,t,n,r,i){for(var s=0;s<r;s++)e[i+s]=t[n+s]},flattenChunks:function(e){return[].concat.apply([],e)}};n.setTyped=function(e){e?(n.Buf8=Uint8Array,n.Buf16=Uint16Array,n.Buf32=Int32Array,n.assign(n,i)):(n.Buf8=Array,n.Buf16=Array,n.Buf32=Array,n.assign(n,s))},n.setTyped(r)},{}],4:[function(e,t,n){function f(e,t){if(t<65537)if(e.subarray&&s||!e.subarray&&i)return String.fromCharCode.apply(null,r.shrinkBuf(e,t));var n="";for(var o=0;o<t;o++)n+=String.fromCharCode(e[o]);return n}var r=e("./common"),i=!0,s=!0;try{String.fromCharCode.apply(null,[0])}catch(o){i=!1}try{String.fromCharCode.apply(null,new Uint8Array(1))}catch(o){s=!1}var u=new r.Buf8(256);for(var a=0;a<256;a++)u[a]=a>=252?6:a>=248?5:a>=240?4:a>=224?3:a>=192?2:1;u[254]=u[254]=1,n.string2buf=function(e){var t,n,i,s,o,u=e.length,a=0;for(s=0;s<u;s++)n=e.charCodeAt(s),(n&64512)===55296&&s+1<u&&(i=e.charCodeAt(s+1),(i&64512)===56320&&(n=65536+(n-55296<<10)+(i-56320),s++)),a+=n<128?1:n<2048?2:n<65536?3:4;t=new r.Buf8(a);for(o=0,s=0;o<a;s++)n=e.charCodeAt(s),(n&64512)===55296&&s+1<u&&(i=e.charCodeAt(s+1),(i&64512)===56320&&(n=65536+(n-55296<<10)+(i-56320),s++)),n<128?t[o++]=n:n<2048?(t[o++]=192|n>>>6,t[o++]=128|n&63):n<65536?(t[o++]=224|n>>>12,t[o++]=128|n>>>6&63,t[o++]=128|n&63):(t[o++]=240|n>>>18,t[o++]=128|n>>>12&63,t[o++]=128|n>>>6&63,t[o++]=128|n&63);return t},n.buf2binstring=function(e){return f(e,e.length)},n.binstring2buf=function(e){var t=new r.Buf8(e.length);for(var n=0,i=t.length;n<i;n++)t[n]=e.charCodeAt(n);return t},n.buf2string=function(e,t){var n,r,i,s,o=t||e.length,a=new Array(o*2);for(r=0,n=0;n<o;){i=e[n++];if(i<128){a[r++]=i;continue}s=u[i];if(s>4){a[r++]=65533,n+=s-1;continue}i&=s===2?31:s===3?15:7;while(s>1&&n<o)i=i<<6|e[n++]&63,s--;if(s>1){a[r++]=65533;continue}i<65536?a[r++]=i:(i-=65536,a[r++]=55296|i>>10&1023,a[r++]=56320|i&1023)}return f(a,r)},n.utf8border=function(e,t){var n;t=t||e.length,t>e.length&&(t=e.length),n=t-1;while(n>=0&&(e[n]&192)===128)n--;return n<0?t:n===0?t:n+u[e[n]]>t?n:t}},{"./common":3}],5:[function(e,t,n){"use strict";function r(e,t,n,r){var i=e&65535|0,s=e>>>16&65535|0,o=0;while(n!==0){o=n>2e3?2e3:n,n-=o;do i=i+t[r++]|0,s=s+i|0;while(--o);i%=65521,s%=65521}return i|s<<16|0}t.exports=r},{}],6:[function(e,t,n){t.exports={Z_NO_FLUSH:0,Z_PARTIAL_FLUSH:1,Z_SYNC_FLUSH:2,Z_FULL_FLUSH:3,Z_FINISH:4,Z_BLOCK:5,Z_TREES:6,Z_OK:0,Z_STREAM_END:1,Z_NEED_DICT:2,Z_ERRNO:-1,Z_STREAM_ERROR:-2,Z_DATA_ERROR:-3,Z_BUF_ERROR:-5,Z_NO_COMPRESSION:0,Z_BEST_SPEED:1,Z_BEST_COMPRESSION:9,Z_DEFAULT_COMPRESSION:-1,Z_FILTERED:1,Z_HUFFMAN_ONLY:2,Z_RLE:3,Z_FIXED:4,Z_DEFAULT_STRATEGY:0,Z_BINARY:0,Z_TEXT:1,Z_UNKNOWN:2,Z_DEFLATED:8}},{}],7:[function(e,t,n){"use strict";function r(){var e,t=[];for(var n=0;n<256;n++){e=n;for(var r=0;r<8;r++)e=e&1?3988292384^e>>>1:e>>>1;t[n]=e}return t}function s(e,t,n,r){var s=i,o=r+n;e^=-1;for(var u=r;u<o;u++)e=e>>>8^s[(e^t[u])&255];return e^-1}var i=r();t.exports=s},{}],8:[function(e,t,n){"use strict";function Y(e,t){return e.msg=u[t],t}function Z(e){return(e<<1)-(e>4?9:0)}function et(e){var t=e.length;while(--t>=0)e[t]=0}function tt(e){var t=e.state,n=t.pending;n>e.avail_out&&(n=e.avail_out);if(n===0)return;r.arraySet(e.output,t.pending_buf,t.pending_out,n,e.next_out),e.next_out+=n,t.pending_out+=n,e.total_out+=n,e.avail_out-=n,t.pending-=n,t.pending===0&&(t.pending_out=0)}function nt(e,t){i._tr_flush_block(e,e.block_start>=0?e.block_start:-1,e.strstart-e.block_start,t),e.block_start=e.strstart,tt(e.strm)}function rt(e,t){e.pending_buf[e.pending++]=t}function it(e,t){e.pending_buf[e.pending++]=t>>>8&255,e.pending_buf[e.pending++]=t&255}function st(e,t,n,i){var u=e.avail_in;return u>i&&(u=i),u===0?0:(e.avail_in-=u,r.arraySet(t,e.input,e.next_in,u,n),e.state.wrap===1?e.adler=s(e.adler,t,u,n):e.state.wrap===2&&(e.adler=o(e.adler,t,u,n)),e.next_in+=u,e.total_in+=u,u)}function ot(e,t){var n=e.max_chain_length,r=e.strstart,i,s,o=e.prev_length,u=e.nice_match,a=e.strstart>e.w_size-F?e.strstart-(e.w_size-F):0,f=e.window,l=e.w_mask,c=e.prev,h=e.strstart+j,p=f[r+o-1],d=f[r+o];e.prev_length>=e.good_match&&(n>>=2),u>e.lookahead&&(u=e.lookahead);do{i=t;if(f[i+o]!==d||f[i+o-1]!==p||f[i]!==f[r]||f[++i]!==f[r+1])continue;r+=2,i++;do;while(f[++r]===f[++i]&&f[++r]===f[++i]&&f[++r]===f[++i]&&f[++r]===f[++i]&&f[++r]===f[++i]&&f[++r]===f[++i]&&f[++r]===f[++i]&&f[++r]===f[++i]&&r<h);s=j-(h-r),r=h-j;if(s>o){e.match_start=t,o=s;if(s>=u)break;p=f[r+o-1],d=f[r+o]}}while((t=c[t&l])>a&&--n!==0);return o<=e.lookahead?o:e.lookahead}function ut(e){var t=e.w_size,n,i,s,o,u;do{o=e.window_size-e.lookahead-e.strstart;if(e.strstart>=t+(t-F)){r.arraySet(e.window,e.window,t,t,0),e.match_start-=t,e.strstart-=t,e.block_start-=t,i=e.hash_size,n=i;do s=e.head[--n],e.head[n]=s>=t?s-t:0;while(--i);i=t,n=i;do s=e.prev[--n],e.prev[n]=s>=t?s-t:0;while(--i);o+=t}if(e.strm.avail_in===0)break;i=st(e.strm,e.window,e.strstart+e.lookahead,o),e.lookahead+=i;if(e.lookahead+e.insert>=B){u=e.strstart-e.insert,e.ins_h=e.window[u],e.ins_h=(e.ins_h<<e.hash_shift^e.window[u+1])&e.hash_mask;while(e.insert){e.ins_h=(e.ins_h<<e.hash_shift^e.window[u+B-1])&e.hash_mask,e.prev[u&e.w_mask]=e.head[e.ins_h],e.head[e.ins_h]=u,u++,e.insert--;if(e.lookahead+e.insert<B)break}}}while(e.lookahead<F&&e.strm.avail_in!==0)}function at(e,t){var n=65535;n>e.pending_buf_size-5&&(n=e.pending_buf_size-5);for(;;){if(e.lookahead<=1){ut(e);if(e.lookahead===0&&t===a)return $;if(e.lookahead===0)break}e.strstart+=e.lookahead,e.lookahead=0;var r=e.block_start+n;if(e.strstart===0||e.strstart>=r){e.lookahead=e.strstart-r,e.strstart=r,nt(e,!1);if(e.strm.avail_out===0)return $}if(e.strstart-e.block_start>=e.w_size-F){nt(e,!1);if(e.strm.avail_out===0)return $}}e.insert=0;if(t===c)return nt(e,!0),e.strm.avail_out===0?K:Q;if(e.strstart>e.block_start){nt(e,!1);if(e.strm.avail_out===0)return $}return $}function ft(e,t){var n,r;for(;;){if(e.lookahead<F){ut(e);if(e.lookahead<F&&t===a)return $;if(e.lookahead===0)break}n=0,e.lookahead>=B&&(e.ins_h=(e.ins_h<<e.hash_shift^e.window[e.strstart+B-1])&e.hash_mask,n=e.prev[e.strstart&e.w_mask]=e.head[e.ins_h],e.head[e.ins_h]=e.strstart),n!==0&&e.strstart-n<=e.w_size-F&&(e.match_length=ot(e,n));if(e.match_length>=B){r=i._tr_tally(e,e.strstart-e.match_start,e.match_length-B),e.lookahead-=e.match_length;if(e.match_length<=e.max_lazy_match&&e.lookahead>=B){e.match_length--;do e.strstart++,e.ins_h=(e.ins_h<<e.hash_shift^e.window[e.strstart+B-1])&e.hash_mask,n=e.prev[e.strstart&e.w_mask]=e.head[e.ins_h],e.head[e.ins_h]=e.strstart;while(--e.match_length!==0);e.strstart++}else e.strstart+=e.match_length,e.match_length=0,e.ins_h=e.window[e.strstart],e.ins_h=(e.ins_h<<e.hash_shift^e.window[e.strstart+1])&e.hash_mask}else r=i._tr_tally(e,0,e.window[e.strstart]),e.lookahead--,e.strstart++;if(r){nt(e,!1);if(e.strm.avail_out===0)return $}}e.insert=e.strstart<B-1?e.strstart:B-1;if(t===c)return nt(e,!0),e.strm.avail_out===0?K:Q;if(e.last_lit){nt(e,!1);if(e.strm.avail_out===0)return $}return J}function lt(e,t){var n,r,s;for(;;){if(e.lookahead<F){ut(e);if(e.lookahead<F&&t===a)return $;if(e.lookahead===0)break}n=0,e.lookahead>=B&&(e.ins_h=(e.ins_h<<e.hash_shift^e.window[e.strstart+B-1])&e.hash_mask,n=e.prev[e.strstart&e.w_mask]=e.head[e.ins_h],e.head[e.ins_h]=e.strstart),e.prev_length=e.match_length,e.prev_match=e.match_start,e.match_length=B-1,n!==0&&e.prev_length<e.max_lazy_match&&e.strstart-n<=e.w_size-F&&(e.match_length=ot(e,n),e.match_length<=5&&(e.strategy===b||e.match_length===B&&e.strstart-e.match_start>4096)&&(e.match_length=B-1));if(e.prev_length>=B&&e.match_length<=e.prev_length){s=e.strstart+e.lookahead-B,r=i._tr_tally(e,e.strstart-1-e.prev_match,e.prev_length-B),e.lookahead-=e.prev_length-1,e.prev_length-=2;do++e.strstart<=s&&(e.ins_h=(e.ins_h<<e.hash_shift^e.window[e.strstart+B-1])&e.hash_mask,n=e.prev[e.strstart&e.w_mask]=e.head[e.ins_h],e.head[e.ins_h]=e.strstart);while(--e.prev_length!==0);e.match_available=0,e.match_length=B-1,e.strstart++;if(r){nt(e,!1);if(e.strm.avail_out===0)return $}}else if(e.match_available){r=i._tr_tally(e,0,e.window[e.strstart-1]),r&&nt(e,!1),e.strstart++,e.lookahead--;if(e.strm.avail_out===0)return $}else e.match_available=1,e.strstart++,e.lookahead--}e.match_available&&(r=i._tr_tally(e,0,e.window[e.strstart-1]),e.match_available=0),e.insert=e.strstart<B-1?e.strstart:B-1;if(t===c)return nt(e,!0),e.strm.avail_out===0?K:Q;if(e.last_lit){nt(e,!1);if(e.strm.avail_out===0)return $}return J}function ct(e,t){var n,r,s,o,u=e.window;for(;;){if(e.lookahead<=j){ut(e);if(e.lookahead<=j&&t===a)return $;if(e.lookahead===0)break}e.match_length=0;if(e.lookahead>=B&&e.strstart>0){s=e.strstart-1,r=u[s];if(r===u[++s]&&r===u[++s]&&r===u[++s]){o=e.strstart+j;do;while(r===u[++s]&&r===u[++s]&&r===u[++s]&&r===u[++s]&&r===u[++s]&&r===u[++s]&&r===u[++s]&&r===u[++s]&&s<o);e.match_length=j-(o-s),e.match_length>e.lookahead&&(e.match_length=e.lookahead)}}e.match_length>=B?(n=i._tr_tally(e,1,e.match_length-B),e.lookahead-=e.match_length,e.strstart+=e.match_length,e.match_length=0):(n=i._tr_tally(e,0,e.window[e.strstart]),e.lookahead--,e.strstart++);if(n){nt(e,!1);if(e.strm.avail_out===0)return $}}e.insert=0;if(t===c)return nt(e,!0),e.strm.avail_out===0?K:Q;if(e.last_lit){nt(e,!1);if(e.strm.avail_out===0)return $}return J}function ht(e,t){var n;for(;;){if(e.lookahead===0){ut(e);if(e.lookahead===0){if(t===a)return $;break}}e.match_length=0,n=i._tr_tally(e,0,e.window[e.strstart]),e.lookahead--,e.strstart++;if(n){nt(e,!1);if(e.strm.avail_out===0)return $}}e.insert=0;if(t===c)return nt(e,!0),e.strm.avail_out===0?K:Q;if(e.last_lit){nt(e,!1);if(e.strm.avail_out===0)return $}return J}function vt(e){e.window_size=2*e.w_size,et(e.head),e.max_lazy_match=dt[e.level].max_lazy,e.good_match=dt[e.level].good_length,e.nice_match=dt[e.level].nice_length,e.max_chain_length=dt[e.level].max_chain,e.strstart=0,e.block_start=0,e.lookahead=0,e.insert=0,e.match_length=e.prev_length=B-1,e.match_available=0,e.ins_h=0}function mt(){this.strm=null,this.status=0,this.pending_buf=null,this.pending_buf_size=0,this.pending_out=0,this.pending=0,this.wrap=0,this.gzhead=null,this.gzindex=0,this.method=N,this.last_flush=-1,this.w_size=0,this.w_bits=0,this.w_mask=0,this.window=null,this.window_size=0,this.prev=null,this.head=null,this.ins_h=0,this.hash_size=0,this.hash_bits=0,this.hash_mask=0,this.hash_shift=0,this.block_start=0,this.match_length=0,this.prev_match=0,this.match_available=0,this.strstart=0,this.match_start=0,this.lookahead=0,this.prev_length=0,this.max_chain_length=0,this.max_lazy_match=0,this.level=0,this.strategy=0,this.good_match=0,this.nice_match=0,this.dyn_ltree=new r.Buf16(P*2),this.dyn_dtree=new r.Buf16((2*_+1)*2),this.bl_tree=new r.Buf16((2*D+1)*2),et(this.dyn_ltree),et(this.dyn_dtree),et(this.bl_tree),this.l_desc=null,this.d_desc=null,this.bl_desc=null,this.bl_count=new r.Buf16(H+1),this.heap=new r.Buf16(2*M+1),et(this.heap),this.heap_len=0,this.heap_max=0,this.depth=new r.Buf16(2*M+1),et(this.depth),this.l_buf=0,this.lit_bufsize=0,this.last_lit=0,this.d_buf=0,this.opt_len=0,this.static_len=0,this.matches=0,this.insert=0,this.bi_buf=0,this.bi_valid=0}function gt(e){var t;return!e||!e.state?Y(e,v):(e.total_in=e.total_out=0,e.data_type=T,t=e.state,t.pending=0,t.pending_out=0,t.wrap<0&&(t.wrap=-t.wrap),t.status=t.wrap?q:X,e.adler=t.wrap===2?0:1,t.last_flush=a,i._tr_init(t),p)}function yt(e){var t=gt(e);return t===p&&vt(e.state),t}function bt(e,t){return!e||!e.state?v:e.state.wrap!==2?v:(e.state.gzhead=t,p)}function wt(e,t,n,i,s,o){if(!e)return v;var u=1;t===y&&(t=6),i<0?(u=0,i=-i):i>15&&(u=2,i-=16);if(s<1||s>C||n!==N||i<8||i>15||t<0||t>9||o<0||o>S)return Y(e,v);i===8&&(i=9);var a=new mt;return e.state=a,a.strm=e,a.wrap=u,a.gzhead=null,a.w_bits=i,a.w_size=1<<a.w_bits,a.w_mask=a.w_size-1,a.hash_bits=s+7,a.hash_size=1<<a.hash_bits,a.hash_mask=a.hash_size-1,a.hash_shift=~~((a.hash_bits+B-1)/B),a.window=new r.Buf8(a.w_size*2),a.head=new r.Buf16(a.hash_size),a.prev=new r.Buf16(a.w_size),a.lit_bufsize=1<<s+6,a.pending_buf_size=a.lit_bufsize*4,a.pending_buf=new r.Buf8(a.pending_buf_size),a.d_buf=a.lit_bufsize>>1,a.l_buf=3*a.lit_bufsize,a.level=t,a.strategy=o,a.method=n,yt(e)}function Et(e,t){return wt(e,t,N,k,L,x)}function St(e,t){var n,r,s,u;if(!e||!e.state||t>h||t<0)return e?Y(e,v):v;r=e.state;if(!e.output||!e.input&&e.avail_in!==0||r.status===V&&t!==c)return Y(e,e.avail_out===0?g:v);r.strm=e,n=r.last_flush,r.last_flush=t;if(r.status===q)if(r.wrap===2)e.adler=0,rt(r,31),rt(r,139),rt(r,8),r.gzhead?(rt(r,(r.gzhead.text?1:0)+(r.gzhead.hcrc?2:0)+(r.gzhead.extra?4:0)+(r.gzhead.name?8:0)+(r.gzhead.comment?16:0)),rt(r,r.gzhead.time&255),rt(r,r.gzhead.time>>8&255),rt(r,r.gzhead.time>>16&255),rt(r,r.gzhead.time>>24&255),rt(r,r.level===9?2:r.strategy>=w||r.level<2?4:0),rt(r,r.gzhead.os&255),r.gzhead.extra&&r.gzhead.extra.length&&(rt(r,r.gzhead.extra.length&255),rt(r,r.gzhead.extra.length>>8&255)),r.gzhead.hcrc&&(e.adler=o(e.adler,r.pending_buf,r.pending,0)),r.gzindex=0,r.status=R):(rt(r,0),rt(r,0),rt(r,0),rt(r,0),rt(r,0),rt(r,r.level===9?2:r.strategy>=w||r.level<2?4:0),rt(r,G),r.status=X);else{var m=N+(r.w_bits-8<<4)<<8,y=-1;r.strategy>=w||r.level<2?y=0:r.level<6?y=1:r.level===6?y=2:y=3,m|=y<<6,r.strstart!==0&&(m|=I),m+=31-m%31,r.status=X,it(r,m),r.strstart!==0&&(it(r,e.adler>>>16),it(r,e.adler&65535)),e.adler=1}if(r.status===R)if(r.gzhead.extra){s=r.pending;while(r.gzindex<(r.gzhead.extra.length&65535)){if(r.pending===r.pending_buf_size){r.gzhead.hcrc&&r.pending>s&&(e.adler=o(e.adler,r.pending_buf,r.pending-s,s)),tt(e),s=r.pending;if(r.pending===r.pending_buf_size)break}rt(r,r.gzhead.extra[r.gzindex]&255),r.gzindex++}r.gzhead.hcrc&&r.pending>s&&(e.adler=o(e.adler,r.pending_buf,r.pending-s,s)),r.gzindex===r.gzhead.extra.length&&(r.gzindex=0,r.status=U)}else r.status=U;if(r.status===U)if(r.gzhead.name){s=r.pending;do{if(r.pending===r.pending_buf_size){r.gzhead.hcrc&&r.pending>s&&(e.adler=o(e.adler,r.pending_buf,r.pending-s,s)),tt(e),s=r.pending;if(r.pending===r.pending_buf_size){u=1;break}}r.gzindex<r.gzhead.name.length?u=r.gzhead.name.charCodeAt(r.gzindex++)&255:u=0,rt(r,u)}while(u!==0);r.gzhead.hcrc&&r.pending>s&&(e.adler=o(e.adler,r.pending_buf,r.pending-s,s)),u===0&&(r.gzindex=0,r.status=z)}else r.status=z;if(r.status===z)if(r.gzhead.comment){s=r.pending;do{if(r.pending===r.pending_buf_size){r.gzhead.hcrc&&r.pending>s&&(e.adler=o(e.adler,r.pending_buf,r.pending-s,s)),tt(e),s=r.pending;if(r.pending===r.pending_buf_size){u=1;break}}r.gzindex<r.gzhead.comment.length?u=r.gzhead.comment.charCodeAt(r.gzindex++)&255:u=0,rt(r,u)}while(u!==0);r.gzhead.hcrc&&r.pending>s&&(e.adler=o(e.adler,r.pending_buf,r.pending-s,s)),u===0&&(r.status=W)}else r.status=W;r.status===W&&(r.gzhead.hcrc?(r.pending+2>r.pending_buf_size&&tt(e),r.pending+2<=r.pending_buf_size&&(rt(r,e.adler&255),rt(r,e.adler>>8&255),e.adler=0,r.status=X)):r.status=X);if(r.pending!==0){tt(e);if(e.avail_out===0)return r.last_flush=-1,p}else if(e.avail_in===0&&Z(t)<=Z(n)&&t!==c)return Y(e,g);if(r.status===V&&e.avail_in!==0)return Y(e,g);if(e.avail_in!==0||r.lookahead!==0||t!==a&&r.status!==V){var b=r.strategy===w?ht(r,t):r.strategy===E?ct(r,t):dt[r.level].func(r,t);if(b===K||b===Q)r.status=V;if(b===$||b===K)return e.avail_out===0&&(r.last_flush=-1),p;if(b===J){t===f?i._tr_align(r):t!==h&&(i._tr_stored_block(r,0,0,!1),t===l&&(et(r.head),r.lookahead===0&&(r.strstart=0,r.block_start=0,r.insert=0))),tt(e);if(e.avail_out===0)return r.last_flush=-1,p}}return t!==c?p:r.wrap<=0?d:(r.wrap===2?(rt(r,e.adler&255),rt(r,e.adler>>8&255),rt(r,e.adler>>16&255),rt(r,e.adler>>24&255),rt(r,e.total_in&255),rt(r,e.total_in>>8&255),rt(r,e.total_in>>16&255),rt(r,e.total_in>>24&255)):(it(r,e.adler>>>16),it(r,e.adler&65535)),tt(e),r.wrap>0&&(r.wrap=-r.wrap),r.pending!==0?p:d)}function xt(e){var t;return!e||!e.state?v:(t=e.state.status,t!==q&&t!==R&&t!==U&&t!==z&&t!==W&&t!==X&&t!==V?Y(e,v):(e.state=null,t===X?Y(e,m):p))}var r=e("../utils/common"),i=e("./trees"),s=e("./adler32"),o=e("./crc32"),u=e("./messages"),a=0,f=1,l=3,c=4,h=5,p=0,d=1,v=-2,m=-3,g=-5,y=-1,b=1,w=2,E=3,S=4,x=0,T=2,N=8,C=9,k=15,L=8,A=29,O=256,M=O+1+A,_=30,D=19,P=2*M+1,H=15,B=3,j=258,F=j+B+1,I=32,q=42,R=69,U=73,z=91,W=103,X=113,V=666,$=1,J=2,K=3,Q=4,G=3,pt=function(e,t,n,r,i){this.good_length=e,this.max_lazy=t,this.nice_length=n,this.max_chain=r,this.func=i},dt;dt=[new pt(0,0,0,0,at),new pt(4,4,8,4,ft),new pt(4,5,16,8,ft),new pt(4,6,32,32,ft),new pt(4,4,16,16,lt),new pt(8,16,32,32,lt),new pt(8,16,128,128,lt),new pt(8,32,128,256,lt),new pt(32,128,258,1024,lt),new pt(32,258,258,4096,lt)],n.deflateInit=Et,n.deflateInit2=wt,n.deflateReset=yt,n.deflateResetKeep=gt,n.deflateSetHeader=bt,n.deflate=St,n.deflateEnd=xt,n.deflateInfo="pako deflate (from Nodeca project)"},{"../utils/common":3,"./adler32":5,"./crc32":7,"./messages":13,"./trees":14}],9:[function(e,t,n){"use strict";function r(){this.text=0,this.time=0,this.xflags=0,this.os=0,this.extra=null,this.extra_len=0,this.name="",this.comment="",this.hcrc=0,this.done=!1}t.exports=r},{}],10:[function(e,t,n){"use strict";var r=30,i=12;t.exports=function(t,n){var s,o,u,a,f,l,c,h,p,d,v,m,g,y,b,w,E,S,x,T,N,C,k,L,A;s=t.state,o=t.next_in,L=t.input,u=o+(t.avail_in-5),a=t.next_out,A=t.output,f=a-(n-t.avail_out),l=a+(t.avail_out-257),c=s.dmax,h=s.wsize,p=s.whave,d=s.wnext,v=s.window,m=s.hold,g=s.bits,y=s.lencode,b=s.distcode,w=(1<<s.lenbits)-1,E=(1<<s.distbits)-1;e:do{g<15&&(m+=L[o++]<<g,g+=8,m+=L[o++]<<g,g+=8),S=y[m&w];t:for(;;){x=S>>>24,m>>>=x,g-=x,x=S>>>16&255;if(x===0)A[a++]=S&65535;else{if(!(x&16)){if((x&64)===0){S=y[(S&65535)+(m&(1<<x)-1)];continue t}if(x&32){s.mode=i;break e}t.msg="invalid literal/length code",s.mode=r;break e}T=S&65535,x&=15,x&&(g<x&&(m+=L[o++]<<g,g+=8),T+=m&(1<<x)-1,m>>>=x,g-=x),g<15&&(m+=L[o++]<<g,g+=8,m+=L[o++]<<g,g+=8),S=b[m&E];n:for(;;){x=S>>>24,m>>>=x,g-=x,x=S>>>16&255;if(!(x&16)){if((x&64)===0){S=b[(S&65535)+(m&(1<<x)-1)];continue n}t.msg="invalid distance code",s.mode=r;break e}N=S&65535,x&=15,g<x&&(m+=L[o++]<<g,g+=8,g<x&&(m+=L[o++]<<g,g+=8)),N+=m&(1<<x)-1;if(N>c){t.msg="invalid distance too far back",s.mode=r;break e}m>>>=x,g-=x,x=a-f;if(N>x){x=N-x;if(x>p&&s.sane){t.msg="invalid distance too far back",s.mode=r;break e}C=0,k=v;if(d===0){C+=h-x;if(x<T){T-=x;do A[a++]=v[C++];while(--x);C=a-N,k=A}}else if(d<x){C+=h+d-x,x-=d;if(x<T){T-=x;do A[a++]=v[C++];while(--x);C=0;if(d<T){x=d,T-=x;do A[a++]=v[C++];while(--x);C=a-N,k=A}}}else{C+=d-x;if(x<T){T-=x;do A[a++]=v[C++];while(--x);C=a-N,k=A}}while(T>2)A[a++]=k[C++],A[a++]=k[C++],A[a++]=k[C++],T-=3;T&&(A[a++]=k[C++],T>1&&(A[a++]=k[C++]))}else{C=a-N;do A[a++]=A[C++],A[a++]=A[C++],A[a++]=A[C++],T-=3;while(T>2);T&&(A[a++]=A[C++],T>1&&(A[a++]=A[C++]))}break}}break}}while(o<u&&a<l);T=g>>3,o-=T,g-=T<<3,m&=(1<<g)-1,t.next_in=o,t.next_out=a,t.avail_in=o<u?5+(u-o):5-(o-u),t.avail_out=a<l?257+(l-a):257-(a-l),s.hold=m,s.bits=g;return}},{}],11:[function(e,t,n){"use strict";function it(e){return(e>>>24&255)+(e>>>8&65280)+((e&65280)<<8)+((e&255)<<24)}function st(){this.mode=0,this.last=!1,this.wrap=0,this.havedict=!1,this.flags=0,this.dmax=0,this.check=0,this.total=0,this.head=null,this.wbits=0,this.wsize=0,this.whave=0,this.wnext=0,this.window=null,this.hold=0,this.bits=0,this.length=0,this.offset=0,this.extra=0,this.lencode=null,this.distcode=null,this.lenbits=0,this.distbits=0,this.ncode=0,this.nlen=0,this.ndist=0,this.have=0,this.next=null,this.lens=new r.Buf16(320),this.work=new r.Buf16(288),this.lendyn=null,this.distdyn=null,this.sane=0,this.back=0,this.was=0}function ot(e){var t;return!e||!e.state?g:(t=e.state,e.total_in=e.total_out=t.total=0,e.msg="",t.wrap&&(e.adler=t.wrap&1),t.mode=S,t.last=0,t.havedict=0,t.dmax=32768,t.head=null,t.hold=0,t.bits=0,t.lencode=t.lendyn=new r.Buf32(et),t.distcode=t.distdyn=new r.Buf32(tt),t.sane=1,t.back=-1,d)}function ut(e){var t;return!e||!e.state?g:(t=e.state,t.wsize=0,t.whave=0,t.wnext=0,ot(e))}function at(e,t){var n,r;return!e||!e.state?g:(r=e.state,t<0?(n=0,t=-t):(n=(t>>4)+1,t<48&&(t&=15)),t&&(t<8||t>15)?g:(r.window!==null&&r.wbits!==t&&(r.window=null),r.wrap=n,r.wbits=t,ut(e)))}function ft(e,t){var n,r;return e?(r=new st,e.state=r,r.window=null,n=at(e,t),n!==d&&(e.state=null),n):g}function lt(e){return ft(e,rt)}function dt(e){if(ct){var t;ht=new r.Buf32(512),pt=new r.Buf32(32),t=0;while(t<144)e.lens[t++]=8;while(t<256)e.lens[t++]=9;while(t<280)e.lens[t++]=7;while(t<288)e.lens[t++]=8;u(f,e.lens,0,288,ht,0,e.work,{bits:9}),t=0;while(t<32)e.lens[t++]=5;u(l,e.lens,0,32,pt,0,e.work,{bits:5}),ct=!1}e.lencode=ht,e.lenbits=9,e.distcode=pt,e.distbits=5}function vt(e,t,n,i){var s,o=e.state;return o.window===null&&(o.wsize=1<<o.wbits,o.wnext=0,o.whave=0,o.window=new r.Buf8(o.wsize)),i>=o.wsize?(r.arraySet(o.window,t,n-o.wsize,o.wsize,0),o.wnext=0,o.whave=o.wsize):(s=o.wsize-o.wnext,s>i&&(s=i),r.arraySet(o.window,t,n-i,s,o.wnext),i-=s,i?(r.arraySet(o.window,t,n-i,i,0),o.wnext=i,o.whave=o.wsize):(o.wnext+=s,o.wnext===o.wsize&&(o.wnext=0),o.whave<o.wsize&&(o.whave+=s))),0}function mt(e,t){var n,et,tt,nt,rt,st,ot,ut,at,ft,lt,ct,ht,pt,mt=0,gt,yt,bt,wt,Et,St,xt,Tt,Nt=new r.Buf8(4),Ct,kt,Lt=[16,17,18,0,8,7,9,6,10,5,11,4,12,3,13,2,14,1,15];if(!e||!e.state||!e.output||!e.input&&e.avail_in!==0)return g;n=e.state,n.mode===D&&(n.mode=P),rt=e.next_out,tt=e.output,ot=e.avail_out,nt=e.next_in,et=e.input,st=e.avail_in,ut=n.hold,at=n.bits,ft=st,lt=ot,Tt=d;e:for(;;)switch(n.mode){case S:if(n.wrap===0){n.mode=P;break}while(at<16){if(st===0)break e;st--,ut+=et[nt++]<<at,at+=8}if(n.wrap&2&&ut===35615){n.check=0,Nt[0]=ut&255,Nt[1]=ut>>>8&255,n.check=s(n.check,Nt,2,0),ut=0,at=0,n.mode=x;break}n.flags=0,n.head&&(n.head.done=!1);if(!(n.wrap&1)||(((ut&255)<<8)+(ut>>8))%31){e.msg="incorrect header check",n.mode=G;break}if((ut&15)!==E){e.msg="unknown compression method",n.mode=G;break}ut>>>=4,at-=4,xt=(ut&15)+8;if(n.wbits===0)n.wbits=xt;else if(xt>n.wbits){e.msg="invalid window size",n.mode=G;break}n.dmax=1<<xt,e.adler=n.check=1,n.mode=ut&512?M:D,ut=0,at=0;break;case x:while(at<16){if(st===0)break e;st--,ut+=et[nt++]<<at,at+=8}n.flags=ut;if((n.flags&255)!==E){e.msg="unknown compression method",n.mode=G;break}if(n.flags&57344){e.msg="unknown header flags set",n.mode=G;break}n.head&&(n.head.text=ut>>8&1),n.flags&512&&(Nt[0]=ut&255,Nt[1]=ut>>>8&255,n.check=s(n.check,Nt,2,0)),ut=0,at=0,n.mode=T;case T:while(at<32){if(st===0)break e;st--,ut+=et[nt++]<<at,at+=8}n.head&&(n.head.time=ut),n.flags&512&&(Nt[0]=ut&255,Nt[1]=ut>>>8&255,Nt[2]=ut>>>16&255,Nt[3]=ut>>>24&255,n.check=s(n.check,Nt,4,0)),ut=0,at=0,n.mode=N;case N:while(at<16){if(st===0)break e;st--,ut+=et[nt++]<<at,at+=8}n.head&&(n.head.xflags=ut&255,n.head.os=ut>>8),n.flags&512&&(Nt[0]=ut&255,Nt[1]=ut>>>8&255,n.check=s(n.check,Nt,2,0)),ut=0,at=0,n.mode=C;case C:if(n.flags&1024){while(at<16){if(st===0)break e;st--,ut+=et[nt++]<<at,at+=8}n.length=ut,n.head&&(n.head.extra_len=ut),n.flags&512&&(Nt[0]=ut&255,Nt[1]=ut>>>8&255,n.check=s(n.check,Nt,2,0)),ut=0,at=0}else n.head&&(n.head.extra=null);n.mode=k;case k:if(n.flags&1024){ct=n.length,ct>st&&(ct=st),ct&&(n.head&&(xt=n.head.extra_len-n.length,n.head.extra||(n.head.extra=new Array(n.head.extra_len)),r.arraySet(n.head.extra,et,nt,ct,xt)),n.flags&512&&(n.check=s(n.check,et,ct,nt)),st-=ct,nt+=ct,n.length-=ct);if(n.length)break e}n.length=0,n.mode=L;case L:if(n.flags&2048){if(st===0)break e;ct=0;do xt=et[nt+ct++],n.head&&xt&&n.length<65536&&(n.head.name+=String.fromCharCode(xt));while(xt&&ct<st);n.flags&512&&(n.check=s(n.check,et,ct,nt)),st-=ct,nt+=ct;if(xt)break e}else n.head&&(n.head.name=null);n.length=0,n.mode=A;case A:if(n.flags&4096){if(st===0)break e;ct=0;do xt=et[nt+ct++],n.head&&xt&&n.length<65536&&(n.head.comment+=String.fromCharCode(xt));while(xt&&ct<st);n.flags&512&&(n.check=s(n.check,et,ct,nt)),st-=ct,nt+=ct;if(xt)break e}else n.head&&(n.head.comment=null);n.mode=O;case O:if(n.flags&512){while(at<16){if(st===0)break e;st--,ut+=et[nt++]<<at,at+=8}if(ut!==(n.check&65535)){e.msg="header crc mismatch",n.mode=G;break}ut=0,at=0}n.head&&(n.head.hcrc=n.flags>>9&1,n.head.done=!0),e.adler=n.check=0,n.mode=D;break;case M:while(at<32){if(st===0)break e;st--,ut+=et[nt++]<<at,at+=8}e.adler=n.check=it(ut),ut=0,at=0,n.mode=_;case _:if(n.havedict===0)return e.next_out=rt,e.avail_out=ot,e.next_in=nt,e.avail_in=st,n.hold=ut,n.bits=at,m;e.adler=n.check=1,n.mode=D;case D:if(t===h||t===p)break e;case P:if(n.last){ut>>>=at&7,at-=at&7,n.mode=J;break}while(at<3){if(st===0)break e;st--,ut+=et[nt++]<<at,at+=8}n.last=ut&1,ut>>>=1,at-=1;switch(ut&3){case 0:n.mode=H;break;case 1:dt(n),n.mode=R;if(t===p){ut>>>=2,at-=2;break e}break;case 2:n.mode=F;break;case 3:e.msg="invalid block type",n.mode=G}ut>>>=2,at-=2;break;case H:ut>>>=at&7,at-=at&7;while(at<32){if(st===0)break e;st--,ut+=et[nt++]<<at,at+=8}if((ut&65535)!==(ut>>>16^65535)){e.msg="invalid stored block lengths",n.mode=G;break}n.length=ut&65535,ut=0,at=0,n.mode=B;if(t===p)break e;case B:n.mode=j;case j:ct=n.length;if(ct){ct>st&&(ct=st),ct>ot&&(ct=ot);if(ct===0)break e;r.arraySet(tt,et,nt,ct,rt),st-=ct,nt+=ct,ot-=ct,rt+=ct,n.length-=ct;break}n.mode=D;break;case F:while(at<14){if(st===0)break e;st--,ut+=et[nt++]<<at,at+=8}n.nlen=(ut&31)+257,ut>>>=5,at-=5,n.ndist=(ut&31)+1,ut>>>=5,at-=5,n.ncode=(ut&15)+4,ut>>>=4,at-=4;if(n.nlen>286||n.ndist>30){e.msg="too many length or distance symbols",n.mode=G;break}n.have=0,n.mode=I;case I:while(n.have<n.ncode){while(at<3){if(st===0)break e;st--,ut+=et[nt++]<<at,at+=8}n.lens[Lt[n.have++]]=ut&7,ut>>>=3,at-=3}while(n.have<19)n.lens[Lt[n.have++]]=0;n.lencode=n.lendyn,n.lenbits=7,Ct={bits:n.lenbits},Tt=u(a,n.lens,0,19,n.lencode,0,n.work,Ct),n.lenbits=Ct.bits;if(Tt){e.msg="invalid code lengths set",n.mode=G;break}n.have=0,n.mode=q;case q:while(n.have<n.nlen+n.ndist){for(;;){mt=n.lencode[ut&(1<<n.lenbits)-1],gt=mt>>>24,yt=mt>>>16&255,bt=mt&65535;if(gt<=at)break;if(st===0)break e;st--,ut+=et[nt++]<<at,at+=8}if(bt<16)ut>>>=gt,at-=gt,n.lens[n.have++]=bt;else{if(bt===16){kt=gt+2;while(at<kt){if(st===0)break e;st--,ut+=et[nt++]<<at,at+=8}ut>>>=gt,at-=gt;if(n.have===0){e.msg="invalid bit length repeat",n.mode=G;break}xt=n.lens[n.have-1],ct=3+(ut&3),ut>>>=2,at-=2}else if(bt===17){kt=gt+3;while(at<kt){if(st===0)break e;st--,ut+=et[nt++]<<at,at+=8}ut>>>=gt,at-=gt,xt=0,ct=3+(ut&7),ut>>>=3,at-=3}else{kt=gt+7;while(at<kt){if(st===0)break e;st--,ut+=et[nt++]<<at,at+=8}ut>>>=gt,at-=gt,xt=0,ct=11+(ut&127),ut>>>=7,at-=7}if(n.have+ct>n.nlen+n.ndist){e.msg="invalid bit length repeat",n.mode=G;break}while(ct--)n.lens[n.have++]=xt}}if(n.mode===G)break;if(n.lens[256]===0){e.msg="invalid code -- missing end-of-block",n.mode=G;break}n.lenbits=9,Ct={bits:n.lenbits},Tt=u(f,n.lens,0,n.nlen,n.lencode,0,n.work,Ct),n.lenbits=Ct.bits;if(Tt){e.msg="invalid literal/lengths set",n.mode=G;break}n.distbits=6,n.distcode=n.distdyn,Ct={bits:n.distbits},Tt=u(l,n.lens,n.nlen,n.ndist,n.distcode,0,n.work,Ct),n.distbits=Ct.bits;if(Tt){e.msg="invalid distances set",n.mode=G;break}n.mode=R;if(t===p)break e;case R:n.mode=U;case U:if(st>=6&&ot>=258){e.next_out=rt,e.avail_out=ot,e.next_in=nt,e.avail_in=st,n.hold=ut,n.bits=at,o(e,lt),rt=e.next_out,tt=e.output,ot=e.avail_out,nt=e.next_in,et=e.input,st=e.avail_in,ut=n.hold,at=n.bits,n.mode===D&&(n.back=-1);break}n.back=0;for(;;){mt=n.lencode[ut&(1<<n.lenbits)-1],gt=mt>>>24,yt=mt>>>16&255,bt=mt&65535;if(gt<=at)break;if(st===0)break e;st--,ut+=et[nt++]<<at,at+=8}if(yt&&(yt&240)===0){wt=gt,Et=yt,St=bt;for(;;){mt=n.lencode[St+((ut&(1<<wt+Et)-1)>>wt)],gt=mt>>>24,yt=mt>>>16&255,bt=mt&65535;if(wt+gt<=at)break;if(st===0)break e;st--,ut+=et[nt++]<<at,at+=8}ut>>>=wt,at-=wt,n.back+=wt}ut>>>=gt,at-=gt,n.back+=gt,n.length=bt;if(yt===0){n.mode=$;break}if(yt&32){n.back=-1,n.mode=D;break}if(yt&64){e.msg="invalid literal/length code",n.mode=G;break}n.extra=yt&15,n.mode=z;case z:if(n.extra){kt=n.extra;while(at<kt){if(st===0)break e;st--,ut+=et[nt++]<<at,at+=8}n.length+=ut&(1<<n.extra)-1,ut>>>=n.extra,at-=n.extra,n.back+=n.extra}n.was=n.length,n.mode=W;case W:for(;;){mt=n.distcode[ut&(1<<n.distbits)-1],gt=mt>>>24,yt=mt>>>16&255,bt=mt&65535;if(gt<=at)break;if(st===0)break e;st--,ut+=et[nt++]<<at,at+=8}if((yt&240)===0){wt=gt,Et=yt,St=bt;for(;;){mt=n.distcode[St+((ut&(1<<wt+Et)-1)>>wt)],gt=mt>>>24,yt=mt>>>16&255,bt=mt&65535;if(wt+gt<=at)break;if(st===0)break e;st--,ut+=et[nt++]<<at,at+=8}ut>>>=wt,at-=wt,n.back+=wt}ut>>>=gt,at-=gt,n.back+=gt;if(yt&64){e.msg="invalid distance code",n.mode=G;break}n.offset=bt,n.extra=yt&15,n.mode=X;case X:if(n.extra){kt=n.extra;while(at<kt){if(st===0)break e;st--,ut+=et[nt++]<<at,at+=8}n.offset+=ut&(1<<n.extra)-1,ut>>>=n.extra,at-=n.extra,n.back+=n.extra}if(n.offset>n.dmax){e.msg="invalid distance too far back",n.mode=G;break}n.mode=V;case V:if(ot===0)break e;ct=lt-ot;if(n.offset>ct){ct=n.offset-ct;if(ct>n.whave&&n.sane){e.msg="invalid distance too far back",n.mode=G;break}ct>n.wnext?(ct-=n.wnext,ht=n.wsize-ct):ht=n.wnext-ct,ct>n.length&&(ct=n.length),pt=n.window}else pt=tt,ht=rt-n.offset,ct=n.length;ct>ot&&(ct=ot),ot-=ct,n.length-=ct;do tt[rt++]=pt[ht++];while(--ct);n.length===0&&(n.mode=U);break;case $:if(ot===0)break e;tt[rt++]=n.length,ot--,n.mode=U;break;case J:if(n.wrap){while(at<32){if(st===0)break e;st--,ut|=et[nt++]<<at,at+=8}lt-=ot,e.total_out+=lt,n.total+=lt,lt&&(e.adler=n.check=n.flags?s(n.check,tt,lt,rt-lt):i(n.check,tt,lt,rt-lt)),lt=ot;if((n.flags?ut:it(ut))!==n.check){e.msg="incorrect data check",n.mode=G;break}ut=0,at=0}n.mode=K;case K:if(n.wrap&&n.flags){while(at<32){if(st===0)break e;st--,ut+=et[nt++]<<at,at+=8}if(ut!==(n.total&4294967295)){e.msg="incorrect length check",n.mode=G;break}ut=0,at=0}n.mode=Q;case Q:Tt=v;break e;case G:Tt=y;break e;case Y:return b;case Z:default:return g}e.next_out=rt,e.avail_out=ot,e.next_in=nt,e.avail_in=st,n.hold=ut,n.bits=at;if(n.wsize||lt!==e.avail_out&&n.mode<G&&(n.mode<J||t!==c))if(vt(e,e.output,e.next_out,lt-e.avail_out))return n.mode=Y,b;return ft-=e.avail_in,lt-=e.avail_out,e.total_in+=ft,e.total_out+=lt,n.total+=lt,n.wrap&&lt&&(e.adler=n.check=n.flags?s(n.check,tt,lt,e.next_out-lt):i(n.check,tt,lt,e.next_out-lt)),e.data_type=n.bits+(n.last?64:0)+(n.mode===D?128:0)+(n.mode===R||n.mode===B?256:0),(ft===0&&lt===0||t===c)&&Tt===d&&(Tt=w),Tt}function gt(e){if(!e||!e.state)return g;var t=e.state;return t.window&&(t.window=null),e.state=null,d}function yt(e,t){var n;return!e||!e.state?g:(n=e.state,(n.wrap&2)===0?g:(n.head=t,t.done=!1,d))}var r=e("../utils/common"),i=e("./adler32"),s=e("./crc32"),o=e("./inffast"),u=e("./inftrees"),a=0,f=1,l=2,c=4,h=5,p=6,d=0,v=1,m=2,g=-2,y=-3,b=-4,w=-5,E=8,S=1,x=2,T=3,N=4,C=5,k=6,L=7,A=8,O=9,M=10,_=11,D=12,P=13,H=14,B=15,j=16,F=17,I=18,q=19,R=20,U=21,z=22,W=23,X=24,V=25,$=26,J=27,K=28,Q=29,G=30,Y=31,Z=32,et=852,tt=592,nt=15,rt=nt,ct=!0,ht,pt;n.inflateReset=ut,n.inflateReset2=at,n.inflateResetKeep=ot,n.inflateInit=lt,n.inflateInit2=ft,n.inflate=mt,n.inflateEnd=gt,n.inflateGetHeader=yt,n.inflateInfo="pako inflate (from Nodeca project)"},{"../utils/common":3,"./adler32":5,"./crc32":7,"./inffast":10,"./inftrees":12}],12:[function(e,t,n){"use strict";var r=e("../utils/common"),i=15,s=852,o=592,u=0,a=1,f=2,l=[3,4,5,6,7,8,9,10,11,13,15,17,19,23,27,31,35,43,51,59,67,83,99,115,131,163,195,227,258,0,0],c=[16,16,16,16,16,16,16,16,17,17,17,17,18,18,18,18,19,19,19,19,20,20,20,20,21,21,21,21,16,72,78],h=[1,2,3,4,5,7,9,13,17,25,33,49,65,97,129,193,257,385,513,769,1025,1537,2049,3073,4097,6145,8193,12289,16385,24577,0,0],p=[16,16,16,16,17,17,18,18,19,19,20,20,21,21,22,22,23,23,24,24,25,25,26,26,27,27,28,28,29,29,64,64];t.exports=function(t,n,d,v,m,g,y,b){var w=b.bits,E=0,S=0,x=0,T=0,N=0,C=0,k=0,L=0,A=0,O=0,M,_,D,P,H,B=null,j=0,F,I=new r.Buf16(i+1),q=new r.Buf16(i+1),R=null,U=0,z,W,X;for(E=0;E<=i;E++)I[E]=0;for(S=0;S<v;S++)I[n[d+S]]++;N=w;for(T=i;T>=1;T--)if(I[T]!==0)break;N>T&&(N=T);if(T===0)return m[g++]=20971520,m[g++]=20971520,b.bits=1,0;for(x=1;x<T;x++)if(I[x]!==0)break;N<x&&(N=x),L=1;for(E=1;E<=i;E++){L<<=1,L-=I[E];if(L<0)return-1}if(L>0&&(t===u||T!==1))return-1;q[1]=0;for(E=1;E<i;E++)q[E+1]=q[E]+I[E];for(S=0;S<v;S++)n[d+S]!==0&&(y[q[n[d+S]]++]=S);t===u?(B=R=y,F=19):t===a?(B=l,j-=257,R=c,U-=257,F=256):(B=h,R=p,F=-1),O=0,S=0,E=x,H=g,C=N,k=0,D=-1,A=1<<N,P=A-1;if(t===a&&A>s||t===f&&A>o)return 1;var V=0;for(;;){V++,z=E-k,y[S]<F?(W=0,X=y[S]):y[S]>F?(W=R[U+y[S]],X=B[j+y[S]]):(W=96,X=0),M=1<<E-k,_=1<<C,x=_;do _-=M,m[H+(O>>k)+_]=z<<24|W<<16|X|0;while(_!==0);M=1<<E-1;while(O&M)M>>=1;M!==0?(O&=M-1,O+=M):O=0,S++;if(--I[E]===0){if(E===T)break;E=n[d+y[S]]}if(E>N&&(O&P)!==D){k===0&&(k=N),H+=x,C=E-k,L=1<<C;while(C+k<T){L-=I[C+k];if(L<=0)break;C++,L<<=1}A+=1<<C;if(t===a&&A>s||t===f&&A>o)return 1;D=O&P,m[D]=N<<24|C<<16|H-g|0}}return O!==0&&(m[H+O]=E-k<<24|64<<16|0),b.bits=N,0}},{"../utils/common":3}],13:[function(e,t,n){"use strict";t.exports={2:"need dictionary",1:"stream end",0:"","-1":"file error","-2":"stream error","-3":"data error","-4":"insufficient memory","-5":"buffer error","-6":"incompatible version"}},{}],14:[function(e,t,n){"use strict";function a(e){var t=e.length;while(--t>=0)e[t]=0}function z(e){return e<256?P[e]:P[256+(e>>>7)]}function W(e,t){e.pending_buf[e.pending++]=t&255,e.pending_buf[e.pending++]=t>>>8&255}function X(e,t,n){e.bi_valid>E-n?(e.bi_buf|=t<<e.bi_valid&65535,W(e,e.bi_buf),e.bi_buf=t>>E-e.bi_valid,e.bi_valid+=n-E):(e.bi_buf|=t<<e.bi_valid&65535,e.bi_valid+=n)}function V(e,t,n){X(e,n[t*2],n[t*2+1])}function $(e,t){var n=0;do n|=e&1,e>>>=1,n<<=1;while(--t>0);return n>>>1}function J(e){e.bi_valid===16?(W(e,e.bi_buf),e.bi_buf=0,e.bi_valid=0):e.bi_valid>=8&&(e.pending_buf[e.pending++]=e.bi_buf&255,e.bi_buf>>=8,e.bi_valid-=8)}function K(e,t){var n=t.dyn_tree,r=t.max_code,i=t.stat_desc.static_tree,s=t.stat_desc.has_stree,o=t.stat_desc.extra_bits,u=t.stat_desc.extra_base,a=t.stat_desc.max_length,f,l,c,h,p,d,v=0;for(h=0;h<=w;h++)e.bl_count[h]=0;n[e.heap[e.heap_max]*2+1]=0;for(f=e.heap_max+1;f<b;f++){l=e.heap[f],h=n[n[l*2+1]*2+1]+1,h>a&&(h=a,v++),n[l*2+1]=h;if(l>r)continue;e.bl_count[h]++,p=0,l>=u&&(p=o[l-u]),d=n[l*2],e.opt_len+=d*(h+p),s&&(e.static_len+=d*(i[l*2+1]+p))}if(v===0)return;do{h=a-1;while(e.bl_count[h]===0)h--;e.bl_count[h]--,e.bl_count[h+1]+=2,e.bl_count[a]--,v-=2}while(v>0);for(h=a;h!==0;h--){l=e.bl_count[h];while(l!==0){c=e.heap[--f];if(c>r)continue;n[c*2+1]!==h&&(e.opt_len+=(h-n[c*2+1])*n[c*2],n[c*2+1]=h),l--}}}function Q(e,t,n){var r=new Array(w+1),i=0,s,o;for(s=1;s<=w;s++)r[s]=i=i+n[s-1]<<1;for(o=0;o<=t;o++){var u=e[o*2+1];if(u===0)continue;e[o*2]=$(r[u]++,u)}}function G(){var e,t,n,r,i,s=new Array(w+1);n=0;for(r=0;r<d-1;r++){B[r]=n;for(e=0;e<1<<k[r];e++)H[n++]=r}H[n-1]=r,i=0;for(r=0;r<16;r++){j[r]=i;for(e=0;e<1<<L[r];e++)P[i++]=r}i>>=7;for(;r<g;r++){j[r]=i<<7;for(e=0;e<1<<L[r]-7;e++)P[256+i++]=r}for(t=0;t<=w;t++)s[t]=0;e=0;while(e<=143)_[e*2+1]=8,e++,s[8]++;while(e<=255)_[e*2+1]=9,e++,s[9]++;while(e<=279)_[e*2+1]=7,e++,s[7]++;while(e<=287)_[e*2+1]=8,e++,s[8]++;Q(_,m+1,s);for(e=0;e<g;e++)D[e*2+1]=5,D[e*2]=$(e,5);I=new F(_,k,v+1,m,w),q=new F(D,L,0,g,w),R=new F(new Array(0),A,0,y,S)}function Y(e){var t;for(t=0;t<m;t++)e.dyn_ltree[t*2]=0;for(t=0;t<g;t++)e.dyn_dtree[t*2]=0;for(t=0;t<y;t++)e.bl_tree[t*2]=0;e.dyn_ltree[x*2]=1,e.opt_len=e.static_len=0,e.last_lit=e.matches=0}function Z(e){e.bi_valid>8?W(e,e.bi_buf):e.bi_valid>0&&(e.pending_buf[e.pending++]=e.bi_buf),e.bi_buf=0,e.bi_valid=0}function et(e,t,n,i){Z(e),i&&(W(e,n),W(e,~n)),r.arraySet(e.pending_buf,e.window,t,n,e.pending),e.pending+=n}function tt(e,t,n,r){var i=t*2,s=n*2;return e[i]<e[s]||e[i]===e[s]&&r[t]<=r[n]}function nt(e,t,n){var r=e.heap[n],i=n<<1;while(i<=e.heap_len){i<e.heap_len&&tt(t,e.heap[i+1],e.heap[i],e.depth)&&i++;if(tt(t,r,e.heap[i],e.depth))break;e.heap[n]=e.heap[i],n=i,i<<=1}e.heap[n]=r}function rt(e,t,n){var r,i,s=0,o,u;if(e.last_lit!==0)do r=e.pending_buf[e.d_buf+s*2]<<8|e.pending_buf[e.d_buf+s*2+1],i=e.pending_buf[e.l_buf+s],s++,r===0?V(e,i,t):(o=H[i],V(e,o+v+1,t),u=k[o],u!==0&&(i-=B[o],X(e,i,u)),r--,o=z(r),V(e,o,n),u=L[o],u!==0&&(r-=j[o],X(e,r,u)));while(s<e.last_lit);V(e,x,t)}function it(e,t){var n=t.dyn_tree,r=t.stat_desc.static_tree,i=t.stat_desc.has_stree,s=t.stat_desc.elems,o,u,a=-1,f;e.heap_len=0,e.heap_max=b;for(o=0;o<s;o++)n[o*2]!==0?(e.heap[++e.heap_len]=a=o,e.depth[o]=0):n[o*2+1]=0;while(e.heap_len<2)f=e.heap[++e.heap_len]=a<2?++a:0,n[f*2]=1,e.depth[f]=0,e.opt_len--,i&&(e.static_len-=r[f*2+1]);t.max_code=a;for(o=e.heap_len>>1;o>=1;o--)nt(e,n,o);f=s;do o=e.heap[1],e.heap[1]=e.heap[e.heap_len--],nt(e,n,1),u=e.heap[1],e.heap[--e.heap_max]=o,e.heap[--e.heap_max]=u,n[f*2]=n[o*2]+n[u*2],e.depth[f]=(e.depth[o]>=e.depth[u]?e.depth[o]:e.depth[u])+1,n[o*2+1]=n[u*2+1]=f,e.heap[1]=f++,nt(e,n,1);while(e.heap_len>=2);e.heap[--e.heap_max]=e.heap[1],K(e,t),Q(n,a,e.bl_count)}function st(e,t,n){var r,i=-1,s,o=t[1],u=0,a=7,f=4;o===0&&(a=138,f=3),t[(n+1)*2+1]=65535;for(r=0;r<=n;r++){s=o,o=t[(r+1)*2+1];if(++u<a&&s===o)continue;u<f?e.bl_tree[s*2]+=u:s!==0?(s!==i&&e.bl_tree[s*2]++,e.bl_tree[T*2]++):u<=10?e.bl_tree[N*2]++:e.bl_tree[C*2]++,u=0,i=s,o===0?(a=138,f=3):s===o?(a=6,f=3):(a=7,f=4)}}function ot(e,t,n){var r,i=-1,s,o=t[1],u=0,a=7,f=4;o===0&&(a=138,f=3);for(r=0;r<=n;r++){s=o,o=t[(r+1)*2+1];if(++u<a&&s===o)continue;if(u<f){do V(e,s,e.bl_tree);while(--u!==0)}else s!==0?(s!==i&&(V(e,s,e.bl_tree),u--),V(e,T,e.bl_tree),X(e,u-3,2)):u<=10?(V(e,N,e.bl_tree),X(e,u-3,3)):(V(e,C,e.bl_tree),X(e,u-11,7));u=0,i=s,o===0?(a=138,f=3):s===o?(a=6,f=3):(a=7,f=4)}}function ut(e){var t;st(e,e.dyn_ltree,e.l_desc.max_code),st(e,e.dyn_dtree,e.d_desc.max_code),it(e,e.bl_desc);for(t=y-1;t>=3;t--)if(e.bl_tree[O[t]*2+1]!==0)break;return e.opt_len+=3*(t+1)+5+5+4,t}function at(e,t,n,r){var i;X(e,t-257,5),X(e,n-1,5),X(e,r-4,4);for(i=0;i<r;i++)X(e,e.bl_tree[O[i]*2+1],3);ot(e,e.dyn_ltree,t-1),ot(e,e.dyn_dtree,n-1)}function ft(e){var t=4093624447,n;for(n=0;n<=31;n++,t>>>=1)if(t&1&&e.dyn_ltree[n*2]!==0)return s;if(e.dyn_ltree[18]!==0||e.dyn_ltree[20]!==0||e.dyn_ltree[26]!==0)return o;for(n=32;n<v;n++)if(e.dyn_ltree[n*2]!==0)return o;return s}function ct(e){lt||(G(),lt=!0),e.l_desc=new U(e.dyn_ltree,I),e.d_desc=new U(e.dyn_dtree,q),e.bl_desc=new U(e.bl_tree,R),e.bi_buf=0,e.bi_valid=0,Y(e)}function ht(e,t,n,r){X(e,(f<<1)+(r?1:0),3),et(e,t,n,!0)}function pt(e){X(e,l<<1,3),V(e,x,_),J(e)}function dt(e,t,n,r){var s,o,a=0;e.level>0?(e.strm.data_type===u&&(e.strm.data_type=ft(e)),it(e,e.l_desc),it(e,e.d_desc),a=ut(e),s=e.opt_len+3+7>>>3,o=e.static_len+3+7>>>3,o<=s&&(s=o)):s=o=n+5,n+4<=s&&t!==-1?ht(e,t,n,r):e.strategy===i||o===s?(X(e,(l<<1)+(r?1:0),3),rt(e,_,D)):(X(e,(c<<1)+(r?1:0),3),at(e,e.l_desc.max_code+1,e.d_desc.max_code+1,a+1),rt(e,e.dyn_ltree,e.dyn_dtree)),Y(e),r&&Z(e)}function vt(e,t,n){return e.pending_buf[e.d_buf+e.last_lit*2]=t>>>8&255,e.pending_buf[e.d_buf+e.last_lit*2+1]=t&255,e.pending_buf[e.l_buf+e.last_lit]=n&255,e.last_lit++,t===0?e.dyn_ltree[n*2]++:(e.matches++,t--,e.dyn_ltree[(H[n]+v+1)*2]++,e.dyn_dtree[z(t)*2]++),e.last_lit===e.lit_bufsize-1}var r=e("../utils/common"),i=4,s=0,o=1,u=2,f=0,l=1,c=2,h=3,p=258,d=29,v=256,m=v+1+d,g=30,y=19,b=2*m+1,w=15,E=16,S=7,x=256,T=16,N=17,C=18,k=[0,0,0,0,0,0,0,0,1,1,1,1,2,2,2,2,3,3,3,3,4,4,4,4,5,5,5,5,0],L=[0,0,0,0,1,1,2,2,3,3,4,4,5,5,6,6,7,7,8,8,9,9,10,10,11,11,12,12,13,13],A=[0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,3,7],O=[16,17,18,0,8,7,9,6,10,5,11,4,12,3,13,2,14,1,15],M=512,_=new Array((m+2)*2);a(_);var D=new Array(g*2);a(D);var P=new Array(M);a(P);var H=new Array(p-h+1);a(H);var B=new Array(d);a(B);var j=new Array(g);a(j);var F=function(e,t,n,r,i){this.static_tree=e,this.extra_bits=t,this.extra_base=n,this.elems=r,this.max_length=i,this.has_stree=e&&e.length},I,q,R,U=function(e,t){this.dyn_tree=e,this.max_code=0,this.stat_desc=t},lt=!1;n._tr_init=ct,n._tr_stored_block=ht,n._tr_flush_block=dt,n._tr_tally=vt,n._tr_align=pt},{"../utils/common":3}],15:[function(e,t,n){"use strict";function r(){this.input=null,this.next_in=0,this.avail_in=0,this.total_in=0,this.output=null,this.next_out=0,this.avail_out=0,this.total_out=0,this.msg="",this.state=null,this.data_type=2,this.adler=0}t.exports=r},{}],"/":[function(e,t,n){var r=e("./lib/utils/common").assign,i=e("./lib/deflate"),s=e("./lib/inflate"),o=e("./lib/zlib/constants"),u={};r(u,i,s,o),t.exports=u},{"./lib/deflate":1,"./lib/inflate":2,"./lib/utils/common":3,"./lib/zlib/constants":6}]},{},[])("/")}),function(e){function t(e,s,o){o=n({},t.defaults,o);var u=[];return s.type==="array"?i(e,e,"",s,o,u):r(e,s,o,u),{valid:!u.length,errors:u}}function n(e){var t=Array.prototype.slice.call(arguments,1);while(t.length){var n=t.shift();if(!n)continue;if(typeof n!="object")throw new TypeError("mixin non-object");for(var r in n)n.hasOwnProperty(r)&&(e[r]=n[r])}return e}function r(e,t,n,r){var s,u=Object.keys(e),a=[];if(t.properties){s=t.properties;for(var f in s)s.hasOwnProperty(f)&&(a.push(f),i(e,e[f],f,s[f],n,r))}if(t.patternProperties){s=t.patternProperties;for(var f in s)if(s.hasOwnProperty(f)){var l=new RegExp(f);for(var c in e)e.hasOwnProperty(c)&&l.exec(c)!==null&&(i(e,e[c],c,s[f],n,r),a.push(c))}}t.additionalProperties===undefined&&(t.additionalProperties=n.additionalProperties);if(undefined!==t.additionalProperties){var h,p,d=u.filter(function(e){return-1===a.indexOf(e)});if(t.additionalProperties===!1&&d.length>0)for(h=0,p=d.length;h<p;h++)o("additionalProperties",d[h],e[d[h]],!1,r);else if(typeof t.additionalProperties=="object"&&d.length>0)for(h=0,p=d.length;h<p;h++)i(e,e[d[h]],d[h],t.unvisitedProperties,n,r)}}function i(e,n,a,f,l,c){function m(e,t,n){f[e]!==undefined&&!n(t,f[e])&&o(e,a,t,f,c)}var h,p,d,v;if(n===undefined){if(f.required&&f.type!=="any")return o("required",a,undefined,f,c);return}if(l.cast){("integer"===f.type||"number"===f.type)&&n==+n&&(n=+n,e[a]=n);if("boolean"===f.type){if("true"===n||"1"===n||1===n)n=!0,e[a]=n;if("false"===n||"0"===n||0===n)n=!1,e[a]=n}}if(f.format&&l.validateFormats){h=f.format,l.validateFormatExtensions&&(d=t.formatExtensions[h]),d||(d=t.formats[h]);if(!d){if(l.validateFormatsStrict)return o("format",a,n,f,c)}else if(!d.test(n))return o("format",a,n,f,c)}f["enum"]&&f["enum"].indexOf(n)===-1&&o("enum",a,n,f,c),typeof f.dependencies=="string"&&e[f.dependencies]===undefined&&o("dependencies",a,null,f,c);if(u(f.dependencies))for(var g=0,y=f.dependencies.length;g<y;g++)e[f.dependencies[g]]===undefined&&o("dependencies",a,null,f,c);typeof f.dependencies=="object"&&r(e,f.dependencies,l,c),s(n,f.type,function(t,s){if(t)return o("type",a,typeof n,f,c);m("conform",n,function(t,n){return n(t,e)});switch(s||(u(n)?"array":typeof n)){case"string":m("allowEmpty",n,function(e,t){return t?t:e!==""}),m("minLength",n.length,function(e,t){return e>=t}),m("maxLength",n.length,function(e,t){return e<=t}),m("pattern",n,function(e,t){return t=typeof t=="string"?t=new RegExp(t):t,t.test(e)});break;case"integer":case"number":m("minimum",n,function(e,t){return e>=t}),m("maximum",n,function(e,t){return e<=t}),m("exclusiveMinimum",n,function(e,t){return e>t}),m("exclusiveMaximum",n,function(e,t){return e<t}),m("divisibleBy",n,function(e,t){var n=Math.max((e-Math.floor(e)).toString().length-2,(t-Math.floor(t)).toString().length-2);return n=n>0?Math.pow(10,n):1,e*n%(t*n)===0});break;case"array":m("items",n,function(t,n){var r;for(var s=0,o=t.length;s<o;s++)r=[],i(e,t[s],a,n,l,r),r.forEach(function(e){e.property=(a?a+".":"")+s+(e.property?"."+e.property.replace(a+".",""):"")}),r.unshift(0,0),Array.prototype.splice.apply(c,r);return!0}),m("minItems",n,function(e,t){return e.length>=t}),m("maxItems",n,function(e,t){return e.length<=t}),m("uniqueItems",n,function(e,t){if(!t)return!0;var n={};for(var r=0,i=e.length;r<i;r++){var s=JSON.stringify(e[r]);if(n[s])return!1;n[s]=!0}return!0});break;case"object":if(f.properties||f.patternProperties||f.additionalProperties){var h=[];r(n,f,l,h),h.forEach(function(e){e.property=a+"."+e.property}),h.unshift(0,0),Array.prototype.splice.apply(c,h)}}})}function s(e,t,n){var r=!1,i=u(t)?t:[t];if(t===undefined)return n(null,t);for(var s=0,o=i.length;s<o;s++){t=i[s].toLowerCase().trim();if(t==="string"?typeof e=="string":t==="array"?u(e):t==="object"?e&&typeof e=="object"&&!u(e):t==="number"?typeof e=="number":t==="integer"?typeof e=="number"&&Math.floor(e)===e:t==="null"?e===null:t==="boolean"?typeof e=="boolean":t==="date"?a(e):t==="any"?typeof e!="undefined":!1)return n(null,t)}n(!0)}function o(e,n,r,i,s){var o={expected:i[e],actual:r,attribute:e,property:n},u=i.messages&&i.messages[e]||i.message||t.messages[e]||"no default message";u=u.replace(/%\{([a-z]+)\}/ig,function(e,t){return o[t.toLowerCase()]||""}),s.push({attribute:e,property:n,expected:i[e],actual:r,message:u})}function u(e){var t=typeof e;return t==="object"&&e&&typeof e.length=="number"&&!e.propertyIsEnumerable("length")&&typeof e.splice=="function"?!0:!1}function a(e){var t=typeof e;return t==="object"&&e&&typeof e.getTime=="function"?!0:!1}e.validate=t,e.mixin=n,t.defaults={validateFormats:!0,validateFormatsStrict:!1,validateFormatExtensions:!0,additionalProperties:!0},t.messages={required:"is required",allowEmpty:"must not be empty",minLength:"is too short (minimum is %{expected} characters)",maxLength:"is too long (maximum is %{expected} characters)",pattern:"invalid input",minimum:"must be greater than or equal to %{expected}",maximum:"must be less than or equal to %{expected}",exclusiveMinimum:"must be greater than %{expected}",exclusiveMaximum:"must be less than %{expected}",divisibleBy:"must be divisible by %{expected}",minItems:"must contain more than %{expected} items",maxItems:"must contain less than %{expected} items",uniqueItems:"must hold a unique set of values",format:"is not a valid %{expected}",conform:"must conform to given constraint",type:"must be of %{expected} type",additionalProperties:"must not exist"},t.messages["enum"]="must be present in given enumerator",t.formats={email:/^((([a-z]|\d|[!#\$%&'\*\+\-\/=\?\^_`{\|}~]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])+(\.([a-z]|\d|[!#\$%&'\*\+\-\/=\?\^_`{\|}~]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])+)*)|((\x22)((((\x20|\x09)*(\x0d\x0a))?(\x20|\x09)+)?(([\x01-\x08\x0b\x0c\x0e-\x1f\x7f]|\x21|[\x23-\x5b]|[\x5d-\x7e]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])|(\\([\x01-\x09\x0b\x0c\x0d-\x7f]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF]))))*(((\x20|\x09)*(\x0d\x0a))?(\x20|\x09)+)?(\x22)))@((([a-z]|\d|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])|(([a-z]|\d|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])([a-z]|\d|-|\.|_|~|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])*([a-z]|\d|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])))\.)+(([a-z]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])|(([a-z]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])([a-z]|\d|-|\.|_|~|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])*([a-z]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])))\.?$/i,"ip-address":/^(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\.(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\.(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\.(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)$/i,ipv6:/^([0-9A-Fa-f]{1,4}:){7}[0-9A-Fa-f]{1,4}$/,"date-time":/^\d{4}-\d{2}-\d{2}T\d{2}:\d{2}:\d{2}(?:.\d{1,3})?Z$/,date:/^\d{4}-\d{2}-\d{2}$/,time:/^\d{2}:\d{2}:\d{2}$/,color:/^#[a-z0-9]{6}|#[a-z0-9]{3}|(?:rgb\(\s*(?:[+-]?\d+%?)\s*,\s*(?:[+-]?\d+%?)\s*,\s*(?:[+-]?\d+%?)\s*\))aqua|black|blue|fuchsia|gray|green|lime|maroon|navy|olive|orange|purple|red|silver|teal|white|yellow$/i,"host-name":/^(([a-zA-Z]|[a-zA-Z][a-zA-Z0-9\-]*[a-zA-Z0-9])\.)*([A-Za-z]|[A-Za-z][A-Za-z0-9\-]*[A-Za-z0-9])/,"utc-millisec":{test:function(e){return typeof e=="number"&&e>=0}},regex:{test:function(e){try{new RegExp(e)}catch(t){return!1}return!0}}},t.formatExtensions={url:/^(https?|ftp|git):\/\/(((([a-z]|\d|-|\.|_|~|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])|(%[\da-f]{2})|[!\$&'\(\)\*\+,;=]|:)*@)?(((\d|[1-9]\d|1\d\d|2[0-4]\d|25[0-5])\.(\d|[1-9]\d|1\d\d|2[0-4]\d|25[0-5])\.(\d|[1-9]\d|1\d\d|2[0-4]\d|25[0-5])\.(\d|[1-9]\d|1\d\d|2[0-4]\d|25[0-5]))|((([a-z]|\d|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])|(([a-z]|\d|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])([a-z]|\d|-|\.|_|~|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])*([a-z]|\d|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])))\.)+(([a-z]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])|(([a-z]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])([a-z]|\d|-|\.|_|~|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])*([a-z]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])))\.?)(:\d*)?)(\/((([a-z]|\d|-|\.|_|~|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])|(%[\da-f]{2})|[!\$&'\(\)\*\+,;=]|:|@)+(\/(([a-z]|\d|-|\.|_|~|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])|(%[\da-f]{2})|[!\$&'\(\)\*\+,;=]|:|@)*)*)?)?(\?((([a-z]|\d|-|\.|_|~|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])|(%[\da-f]{2})|[!\$&'\(\)\*\+,;=]|:|@)|[\uE000-\uF8FF]|\/|\?)*)?(\#((([a-z]|\d|-|\.|_|~|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])|(%[\da-f]{2})|[!\$&'\(\)\*\+,;=]|:|@)|\/|\?)*)?$/i}}(typeof module=="object"&&module&&module.exports?module.exports:window),define("revalidator",function(){}),function(){function n(){var n="";return this===Function||this===Function.prototype.constructor?n="Function":this!==Function.prototype&&(n=(""+this).replace(e,"").replace(t,"")),n}var e=/^[\S\s]*?function\s*/,t=/[\s\(\/][\S\s]+$/,r=!("name"in Function.prototype&&"name"in function(){}),i=typeof Object.defineProperty=="function"&&function(){var e;try{Object.defineProperty(Function.prototype,"_xyz",{get:function(){return"blah"},configurable:!0}),e=Function.prototype._xyz==="blah",delete Function.prototype._xyz}catch(t){e=!1}return e}();Function.prototype._name=n,i&&r&&Object.defineProperty(Function.prototype,"name",{get:n})}.call(this),define("function-name",function(){}),function(){define("kryptnostic.authentication-service",["require","bluebird","kryptnostic.logger","kryptnostic.configuration","kryptnostic.credential-provider-loader","kryptnostic.credential-service","kryptnostic.crypto-service-loader","kryptnostic.search-credential-service","kryptnostic.authentication-stage","kryptnostic.user-directory-api","kryptnostic.kryptnostic-engine-provider","kryptnostic.crypto-service-migrator"],function(e){var t,n,r,i,s,o,u,a,f,l,c,h,p,d;return c=e("bluebird"),l=e("kryptnostic.logger"),r=e("kryptnostic.configuration"),i=e("kryptnostic.credential-provider-loader"),s=e("kryptnostic.credential-service"),o=e("kryptnostic.crypto-service-loader"),h=e("kryptnostic.search-credential-service"),n=e("kryptnostic.authentication-stage"),p=e("kryptnostic.user-directory-api"),a=e("kryptnostic.kryptnostic-engine-provider"),u=e("kryptnostic.crypto-service-migrator"),d=l.get("AuthenticationService"),f="invalid credentials",t=function(){function e(){}return e.authenticate=function(t,a){var l,h,v,m,g,y,b,w,E;return m=t.email,y=t.password,a==null&&(a=function(){}),E={},b=E.principal,l=E.credential,g=E.keypair,v=new s,w=new p,h=i.load(r.get("credentialProvider")),c.resolve().then(function(){return w.resolve({email:m})}).then(function(e){if(_.isEmpty(e))throw new Error(f);return b=e,d.info("authenticating",m),v.deriveCredential({principal:b,password:y},a)}).then(function(e){return l=e,d.info("derived credential"),h.store({principal:b,credential:l}),v.deriveKeyPair({password:y})}).then(function(e){return g=e,h.store({principal:b,credential:l,keypair:g})}).then(function(){return o.initializeMasterAesCryptoService()}).then(function(){return e.initializeEngine()}).then(function(){var e;return e=new u,e.migrateRSACryptoServices()}).then(function(){return c.resolve(a(n.COMPLETED))}).then(function(){return d.info("authentication complete")})},e.initializeEngine=function(){var e;return e=new h,c.resolve().then(function(){return e.getKeys()}).then(function(e){var t,n;return t=e.FHE_PRIVATE_KEY,n=e.FHE_SEARCH_PRIVATE_KEY,a.init({fhePrivateKey:t,fheSearchPrivateKey:n}),d.info("KryptnosticEngine initialized")})},e.destroy=function(){var e;return e=i.load(r.get("credentialProvider")),e.destroy()},e}(),t})}.call(this),function(){define("kryptnostic.authentication-stage",["require"],function(e){var t;return t={DERIVE_CREDENTIAL:"deriving credential",RSA_KEYGEN:"generating rsa keypair",DERIVE_KEYPAIR:"deriving rsa keypair",FHE_KEYGEN:"initializing fhe key",SEARCH_KEYGEN:"initializing search key",CLIENT_HASH_GEN:"initializing hash function",COMPLETED:"authentication complete"},t})}.call(this),function(){define("kryptnostic.credential-loader",["require","kryptnostic.configuration","kryptnostic.credential-provider-loader"],function(e){var t,n,r,i,s;return i=e("kryptnostic.logger"),t=e("kryptnostic.configuration"),r=e("kryptnostic.credential-provider-loader"),s=i.get("CredentialLoader"),n=function(){function e(){}return e.prototype.getCredentials=function(){var e,n;return n=t.get("credentialProvider"),e=r.load(n),e.load()},e}(),n})}.call(this),function(){define("kryptnostic.credential-provider-loader",["require","kryptnostic.logger","kryptnostic.credential-provider.memory","kryptnostic.credential-provider.local-storage","kryptnostic.credential-provider.session-storage"],function(e){var t,n,r;return n=e("kryptnostic.logger"),r=n.get("CredentialProviderLoader"),t=function(){function t(){}return t.load=function(t){var n;t==="kryptnostic.credential-provider.local-storage"?n=e("kryptnostic.credential-provider.local-storage"):t==="kryptnostic.credential-provider.session-storage"?n=e("kryptnostic.credential-provider.session-storage"):t==="kryptnostic.credential-provider.memory"&&(n=e("kryptnostic.credential-provider.memory"));if(n!=null)return n;throw new Error("failed to load credential provider for URI "+t)},t}()})}.call(this),function(){define("kryptnostic.credential-service",["require","bluebird","forge","kryptnostic.logger","kryptnostic.key-storage-api","kryptnostic.binary-utils","kryptnostic.rsa-key-generator","kryptnostic.password-crypto-service","kryptnostic.salt-generator","kryptnostic.validators"],function(e){var t,n,r,i,s,o,u,a,f,l,c,h,p,d,v;return a=e("kryptnostic.logger"),o=e("forge"),l=e("bluebird"),n=e("kryptnostic.binary-utils"),u=e("kryptnostic.key-storage-api"),f=e("kryptnostic.password-crypto-service"),c=e("kryptnostic.rsa-key-generator"),h=e("kryptnostic.salt-generator"),p=e("kryptnostic.validators"),i=1e3,s=256,t=8,v=p.validateUuid,d=a.get("CredentialService"),r=function(){function e(){this.rsaKeyGenerator=new c}return e.prototype.deriveCredential=function(t){var n,r;return r=t.principal,n=t.password,l.resolve(u.getEncryptedSalt(r)).then(function(t){return e.derive({encryptedSalt:t,password:n})})},e.derive=function(e){var n,r,u,a,l,c,h,p,d;return r=e.encryptedSalt,h=e.password,p=new f,a=i,l=s/t,d=p.decrypt(r,h),c=o.sha1.create(),n=o.pkcs5.pbkdf2(h,d,a,l,c),u=o.util.bytesToHex(n),u},e.generateCredentialPair=function(n){var r,i,o,u,a;return o=n.password,d.info("generating a new credential pair"),a=h.generateSalt(s/t),u=new f,i=u.encrypt(a,o),r=e.derive({password:o,encryptedSalt:i}),{credential:r,encryptedSalt:i}},e.prototype.initializeSalt=function(e){var t,n,r;return r=e.uuid,n=e.encryptedSalt,t=e.credential,v(r)?l.resolve(u.setEncryptedSalt(r,t,n)):l.resolve(null)},e.prototype.initializeKeypair=function(e){var t,r,i,s,a;return r=e.password,a={},s=a.publicKey,i=a.privateKey,t=a.keypair,l.resolve(this.rsaKeyGenerator.generateKeypair()).then(function(e){var n,u,a,l,c;return t={},n=new f,c=e.publicKey.data,a=e.privateKey.data,s=c,i=n.encrypt(a,r),l=o.asn1.fromDer(e.publicKey),t.publicKey=o.pki.publicKeyFromAsn1(l),u=o.asn1.fromDer(e.privateKey),t.privateKey=o.pki.privateKeyFromAsn1(u)}).then(function(){return u.setRSAPrivateKey(i)}).then(function(){var e;return e=n.stringToUint8(s),u.setRSAPublicKey(e)}).then(function(){return d.info("keypair initialization complete"),t})["catch"](function(e){return d.error(e),d.error("keypair generation failed!",e)})},e.prototype.deriveKeyPair=function(e){var t;return t=e.password,l.resolve(u.getRSAPrivateKey()).then(function(e){return function(n){var r,i,s,u,a,c;return _.isEmpty(n)?(d.info("no keypair exists, generating on-the-fly"),l.resolve(e.initializeKeypair({password:t}))):(d.info("using existing keypair"),r=new f,a=r.decrypt(n,t),u=o.util.createBuffer(a,"raw"),s=o.asn1.fromDer(u),i=o.pki.privateKeyFromAsn1(s),c=o.pki.setRsaPublicKey(i.n,i.e),{privateKey:i,publicKey:c})}}(this))},e}(),r})}.call(this),function(){define("kryptnostic.salt-generator",["require","forge"],function(e){var t,n;return t=e("forge"),n=function(e){return t.random.getBytesSync(e)},{generateSalt:n}})}.call(this),function(){define("kryptnostic.search-credential-service",["require","lodash","bluebird","kryptnostic.logger","kryptnostic.authentication-stage","kryptnostic.search-key-generator","kryptnostic.key-storage-api","kryptnostic.crypto-service-loader"],function(e){var t,n,r,i,s,o,u,a,f,l,c,h;return h=e("lodash"),a=e("bluebird"),u=e("kryptnostic.logger"),t=e("kryptnostic.authentication-stage"),o=e("kryptnostic.key-storage-api"),l=e("kryptnostic.search-key-generator"),r=e("kryptnostic.crypto-service-loader"),c=u.get("SearchCredentialService"),i="FHE_PRIVATE_KEY",s="FHE_SEARCH_PRIVATE_KEY",n={FHE_PRIVATE_KEY:{getKey:function(e){return e.FHE_PRIVATE_KEY},getter:function(){return o.getFHEPrivateKey},setter:function(){return o.setFHEPrivateKey},stage:t.FHE_KEYGEN,encrypt:!0,decrypt:!0,id:"KryptnosticEngine.PrivateKey"},FHE_SEARCH_PRIVATE_KEY:{getKey:function(e){return e.FHE_SEARCH_PRIVATE_KEY},getter:function(){return o.getFHESearchPrivateKey},setter:function(){return o.setFHESearchPrivateKey},stage:t.SEARCH_KEYGEN,encrypt:!0,decrypt:!0,id:"KryptnosticEngine.SearchPrivateKey"},FHE_HASH_FUNCTION:{getKey:function(e){return e.FHE_HASH_FUNCTION},setter:function(){return o.setFHEHashFunction},stage:t.CLIENT_HASH_GEN,encrypt:!1,decrypt:!1,id:"KryptnosticEngine.ClientHashFunction"}},f=function(){function e(){this.searchKeyGenerator=new l,this.cryptoServiceLoader=new r}return e.prototype.getKeys=function(){return a.resolve(this.loadKeys()).then(function(e){return function(t){return h.isEmpty(t)?e.initializeKeys():t}}(this))},e.prototype.loadKeys=function(){return a.props({masterAesCryptoService:this.cryptoServiceLoader.getMasterAesCryptoService(),fhePrivateKeyBlockCiphertext:o.getFHEPrivateKey(),fheSearchPrivateKeyBlockCiphertext:o.getFHESearchPrivateKey()}).then(function(e){var t,n,r,o,u,a;return a=e.masterAesCryptoService,n=e.fhePrivateKeyBlockCiphertext,o=e.fheSearchPrivateKeyBlockCiphertext,u={},n&&o&&(t=a.decryptToUint8Array(n),u[i]=t,r=a.decryptToUint8Array(o),u[s]=r),u})},e.prototype.initializeKeys=function(){var e;return e={}.clientKeys,a.resolve().then(function(t){return function(){return e=t.searchKeyGenerator.generateClientKeys()}}(this)).then(function(t){return function(){return t.initializeKey(n.FHE_PRIVATE_KEY,e)}}(this)).then(function(t){return function(){return t.initializeKey(n.FHE_SEARCH_PRIVATE_KEY,e)}}(this)).then(function(t){return function(){return t.initializeKey(n.FHE_HASH_FUNCTION,e)}}(this)).then(function(){return e})},e.prototype.initializeKey=function(e,t){return a.resolve(this.cryptoServiceLoader.getMasterAesCryptoService()).then(function(n){var r,i;return r=e.getKey(t),e.encrypt===!0&&(r=n.encryptUint8Array(r)),i=e.setter(),i(r)})},e}(),f})}.call(this),function(){define("kryptnostic.search-key-serializer",["require","forge","kryptnostic.logger","kryptnostic.binary-utils","kryptnostic.rsa-crypto-service","kryptnostic.credential-loader","kryptnostic.chunking.strategy.default"],function(e){var t,n,r,i,s,o,u,a,f,l,c,h,p,d,v,m,g,y;return c=e("forge"),t=e("kryptnostic.binary-utils"),n=e("kryptnostic.credential-loader"),r=e("kryptnostic.chunking.strategy.default"),s=e("kryptnostic.logger"),o=e("kryptnostic.rsa-crypto-service"),p=s.get("SearchKeySerializer"),f=t.chunkUint8,l=t.cleanUint8Buffer,h=t.joinUint8,d=t.stringToUint16,v=t.uint16ToString,m=t.uint16ToUint8,g=t.uint8ToUint16,a=384,i=1024,y=function(e){return e.forEach(function(e){if(e.length!==i)throw p.error("chunk failed validation",{length:e.length,expected:i}),new Error("chunk validation error: wrong block size")})},u=function(){function e(){this.chunkingStrategy=new r,this.credentialLoader=new n}return e.prototype.createRsaCryptoService=function(){var e;return e=this.credentialLoader.getCredentials().keypair,new o(e)},e.prototype.encrypt=function(e){var t,n;return n=this.createRsaCryptoService(),t=_.chain(e).thru(function(e){return l(e)}).thru(function(e){return c.util.binary.base64.encode(e)}).thru(function(e){return function(t){return e.chunkingStrategy.split(t,a)}}(this)).map(function(e){return n.encrypt(e)}).map(function(e){return d(e)}).map(function(e){return m(e)}).tap(function(e){return y(e)}).thru(function(e){return h(e)}).value(),t},e.prototype.decrypt=function(e){var t,n;return n=this.createRsaCryptoService(),t=_.chain(e).thru(function(e){return f(e,i)}).tap(function(e){return y(e)}).map(function(e){return g(e)}).map(function(e){return v(e)}).map(function(e){return n.decrypt(e)}).thru(function(e){return function(t){return e.chunkingStrategy.join(t)}}(this)).thru(function(e){return c.util.binary.base64.decode(e)}).thru(function(e){return l(e)}).value(),t},e}()})}.call(this),function(){define("kryptnostic.credential-provider.memory",["require","kryptnostic.logger"],function(e){var t,n,r;return n=e("kryptnostic.logger"),r=n.get("InMemoryCredentialProvider"),t=function(){function e(){}return e.store=function(e){this.principal=e.principal,this.credential=e.credential,this.keypair=e.keypair;if(!this.principal||!this.credential)throw new Error("must specify all credentials");return r.info("stored credentials")},e.load=function(){if(!this.principal||!this.credential)throw new Error("user is not authenticated");return{principal:this.principal,credential:this.credential,keypair:this.keypair}},e.destroy=function(){return this.principal=void 0,this.credential=void 0,this.keypair=void 0,r.info("destroyed credentials")},e}(),t})}.call(this),function(){define("kryptnostic.credential-provider.key-value",["require","kryptnostic.logger","kryptnostic.keypair-serializer"],function(e){var t,n,r,i,s,o,u,a,f;return s=e("kryptnostic.logger"),i=e("kryptnostic.keypair-serializer"),f=s.get("KeyValueCredentialProvider"),o="kryptnostic.principal",t="kryptnostic.credential",n="kryptnostic.keypair",u="undefined",a=function(e){return!!e&&e!==u},r=function(){function e(){}return e.store=function(e,r){var s,u,l;this.storage=e,l=r.principal,s=r.credential,u=r.keypair,f.info("store");if(!a(l)||!a(s))throw new Error("must specify all credentials");this.storage.setItem(o,l),this.storage.setItem(t,s);if(!!u)return u=i.serialize(u),this.storage.setItem(n,u)},e.load=function(e){var r,s,u;this.storage=e,u=this.storage.getItem(o),r=this.storage.getItem(t),s=this.storage.getItem(n),s=i.hydrate(s);if(!a(u)||!a(r))throw new Error("user is not authenticated");return{principal:u,credential:r,keypair:s}},e.destroy=function(e){return this.storage=e,f.info("destroy"),this.storage.setItem(o,void 0),this.storage.setItem(t,void 0),this.storage.setItem(n,void 0)},e}(),r})}.call(this),function(){define("kryptnostic.credential-provider.local-storage",["require","kryptnostic.credential-provider.key-value"],function(e){var t,n;return t=e("kryptnostic.credential-provider.key-value"),n=function(){function e(){}return e.delegate=window.localStorage,e.store=function(e){var n,r,i;return i=e.principal,n=e.credential,r=e.keypair,t.store(this.delegate,{principal:i,credential:n,keypair:r})},e.load=function(){return t.load(this.delegate)},e.destroy=function(){return t.destroy(this.delegate)},e}(),n})}.call(this),function(){define("kryptnostic.credential-provider.session-storage",["require","kryptnostic.credential-provider.key-value"],function(e){var t,n;return t=e("kryptnostic.credential-provider.key-value"),n=function(){function e(){}return e.delegate=window.sessionStorage,e.store=function(e){var n,r,i;return i=e.principal,n=e.credential,r=e.keypair,t.store(this.delegate,{principal:i,credential:n,keypair:r})},e.load=function(){return t.load(this.delegate)},e.destroy=function(){return t.destroy(this.delegate)},e}(),n})}.call(this),function(){define("kryptnostic.chunking.registry",["require","kryptnostic.chunking.strategy.default","kryptnostic.chunking.strategy.json","kryptnostic.logger"],function(e){var t,n,r,i,s;return s=e("kryptnostic.logger").get("ChunkingStrategyRegistry"),n="kryptnostic.chunking.strategy.default",r="kryptnostic.chunking.strategy.json",i=[n,r],t=function(){function t(){}return t.registry={},t.initialize=function(){return i.forEach(function(t){return function(n){return t.register(e(n))}}(this))},t.register=function(e){var t;if(!e.URI||!_.isString(e.URI))throw new Error("cannot register strategy class without a uri");return t=e.URI,this.registry[t]=e,s.info("registered",{strategyUri:t})},t.get=function(e){return this.registry[e]!=null?this.registry[e]:(s.warn("unknown strategy, using default",{strategyUri:e}),s.info(JSON.stringify(this.registry)),this.registry[n])},t}(),t.initialize(),t})}.call(this),function(){define("kryptnostic.chunking.strategy.default",["require","lodash"],function(e){var t,n,r,i;return i=e("lodash"),t=1e6,r="",n=function(){function e(){}return e.URI="com.kryptnostic.kodex.v1.serialization.crypto.DefaultChunkingStrategy",e.prototype.split=function(e,n){return n==null&&(n=t),[e]},e.prototype.join=function(e){return e.join(r)},e}(),n})}.call(this),function(){define("kryptnostic.chunking.strategy.json",["require","lodash"],function(e){var t,n,r;return r=e("lodash"),n=function(e){if(e.length!==1)throw new Error("expected exactly one chunk")},t=function(){function e(){}return e.URI="com.kryptnostic.kodex.v1.serialization.crypto.JsonChunkingStrategy",e.prototype.split=function(e){var t;return t=JSON.stringify(e),[t]},e.prototype.join=function(e){return n(e),JSON.parse(r.first(e))},e}(),t})}.call(this),function(){var e=function(e,t){return function(){return e.apply(t,arguments)}};define("kryptnostic.abstract-crypto-service",["require","forge","kryptnostic.crypto-algorithm"],function(t){var n,r,i;return i=t("forge"),r=t("kryptnostic.crypto-algorithm"),n=function(){function t(t){this.algorithm=t.algorithm,this.mode=t.mode,this.decrypt=e(this.decrypt,this),this.encrypt=e(this.encrypt,this);if(this.algorithm!==r.AES||this.mode!=="CTR")throw new Error("cypher not implemented")}return t.prototype.encrypt=function(e,t,n){var r;return r=this.encryptBuffer(e,t,i.util.createBuffer(n)),r},t.prototype.encryptBuffer=function(e,t,n){var r;return r=i.cipher.createCipher(this.algorithm+"-"+this.mode,e),r.start({iv:t}),r.update(n),r.finish(),r.output.data},t.prototype.decrypt=function(e,t,n){var r;return r=this.decryptToBuffer(e,t,i.util.createBuffer(n)),r.data},t.prototype.decryptToBuffer=function(e,t,n){var r;return r=i.cipher.createDecipher(this.algorithm+"-"+this.mode,e),r.start({iv:t}),r.update(n),r.finish(),r.output},t}(),n})}.call(this),function(){define("kryptnostic.aes-crypto-service",["require","forge","kryptnostic.abstract-crypto-service","kryptnostic.logger","kryptnostic.block-ciphertext"],function(e){"use strict";var t,n,r,i,s,o,u,a,f;return o=e("forge"),t=e("kryptnostic.abstract-crypto-service"),s=e("kryptnostic.block-ciphertext"),i=e("kryptnostic.schema.block-ciphertext"),u=e("kryptnostic.logger"),a=e("kryptnostic.schema.validator"),r=8,f=u.get("AesCryptoService"),n=function(){function e(e,n){this.cypher=e,this.key=n,this.key||(f.info("no key passed! generating a key."),this.key=o.random.getBytesSync(this.cypher.keySize/r)),this.abstractCryptoService=new t(this.cypher)}return e.BLOCK_CIPHER_KEY_SIZE=16,e.prototype.encrypt=function(t){var n,r;return r=o.random.getBytesSync(e.BLOCK_CIPHER_KEY_SIZE),n=this.abstractCryptoService.encrypt(this.key,r,t),new s({iv:btoa(r),salt:btoa(o.random.getBytesSync(0)),contents:btoa(n)})},e.prototype.encryptUint8Array=function(t){var n,r,i;return i=o.random.getBytesSync(e.BLOCK_CIPHER_KEY_SIZE),n=o.util.createBuffer(t),r=this.abstractCryptoService.encryptBuffer(this.key,i,n),new s({iv:btoa(i),salt:btoa(o.random.getBytesSync(0)),contents:btoa(r)})},e.prototype.decrypt=function(e){var t,n;return a.validate(e,s,i),n=atob(e.iv),t=atob(e.contents),this.abstractCryptoService.decrypt(this.key,n,t)},e.prototype.decryptToUint8Array=function(e){var t;return t=this.decrypt(e),new Uint8Array(_.map(t,function(e){return e.charCodeAt()}))},e}(),n})}.call(this),function(){define("kryptnostic.crypto-algorithm",["require"],function(e){return{RSA:"RSA",AES:"AES"}})}.call(this),function(){define("kryptnostic.crypto-material",[],function(e){var t,n;return t={IV:"IV",TAG:"TAG",CONTENTS:"CONTENTS",SALT:"SALT"},n=[t.IV,t.CONTENTS,t.SALT],{DEFAULT_REQUIRED_CRYPTO_MATERIAL:n}})}.call(this),function(){define("kryptnostic.crypto-service-loader",["require","bluebird","kryptnostic.logger","kryptnostic.cypher","kryptnostic.caching-service","kryptnostic.rsa-crypto-service","kryptnostic.aes-crypto-service","kryptnostic.key-storage-api","kryptnostic.crypto-service-marshaller","kryptnostic.credential-loader"],function(e){"use strict";var t,n,r,i,s,o,u,a,f,l,c,h,p,d;return h=e("bluebird"),p=e("kryptnostic.rsa-crypto-service"),t=e("kryptnostic.aes-crypto-service"),n=e("kryptnostic.caching-service"),o=e("kryptnostic.cypher"),l=e("kryptnostic.key-storage-api"),c=e("kryptnostic.logger"),s=e("kryptnostic.crypto-service-marshaller"),r=e("kryptnostic.credential-loader"),f=4,a="",d=c.get("CryptoServiceLoader"),u={expectMiss:!1},i=function(){function e(){this.marshaller=new s,this.cache={}}return e.initializeMasterAesCryptoService=function(){return h.resolve(l.getMasterAesCryptoService()).then(function(e){var n,i,u,a,f;if(!e)return e=new t(o.AES_CTR_128),i=new s,a=i.marshall(e),n=new r,f=new p(n.getCredentials().keypair),u=f.encrypt(a),l.setMasterAesCryptoService(u)})},e.prototype.getRsaCryptoService=function(){var e;return e=new r,new p(e.getCredentials().keypair)},e.prototype.getMasterAesCryptoService=function(){return this.cache[n.MASTER_AES_CRYPTO_SERVICE_ID]?h.resolve(this.cache[n.MASTER_AES_CRYPTO_SERVICE_ID]):h.resolve(l.getMasterAesCryptoService()).then(function(e){return function(t){var r,i;return r=e.getRsaCryptoService().decrypt(t),i=e.marshaller.unmarshall(r),e.cache[n.MASTER_AES_CRYPTO_SERVICE_ID]=i,i}}(this))},e.prototype.getObjectCryptoServiceV2=function(e,n){var r,i;return n=_.defaults({},n,u),r=n.expectMiss,i=e.objectId,this.cache[i]?h.resolve(this.cache[i]):h.props({masterAesCryptoService:this.getMasterAesCryptoService(),cryptoServiceBlockCiphertext:l.getAesEncryptedObjectCryptoService(e)}).then(function(n){return function(s){var u,a,f,l;f=s.masterAesCryptoService,u=s.cryptoServiceBlockCiphertext,l={};if(!u&&r)d.info("no cryptoService exists for this object. creating one on-the-fly",{objectId:i}),l=new t(o.AES_CTR_128),n.setObjectCryptoServiceV2(e,l,f);else{if(!u&&!r)return d.error("no cryptoservice exists for this object, but a miss was not expected"),null;a=f.decrypt(u),l=n.marshaller.unmarshall(a,f),n.cache[i]=l}return l}}(this))},e.prototype.setObjectCryptoServiceV2=function(e,t,n){var r,i;if(t.constructor.name!=="AesCryptoService")throw new Error("support is only implemented for AesCryptoService");return i=this.marshaller.marshall(t),r=n.encrypt(i),h.resolve(l.setAesEncryptedObjectCryptoService(e,r)).then(function(n){return function(){n.cache[e.objectId]=t}}(this))},e}(),i})}.call(this),function(){define("kryptnostic.crypto-service-marshaller",["require","kryptnostic.deflating-marshaller","kryptnostic.aes-crypto-service"],function(e){var t,n,r;return r=e("kryptnostic.deflating-marshaller"),t=e("kryptnostic.aes-crypto-service"),n=function(){function e(){this.deflatingMarshaller=new r}return e.prototype.marshall=function(e){var t,n,r,i;n=e.key,t=e.cypher;if(e.constructor.name!=="AesCryptoService")throw new Error("serialization only implemented for AesCryptoService");if(!n)throw new Error("key cannot be blank");if(!t)throw new Error("cypher cannot be blank");return r={cypher:t,key:btoa(n)},i=JSON.stringify(r),this.deflatingMarshaller.marshall(i)},e.prototype.unmarshall=function(e){var n,r,i;return r=this.deflatingMarshaller.unmarshall(e),n=JSON.parse(r),i=new t(n.cypher,atob(n.key)),i},e}(),n})}.call(this),function(){define("kryptnostic.crypto-service-migrator",["require","axios","bluebird","kryptnostic.configuration","kryptnostic.credential-loader","kryptnostic.crypto-service-loader","kryptnostic.crypto-service-marshaller","kryptnostic.rsa-crypto-service","kryptnostic.logger","kryptnostic.requests","kryptnostic.validators"],function(e){var t,n,r,i,s,o,u,a,f,l,c,h,p,d,v,m,g,y,b,w;return d=e("axios"),f=e("bluebird"),n=e("kryptnostic.credential-loader"),r=e("kryptnostic.crypto-service-loader"),i=e("kryptnostic.crypto-service-marshaller"),c=e("kryptnostic.rsa-crypto-service"),t=e("kryptnostic.configuration"),u=e("kryptnostic.logger"),l=e("kryptnostic.requests"),h=e("kryptnostic.validators"),a={"58694df5-e76a-4053-8c98-281bd9f35167":!0,"d1e02b1f-575b-4ae8-9bfa-33b876ef8cee":!0,"3ed853a2-2fe5-4224-b6a8-479fba6556f3":!0,"37b93117-991d-414f-9f73-b99932f8d019":!0},o={"Content-Type":"application/json"},w=h.validateUuid,g=u.get("CryptoServiceMigrator"),m=function(){return t.get("servicesUrlV2")+"/keys"},y=function(){return m()+"/bulk/cryptoservices"},p=function(e){return m()+"/aes/cryptoservice-migration/id/"+e},v=function(){return f.resolve(d(l.wrapCredentials({method:"GET",url:y()}))).then(function(e){return e&&e.data?e.data:null})},b=function(e,t){return w(e)?f.resolve(d(l.wrapCredentials({method:"PUT",url:p(e),data:JSON.stringify(t),headers:o}))):f.resolve()},s=function(){function e(){this.credentialLoader=new n,this.cryptoServiceLoader=new r,this.cryptoServiceMarshaller=new i,this.rsaCryptoService=new c(this.credentialLoader.getCredentials().keypair)}return e.prototype.migrateRSACryptoServices=function(){return f.props({masterAesCryptoService:this.cryptoServiceLoader.getMasterAesCryptoService(),objectCryptoServiceMap:v()}).then(function(e){return function(t){var n,r,i;return n=t.masterAesCryptoService,i=t.objectCryptoServiceMap,r=_.map(i,function(t,r){var i,s,o,u;return _.isEmpty(t)||!a[r]?f.resolve():(g.info("attempting to migrate RSA crypto service for objectId: "+r),u=atob(t),s=e.rsaCryptoService.decrypt(u),o=e.cryptoServiceMarshaller.unmarshall(s),s=e.cryptoServiceMarshaller.marshall(o),i=n.encrypt(s),f.resolve(b(r,i)).then(function(){g.info("successfully migrated RSA crypto service for objectId: "+r)})["catch"](function(e){g.info("failed to migrate RSA crypto service for objectId: "+r)}))}),f.all(r)["catch"](function(e){return g.error(e),g.error("error during RSA crypto service migration")})}}(this))},e}(),s})}.call(this),function(){define("kryptnostic.cypher",[],function(e){return{AES_CTR_128:{algorithm:"AES",mode:"CTR",padding:"NoPadding",keySize:128}}})}.call(this),function(){define("kryptnostic.hash-function",["require","forge","murmurhash3"],function(e){var t,n,r,i,s;return i=e("forge"),s=e("murmurhash3"),n=function(e){return i.md.sha256.create().update(e).digest().getBytes()},r=function(e){var t,n,r,s;return s=i.md.sha256.create().update(e).digest(),t=s.length()/2,n=new i.util.ByteBuffer(s.getBytes(t)),r=new i.util.ByteBuffer(s.getBytes()),i.util.xorBytes(n.getBytes(),r.getBytes(),t)},t=function(e){return s.x86.hash128(e)},{SHA_256:n,SHA_256_TO_128:r,MURMUR3_128:t}})}.call(this),function(){define("kryptnostic.keypair-serializer",["require","forge","kryptnostic.logger"],function(e){var t,n,r,i,s;return t=e("forge"),r=e("kryptnostic.logger"),s=r.get("KeypairSerializer"),i=function(e){return e==="undefined"},n=function(){function e(){}return e.serialize=function(e){var n,r,i;if(!e||!e.privateKey)throw new Error("cannot serialize empty keypair");return n=t.pki.privateKeyToAsn1(e.privateKey),r=t.asn1.toDer(n),i=btoa(r.data),i},e.hydrate=function(e){var n,r,o,u;return!e||i(e)?(s.info("keypair not initialized"),void 0):(o=t.util.createBuffer(atob(e),"raw"),r=t.asn1.fromDer(o),n=t.pki.privateKeyFromAsn1(r),u=t.pki.setRsaPublicKey(n.n,n.e),{privateKey:n,publicKey:u})},e}(),n})}.call(this),function(){define("kryptnostic.password-crypto-service",["require","forge","kryptnostic.abstract-crypto-service"],function(e){"use strict";var t,n,r,i,s,o,u;return s=e("forge"),t=e("kryptnostic.abstract-crypto-service"),n=e("kryptnostic.block-ciphertext"),r="AES",i="CTR",u=function(e,t,n,r){var i;return i=s.sha1.create(),s.pkcs5.pbkdf2(e,t,n,r,i)},o=function(){function e(){this.abstractCryptoService=new t({algorithm:r,mode:i})}return e.BLOCK_CIPHER_ITERATIONS=128,e.BLOCK_CIPHER_KEY_SIZE=16,e.prototype.encrypt=function(t,r){var i,o,a,f,l,c;return o=e.BLOCK_CIPHER_KEY_SIZE,i=e.BLOCK_CIPHER_ITERATIONS,c=s.random.getBytesSync(o),l=u(r,c,i,o),f=s.random.getBytesSync(o),a=this.abstractCryptoService.encrypt(l,f,t),new n({contents:btoa(a),iv:btoa(f),salt:btoa(c)})},e.prototype.decrypt=function(t,n){var r,i,s,o,a,f;return i=e.BLOCK_CIPHER_KEY_SIZE,r=e.BLOCK_CIPHER_ITERATIONS,f=atob(t.salt),a=u(n,f,r,i),o=atob(t.iv),s=atob(t.contents),this.abstractCryptoService.decrypt(a,o,s)},e.prototype._derive=function(e,t,n,r){return u(e,t,n,r)},e}(),o})}.call(this),function(){define("kryptnostic.rsa-crypto-service",["require","forge","lodash"],function(e){"use strict";var t,n,r;return r=e("lodash"),t=e("forge"),n=function(){function e(e){this.privateKey=e.privateKey,this.publicKey=e.publicKey;if(r.isEmpty(this.privateKey)&&r.isEmpty(this.publicKey))throw new Error("no public key or private key provided")}return e.prototype.encrypt=function(e){var n;return n=this.publicKey.encrypt(e,"RSA-OAEP",{md:t.md.sha1.create()}),n},e.prototype.decrypt=function(e){var n;return n=this.privateKey.decrypt(e,"RSA-OAEP",{md:t.md.sha1.create()}),n},e}(),n})}.call(this),function(){define("kryptnostic.rsa-key-generator",["require","forge","kryptnostic.logger","bluebird"],function(e){var t,n,r,i,s,o,u,a;return u=e("forge"),r=e("kryptnostic.logger"),i=e("bluebird"),a=r.get("RsaKeyGenerator"),s=4096,n=65537,t=new Uint8Array([1,0,1]),o=function(){function e(){}return e.prototype.forgeGenerate=function(){return i.resolve().then(function(){var e,t,r,i;return t={},e=u.rsa.generateKeyPair(s,n),r=u.pki.privateKeyToAsn1(e.privateKey),i=u.pki.publicKeyToAsn1(e.publicKey),t.privateKey=u.asn1.toDer(r),t.publicKey=u.asn1.toDer(i),t})},e.prototype.webCryptoGenerate=function(){return i.resolve(window.crypto.subtle.generateKey({name:"RSA-OAEP",modulusLength:s,publicExponent:t,hash:{name:"SHA-256"}},!0,["encrypt","decrypt"])).then(function(e){var t,n;return t=window.crypto.subtle.exportKey("pkcs8",e.privateKey).then(function(e){var t;return t=new u.util.ByteBuffer(e)}),n=window.crypto.subtle.exportKey("spki",e.publicKey).then(function(e){var t;return t=new u.util.ByteBuffer(e)}),i.join(t,n,function(e,t){var n;return n={},n.privateKey=e,n.publicKey=t,n})})},e.prototype.ieWebCryptoGenerate=function(){return i.resolve().then(function(){var e,n;return e=i.defer(),n=window.msCrypto.subtle.generateKey({name:"RSA-OAEP",modulusLength:s,publicExponent:t,hash:{name:"SHA-256"}},!0,["encrypt","decrypt"]),n.onerror=function(){return a.error("Failed to generate RSA keys using IE web crypto")},n.oncomplete=function(){var t;return t=n.result,e.resolve(t)},e.promise}).then(function(e){var t,n,r,s,o,f;return t=i.defer(),r=window.msCrypto.subtle.exportKey("pkcs8",e.privateKey),r.onerror=function(){return a.error("Failed to export RSA private key using IE web crypto")},r.oncomplete=function(){var e;return e=new u.util.ByteBuffer(r.result),t.resolve(e)},o=t.promise,n=i.defer(),s=window.msCrypto.subtle.exportKey("spki",e.publicKey),s.onerror=function(){return a.error("Failed to export RSA public key using IE web crypto")},s.oncomplete=function(){var e;return e=new u.util.ByteBuffer(s.result),n.resolve(e)},f=n.promise,i.join(o,f,function(e,t){var n;return n={},n.privateKey=e,n.publicKey=t,n})})},e.prototype.generateKeypair=function(){var e,t;return((e=window.crypto)!=null?e.subtle:void 0)!=null?this.webCryptoGenerate():((t=window.msCrypto)!=null?t.subtle:void 0)!=null?this.ieWebCryptoGenerate():this.forgeGenerate()},e}(),o})}.call(this),function(){define("kryptnostic.kryptnostic-engine",["require","kryptnostic.logger"],function(e){var t,n,r,i;return r=e("kryptnostic.logger"),t="KryptnosticClient is unavailable. This component must be included separately.\nIt is not built as a part of the kryptnostic.js binary. Please see the krytpnostic.js\ndocumentation for more information and/or file an issue on the kryptnostic-js github project:\nhttps://github.com/kryptnostic/kryptnostic-js/issues",i=r.get("KryptnosticEngine"),n=function(){function e(e){var n;n=e!=null?e:{},this.fhePrivateKey=n.fhePrivateKey,this.fheSearchPrivateKey=n.fheSearchPrivateKey,(typeof Module=="undefined"||Module===null||Module.KryptnosticClient==null)&&i.error(t),this.fhePrivateKey&&this.fheSearchPrivateKey?this.krypto=new Module.KryptnosticClient(this.fhePrivateKey,this.fheSearchPrivateKey):this.krypto=new Module.KryptnosticClient}return e.OBJECT_INDEX_PAIR_SIZE=2064,e.OBJECT_SHARE_PAIR_SIZE=2064,e.OBJECT_SEARCH_PAIR_SIZE=2080,e.prototype.getPrivateKey=function(){return new Uint8Array(this.krypto.getPrivateKey())},e.prototype.getSearchPrivateKey=function(){return new Uint8Array(this.krypto.getSearchPrivateKey())},e.prototype.calculateClientHashFunction=function(){return new Uint8Array(this.krypto.calculateClientHashFunction())},e.prototype.generateObjectIndexPair=function(){return new Uint8Array(this.krypto.generateObjectIndexPair())},e.prototype.calculateMetadataAddress=function(e,t){return new Uint8Array(this.krypto.calculateMetadataAddress(e,t))},e.prototype.calculateObjectSearchPairFromObjectIndexPair=function(e){return new Uint8Array(this.krypto.calculateObjectSearchPairFromObjectIndexPair(e))},e.prototype.calculateObjectIndexPairFromObjectSearchPair=function(e){return new Uint8Array(this.krypto.calculateObjectIndexPairFromObjectSearchPair(e))},e.prototype.calculateEncryptedSearchToken=function(e){return new Uint8Array(this.krypto.calculateEncryptedSearchToken(e))},e.prototype.calculateObjectSharePairFromObjectSearchPair=function(e){return new Uint8Array(this.krypto.calculateObjectSharePairFromObjectSearchPair(e))},e.prototype.calculateObjectSearchPairFromObjectSharePair=function(e){return new Uint8Array(this.krypto.calculateObjectSearchPairFromObjectSharePair(e))},e.isValidObjectIndexPair=function(t){return t instanceof Uint8Array&&t.length===e.OBJECT_INDEX_PAIR_SIZE},e.isValidObjectSharePair=function(t){return t instanceof Uint8Array&&t.length===e.OBJECT_SHARE_PAIR_SIZE},e.isValidObjectSearchPair=function(t){return t instanceof Uint8Array&&t.length===e.OBJECT_SEARCH_PAIR_SIZE},e}(),n})}.call(this),function(){define("kryptnostic.kryptnostic-engine-provider",["require","kryptnostic.kryptnostic-engine","kryptnostic.logger"],function(e){var t,n,r,i;return t=e("kryptnostic.kryptnostic-engine"),r=e("kryptnostic.logger"),i=r.get("KryptnosticEngineProvider"),n=function(){function n(){}var e;return e=null,n.init=function(n){var r;return r=n!=null?n:{},this.fhePrivateKey=r.fhePrivateKey,this.fheSearchPrivateKey=r.fheSearchPrivateKey,i.debug("initializing KryptnosticEngine with keys"),e!=null?e:e=new t({fhePrivateKey:this.fhePrivateKey,fheSearchPrivateKey:this.fheSearchPrivateKey})},n.getEngine=function(){return e!=null?e:(i.debug("initializing a new KryptnosticEngine without keys..."),this.init())},n}(),n})}.call(this),function(){define("kryptnostic.mock.kryptnostic-engine",["require","kryptnostic.binary-utils"],function(e){var t,n,r,i;return t=e("kryptnostic.binary-utils"),r=" ",i=function(e){return e.length%2===0?e:e+r},n=function(){function e(e){var t;t=e!=null?e:{},this.fhePrivateKey=t.fhePrivateKey,this.searchPrivateKey=t.searchPrivateKey}return e.prototype.generateObjectIndexPair=function(){return t.stringToUint8(i("doc.search.doc.index"))},e.prototype.calculateMetadataAddress=function(e,n){return t.stringToUint8("search.address."+t.uint8ToString(n))},e}(),n})}.call(this),function(){define("kryptnostic.mock.search-key-generator",["require","kryptnostic.binary-utils"],function(e){var t,n,r;return t=e("kryptnostic.binary-utils"),r=function(e){return e.length%2===0?e:e+SPACE},n=function(){function e(){}return e.prototype.generateClientKeys=function(){return{fhePrivateKey:t.stringToUint8(r("fhe.priv")),searchPrivateKey:t.stringToUint8(r("search.pvt")),clientHashFunction:t.stringToUint8(r("hash.fun"))}},e}(),n})}.call(this),function(){define("kryptnostic.search-key-generator",["require","kryptnostic.logger","kryptnostic.kryptnostic-engine-provider"],function(e){var t,n,r,i;return t=e("kryptnostic.kryptnostic-engine-provider"),n=e("kryptnostic.logger"),i=n.get("SearchKeyGenerator"),r=function(){function e(){}return e.prototype.generateClientKeys=function(){var e;return e=t.getEngine(),{FHE_PRIVATE_KEY:e.getPrivateKey(),FHE_SEARCH_PRIVATE_KEY:e.getSearchPrivateKey(),FHE_HASH_FUNCTION:e.calculateClientHashFunction()}},e}(),r})}.call(this),function(){define("kryptnostic.key-storage-api",["require","axios","bluebird","forge","kryptnostic.block-ciphertext","kryptnostic.caching-service","kryptnostic.configuration","kryptnostic.logger","kryptnostic.requests","kryptnostic.validators"],function(e){var t,n,r,i,s,o,u,a,f,l,c,h,p,d,v,m,g,y,b,w,E,S,x,T,N,C,k,L,A,O;return p=e("axios"),s=e("forge"),a=e("bluebird"),t=e("kryptnostic.block-ciphertext"),n=e("kryptnostic.caching-service"),r=e("kryptnostic.configuration"),u=e("kryptnostic.logger"),f=e("kryptnostic.requests"),l=e("kryptnostic.validators"),i={"Content-Type":"application/json"},L=l.validateUuid,A=l.validateUuids,O=l.validateVersionedObjectKey,k=l.validateObjectCryptoService,E=u.get("KeyStorageApi"),w=function(){return r.get("servicesUrlV2")+"/keys"},v=function(){return w()+"/fhe"},d=function(){return v()+"/hash"},m=function(){return v()+"/private"},g=function(){return v()+"/searchprivate"},T=function(e){return w()+"/salt/"+e},S=function(){return w()+"/rsa"},x=function(){return S()+"/private"},N=function(){return S()+"/public"},b=function(e){return S()+"/public/"+e},y=function(){return S()+"/public/bulk"},h=function(){return w()+"/aes"},c=function(e,t){return h()+"/cryptoservice/id/"+e+"/"+t},C=function(e){return e.objectId+"/"+e.objectVersion},o=function(){function e(){}return e.getFHEPrivateKey=function(){return f.getBlockCiphertextFromUrl(m())},e.setFHEPrivateKey=function(e){return a.resolve(p(f.wrapCredentials({method:"POST",url:m(),data:e,headers:i})))},e.getFHESearchPrivateKey=function(){return f.getBlockCiphertextFromUrl(g())},e.setFHESearchPrivateKey=function(e){return a.resolve(p(f.wrapCredentials({method:"POST",url:g(),data:e,headers:i})))},e.getFHEHashFunction=function(){return f.getAsUint8FromUrl(d())},e.setFHEHashFunction=function(e){return a.resolve(p(f.wrapCredentials({method:"POST",url:d(),data:e,headers:i})))},e.getEncryptedSalt=function(e){var r;return L(e)?(r=n.get(n.SALTS,e),r?a.resolve(r):a.resolve(p({method:"GET",url:T(e)})).then(function(r){var i,s;if(!r||!r.data)return null;try{return s=new t(r.data),n.store(n.SALTS,e,s),s}catch(o){return i=o,null}})):a.resolve(null)},e.setEncryptedSalt=function(e,t,n){return L(e)?a.resolve(p(f.wrapCredentials({method:"POST",url:T(e),data:JSON.stringify(n),headers:i},{principal:e,credential:t}))):a.resolve(null)},e.getRSAPrivateKey=function(){return f.getBlockCiphertextFromUrl(x())},e.setRSAPrivateKey=function(e){return a.resolve(p(f.wrapCredentials({method:"POST",url:x(),data:JSON.stringify(e),headers:i})))},e.getRSAPublicKeys=function(e){return A(e)?a.resolve(p(f.wrapCredentials({method:"POST",url:y(),data:JSON.stringify(e),headers:i}))).then(function(e){var t,n,r;if(!e||!e.data)return null;try{return n=e.data,r=_.mapValues(n,function(e){var t,n,r,i,o;try{return n=atob(e),i=s.util.createBuffer(n,"raw"),r=s.asn1.fromDer(i),o=s.pki.publicKeyFromAsn1(r),o}catch(u){return t=u,null}}),r}catch(i){return t=i,null}}):a.resolve(null)},e.getRSAPublicKey=function(e){throw new Error("KeyStorageApi:getRSAPublicKey() - not yet implemented!")},e.setRSAPublicKey=function(e){var t;return t=btoa(e),a.resolve(p(f.wrapCredentials({method:"POST",url:N(),data:e,headers:i})))},e.getMasterAesCryptoService=function(){var e,t;return t=n.MASTER_AES_CRYPTO_SERVICE_ID,e=n.get(n.CRYPTO_SERVICES,t),e?a.resolve(e):a.resolve(p(f.wrapCredentials({method:"GET",url:h()}))).then(function(e){var r;return e&&e.data?(r=atob(e.data),t=n.MASTER_AES_CRYPTO_SERVICE_ID,n.store(n.CRYPTO_SERVICES,t,r),r):null})},e.setMasterAesCryptoService=function(e){var t;return e?(t=btoa(e),a.resolve(p(f.wrapCredentials({method:"PUT",url:h(),data:t,headers:i}))).then(function(){var t;t=n.MASTER_AES_CRYPTO_SERVICE_ID,n.store(n.CRYPTO_SERVICES,t,e)})):a.resolve(null)},e.getAesEncryptedObjectCryptoService=function(e){var t,r;return O(e)?(r=C(e),t=n.get(n.CRYPTO_SERVICES,r),t?a.resolve(t):f.getBlockCiphertextFromUrl(c(e.objectId,e.objectVersion)).then(function(e){return e?(n.store(n.CRYPTO_SERVICES,r,e),e):null})):a.resolve(null)},e.setAesEncryptedObjectCryptoService=function(e,t){return O(e)?a.resolve(p(f.wrapCredentials({method:"PUT",url:c(e.objectId,e.objectVersion),data:JSON.stringify(t),headers:i}))).then(function(){var r;r=C(e),n.store(n.CRYPTO_SERVICES,r,t)}):a.resolve(null)},e}(),o})}.call(this),function(){define("kryptnostic.metadata-api",["require","axios","bluebird","kryptnostic.configuration","kryptnostic.requests","kryptnostic.logger"],function(e){var t,n,r,i,s,o,u,a,f,l;return u=e("axios"),s=e("bluebird"),t=e("kryptnostic.configuration"),r=e("kryptnostic.logger"),o=e("kryptnostic.requests"),n={"Content-Type":"application/json"},l=function(){return t.get("servicesUrl")+"/metadata"},a=function(){return l()+"/delete"},f=r.get("MetadataApi"),i=function(){function e(){}return e.prototype.uploadMetadata=function(e){return s.resolve().then(function(){return e.validate(),u(o.wrapCredentials({url:l(),method:"POST",headers:n,data:JSON.stringify(e)}))}).then(function(e){return f.debug("uploadMetadata()",e.data.data)})},e.prototype.deleteAll=function(e){throw new Error("deleteAll() not implemented")},e}(),i})}.call(this),function(){define("kryptnostic.object-api",["require","axios","bluebird","kryptnostic.block-ciphertext","kryptnostic.configuration","kryptnostic.kryptnostic-object","kryptnostic.logger","kryptnostic.requests","kryptnostic.object-metadata","kryptnostic.validators","kryptnostic.object-tree-load-request"],function(e){var t,n,r,i,s,o,u,a,f,l,c,h,p,d,v,m,g,y,b,w,E,S,x,T;return h=e("axios"),t=e("kryptnostic.block-ciphertext"),l=e("kryptnostic.requests"),i=e("kryptnostic.logger"),n=e("kryptnostic.configuration"),f=e("bluebird"),o=e("kryptnostic.object-metadata"),u=e("kryptnostic.object-metadata-tree"),a=e("kryptnostic.object-tree-load-request"),c=e("kryptnostic.validators"),S=c.validateId,x=c.validateUuid,T=c.validateUuids,r={"Content-Type":"application/json"},v=i.get("ObjectApi"),b=function(){return n.get("servicesUrlV2")+"/object"},E=function(){return b()+"/bulk"},m=function(e){return b()+"/id/"+e},d=function(e){return b()+"/latest/id/"+e},y=function(e){return b()+"/objectmetadata/id/"+e},w=function(e,t){return m(e)+"/"+t},g=function(){return b()+"/levels"},p=function(){return b()+"/index-segment"},s=function(){function e(){}return e.prototype.getObject=function(e){return x(e)?f.resolve(this.getObjects([e])).then(function(t){return t[e]}):f.resolve(null)},e.prototype.getObjects=function(e){return T(e)?f.resolve(h(l.wrapCredentials({method:"POST",url:E(),data:JSON.stringify(e),headers:r}))).then(function(e){return e!=null&&e.data!=null?_.mapValues(e.data,function(e){var n;try{return new t(e)}catch(r){return n=r,null}}):null}):f.resolve(null)},e.prototype.getLatestVersionedObjectKey=function(e){return x(e)?f.resolve(h(l.wrapCredentials({method:"GET",url:d(e)}))).then(function(e){return e!=null&&e.data!=null?e.data:null}):f.resolve(null)},e.prototype.getObjectMetadata=function(e){return x(e)?f.resolve(h(l.wrapCredentials({method:"GET",url:y(e)}))).then(function(e){return e!=null&&e.data!=null?new o(e.data):null}):f.resolve(null)},e.prototype.getObjectsByTypeAndLoadLevel=function(e,t,n){var i;return i=new a({objectIds:e,loadLevels:t,depth:n}),f.resolve(h(l.wrapCredentials({method:"POST",url:g(),data:JSON.stringify(i),headers:r}))).then(function(e){return e!=null&&e.data!=null?e.data:null})},e.prototype.createObject=function(e){return f.resolve(h(l.wrapCredentials({method:"POST",url:b(),data:JSON.stringify(e),headers:r}))).then(function(e){return e!=null&&e.data!=null?e.data:null})},e.prototype.createIndexSegment=function(e){return f.resolve(h(l.wrapCredentials({method:"POST",url:p(),data:JSON.stringify(e),headers:r}))).then(function(e){return e!=null&&e.data!=null?e.data:null})},e.prototype.getObjectAsBlockCiphertext=function(e){return l.getBlockCiphertextFromUrl(w(e.objectId,e.objectVersion))},e.prototype.setObjectFromBlockCiphertext=function(e,t){return f.resolve(h(l.wrapCredentials({method:"PUT",url:w(e.objectId,e.objectVersion),data:JSON.stringify(t),headers:r}))).then(function(e){return e!=null&&e.data!=null?e.data:null})},e.prototype.deleteObjectTrees=function(e){return f.resolve(h(l.wrapCredentials({method:"DELETE",url:b(),data:JSON.stringify(e),headers:r})))},e}(),s})}.call(this),function(){define("kryptnostic.object-authorization-api",["require","axios","bluebird","kryptnostic.configuration","kryptnostic.kryptnostic-object","kryptnostic.logger","kryptnostic.requests","kryptnostic.object-metadata","kryptnostic.validators"],function(e){var t,n,r,i,s,o,u,a,f,l,c,h;return a=e("axios"),s=e("bluebird"),t=e("kryptnostic.configuration"),r=e("kryptnostic.logger"),o=e("kryptnostic.requests"),n={"Content-Type":"application/json"},u=function(){return t.get("servicesUrlV2")+"/access"},l=function(e){return u()+"/owners/"+e},c=function(e){return u()+"/readers/"+e},h=function(e){return u()+"/writers/"+e},f=r.get("ObjectAuthorizationApi"),i=function(){function e(){}return e.prototype.wrapCredentials=function(e,t){return o.wrapCredentials(e,t)},e.prototype.getUsersWithOwnerAccess=function(e){return s.resolve(a(this.wrapCredentials({method:"GET",url:l(e)}))).then(function(e){return e!=null&&e.data!=null?e.data:null})},e.prototype.getUsersWithReadAccess=function(e){return s.resolve(a(this.wrapCredentials({method:"GET",url:c(e)}))).then(function(e){return e!=null&&e.data!=null?e.data:null})},e.prototype.getUsersWithWriteAccess=function(e){return s.resolve(a(this.wrapCredentials({method:"GET",url:h(e)}))).then(function(e){return e!=null&&e.data!=null?e.data:null})},e}(),i})}.call(this),function(){define("kryptnostic.object-listing-api",["require","axios","bluebird","kryptnostic.configuration","kryptnostic.kryptnostic-object","kryptnostic.logger","kryptnostic.requests","kryptnostic.object-metadata","kryptnostic.validators"],function(e){var t,n,r,i,s,o,u,a,f,l,c,h;return o=e("axios"),i=e("bluebird"),t=e("kryptnostic.configuration"),n=e("kryptnostic.logger"),s=e("kryptnostic.requests"),u=n.get("ObjectListingApi"),f=function(){return t.get("servicesUrlV2")+"/listing"},l=function(){return f()+"/objects"},h=function(){return f()+"/versioned/objects"},c=function(e){return l()+"/typename/"+e},a=function(e,t){return l()+"/"+e+"/type/"+t},r=function(){function e(){}return e.prototype.getObjectIdsByTypeId=function(e,t){return i.resolve(o(s.wrapCredentials({method:"GET",url:a(e,t)}))).then(function(e){return e!=null&&e.data!=null?e.data:null})},e.prototype.getTypeIdForTypeName=function(e){return i.resolve(o(s.wrapCredentials({method:"GET",url:c(e)}))).then(function(e){return e!=null&&e.data!=null?e.data:null})},e}(),r})}.call(this),function(){define("kryptnostic.registration-api",["require","axios","bluebird","kryptnostic.configuration"],function(e){var t,n,r,i,s,o;return s=e("axios"),r=e("bluebird"),t=e("kryptnostic.configuration"),o=function(){return t.get("heraclesUrlV2")+"/registration/user"},n={"Content-Type":"application/json"},i=function(){function e(){}return e.prototype.register=function(e){return r.resolve().then(function(){return e.validate()}).then(function(){return s({method:"POST",data:JSON.stringify(e),url:o(),headers:_.clone(n)})}).then(function(e){return e.data})},e}(),i})}.call(this),function(){define("kryptnostic.search-api",["require","axios","bluebird","kryptnostic.logger","kryptnostic.requests","kryptnostic.configuration"],function(e){var t,n,r,i,s,o,u,a,f,l,c,h;return a=e("axios"),i=e("bluebird"),t=e("kryptnostic.configuration"),r=e("kryptnostic.logger"),s=e("kryptnostic.requests"),u=e("kryptnostic.validators"),n={"Content-Type":"application/json"},h=u.validateVersionedObjectKey,l=function(){return t.get("servicesUrlV2")+"/search"},c=function(e,t){return l()+"/"+e+"/"+t},f=r.get("SearchApi"),o=function(){function e(){}return e.prototype.search=function(e){return i.resolve(a(s.wrapCredentials({method:"POST",url:l(),data:e,headers:n}))).then(function(e){return e&&e.data?e.data:null})["catch"](function(e){return null})},e.reserveSegmentRange=function(e,t){return h(e)?!_.isFinite(t)||t<0?i.resolve(null):i.resolve(a(s.wrapCredentials({method:"POST",url:c(e.objectId,t),headers:n}))).then(function(e){return e!=null&&e.data!=null?e.data:null})["catch"](function(e){return null}):i.resolve(null)},e}(),o})}.call(this),function(){define("kryptnostic.sharing-api",["require","axios","bluebird","kryptnostic.binary-utils","kryptnostic.configuration","kryptnostic.logger","kryptnostic.requests","kryptnostic.validators"],function(e){var t,n,r,i,s,o,u,a,f,l,c,h,p,d,v,m,g;return l=e("axios"),s=e("bluebird"),t=e("kryptnostic.binary-utils"),n=e("kryptnostic.configuration"),i=e("kryptnostic.logger"),o=e("kryptnostic.requests"),a=e("kryptnostic.validators"),r={"Content-Type":"application/json"},g=a.validateVersionedObjectKey,p=i.get("SharingApi"),m=function(){return n.get("servicesUrlV2")+"/share"},v=function(){return m()+"/object"},d=function(){return m()+"/object"},h=function(){return m()+"/object"},f=function(){return m()+"/keys"},c=function(e,t){return m()+"/keys/id/"+e+"/"+t},u=function(){function e(){}return e.prototype.getIncomingShares=function(){return s.resolve(l(o.wrapCredentials({method:"GET",url:h()}))).then(function(e){return e!=null&&e.data!=null?e.data:null})},e.prototype.shareObject=function(e){return e.validate(),s.resolve(l(o.wrapCredentials({method:"POST",url:v(),data:JSON.stringify(e),headers:r})))},e.prototype.revokeObject=function(e){return e.validate(),s.resolve(l(o.wrapCredentials({method:"DELETE",url:d(),data:JSON.stringify(e),headers:r})))},e.prototype.getObjectSearchPair=function(e){return g(e)?o.getAsUint8FromUrl(c(e.objectId,e.objectVersion)):s.resolve(null)},e.prototype.addObjectSearchPair=function(e,n){var i,u;return g(e)?(u={objectKey:e,objectSearchPair:t.uint8ToBase64(n)},i=[u],s.resolve(l(o.wrapCredentials({method:"POST",url:f(),data:i,headers:r})))):s.resolve(null)},e}(),u})}.call(this),function(){var e=function(e,t){return function(){return e.apply(t,arguments)}};define("kryptnostic.user-directory-api",["require","axios","bluebird","kryptnostic.logger","kryptnostic.configuration","kryptnostic.caching-service","kryptnostic.requests","kryptnostic.validators"],function(t){var n,r,i,s,o,u,a,f,l,c,h,p,d,v,m,g;return l=t("axios"),o=t("bluebird"),s=t("kryptnostic.logger"),r=t("kryptnostic.configuration"),n=t("kryptnostic.caching-service"),u=t("kryptnostic.requests"),f=t("kryptnostic.validators"),c=function(){return r.get("heraclesUrlV2")+"/directory/user"},h=function(){return r.get("heraclesUrlV2")+"/directory/users"},d=function(){return r.get("servicesUrl")+"/directory"},p=s.get("UserDirectoryApi"),i={"Content-Type":"application/json"},g=f.validateUuids,v=function(e){if(_.isEmpty(e))throw p.error("illegal email address",e),new Error("illegal email address")},m=function(e){if(_.isEmpty(e))throw p.error("illegal uuid",e),new Error("illegal uuid")},a=function(){function t(){this.getUserName=e(this.getUserName,this)}return t.prototype.getUserName=function(e){return this.getUser(e).then(function(e){return e.name})},t.prototype.resolve=function(e){var t;return t=e.email,o.resolve().then(function(){return v(t),l({url:c()+"/email/"+t,method:"GET"})}).then(function(e){var t;return t=e.data,t==="null"||!t?void 0:t})},t.prototype.getUser=function(e){var t;return t=n.get(n.USERS,e),t!=null?o.resolve().then(function(){return t}):o.resolve().then(function(){return m(e),l({url:c()+"/"+e,method:"GET"})}).then(function(t){var r;return t!=null&&t.data!=null?(r=t.data,n.store(n.USERS,e,r),r):null})},t.prototype.getUsers=function(e){var t,r,i;return g(e)?(r=n.search(n.USERS,e),i=r.uncached,t=r.cached,i&&i.length===0?o.resolve(t):o.resolve().then(function(){var e,t,n;for(t=0,n=i.length;t<n;t++)e=i[t],m(e);return l({url:h(),method:"POST",data:i})}).then(function(e){var r,i,s,o;i=e.data;if(i==="null"||!i)return void 0;for(s=0,o=i.length;s<o;s++)r=i[s],n.store(n.USERS,r.id,r);return t.concat(i)})):o.resolve([])},t.prototype.getInitializedUsers=function(e){var t;return t=e.realm,o.resolve(l(u.wrapCredentials({url:d()+"/initialized/"+t,method:"GET"}))).then(function(e){var t;return t=e.data,t})},t}(),a})}.call(this),function(){define("kryptnostic.indexing.inverted-index-segment",["require","kryptnostic.schema.inverted-index-segment","kryptnostic.schema.validator"],function(e){var t,n,r;return n=e("kryptnostic.schema.inverted-index-segment"),r=e("kryptnostic.schema.validator"),t=function(){function e(e){_.extend(this,e),this.validate()}return e.prototype.validate=function(){return r.validate(this,e,n)},e}(),t})}.call(this),function(){define("kryptnostic.indexing.object-indexer",["require","kryptnostic.indexing.inverted-index-segment","kryptnostic.indexing.object-tokenizer","kryptnostic.validators"],function(e){var t,n,r,i,s;return t=e("kryptnostic.indexing.inverted-index-segment"),r=e("kryptnostic.indexing.object-tokenizer"),i=e("kryptnostic.validators"),s=i.validateVersionedObjectKey,n=function(){function e(){this.objectTokenizer=new r}return e.prototype.buildInvertedIndexSegments=function(e,n,r){var i,o;return s(n)?!_.isUndefined(r)&&!_.isNull(r)&&!s(r)?[]:(o=this.objectTokenizer.buildPaddedInvertedIndex(e),i=[],_.map(o,function(e,s){return _.forEach(e,function(e){var o;return o=new t({objectKey:n,parentObjectKey:r,token:s,indices:e}),i.push(o)})}),i):[]},e}(),n})}.call(this),function(){define("kryptnostic.indexing.object-indexing-service",["require","bluebird","forge","kryptnostic.binary-utils","kryptnostic.chunking.strategy.json","kryptnostic.create-object-request","kryptnostic.crypto-material","kryptnostic.crypto-service-loader","kryptnostic.hash-function","kryptnostic.kryptnostic-engine","kryptnostic.kryptnostic-engine-provider","kryptnostic.kryptnostic-object","kryptnostic.object-api","kryptnostic.search-api","kryptnostic.sharing-api","kryptnostic.validators"],function(e){var t,n,r,i,s,o,u,a,f,l,c,h,p,d,v,m,g,y,b;return d=e("bluebird"),y=e("forge"),c=e("kryptnostic.object-api"),v=e("kryptnostic.search-api"),m=e("kryptnostic.sharing-api"),n=e("kryptnostic.create-object-request"),r=e("kryptnostic.crypto-material"),i=e("kryptnostic.crypto-service-loader"),o=e("kryptnostic.chunking.strategy.json"),u=e("kryptnostic.kryptnostic-engine"),a=e("kryptnostic.kryptnostic-engine-provider"),f=e("kryptnostic.kryptnostic-object"),h=e("kryptnostic.indexing.object-indexer"),t=e("kryptnostic.binary-utils"),s=e("kryptnostic.hash-function"),g=e("kryptnostic.validators"),l=1,b=g.validateVersionedObjectKey,p=function(){function e(){this.cryptoServiceLoader=new i,this.objectIndexer=new h,this.objectApi=new c,this.sharingApi=new m}return e.INDEX_SEGMENT_TYPE_ID="00000000-0000-0000-0000-000000000007",e.prototype.index=function(e,t,n,r){var i;return b(t)?(b(n)||(n=t),i=this.objectIndexer.buildInvertedIndexSegments(e,t,n),this.shuffle(i),d.props({objectCryptoService:this.cryptoServiceLoader.getObjectCryptoServiceV2(n),segmentRangeStartIndex:v.reserveSegmentRange(n,i.length)}).then(function(e){return function(s){var o,u,a,f;o=s.objectCryptoService,f=s.segmentRangeStartIndex;if(!o)return;return a=e.calculateObjectIndexPairAndObjectSearchPair(n,r),u=a.objectIndexPair,r=a.objectSearchPair,_.forEach(i,function(r,i){var s;s=e.computeSegmentAddressHash(r.token,f,i,u);if(s)return d.resolve(e.createInvertedIndexSegmentObject(s,t,n)).then(function(t){var i;i=e.encryptInvertedIndexSegment(r,n,o),e.objectApi.setObjectFromBlockCiphertext(t,i)})}),r}}(this))):d.resolve()},e.prototype.createInvertedIndexSegmentObject=function(t,i,s){var o,u;return u=new n({type:e.INDEX_SEGMENT_TYPE_ID,parentObjectId:s,requiredCryptoMats:r.DEFAULT_REQUIRED_CRYPTO_MATERIAL}),o={address:t,createObjectRequest:u},d.resolve(this.objectApi.createIndexSegment(o)).then(function(e){return e})},e.prototype.encryptInvertedIndexSegment=function(e,t,n){var r,i;return r=JSON.stringify(e),i=n.encrypt(r),i},e.prototype.computeSegmentAddressHash=function(e,n,r,i){var o,u,f,c,h,p,d,v,m,g;return!_.isString(e)||e.length<=l?null:(g=s.SHA_256_TO_128(e),m=t.stringToUint8(g),u=a.getEngine(),o=u.calculateMetadataAddress(i,m),d=n+r,v=t.intToUint8(d),c=new Uint8Array(o.byteLength+v.byteLength),c.set(new Uint8Array(o),0),c.set(new Uint8Array(v),o.byteLength),f=new y.util.ByteBuffer(c),h=s.SHA_256(f.getBytes()),p=btoa(h),p)},e.prototype.calculateObjectIndexPairAndObjectSearchPair=function(e,t){var n,r;return r=null,n=a.getEngine(),u.isValidObjectSearchPair(t)?r=n.calculateObjectIndexPairFromObjectSearchPair(t):(r=n.generateObjectIndexPair(),t=n.calculateObjectSearchPairFromObjectIndexPair(r),this.sharingApi.addObjectSearchPair(e,t)),{objectIndexPair:r,objectSearchPair:t}},e.prototype.shuffle=function(e){var t,n,r;n=e.length;while(n)r=Math.floor(Math.random()*n),n--,t=e[n],e[n]=e[r],e[r]=t;return e},e}(),p})}.call(this),function(){define("kryptnostic.indexing.object-tokenizer",["require"],function(e){var t;return t=function(){function t(e){_.isFinite(e)&&e>0?this.bucketSize=e:this.bucketSize=t.DEFAULT_BUCKET_SIZE}var e;return t.DEFAULT_BUCKET_SIZE=10,e=/([a-zA-Z0-9']+)/g,t.prototype.buildPaddedInvertedIndex=function(t){var n,r,i,s,o;if(!_.isString(t))return{};i={};while(s=e.exec(t))o=s[0].toLowerCase(),n=s.index,r=i[o],r?r[r.length-1].length===this.bucketSize&&r.push([]):(r=[[]],i[o]=r),r[r.length-1].push(n);return _.forEach(i,function(e){return function(t){var n;n=t[t.length-1];while(n.length<e.bucketSize)n.push(-1)}}(this)),i},t}(),t})}.call(this),function(){define("kryptnostic.deflating-marshaller",["require","pako","forge","lodash"],function(e){var t,n,r,i,s,o,u,a;return s=e("pako"),r=e("forge"),a=e("lodash"),n="",i=4,o=function(e){return r.util.createBuffer(e,"raw").length()},u=function(e){if(!a.isString(e))throw new Error("input data must be in string form")},t=function(){function e(){}return e.prototype.marshall=function(e){var t,i,a;return u(e),a=o(e),i=s.deflate(e,{to:"string"}),t=r.util.createBuffer(n,"raw"),t.putInt32(a),t.putBytes(i),t.data},e.prototype.unmarshall=function(e){var t,n,a,f,l;u(e),t=r.util.createBuffer(e,"raw"),l=t.getInt32(i),n=t.getBytes(t.length()),a=s.inflate(n,{to:"string"}),f=o(a);if(l!==f)throw new Error("verifying byte count failed");return a},e}(),t})}.call(this),function(){define("kryptnostic.block-ciphertext",["require","lodash","kryptnostic.schema.validator","kryptnostic.schema.block-ciphertext"],function(e){"use strict";var t,n,r,i;return i=e("lodash"),n=e("kryptnostic.schema.block-ciphertext"),r=e("kryptnostic.schema.validator"),t=function(){function e(e){i.extend(this,e),this.validate()}return e.prototype.validate=function(){return r.validate(this,e,n)},e}(),t})}.call(this),function(){define("kryptnostic.encrypted-block",["require","lodash","kryptnostic.schema.validator","kryptnostic.schema.encrypted-block"],function(e){"use strict";var t,n,r,i;return i=e("lodash"),r=e("kryptnostic.schema.validator"),n=e("kryptnostic.schema.encrypted-block"),t=function(){function e(e){i.extend(this,e),this.validate()}return e.prototype.validate=function(){return r.validate(this,e,n)},e}(),t})}.call(this),function(){define("kryptnostic.kryptnostic-object",["require","lodash","kryptnostic.chunking.registry","kryptnostic.object-metadata","kryptnostic.schema.validator","kryptnostic.schema.kryptnostic-object","kryptnostic.block-encryption-service","kryptnostic.logger"],function(e){"use strict";var t,n,r,i,s,o,u,a,f;return f=e("lodash"),a=e("kryptnostic.schema.validator"),o=e("kryptnostic.schema.kryptnostic-object"),n=e("kryptnostic.chunking.registry"),s=e("kryptnostic.object-metadata"),t=e("kryptnostic.block-encryption-service"),i=e("kryptnostic.logger"),u=i.get("KryptnosticObject"),r=function(){function e(e){f.extend(this,e),this.validate()}return e.prototype.validate=function(){return a.validate(this,e,o)},e.createFromEncrypted=function(t){var n;return n=new e(t),f.defaults(n,{metadata:{strategy:{}}}),n},e.createFromDecrypted=function(t){var n,r,i;return r=t.id,n=t.body,i=new s({id:r}),n={data:n},new e({metadata:i,body:n})},e.prototype.setChunkingStrategy=function(e){return this.metadata.strategy["@class"]=e},e.prototype.validateEncrypted=function(){if(!this.isEncrypted())throw new Error("object must be in an encrypted state")},e.prototype.validateDecrypted=function(){if(!this.isDecrypted())throw new Error("object must be in a decrypted state")},e.prototype.isEncrypted=function(){var e,t;return e=f.isArray(this.body.data),t=f.first(this.body.data).block!=null,e&&t},e.prototype.isDecrypted=function(){return!this.isEncrypted()},e.prototype.decrypt=function(r){var i,s,o,a,l,c,h;return this.isDecrypted()?(u.error("object is already decrypted",this),this):(i=new t,l=i.decrypt(this.body.data,r),a=this.metadata.strategy["@class"],o=n.get(a),s=new o,c=s.join(l),h=f.extend({},f.cloneDeep(this),{body:{data:c}}),new e(h))},e.prototype.encrypt=function(r){var i,s,o,a,l,c,h;return this.isEncrypted()?(u.error("object is already encrypted",this),this):(i=new t,a=this.metadata.strategy["@class"],o=n.get(a),s=new o,l=s.split(this.body.data),c=i.encrypt(l,r),h=f.extend({},f.cloneDeep(this),{body:{data:c}}),new e(h))},e}(),r})}.call(this),function(){var e=function(e,t){return function(){return e.apply(t,arguments)}};define("kryptnostic.object-metadata",["require","lodash","kryptnostic.schema.validator","kryptnostic.schema.object-metadata"],function(t){"use strict";var n,r,i,s,o;return o=t("lodash"),s=t("kryptnostic.schema.validator"),r=t("kryptnostic.schema.object-metadata"),i=function(){return{timeCreated:(new Date).getTime(),version:0,total:0,childObjectCount:0,owners:[],readers:[],writers:[],name:{},strategy:{"@class":"com.kryptnostic.kodex.v1.serialization.crypto.DefaultChunkingStrategy"}}},n=function(){function t(t){this.validate=e(this.validate,this),o.extend(this,i(),t),this.validate()}return t.prototype.validate=function(){return s.validate(this,t,r)},t}(),n})}.call(this),function(){var e=function(e,t){return function(){return e.apply(t,arguments)}};define("kryptnostic.object-metadata-tree",["require","lodash","kryptnostic.schema.validator","kryptnostic.schema.object-metadata-tree"],function(t){"use strict";var n,r,i,s;return s=t("lodash"),i=t("kryptnostic.schema.validator"),r=t("kryptnostic.schema.object-metadata-tree"),n=function(){function t(t){this.validate=e(this.validate,this),s.extend(this,{},t),this.validate()}return t.prototype.validate=function(){return i.validate(this,t,r)},t}(),n})}.call(this),function(){define("kryptnostic.create-object-request",["require","lodash","kryptnostic.schema.create-object-request","kryptnostic.schema.validator"],function(e){var t,n,r,i;return i=e("lodash"),n=e("kryptnostic.schema.create-object-request"),r=e("kryptnostic.schema.validator"),t=function(){function e(e){i.extend(this,e),this.validate()}return e.prototype.validate=function(){return r.validate(this,e,n)},e}(),t})}.call(this),function(){define("kryptnostic.metadata-request",["require"],function(e){var t,n;return n=function(e){var t,n,r,i;if(!_.isArray(e))throw new Error("must construct with a list of metadata");i=[];for(n=0,r=e.length;n<r;n++){t=e[n];if(t.constructor.name!=="IndexedMetadata")throw new Error("metadata list member must be indexed metadata");i.push(void 0)}return i},t=function(){function e(e){this.metadata=e.metadata,this.validate()}return e.prototype.validate=function(){return n(this.metadata)},e}(),t})}.call(this),function(){define("kryptnostic.object-tree-load-request",["require","kryptnostic.schema.create-object-request","kryptnostic.schema.validator"],function(e){var t,n,r,i,s;return s=e("lodash"),r=e("kryptnostic.schema.object-tree-load-request"),i=e("kryptnostic.schema.validator"),t={},n=function(){function e(e){s.extend(this,t,e),this.validate()}return e.prototype.validate=function(){return i.validate(this,e,r)},e}(),n})}.call(this),function(){define("kryptnostic.revocation-request",["require","lodash","kryptnostic.schema.revocation-request","kryptnostic.schema.validator"],function(e){var t,n,r,i,s;return s=e("lodash"),r=e("kryptnostic.schema.revocation-request"),i=e("kryptnostic.schema.validator"),t={},n=function(){function e(e){s.extend(this,t,e),this.validate()}return e.prototype.validate=function(){return i.validate(this,e,r)},e}(),n})}.call(this),function(){define("kryptnostic.search-request",["require","kryptnostic.schema.search-request","kryptnostic.schema.validator"],function(e){var t,n,r;return t=e("kryptnostic.schema.search-request"),r=e("kryptnostic.schema.validator"),n=function(){function e(e){_.extend(this,e),this.validate()}return e.prototype.validate=function(){return r.validate(this,e,t)},e}(),n})}.call(this),function(){define("kryptnostic.sharing-request",["require","lodash","kryptnostic.schema.sharing-request","kryptnostic.schema.validator"],function(e){var t,n,r,i,s;return s=e("lodash"),n=e("kryptnostic.schema.sharing-request"),i=e("kryptnostic.schema.validator"),t={},r=function(){function e(e){s.extend(this,t,e),this.validate()}return e.prototype.validate=function(){return i.validate(this,e,n)},e}(),r})}.call(this),function(){define("kryptnostic.storage-request",["require","lodash","kryptnostic.schema.storage-request","kryptnostic.schema.validator"],function(e){var t,n,r,i,s;return s=e("lodash"),n=e("kryptnostic.schema.storage-request"),i=e("kryptnostic.schema.validator"),t={type:"object",version:0},r=function(){function e(e){s.extend(this,t,e),this.validate()}return e.prototype.validate=function(){return i.validate(this,e,n)},e}(),r})}.call(this),function(){define("kryptnostic.user-registration-request",["require","kryptnostic.schema.validator","kryptnostic.schema.user-registration-request"],function(e){var t,n,r,i;return i=e("kryptnostic.schema.validator"),n=e("kryptnostic.schema.user-registration-request"),t={confirmationEmailNeeded:!1},r=function(){function e(e){this.password=e.password,this.email=e.email,this.name=e.name,this.confirmationEmailNeeded=e.confirmationEmailNeeded,_.defaults(this,t)}return e.prototype.validate=function(){return i.validate(this,e,n)},e}(),r})}.call(this),function(){define("kryptnostic.schema.block-ciphertext",[],function(){var e;return e={type:"object",properties:{iv:{type:"string",required:!0,allowEmpty:!1},salt:{type:"string",required:!0,allowEmpty:!0},contents:{type:"string",required:!0,allowEmpty:!1}}},e})}.call(this),function(){define("kryptnostic.schema.create-object-request",[],function(){var e;return e={properties:{type:{type:"string",required:!0,allowEmpty:!1},parentObjectId:{type:"object",required:!1,allowEmpty:!1},id:{type:"object",required:!1,allowEmpty:!1},inheritOwnership:{type:"boolean",required:!1,allowEmpty:!1},inheritCryptoService:{type:"boolean",required:!1,allowEmpty:!1},locked:{type:"boolean",required:!1,allowEmpty:!1}}},e})}.call(this),function(){define("kryptnostic.schema.encryptable",["require","kryptnostic.schema.encrypted-block","kryptnostic.schema.block-ciphertext"],function(e){var t,n;return n=e("kryptnostic.schema.encrypted-block"),t=e("kryptnostic.schema.block-ciphertext"),{properties:{data:{description:"list of encrypted blocks",type:"array",required:!0,allowEmpty:!1,items:n},key:{description:"id of the cryptoservice for decrypting this object",type:"string",required:!0,allowEmpty:!1},strategy:{type:"object",required:!0},name:_.extend({},t,{description:"encrypted class name"})}}})}.call(this),function(){define("kryptnostic.schema.encrypted-block",["require","kryptnostic.schema.block-ciphertext"],function(e){var t,n;return t=e("kryptnostic.schema.block-ciphertext"),n={type:"object",properties:{block:t,name:t,verify:{type:"string",required:!0,allowEmpty:!1},index:{type:"number",required:!0,minimum:0},last:{type:"boolean",required:!0},strategy:{type:"object",required:!0,properties:{"@class":{type:"string",required:!0,allowEmpty:!1}}},timeCreated:{type:"number",required:!0}}},n})}.call(this),function(){define("kryptnostic.schema.indexed-metadata",["require","kryptnostic.schema.encryptable"],function(e){var t,n;return t=e("kryptnostic.schema.encryptable"),n={properties:{key:{description:"the indexed search key for this term",type:"string",required:!0,allowEmpty:!1},id:{description:"the object id which the term came from",type:"string",required:!0,allowEmpty:!1},data:_.extend({},t,{description:"the encrypted metadata content"})}},n})}.call(this),function(){define("kryptnostic.schema.inverted-index-segment",[],function(){var e;return e={properties:{objectKey:{description:"VersionedObjectKey of the object",type:"object",required:!0,allowEmpty:!1},parentObjectKey:{description:"VersionedObjectKey of the parent object",type:"object",required:!1,allowEmpty:!1},token:{description:"the token being indexed for search",type:"string",required:!0,allowEmpty:!1},indices:{description:"the 2D array of indices (locations)",type:"array",required:!0,allowEmpty:!1}}},e})}.call(this),function(){define("kryptnostic.schema.kryptnostic-object",["require","kryptnostic.schema.object-metadata"],function(e){var t,n;return t=e("kryptnostic.schema.object-metadata"),n={properties:{metadata:t}}})}.call(this),function(){define("kryptnostic.schema.object-metadata",[],function(){var e;return e={properties:{id:{type:"string"},type:{type:"string"},timeCreated:{type:"number"},version:{type:"number"},total:{type:"number"},childObjectCount:{type:"number"},owners:{type:"array"},readers:{type:"array"},writers:{type:"array"},name:{type:"object",description:"encrypted class name",properties:{iv:{type:"string"},salt:{type:"string"},contents:{type:"string"}}},strategy:{type:"object",required:!0,properties:{"@class":{type:"string",required:!0,allowEmpty:!1}}}}},e})}.call(this),function(){define("kryptnostic.schema.object-metadata-tree",[],function(){var e;return e={type:"object",description:"Map<java.util.UUID, com.kryptnostic.v2.storage.models.ObjectMetadataEncryptedNode>",patternProperties:{"^[0-9a-f]{8}-[0-9a-f]{4}-[1-4][0-9a-f]{3}-[0-9a-f]{4}-[0-9a-f]{12}$":{children:{type:"object"},contents:{type:"object",properties:{iv:{type:"string",required:!0,allowEmpty:!1},salt:{type:"string",required:!0,allowEmpty:!1},contents:{type:"string",required:!0,allowEmpty:!1},tag:{type:"string",required:!1,allowEmpty:!1},encryptedLength:{type:"string",required:!1,allowEmpty:!1}}},metadata:{type:"object",description:"com.kryptnostic.v2.storage.models.ObjectMetadata",properties:{id:{type:"string",pattern:"^[0-9a-f]{8}-[0-9a-f]{4}-[1-4][0-9a-f]{3}-[0-9a-f]{4}-[0-9a-f]{12}$",required:!0,allowEmpty:!1},type:{type:"string",pattern:"^[0-9a-f]{8}-[0-9a-f]{4}-[1-4][0-9a-f]{3}-[0-9a-f]{4}-[0-9a-f]{12}$",required:!0,allowEmpty:!1},version:{type:"number",required:!0,allowEmpty:!1},size:{type:"number",required:!0,allowEmpty:!1},creator:{type:"string",pattern:"^[0-9a-f]{8}-[0-9a-f]{4}-[1-4][0-9a-f]{3}-[0-9a-f]{4}-[0-9a-f]{12}$"},requiredCryptoMats:{type:"array",required:!0,allowEmpty:!1},timeCreated:{type:"number",required:!0,allowEmpty:!1}}}}}},e})}.call(this),function(){define("kryptnostic.schema.object-tree-load-request",[],function(){var e;return e={properties:{objectIds:{type:"array",required:!0,allowEmpty:!1},loadLevels:{type:"object",required:!0,allowEmpty:!1},depth:{type:"number",required:!1,allowEmpty:!1}}},e})}.call(this),function(){define("kryptnostic.schema.pending-object-request",[],function(){var e;return e={properties:{type:{description:"the type of object being stored",type:"string",required:!0,allowEmpty:!1},parentObjectId:{description:"id of the parent object if creating a child object",type:"string",required:!1,allowEmpty:!1}}},e})}.call(this),function(){define("kryptnostic.schema.revocation-request",[],function(){return{properties:{id:{description:"VersionedObjectKey of the object being revoked",type:"object",required:!0,allowEmpty:!1},users:{description:"list of user keys whose access must be revoked",type:"array",required:!0,allowEmpty:!1}}}})}.call(this),function(){define("kryptnostic.schema.search-request",[],function(){var e;return e={properties:{query:{description:"array of FHE-encrypted search tokens represented as an Uint8Array",type:"array",required:!0,allowEmpty:!1},offset:{type:"number",required:!1,allowEmpty:!1},max:{type:"number",required:!1,allowEmpty:!1}}},e})}.call(this),function(){define("kryptnostic.schema.sharing-request",[],function(){var e;return e={properties:{id:{description:"VersionedObjectKey of the object being shared",type:"object",required:!0,allowEmpty:!1},users:{description:"map of uuid to encrypted bytes containing RsaCompressingEncryptionService",type:"object",required:!1,allowEmpty:!1},sharingPair:{description:"the encrypted object sharing pair",type:"object",required:!1,allowEmpty:!1}}},e})}.call(this),function(){define("kryptnostic.schema.storage-request",[],function(){var e;return e={properties:{parentId:{description:"object ID of the parent object if creating a child object",type:"string",required:!1,allowEmpty:!1,pattern:"^[0-9a-f]{8}-[0-9a-f]{4}-[1-4][0-9a-f]{3}-[0-9a-f]{4}-[0-9a-f]{12}$"},typeId:{description:"the type ID of object being stored",type:"string",required:!1,allowEmpty:!1,pattern:"^[0-9a-f]{8}-[0-9a-f]{4}-[1-4][0-9a-f]{3}-[0-9a-f]{4}-[0-9a-f]{12}$"},typeName:{description:"the type name of object being stored",type:"string",required:!0,allowEmpty:!1},body:{description:"content to be encrypted",type:"string",required:!0,allowEmpty:!1},isSearchable:{description:"indicates whether the object should be indexed",type:"boolean",required:!1}}},e})}.call(this),function(){define("kryptnostic.schema.user-registration-request",[],function(){return{properties:{password:{type:"string",description:"user credential (password hash)",required:!0,allowEmpty:!1},email:{type:"string",description:"user email address",required:!0,allowEmpty:!1},name:{type:"string",description:"user given name",required:!0,allowEmpty:!1},confirmationEmailNeeded:{type:"boolean",description:"flag for indicating whether confirmation email is needed",required:!0,allowEmpty:!1}}}})}.call(this),function(){define("kryptnostic.schema.validator",["require","revalidator","kryptnostic.logger"],function(e){var t,n,r;return t=e("kryptnostic.logger").get("validator"),n=e("revalidator"),r=function(e,r,i){var s;if(!e instanceof r)return;s={},n&&n.validate?s=n.validate(e,i):window.validate?s=window.validate(e,i):t.error("missing dependency: revalidator");if(!s.valid)throw new Error("schema validation failed for "+e.constructor.name)},{validate:r}})}.call(this),function(){define("kryptnostic.indexed-metadata",["require","lodash","kryptnostic.schema.indexed-metadata","kryptnostic.schema.validator"],function(e){var t,n,r,i,s;return s=e("lodash"),r=e("kryptnostic.schema.indexed-metadata"),i=e("kryptnostic.schema.validator"),t={},n=function(){function e(e){s.extend(this,t,e),this.validate()}return e.prototype.validate=function(){return i.validate(this,e,r)},e}(),n})}.call(this),function(){define("kryptnostic.search.random-index-generator",["require"],function(e){var t;return t=function(){function e(){}return e.prototype.generate=function(e){var t;return t=new Uint32Array(e),window.crypto.getRandomValues(t),Array.prototype.slice.call(t)},e}(),t})}.call(this),function(){define("kryptnostic.search-client",["require","bluebird","kryptnostic.binary-utils","kryptnostic.logger","kryptnostic.crypto-service-loader","kryptnostic.hash-function","kryptnostic.kryptnostic-engine-provider","kryptnostic.object-api","kryptnostic.search-api"],function(e){var t,n,r,i,s,o,u,a,f,l;return u=e("bluebird"),o=e("kryptnostic.object-api"),a=e("kryptnostic.search-api"),n=e("kryptnostic.crypto-service-loader"),i=e("kryptnostic.kryptnostic-engine-provider"),t=e("kryptnostic.binary-utils"),r=e("kryptnostic.hash-function"),s=e("kryptnostic.logger"),l=s.get("SearchClient"),f=function(){function e(){this.cryptoServiceLoader=new n,this.objectApi=new o,this.searchApi=new a}return e.prototype.search=function(e){return u.resolve().then(function(n){return function(){var s,o,u,a,f,l;return l=r.SHA_256_TO_128(e),f=t.stringToUint8(l),u=i.getEngine(),o=u.calculateEncryptedSearchToken(f),s=t.uint8ToBase64(o),a=[s],n.searchApi.search(a)}}(this)).then(function(e){return function(t){var n,r;return _.isEmpty(t)?{}:(r=[],n=_.map(t,function(t,n){var i,s;return r.push(n),i=e.objectApi.getObjects(t),s=e.cryptoServiceLoader.getObjectCryptoServiceV2({objectId:n,objectVersion:0},{expectMiss:!1}),u.props({invertedIndexSegments:i,objectCryptoService:s}).then(function(e){var t,n;return t=e.invertedIndexSegments,n=e.objectCryptoService,_.map(t,function(e){var t,r;return r=n.decrypt(e),t=JSON.parse(r),t})})["catch"](function(e){return[]})}),u.all(n).then(function(e){var t;return t={},_.forEach(e,function(e,n){var i;if(!_.isEmpty(e))return i=r[n],t[i]=e}),t})["catch"](function(e){return{}}))}}(this))["catch"](function(e){return{}})},e}(),f})}.call(this),function(){var e=[].indexOf||function(e){for(var t=0,n=this.length;t<n;t++)if(t in this&&this[t]===e)return t;return-1};define("kryptnostic.block-encryption-service",["require","lodash","forge","kryptnostic.encrypted-block","kryptnostic.logger"],function(t){"use strict";var n,r,i,s,o,u,a,f,l;return l=t("lodash"),u=t("forge"),i=t("kryptnostic.encrypted-block"),s=t("kryptnostic.logger"),a=s.get("BlockEncryptionService"),o={String:"java.lang.String"},r={"@class":"com.kryptnostic.kodex.v1.serialization.crypto.DefaultChunkingStrategy"},f=function(e){return btoa(u.md.sha256.create().update(atob(e)).digest().data)},n=function(){function t(){}return t.prototype.encrypt=function(t,n){return t.map(function(s,u){var c,h,p,d,v,m,g,y,b;if(b=s.constructor.name,e.call(l.keys(o),b)<0)throw new Error("unsupported chunk type");return h=s.constructor.name,d=o[h],c=n.encrypt(s),v=n.encrypt(d),y=f(c.contents),p=u===t.length-1,m=r,g=(new Date).getTime(),c={block:c,name:v,verify:y,index:u,last:p,strategy:m,timeCreated:g},a.info("created block"),new i(c)})},t.prototype.decrypt=function(e,t){return e.map(function(e){var n,r,i,s;n=e.block,s=e.verify,r=f(n.contents);if(s!==r)throw a.info("block verify mismatch",{verify:s,computed:r}),new Error("cannot decrypt block because verify of block contents does not match.");return i=t.decrypt(n),i})},t}(),n})}.call(this),function(){define("kryptnostic.configuration",["require","lodash","kryptnostic.logger"],function(e){var t,n,r,i;return r=e("kryptnostic.logger"),i=r.get("ConfigurationService"),n={servicesUrl:"http://api.kryptnostic.com/v1",servicesUrlV2:"http://api.kryptnostic.com/v2",heraclesUrl:"https://api.kryptnostic.com/heracles/v1",heraclesUrlV2:"https://api.kryptnostic.com/heracles/v2",credentialProvider:"kryptnostic.credential-provider.local-storage",cachingProvider:"kryptnostic.caching-provider.jscache"},t=function(){function e(){}return e.config=_.cloneDeep(n),e.set=function(t){return _.extend(e.config,t),i.info("configuration was updated",this.config)},e.get=function(t){return t!=null?e.config[t]:e.config},e}(),t})}.call(this),function(){define("kryptnostic.registration-client",["require","kryptnostic.logger","kryptnostic.registration-api","kryptnostic.credential-service","kryptnostic.user-registration-request"],function(e){var t,n,r,i,s,o;return n=e("kryptnostic.logger"),r=e("kryptnostic.registration-api"),t=e("kryptnostic.credential-service"),s=e("kryptnostic.user-registration-request"),o=n.get("RegistrationClient"),i=function(){function e(){this.registrationApi=new r,this.credentialService=new t}return e.prototype.register=function(e){var n,r,i,u,a,f,l;return r=e.email,u=e.name,a=e.password,l=t.generateCredentialPair({password:a}),n=l.credential,i=l.encryptedSalt,a=null,f=new s({email:r,name:u,password:n}),Promise.resolve().then(function(e){return function(){return e.registrationApi.register(f)}}(this)).then(function(e){return function(t){return o.info("registered new user account",{uuid:t}),e.credentialService.initializeSalt({uuid:t,encryptedSalt:i,credential:n})}}(this)).then(function(){return o.info("initialized user salt"),o.info("user registration complete")})},e}(),i})}.call(this),function(){define("kryptnostic.sharing-client",["require","bluebird","kryptnostic.crypto-service-loader","kryptnostic.crypto-service-marshaller","kryptnostic.key-storage-api","kryptnostic.kryptnostic-engine-provider","kryptnostic.logger","kryptnostic.object-api","kryptnostic.revocation-request","kryptnostic.rsa-crypto-service","kryptnostic.sharing-api","kryptnostic.sharing-request","kryptnostic.validators"],function(e){var t,n,r,i,s,o,u,a,f,l,c,h,p,d,v,m,g,y;return y=e("lodash"),u=e("bluebird"),r=e("kryptnostic.key-storage-api"),o=e("kryptnostic.object-api"),l=e("kryptnostic.sharing-api"),t=e("kryptnostic.crypto-service-loader"),n=e("kryptnostic.crypto-service-marshaller"),i=e("kryptnostic.kryptnostic-engine-provider"),a=e("kryptnostic.revocation-request"),f=e("kryptnostic.rsa-crypto-service"),h=e("kryptnostic.sharing-request"),s=e("kryptnostic.logger"),p=e("kryptnostic.validators"),d=s.get("SharingClient"),v=p.validateUuid,m=p.validateUuids,g=p.validateVersionedObjectKey,c=function(){function e(){this.sharingApi=new l,this.objectApi=new o,this.cryptoServiceMarshaller=new n,this.cryptoServiceLoader=new t}return e.prototype.shareObject=function(e,t,n){return v(e)?y.isEmpty(t)||!m(t)?u.resolve():u.resolve(this.objectApi.getLatestVersionedObjectKey(e)).then(function(e){return function(s){var o;return o=void 0,n?o=u.resolve(n):o=e.sharingApi.getObjectSearchPair(s),u.join(o,e.cryptoServiceLoader.getObjectCryptoServiceV2(s),r.getRSAPublicKeys(t),function(t,n,r){var o,u,a,l,c;return l=y.mapValues(r,function(t){var r,i,s,o;if(t)return i=new f({publicKey:t}),r=e.cryptoServiceMarshaller.marshall(n),s=i.encrypt(r),o=btoa(s),o}),d.info("seals",l),t?(u=i.getEngine(),a=u.calculateObjectSharePairFromObjectSearchPair(t),o=n.encryptUint8Array(a),c=new h({id:s,users:l,sharingPair:o})):c=new h({id:s,users:l}),e.sharingApi.shareObject(c)})}}(this)):u.resolve()},e.prototype.revokeObject=function(e,t){var n;return n={}.revocationRequest,v(e)?y.isEmpty(t)||!m(t)?u.resolve():u.resolve(this.objectApi.getLatestVersionedObjectKey(e)).then(function(e){return function(r){return n=new a({id:r,users:t}),e.sharingApi.revokeObject(n)}}(this)).then(function(){return d.info("revoked access",{objectId:e,uuids:t})}):u.resolve()},e.prototype.processIncomingShares=function(){return u.props({incomingShares:this.sharingApi.getIncomingShares(),masterAesCryptoService:this.cryptoServiceLoader.getMasterAesCryptoService()}).then(function(e){return function(t){var n,r,s;return n=t.incomingShares,r=t.masterAesCryptoService,s=e.cryptoServiceLoader.getRsaCryptoService(),y.forEach(n,function(t){var n,o,u,a,f,l,c,h,p,v;try{if(t.sharingPair)return u=t.publicKeyEncryptedCryptoService,a=atob(u),c=s.decrypt(a),h=e.cryptoServiceMarshaller.unmarshall(c),f=t.sharingPair,n=h.decryptToUint8Array(f),l=i.getEngine(),v=l.calculateObjectSearchPairFromObjectSharePair(n),p=t.id,e.sharingApi.addObjectSearchPair(p,v),e.cryptoServiceLoader.setObjectCryptoServiceV2(p,h,r)}catch(m){return o=m,d.error("failed to process incoming share"),d.error(o)}})}}(this))["catch"](function(e){return d.error("failed to process incoming shares",e)})},e.prototype.getObjectSearchPair=function(e){return u.resolve(this.objectApi.getLatestVersionedObjectKey(e)).then(function(e){return function(t){return e.sharingApi.getObjectSearchPair(t)}}(this))},e}(),c})}.call(this),function(){define("kryptnostic.storage-client",["require","bluebird","kryptnostic.logger","kryptnostic.validators","kryptnostic.object-api","kryptnostic.object-listing-api","kryptnostic.kryptnostic-object","kryptnostic.crypto-service-loader","kryptnostic.object-utils","kryptnostic.indexing.object-indexing-service","kryptnostic.create-object-request","kryptnostic.credential-loader","kryptnostic.crypto-material"],function(e){"use strict";var t,n,r,i,s,o,u,a,f,l,c,h,p,d,v;return l=e("bluebird"),r=e("kryptnostic.crypto-material"),t=e("kryptnostic.create-object-request"),i=e("kryptnostic.crypto-service-loader"),s=e("kryptnostic.kryptnostic-object"),u=e("kryptnostic.object-api"),f=e("kryptnostic.object-listing-api"),a=e("kryptnostic.indexing.object-indexing-service"),n=e("kryptnostic.credential-loader"),o=e("kryptnostic.logger"),h=e("kryptnostic.validators"),d=h.validateUuid,v=h.validateUuids,p=o.get("StorageClient"),c=function(){function e(){p.info("storage client created"),this.objectApi=new u,this.objectListingApi=new f,this.cryptoServiceLoader=new i,this.objectIndexingService=new a,this.credentialLoader=new n}return e.prototype.getObject=function(e,t){var n;return d(e)?(n=null,t!=null&&(n=this.objectApi.getLatestVersionedObjectKey(t)),l.props({objectKey:this.objectApi.getLatestVersionedObjectKey(e),parentObjectKey:n}).then(function(e){return function(t){var n,r,i;return r=t.objectKey,i=t.parentObjectKey,n=null,i!=null?n=e.cryptoServiceLoader.getObjectCryptoServiceV2(i):n=e.cryptoServiceLoader.getObjectCryptoServiceV2(r),l.props({blockCiphertext:e.objectApi.getObjectAsBlockCiphertext(r),cryptoService:n}).then(function(e){var t,n,r;return t=e.blockCiphertext,n=e.cryptoService,t!=null&&n!=null?(r=n.decrypt(t),r):null})}}(this))):l.resolve(null)},e.prototype.getObjects=function(e){var t;return t=[],_.forEach(e,function(e){return function(n){return t.push(e.objectApi.getLatestVersionedObjectKey(n))}}(this)),l.all(t).then(function(e){return function(t){var n;return n=[],_.forEach(t,function(t){var r;return r=l.join(e.cryptoServiceLoader.getObjectCryptoServiceV2(t),e.objectApi.getObjectAsBlockCiphertext(t)).then(function(e){return{objectKey:t,cryptoService:e[0],blockCiphertext:e[1]}})["catch"](function(e){return{objectKey:t,cryptoService:null,blockCiphertext:null}}),n.push(r)}),l.all(n).then(function(e){var t;return t={},_.forEach(e,function(e){var n,r,i,s;s=e.objectKey,r=e.cryptoService,n=e.blockCiphertext;if(n!=null&&r!=null)return i=r.decrypt(n),t[s.objectId]=i}),t})["catch"](function(e){return p.error("Failed  to get objects")})}}(this))},e.prototype.getChildObjects=function(e,t){return!v(e)||!d(t)?l.resolve(null):l.resolve(this.objectApi.getLatestVersionedObjectKey(t)).then(function(t){return function(n){return l.props({objectCryptoService:t.cryptoServiceLoader.getObjectCryptoServiceV2(n),objectBlockCiphertexts:t.objectApi.getObjects(e)}).then(function(t){var n,r,i;return r=t.objectBlockCiphertexts,i=t.objectCryptoService,n={},_.forEach(e,function(e,t){var s,o;s=r[e];if(s&&i)return o=cryptoService.decrypt(s),n[e]=o}),n})}}(this))},e.prototype.getChildObjectsByTypeAndLoadLevel=function(e,t,n,r){return!v(e)||!d(t)?l.resolve(null):l.resolve(this.objectApi.getLatestVersionedObjectKey(t)).then(function(t){return function(i){return l.props({objectCryptoService:t.cryptoServiceLoader.getObjectCryptoServiceV2(i),objectMetadataTrees:t.objectApi.getObjectsByTypeAndLoadLevel(e,n,r)}).then(function(t){var n,r,i;return i=t.objectMetadataTrees,r=t.objectCryptoService,n={},_.forEach(e,function(e,t){var s,o,u,a;a=i[e],s=i[e].data;if(s&&r)try{o=r.decrypt(s),a.data=o}catch(f){u=f,a.data=""}return n[e]=a}),n})}}(this))},e.prototype.storeObject=function(e,n){var i,s,o;return e.validate(),s={},o=null,d(e.typeId)?o=l.resolve(e.typeId):o=this.objectListingApi.getTypeIdForTypeName(e.typeName),i=null,d(e.parentId)&&(i=this.objectApi.getLatestVersionedObjectKey(e.parentId)),l.join(o,i,function(i){return function(o,u){var a;return a=new t({type:o,requiredCryptoMats:r.DEFAULT_REQUIRED_CRYPTO_MATERIAL}),u!=null&&(a.parentObjectId=u),l.resolve(i.objectApi.createObject(a)).then(function(t){return u=u!=null?u:t,l.resolve(i.cryptoServiceLoader.getObjectCryptoServiceV2(u,{expectMiss:!0})).then(function(n){return i.encrypt(t.objectId,e.body,n)}).then(function(e){var n;return n=e.body.data[0].block,i.objectApi.setObjectFromBlockCiphertext(t,n)}).then(function(){return e.isSearchable?i.objectIndexingService.index(e.body,t,u,n):n}).then(function(e){return s.objectKey=t,s.objectSearchPair=e,s})})}}(this))},e.prototype.encrypt=function(e,t,n){var r;return r=s.createFromDecrypted({id:e,body:t}),r.encrypt(n)},e.prototype.updateObject=function(e,t){return d(e)?l.resolve(this.objectApi.getLatestVersionedObjectKey(e)).then(function(e){return function(n){return l.resolve(e.cryptoServiceLoader.getObjectCryptoServiceV2(versionedObjectKey)).then(function(r){return e.encrypt(n.objectId,t,r)}).then(function(n){var r;return r=n.body.data[0].block,e.objectApi.setObjectFromBlockCiphertext(versionedObjectKey,r),e.objectIndexingService.index(t,objectKeyForNewlyCreatedObject,parentObjectKey,objectSearchPair)}).then(function(){})}}(this)):l.resolve(null)},e}(),c})}.call(this),function(){define("kryptnostic.caching-provider-loader",["require","kryptnostic.logger","kryptnostic.caching-provider.jscache","kryptnostic.caching-provider.memory"],function(e){var t,n,r;return n=e("kryptnostic.logger"),r=n.get("CachingProviderLoader"),t=function(){function t(){}return t.load=function(t){var n;t==="kryptnostic.caching-provider.jscache"?n=e("kryptnostic.caching-provider.jscache"):t==="kryptnostic.caching-provider.memory"&&(n=e("kryptnostic.caching-provider.memory"));if(n!=null)return n;throw new Error("failed to load caching provider for URI "+t)},t}()})}.call(this),function(){define("kryptnostic.caching-service",["require","lodash","kryptnostic.configuration","kryptnostic.caching-provider-loader","kryptnostic.logger"],function(e){var t,n,r,i,s;return i=e("kryptnostic.logger"),r=e("kryptnostic.configuration"),t=e("kryptnostic.caching-provider-loader"),s=i.get("CachingService"),n=function(){function e(){}return e.USERS="users",e.UUIDS="uuids",e.SALTS="user_salts",e.OBJECTS="objects",e.PUBLIC_KEYS="public_keys",e.DEFAULT_GROUP="default_group",e.CRYPTO_SERVICES="object_crypto_services",e.MASTER_AES_CRYPTO_SERVICE_ID="master_aes_crypto_service_id",e.store=function(e,n,i){var o;if(e==null||n==null||i==null)throw new Error("Bad arguments to store cache!"+e+", "+n+", "+i);return o=t.load(r.get("cachingProvider")),s.debug("Cached "+e+": "+n+", "+JSON.stringify(i)),o.store(e,n,i)},e.get=function(e,n){var i,o;return i=t.load(r.get("cachingProvider")),o=i.get(e,n),o!=null?s.debug("Cache hit: "+e+", "+n+": "+JSON.stringify(o)):s.debug("Cache miss: "+e+", "+n),o},e.search=function(e,n){var i,o,u,a,f,l,c,h;i=t.load(r.get("cachingProvider")),f={},f.uncached=[],f.cached=[];if(_.isEmpty(n))return f;for(c=0,h=n.length;c<h;c++)u=n[c],o=i.get(e,u),o!=null?(a=f.cached,a.push(o),f.cached=a,s.debug("search hit: "+e+", "+u)):(l=f.uncached,l.push(u),f.uncached=l,s.debug("search miss: "+e+", "+u));return f},e.destroy=function(){var e;return e=t.load(r.get("cachingProvider")),e.destroy()},e}(),n})}.call(this),function(){define("kryptnostic.caching-provider.memory",["require","kryptnostic.logger"],function(e){var t,n,r;return n=e("kryptnostic.logger"),r=n.get("InMemoryCachingProvider"),t=function(){function e(){}return e.cache={},e.store=function(e,t,n){return this.cache[e]==null&&(this.cache[e]={}),this.cache[e][t]=n},e.get=function(e,t){var n;return this.cache[e]!=null&&(n=this.cache[e][t]),n!=null?n:null},e.destroy=function(){return this.cache={}},e}(),t})}.call(this),function(){define("kryptnostic.caching-provider.jscache",["require","jscache","kryptnostic.logger"],function(e){var t,n,r,i,s,o,u;return i=e("kryptnostic.logger"),n=e("jscache"),u=i.get("JsCacheCachingProvider"),s=500,t=288e5,o=function(){return{expirationAbsolute:new Date((new Date).getTime()+t),expirationSliding:void 0,priority:n.Priority.HIGH,callback:function(e,t){return u.info("expired cached user",e)}}},r=function(){function e(){}return e.cache={},e.store=function(e,t,r){return this.cache[e]==null&&(this.cache[e]=new n(s)),this.cache[e].setItem(t,r,o())},e.get=function(e,t){var n;return this.cache[e]!=null?(n=this.cache[e].getItem(t),n):null},e.destroy=function(){var e,t,n;n=this.cache;for(e in n)t=n[e],t.clear();return this.cache={}},e}(),r})}.call(this),function(){define("kryptnostic.permission-change-visitor",["require","bluebird","kryptnostic.logger","kryptnostic.validators","kryptnostic.storage-client","kryptnostic.sharing-client"],function(e){var t,n,r,i,s,o,u,a;return i=e("bluebird"),t=e("kryptnostic.logger"),a=e("kryptnostic.validators"),s=e("kryptnostic.sharing-client"),n=e("kryptnostic.object-authorization-api"),o=t.get("PermissionChangeVisitor"),u=a.validateId,r=function(){function e(e){this.uuids=e,this.objectAuthApi=new n,this.sharingClient=new s,this.changed=[],this.failed=[],this.changedUsers={}}return e.prototype.visit=function(e){var t;return t=e.metadata.id,i.resolve().then(function(t){return function(){return t.changePermissions(e)}}(this)).then(function(e){return function(){return e.changed.push(t)}}(this))["catch"](function(e){return function(n){return o.error("failed to change permissions",{objectId:t}),o.error("error",_.extend({},n,{msg:n.message,stack:n.stack})),e.failed.push(t)}}(this))},e.prototype.changePermissions=function(e){var t,n,r,s;return s={},n=s.uuidsAdd,r=s.uuidsRemove,t=e.metadata.id,i.resolve(this.getParticipants(e)).then(function(e){return function(i){return n=_.difference(e.uuids,i),r=_.difference(i,e.uuids),o.info("changePermissions",{objectId:t,uuidsRemove:r,uuidsAdd:n})}}(this)).then(function(e){return function(){return e.sharingClient.revokeObject(t,r)}}(this)).then(function(e){return function(){return e.sharingClient.shareObject(t,n)}}(this)).then(function(e){return function(){return e.changedUsers[t]={added:n,removed:r}}}(this))},e.prototype.getParticipants=function(e){var t;return t=e.metadata.id,i.props({owners:this.objectAuthApi.getUsersWithOwnerAccess(t),readers:this.objectAuthApi.getUsersWithReadAccess(t),writers:this.objectAuthApi.getUsersWithWriteAccess(t)}).then(function(e){var t,n,r,i;return t=e.owners,n=e.readers,i=e.writers,r=_.chain([t,n,i]).flatten().unique().value(),r})},e}()})}.call(this),function(){define("kryptnostic.tree-loader",["require","bluebird","kryptnostic.logger","kryptnostic.tree-node","kryptnostic.object-api","kryptnostic.object-utils"],function(e){var t,n,r,i,s,o,u;return n=e("kryptnostic.object-api"),r=e("kryptnostic.object-utils"),o=e("kryptnostic.tree-node"),t=e("kryptnostic.logger"),i=e("bluebird"),u=t.get("TreeLoader"),s=function(){function e(){this.objectApi=new n}return e.prototype.loadTree=function(e,t,n){return i.resolve().then(function(r){return function(){return r.objectApi.getObjectsByTypeAndLoadLevel(e,t,n)}}(this)).then(function(e){var t;return t={},_.map(e,function(e,n){var i;if(_.isObject(e))return i=_.sortBy(e.children,function(e){return e.metadata.timeCreated}),_.map(i,function(t,n){var i,s;s=e.metadata.id,i=r.createChildId(s,n),t.metadata.nodeId=i}),t[n]=new o(e)}),t})},e.prototype.load=function(e,t){var n;throw n=(t!=null?t:{}).depth,new Error("TreeLoader:load() is deprecated")},e}(),s})}.call(this),function(){define("kryptnostic.tree-node",["require","bluebird","lodash","kryptnostic.logger"],function(e){var t,n,r,i,s,o,u;return u=e("lodash"),n=e("bluebird"),t=e("kryptnostic.logger"),i=t.get("TreeNode"),o=function(e){var t;if(u.isEmpty(e))throw t="illegal TreeNode - no id provided",i.error(t),new Error(t);if(!u.isString(e))throw t="illegal TreeNode - id must be a String",i.error(t,{id:e}),new Error(t)},s=function(e){var t;if(!u.isObject(e))throw t="illegal TreeNode - children must be an Object",new Error(t)},r=function(){function e(e){this.objectMetadataTree=e!=null?e:{},o(this.objectMetadataTree.metadata.id),s(this.objectMetadataTree.children)}return e.prototype.visit=function(t){var r;return r=u.map(this.objectMetadataTree.children,function(n){var r;return r=new e(n),r.visit(t)}),n.all(r).then(function(e){return function(){return t.visit(e.objectMetadataTree)}}(this))},e}(),r})}.call(this),function(){var e=[].slice;define("kryptnostic.logger",["require","lodash","loglevel"],function(t){var n,r,i,s,o;return s=t("loglevel"),o=t("lodash"),r=!0,s.setLevel("info",r),i=function(e,t){return o.isArray(t)&&t.length?""+e+" "+t.map(JSON.stringify):e},n=function(){function t(e){this.moduleName=e}return t.get=function(e){return new t(e)},t.setLevel=function(e){return s.info("log level changing to",e),s.setLevel(e,r)},t.prototype.trace=function(){var t,n;return n=arguments[0],t=2<=arguments.length?e.call(arguments,1):[],s.trace("["+this.moduleName+"] "+i(n,t))},t.prototype.info=function(){var t,n;return n=arguments[0],t=2<=arguments.length?e.call(arguments,1):[],s.info("["+this.moduleName+"] "+i(n,t))},t.prototype.warn=function(){var t,n;return n=arguments[0],t=2<=arguments.length?e.call(arguments,1):[],s.warn("["+this.moduleName+"] "+i(n,t))},t.prototype.error=function(){var t,n;return n=arguments[0],t=2<=arguments.length?e.call(arguments,1):[],s.error("["+this.moduleName+"] "+i(n,t))},t.prototype.debug=function(){var t,n;return n=arguments[0],t=2<=arguments.length?e.call(arguments,1):[],s.debug("["+this.moduleName+"] "+i(n,t))},t}(),n})}.call(this),function(){define("kryptnostic.binary-utils",["require","lodash","kryptnostic.logger"],function(e){var t,n,r,i,s,o,u,a,f,l,c,h,p,d,v,m,g,y,b,w,E,S,x,T,N,C;return C=e("lodash"),i=e("kryptnostic.logger"),p=i.get("BinaryUtils"),t="",x=function(e){if(!C.isString(e))throw new Error("argument is not a string")},N=function(e){if(e.buffer==null)throw new Error("argument is not a uint8 array")},T=function(e){if(e.buffer==null)throw new Error("argument is not a uint16 array")},f=function(e,t){var n;n=e.charCodeAt();if(n>=t)throw new Error("code outside of range!");return n},n=2,r=16,l=function(e){var t,i,s,o,u;x(e),t=[];for(s=o=0,u=e.length;n>0?o<u:o>u;s=o+=n)i=e.substr(s,n),t.push(parseInt(i,r));return new Uint8Array(t)},d=function(e){if(!C.isString(e))throw new Error("argument is not a string");return e.split(t).map(function(e){return e.charCodeAt().toString(16)}).join(t)},o=Math.pow(2,8),s=Math.pow(2,16),a=function(e){var t,n,r,i;return N(e),e.length===e.byteLength&&e.length===e.buffer.byteLength?e:(t=function(){i=[];for(var t=0,n=e.length;0<=n?t<n:t>n;0<=n?t++:t--)i.push(t);return i}.apply(this).map(function(t){return e[t]}),new Uint8Array(t))},w=function(e){var t,n,r;return N(e),function(){r=[];for(var t=0,n=e.length;0<=n?t<n:t>n;0<=n?t++:t--)r.push(t);return r}.apply(this).map(function(t){return e[t]})},E=function(e){var n,r,i;return N(e),function(){i=[];for(var t=0,n=e.length;0<=n?t<n:t>n;0<=n?t++:t--)i.push(t);return i}.apply(this).map(function(t){return String.fromCharCode(e[t])}).join(t)},b=function(e){return N(e),btoa(E(e))},g=function(e){var n,r,i;return T(e),function(){i=[];for(var t=0,n=e.length;0<=n?t<n:t>n;0<=n?t++:t--)i.push(t);return i}.apply(this).map(function(t){return String.fromCharCode(e[t])}).join(t)},m=function(e){return x(e),new Uint8Array(C.map(e,function(e){return f(e,o)}))},v=function(e){return x(e),new Uint16Array(C.map(e,function(e){return f(e,s)}))},y=function(e){return T(e),new Uint8Array(e.buffer)},S=function(e){return N(e),new Uint16Array(e.buffer)},c=function(e){var t,n;n=[];while(e>0)t=e&255,n.push(t),e=(e-t)/256;return new Uint8Array(n)},h=function(e){var t,n,r;return r=C.reduce(e,function(e,t){return e+t.length},0),t=new Uint8Array(r),n=0,e.forEach(function(e){var r,i,s,o;o=[];for(r=i=0,s=e.length;0<=s?i<s:i>s;r=0<=s?++i:--i)t[n]=e[r],o.push(n+=1);return o}),t},u=function(e,t){var n,r,i,s;N(e),n=[],i=0,r=new Uint8Array(t);while(i<e.length)s=e.subarray(i,i+t),n.push(new Uint8Array(s)),i+=t;return n},{chunkUint8:u,cleanUint8Buffer:a,hexToUint8:l,intToUint8:c,joinUint8:h,stringToHex:d,stringToUint16:v,stringToUint8:m,uint16ToString:g,uint16ToUint8:y,uint8ToString:E,uint8ToBase64:b,uint8ToUint16:S,uint8ToNumeric:w}})}.call(this),function(){define("kryptnostic.object-utils",["require"],function(e){var t,n,r,i,s;return t="~",r=function(e,n){return""+e+t+n},s=function(e){return e!=null?e.indexOf(t)>=0:!1},n=function(e){var n;return e!=null?(n=e.indexOf(t),n>=0?e.slice(0,n):e):null},i=function(e){var n;return e!=null?(n=e.split(t),n.length>1?_.parseInt(_.last(n)):-1):-1},{isChildId:s,createChildId:r,getChildIndex:i,childIdToParent:n}})}.call(this),function(){define("kryptnostic.requests",["require","axios","bluebird","kryptnostic.block-ciphertext","kryptnostic.credential-loader"],function(e){"use strict";var t,n,r,i,s,o,u,a,f;return o=e("axios"),s=e("bluebird"),t=e("kryptnostic.block-ciphertext"),r=e("kryptnostic.credential-loader"),i="X-Kryptnostic-Principal",n="X-Kryptnostic-Credential",f=function(e,t){return t==null&&(t={}),_.isEmpty(t)&&(t=(new r).getCredentials()),_.defaults(e,{headers:{}}),e.headers[i]=t.principal,e.headers[n]=t.credential,e},u=function(e){return s.resolve(o(f({url:e,method:"GET",responseType:"arraybuffer"}))).then(function(e){return e&&e.data&&e.data.byteLength&&e.data.byteLength>0?new Uint8Array(e.data):null})},a=function(e){return s.resolve(o(f({url:e,method:"GET",responseType:"json"}))).then(function(e){var n;if(!e||!e.data)return null;try{return new t(e.data)}catch(r){return n=r,null}})},{wrapCredentials:f,getAsUint8FromUrl:u,getBlockCiphertextFromUrl:a}})}.call(this),function(){define("kryptnostic.validators",["require","lodash","kryptnostic.logger"],function(e){var t,n,r,i,s,o,u,a,f,l,c;return c=e("lodash"),t=e("kryptnostic.logger"),n=t.get("validators"),s=function(e,t){t==null&&(t="value");if(!c.isString(e))throw n.error(""+t+" is not a string",e),new Error(""+t+" is not a string");if(c.isEmpty(e))throw n.error(""+t+" is empty",e),new Error(""+t+" is empty")},a=function(e){var t;return t=/^[0-9a-f]{8}-[0-9a-f]{4}-[1-4][0-9a-f]{3}-[0-9a-f]{4}-[0-9a-f]{12}$/,t.test(e)},r=function(e){return s(e,"id")},i=function(e){return s(e,"key")},u=function(e){return s(e,"object type")},f=function(e){return c.isArray(e)?(c.forEach(e,function(e){if(!a(e))return!1}),!0):!1},l=function(e){return c.isObject(e)?a(e.objectId)?c.isFinite(e.objectVersion)?!0:!1:!1:!1},o=function(e){return!c.isString(e)||c.isEmpty(e)?!1:!0},{validateId:r,validateKey:i,validateUuid:a,validateUuids:f,validateObjectType:u,validateNonEmptyString:s,validateVersionedObjectKey:l,validateObjectCryptoService:o}})}.call(this),function(){var e;e=["axios","bluebird","forge","jscache","lodash","loglevel","murmurhash3","pako","revalidator","function-name","cs!auth/AuthenticationService","cs!auth/AuthenticationStage","cs!auth/CredentialLoader","cs!auth/CredentialProviderLoader","cs!auth/CredentialService","cs!auth/SaltGenerator","cs!auth/SearchCredentialService","cs!auth/SearchKeySerializer","cs!auth/credential-provider/InMemoryCredentialProvider","cs!auth/credential-provider/KeyValueCredentialProvider","cs!auth/credential-provider/LocalStorageCredentialProvider","cs!auth/credential-provider/SessionStorageCredentialProvider","cs!chunking/ChunkingStrategyRegistry","cs!chunking/DefaultChunkingStrategy","cs!chunking/JsonChunkingStrategy","cs!crypto/AbstractCryptoService","cs!crypto/AesCryptoService","cs!crypto/CryptoAlgorithm","cs!crypto/CryptoMaterial","cs!crypto/CryptoServiceLoader","cs!crypto/CryptoServiceMarshaller","cs!crypto/CryptoServiceMigrator","cs!crypto/Cypher","cs!crypto/HashFunction","cs!crypto/KeypairSerializer","cs!crypto/PasswordCryptoService","cs!crypto/RsaCryptoService","cs!crypto/RsaKeyGenerator","cs!engine/KryptnosticEngine","cs!engine/KryptnosticEngineProvider","cs!engine/MockKryptnosticEngine","cs!engine/MockSearchKeyGenerator","cs!engine/SearchKeyGenerator","cs!http/KeyStorageApi","cs!http/MetadataApi","cs!http/ObjectApi","cs!http/ObjectAuthorizationApi","cs!http/ObjectListingApi","cs!http/RegistrationApi","cs!http/SearchApi","cs!http/SharingApi","cs!http/UserDirectoryApi","cs!indexing/InvertedIndexSegment","cs!indexing/ObjectIndexer","cs!indexing/ObjectIndexingService","cs!indexing/ObjectTokenizer","cs!marshalling/DeflatingMarshaller","cs!model/object/BlockCiphertext","cs!model/object/EncryptedBlock","cs!model/object/KryptnosticObject","cs!model/object/ObjectMetadata","cs!model/object/ObjectMetadataTree","cs!model/request/CreateObjectRequest","cs!model/request/MetadataRequest","cs!model/request/ObjectTreeLoadRequest","cs!model/request/RevocationRequest","cs!model/request/SearchRequest","cs!model/request/SharingRequest","cs!model/request/StorageRequest","cs!model/request/UserRegistrationRequest","cs!model/schema/block-ciphertext","cs!model/schema/create-object-request","cs!model/schema/encryptable","cs!model/schema/encrypted-block","cs!model/schema/indexed-metadata","cs!model/schema/inverted-index-segment","cs!model/schema/kryptnostic-object","cs!model/schema/object-metadata","cs!model/schema/object-metadata-tree","cs!model/schema/object-tree-load-request","cs!model/schema/pending-object-request","cs!model/schema/revocation-request","cs!model/schema/search-request","cs!model/schema/sharing-request","cs!model/schema/storage-request","cs!model/schema/user-registration-request","cs!model/schema/validator","cs!model/search/IndexedMetadata","cs!search/RandomIndexGenerator","cs!search/SearchClient","cs!service/BlockEncryptionService","cs!service/ConfigurationService","cs!service/RegistrationClient","cs!service/SharingClient","cs!service/StorageClient","cs!service/caching-provider/CachingProviderLoader","cs!service/caching-provider/CachingService","cs!service/caching-provider/InMemoryCachingProvider","cs!service/caching-provider/JscacheCachingProvider","cs!tree/PermissionChangeVisitor","cs!tree/TreeLoader","cs!tree/TreeNode","cs!util/Logger","cs!util/binary-utils","cs!util/object-utils","cs!util/requests","cs!util/validators"],define("kryptnostic",e,function(e){"use strict";return{}})}.call(this);